=== modified file 'ChangeLog'
--- ChangeLog	2012-06-29 16:47:49 +0000
+++ ChangeLog	2012-09-11 15:34:43 +0000
@@ -1,33 +1,102 @@
-2012-06-14 lttng-ust 2.0.4
+2012-09-10 lttng-ust 2.1.0-rc1
+	* Fix make dist: fix liblttng-ust-java dependencies
+	* Fix make dist: add missing filter header
+	* Fix: backward compatibility with UST 2.0 app probes
+	* Fix: Filter ABI changes to support FILTER_BYTECODE_MAX_LEN (65536)
+	* Export "written" information about fields
+	* Fix filter: pointer to string, not string, should be on stack
+	* Fix: tracepoint float nowrite
+	* Fix: accept 65536 bytes long bytecodes
+	* Add hostname to env
+	* ABI change: bump internal version to 3.0.0
+	* Fix: threads should be created in DETACHED state
+	* Fix: 32-bit x86 strict-aliasing warnings
+	* Fix UST SIGPIPE handling
+	* Fix: Libtool fails to find dependent libraries when cross-compiling lttng-ust
+	* Cleanup: filter: turn bytecode linking error msg into debug
+	* Make lttng-ust robust against -finstrument-functions.
+	* Filter: keep aliased ax and bx registers
+	* Filter: remove interpreter dynamic typing
+	* Filter: add missing specialized op names
+	* Filter: specialize double-s64 binary comparators
+	* Fix filter: fix stack leak on taken branch
+	* Filter: Implement stack-based interpreter
+	* Filter: double comparator produces s64
+	* Filter: use hash table to check merge points
+	* Filter: split passes into separate components
+	* Filter: cleanup macros
+	* Filter: validate range overflow with end of insn
+	* Filter: validate that field ref strings are non-NULL
+	* Filter: ensure logical operator merge is always s64
+	* Filter: we don't care if double/s64 are literals
+	* Filter: specialize 'and' and 'or' ops.
+	* Implement dispatch-table based interpretor
+	* Filter: Specialize unary operators
+	* Define switch use as macro in interpreter
+	* Filter interpreter: mark float test as unlikely
+	* Filter: fix bytecode validation typo
+	* Filter: specialize comparators
+	* Specialize load and unary ops
+	* Validate registers, no need to initialize to 0
+	* Filter: opcode for ref loads
+	* Remove redundant validation from interpreter
+	* filter: Add bytecode validation pass
+	* TRACEPOINT_EVENT: add *_nowrite fields for filter
+	* Only print filter errors if LTTNG_UST_DEBUG is set
+	* Cleanup: remove debug define
+	* Filter: add floating point support
+	* Remove filter test printouts
+	* Implement filter bytecode interpreter and linker
+	* Filter: receive, attach and link empty filter
+	* Filter: prepare filter stack data
+	* Wrap dynamic len array into stackvar union
+	* liblttng-ust-comm/lttng-ust-com.c: remove unnecessary goto in ustcomm_accept_unix_sock()
+	* liblttng-ust/lttng-ust-comm.c: fixing typo.
+	* Fix: remove unused texinfo dep from configure.ac
+	* Fix C99 strict compatibility: don't use void * for function pointers
+	* Fix c99 compatibility: tp_rcu_dereference_bp() should not use braced-groups within expressions
+	* Revert "Fix c99 compatibility: tp_rcu_dereference_bp() should not use braced-groups within expressions"
+	* Fix c99 compatibility: tp_rcu_dereference_bp() should not use braced-groups within expressions
 	* Fix: perform TLS fixup of nest count outside of UST mutex
 	* Fix: liblttng-ust-fork deadlock
 	* Fix: handle pthread errors
 	* Fix: local apps allowed should disable local (not global) tracing
 	* Fix strict ISO-C compatibility for ust-tracepoint-event.h public header
 	* Fix: support -std=c99 in tracepoint macros
+	* Fix c99 compatibility: use __typeof__ instead of typeof in public headers
+	* hello test: fail on old style definition
 	* Fix: tracepoint.h should not generate old-style definitions
 	* Fix: don't define variables in headers
 	* test "hello": add boolean test
 	* Fix: perform macro expansion on tracepoint signatures
 	* UST check pointer/de-reference order
-
-2012-06-01 lttng-ust 2.0.3
+	* Fix list field: handle error
+	* Implement event fields listing
+	* Implement field listing command
 	* Fix: Block all signals in listener thread
-	* Remove jni support for configure
+	* Add CodingStyle document to tarball
+	* Add coding style document
+	* endian.h: support cygwin
+	* align.h: support cygwin page size
+	* Add cygwin support to libringbuffer getcpu.h
+	* Add "2x int" and "2x long" types to the Java interface
+	* Add Integer and Long tracepoint types to the Java interface
 	* Fix: don't SIGBUS when filesystem is full
 	* tracepoint: include stdio.h for NULL definition
 	* manpage update: document that probes need gcc
 	* Fix: remove # in front on extern "C" {
 	* Cleanup: don't use GNU old-style field designator extension
 	* Fix: remove padding field after variable sized array
+	* Use unsigned long type for events discarded counter
+	* Fix: getcpu build with modern uClibc versions
 	* Fix: lttng-ust.pc needs to specify -ldl
-	* Update changelog after liblttng-ust-java removal
-	* Fix: drop unusable liblttng-ust-java.so
-
-2012-04-18 lttng-ust 2.0.2
-	* Fix: drop unusable liblttng-ust-java.so
 	* Fix: examples Makefiles should pass $(LIBS) at last
+	* Build a jar for the Java side of the JNI interface
 	* Fix: ustctl need to send the second fd upon error of 1st fd
+	* Fix: Add missing fork test program dependency library
+	* Fix: Make the JNI interface actually work
+	* Merge branch 'dev'
+	* Fix: stringify version description
 
 2012-03-29 lttng-ust 2.0.1
 	* Use bsd-compatible fcntl for close-on-exec on socket

=== added file 'CodingStyle'
--- CodingStyle	1970-01-01 00:00:00 +0000
+++ CodingStyle	2012-09-11 15:34:43 +0000
@@ -0,0 +1,10 @@
+LTTng-UST Coding Style
+
+The coding style used for this project follows the the Linux kernel
+guide lines. Please refer to:
+
+- Linux kernel Documentation/CodingStyle document for details,
+- Linux kernel scripts/checkpatch.pl for a script which verify the patch
+  coding style.
+
+Mathieu Desnoyers, May 30, 2012

=== modified file 'Makefile.am'
--- Makefile.am	2012-06-29 16:47:49 +0000
+++ Makefile.am	2012-09-11 15:34:43 +0000
@@ -9,10 +9,9 @@
 		tests \
 		doc
 
-#disabled for 2.0
-#if BUILD_JNI_INTERFACE
-#SUBDIRS += liblttng-ust-java
-#endif
+if BUILD_JNI_INTERFACE
+SUBDIRS += liblttng-ust-java
+endif
 
 #temporarily disabled
 # liblttng-ust-malloc
@@ -21,3 +20,5 @@
 pkgconfig_DATA = lttng-ust.pc
 
 dist_doc_DATA = README ChangeLog
+
+dist_noinst_DATA = CodingStyle

=== modified file 'Makefile.in'
--- Makefile.in	2012-06-29 16:47:49 +0000
+++ Makefile.in	2012-09-11 15:34:43 +0000
@@ -1,4 +1,4 @@
-# Makefile.in generated by automake 1.11.3 from Makefile.am.
+# Makefile.in generated by automake 1.11.6 from Makefile.am.
 # @configure_input@
 
 # Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2000, 2001, 2002,
@@ -16,6 +16,23 @@
 @SET_MAKE@
 
 VPATH = @srcdir@
+am__make_dryrun = \
+  { \
+    am__dry=no; \
+    case $$MAKEFLAGS in \
+      *\\[\ \	]*) \
+        echo 'am--echo: ; @echo "AM"  OK' | $(MAKE) -f - 2>/dev/null \
+          | grep '^AM OK$$' >/dev/null || am__dry=yes;; \
+      *) \
+        for am__flg in $$MAKEFLAGS; do \
+          case $$am__flg in \
+            *=*|--*) ;; \
+            *n*) am__dry=yes; break;; \
+          esac; \
+        done;; \
+    esac; \
+    test $$am__dry = yes; \
+  }
 pkgdatadir = $(datadir)/@PACKAGE@
 pkgincludedir = $(includedir)/@PACKAGE@
 pkglibdir = $(libdir)/@PACKAGE@
@@ -35,11 +52,12 @@
 build_triplet = @build@
 host_triplet = @host@
 target_triplet = @target@
+@BUILD_JNI_INTERFACE_TRUE@am__append_1 = liblttng-ust-java
 subdir = .
 DIST_COMMON = README $(am__configure_deps) $(dist_doc_DATA) \
-	$(srcdir)/Makefile.am $(srcdir)/Makefile.in \
-	$(srcdir)/config.h.in $(srcdir)/lttng-ust.pc.in \
-	$(top_srcdir)/configure \
+	$(dist_noinst_DATA) $(srcdir)/Makefile.am \
+	$(srcdir)/Makefile.in $(srcdir)/config.h.in \
+	$(srcdir)/lttng-ust.pc.in $(top_srcdir)/configure \
 	$(top_srcdir)/include/lttng/ust-config.h.in \
 	$(top_srcdir)/include/lttng/ust-version.h.in COPYING ChangeLog \
 	TODO config/compile config/config.guess config/config.sub \
@@ -74,6 +92,11 @@
 	install-pdf-recursive install-ps-recursive install-recursive \
 	installcheck-recursive installdirs-recursive pdf-recursive \
 	ps-recursive uninstall-recursive
+am__can_run_installinfo = \
+  case $$AM_UPDATE_INFO_DIR in \
+    n|no|NO) false;; \
+    *) (install-info --version) >/dev/null 2>&1;; \
+  esac
 am__vpath_adj_setup = srcdirstrip=`echo "$(srcdir)" | sed 's|.|.|g'`;
 am__vpath_adj = case $$p in \
     $(srcdir)/*) f=`echo "$$p" | sed "s|^$$srcdirstrip/||"`;; \
@@ -102,7 +125,7 @@
          $(am__cd) "$$dir" && rm -f $$files; }; \
   }
 am__installdirs = "$(DESTDIR)$(docdir)" "$(DESTDIR)$(pkgconfigdir)"
-DATA = $(dist_doc_DATA) $(pkgconfig_DATA)
+DATA = $(dist_doc_DATA) $(dist_noinst_DATA) $(pkgconfig_DATA)
 RECURSIVE_CLEAN_TARGETS = mostlyclean-recursive clean-recursive	\
   distclean-recursive maintainer-clean-recursive
 AM_RECURSIVE_TARGETS = $(RECURSIVE_TARGETS:-recursive=) \
@@ -110,7 +133,9 @@
 	distdir dist dist-all distcheck
 ETAGS = etags
 CTAGS = ctags
-DIST_SUBDIRS = $(SUBDIRS)
+DIST_SUBDIRS = . include snprintf libringbuffer liblttng-ust-comm \
+	liblttng-ust liblttng-ust-ctl liblttng-ust-fork \
+	liblttng-ust-libc-wrapper tools tests doc liblttng-ust-java
 DISTFILES = $(DIST_COMMON) $(DIST_SOURCES) $(TEXINFOS) $(EXTRA_DIST)
 distdir = $(PACKAGE)-$(VERSION)
 top_distdir = $(distdir)
@@ -221,7 +246,6 @@
 SET_MAKE = @SET_MAKE@
 SHELL = @SHELL@
 STRIP = @STRIP@
-TEXINFO = @TEXINFO@
 VERSION = @VERSION@
 abs_builddir = @abs_builddir@
 abs_srcdir = @abs_srcdir@
@@ -282,25 +306,15 @@
 top_srcdir = @top_srcdir@
 ACLOCAL_AMFLAGS = -I config
 SUBDIRS = . include snprintf libringbuffer liblttng-ust-comm \
-		liblttng-ust \
-		liblttng-ust-ctl \
-		liblttng-ust-fork \
-		liblttng-ust-libc-wrapper \
-		tools \
-		tests \
-		doc
-
-
-#disabled for 2.0
-#if BUILD_JNI_INTERFACE
-#SUBDIRS += liblttng-ust-java
-#endif
+	liblttng-ust liblttng-ust-ctl liblttng-ust-fork \
+	liblttng-ust-libc-wrapper tools tests doc $(am__append_1)
 
 #temporarily disabled
 # liblttng-ust-malloc
 pkgconfigdir = $(libdir)/pkgconfig
 pkgconfig_DATA = lttng-ust.pc
 dist_doc_DATA = README ChangeLog
+dist_noinst_DATA = CodingStyle
 all: config.h
 	$(MAKE) $(AM_MAKEFLAGS) all-recursive
 
@@ -377,8 +391,11 @@
 	-rm -f libtool config.lt
 install-dist_docDATA: $(dist_doc_DATA)
 	@$(NORMAL_INSTALL)
-	test -z "$(docdir)" || $(MKDIR_P) "$(DESTDIR)$(docdir)"
 	@list='$(dist_doc_DATA)'; test -n "$(docdir)" || list=; \
+	if test -n "$$list"; then \
+	  echo " $(MKDIR_P) '$(DESTDIR)$(docdir)'"; \
+	  $(MKDIR_P) "$(DESTDIR)$(docdir)" || exit 1; \
+	fi; \
 	for p in $$list; do \
 	  if test -f "$$p"; then d=; else d="$(srcdir)/"; fi; \
 	  echo "$$d$$p"; \
@@ -395,8 +412,11 @@
 	dir='$(DESTDIR)$(docdir)'; $(am__uninstall_files_from_dir)
 install-pkgconfigDATA: $(pkgconfig_DATA)
 	@$(NORMAL_INSTALL)
-	test -z "$(pkgconfigdir)" || $(MKDIR_P) "$(DESTDIR)$(pkgconfigdir)"
 	@list='$(pkgconfig_DATA)'; test -n "$(pkgconfigdir)" || list=; \
+	if test -n "$$list"; then \
+	  echo " $(MKDIR_P) '$(DESTDIR)$(pkgconfigdir)'"; \
+	  $(MKDIR_P) "$(DESTDIR)$(pkgconfigdir)" || exit 1; \
+	fi; \
 	for p in $$list; do \
 	  if test -f "$$p"; then d=; else d="$(srcdir)/"; fi; \
 	  echo "$$d$$p"; \
@@ -581,13 +601,10 @@
 	done
 	@list='$(DIST_SUBDIRS)'; for subdir in $$list; do \
 	  if test "$$subdir" = .; then :; else \
-	    test -d "$(distdir)/$$subdir" \
-	    || $(MKDIR_P) "$(distdir)/$$subdir" \
-	    || exit 1; \
-	  fi; \
-	done
-	@list='$(DIST_SUBDIRS)'; for subdir in $$list; do \
-	  if test "$$subdir" = .; then :; else \
+	    $(am__make_dryrun) \
+	      || test -d "$(distdir)/$$subdir" \
+	      || $(MKDIR_P) "$(distdir)/$$subdir" \
+	      || exit 1; \
 	    dir1=$$subdir; dir2="$(distdir)/$$subdir"; \
 	    $(am__relativize); \
 	    new_distdir=$$reldir; \
@@ -672,7 +689,7 @@
 	*.zip*) \
 	  unzip $(distdir).zip ;;\
 	esac
-	chmod -R a-w $(distdir); chmod a+w $(distdir)
+	chmod -R a-w $(distdir); chmod u+w $(distdir)
 	mkdir $(distdir)/_build
 	mkdir $(distdir)/_inst
 	chmod a-w $(distdir)

=== modified file 'README'
--- README	2012-06-29 16:47:49 +0000
+++ README	2012-09-11 15:34:43 +0000
@@ -16,7 +16,7 @@
   - liburcu
     Userspace RCU library, by Mathieu Desnoyers and Paul E. McKenney
 
-    -> This release depends on liburcu v0.6.6
+    -> This release depends on liburcu v0.7.2
 
       * Debian/Ubuntu package: liburcu-dev
       * Website:  http://lttng.org/urcu
@@ -67,7 +67,7 @@
       "TRACEPOINT_DEFINE" and include the tracepoint provider.
     - Use "-I." for the compilation unit containing the tracepoint
       provider include (e.g. tp.c).
-    - Link application with "-ldl".
+    - Link application with "-ldl" on Linux, with "-lc" on BSD.
     - If building the provider directly into the application,
       link the application with "-llttng-ust".
     - If building a static library for the provider, link the static
@@ -75,7 +75,7 @@
     - Include the tracepoint provider header into all C files using
       the provider.
     - Example:
-        tests/hello/  hello.c tp.c ust_tests_hello.h Makefile.example
+        tests/hello/  hello.c tp.c ust_tests_hello.h Makefile.example.*
 
   2) Compile the Tracepoint Provider separately from the application,
      using dynamic linking:
@@ -87,7 +87,7 @@
       files that use the provider.
     - Compile the tracepoint provider with "-I.".
     - Link the tracepoint provider with "-llttng-ust".
-    - Link application with "-ldl".
+    - Link application with "-ldl" on Linux, "-lc" on BSD.
     - Set a LD_PRELOAD environment to preload the tracepoint provider
       shared object before starting the application when tracing is
       needed. Another way is to dlopen the tracepoint probe when needed

=== modified file 'aclocal.m4'
--- aclocal.m4	2012-06-29 16:47:49 +0000
+++ aclocal.m4	2012-09-11 15:34:43 +0000
@@ -1,4 +1,4 @@
-# generated automatically by aclocal 1.11.3 -*- Autoconf -*-
+# generated automatically by aclocal 1.11.6 -*- Autoconf -*-
 
 # Copyright (C) 1996, 1997, 1998, 1999, 2000, 2001, 2002, 2003, 2004,
 # 2005, 2006, 2007, 2008, 2009, 2010, 2011 Free Software Foundation,
@@ -14,8 +14,8 @@
 
 m4_ifndef([AC_AUTOCONF_VERSION],
   [m4_copy([m4_PACKAGE_VERSION], [AC_AUTOCONF_VERSION])])dnl
-m4_if(m4_defn([AC_AUTOCONF_VERSION]), [2.68],,
-[m4_warning([this file was generated for autoconf 2.68.
+m4_if(m4_defn([AC_AUTOCONF_VERSION]), [2.69],,
+[m4_warning([this file was generated for autoconf 2.69.
 You have another version of autoconf.  It may work, but is not guaranteed to.
 If you have problems, you may need to regenerate the build system entirely.
 To do so, use the procedure documented by the package, typically `autoreconf'.])])
@@ -38,7 +38,7 @@
 [am__api_version='1.11'
 dnl Some users find AM_AUTOMAKE_VERSION and mistake it for a way to
 dnl require some minimum version.  Point them to the right macro.
-m4_if([$1], [1.11.3], [],
+m4_if([$1], [1.11.6], [],
       [AC_FATAL([Do not call $0, use AM_INIT_AUTOMAKE([$1]).])])dnl
 ])
 
@@ -54,7 +54,7 @@
 # Call AM_AUTOMAKE_VERSION and AM_AUTOMAKE_VERSION so they can be traced.
 # This function is AC_REQUIREd by AM_INIT_AUTOMAKE.
 AC_DEFUN([AM_SET_CURRENT_AUTOMAKE_VERSION],
-[AM_AUTOMAKE_VERSION([1.11.3])dnl
+[AM_AUTOMAKE_VERSION([1.11.6])dnl
 m4_ifndef([AC_AUTOCONF_VERSION],
   [m4_copy([m4_PACKAGE_VERSION], [AC_AUTOCONF_VERSION])])dnl
 _AM_AUTOCONF_VERSION(m4_defn([AC_AUTOCONF_VERSION]))])

=== modified file 'config.h.in'
--- config.h.in	2012-06-29 16:47:49 +0000
+++ config.h.in	2012-09-11 15:34:43 +0000
@@ -9,8 +9,8 @@
 /* Define to 1 if you have the <inttypes.h> header file. */
 #undef HAVE_INTTYPES_H
 
-/* Define to 1 if you have the `dl' library (-ldl). */
-#undef HAVE_LIBDL
+/* Define to 1 if you have the <jni.h> header file. */
+#undef HAVE_JNI_H
 
 /* Define to 1 if you have the `pthread' library (-lpthread). */
 #undef HAVE_LIBPTHREAD
@@ -18,8 +18,8 @@
 /* Define to 1 if you have the `urcu-bp' library (-lurcu-bp). */
 #undef HAVE_LIBURCU_BP
 
-/* Define to 1 if you have the `uuid' library (-luuid). */
-#undef HAVE_LIBUUID
+/* Define to 1 if you have the `urcu-cds' library (-lurcu-cds). */
+#undef HAVE_LIBURCU_CDS
 
 /* Define to 1 if your system has a GNU libc compatible `malloc' function, and
    to 0 otherwise. */
@@ -73,6 +73,12 @@
 /* Use efficient unaligned access. */
 #undef LTTNG_UST_HAVE_EFFICIENT_UNALIGNED_ACCESS
 
+/* Has libc uuid support. */
+#undef LTTNG_UST_HAVE_LIBC_UUID
+
+/* Has libuuid support. */
+#undef LTTNG_UST_HAVE_LIBUUID
+
 /* SystemTap integration via sdt.h */
 #undef LTTNG_UST_HAVE_SDT_INTEGRATION
 

=== modified file 'config/libtool.m4'
--- config/libtool.m4	2012-06-29 16:47:49 +0000
+++ config/libtool.m4	2012-09-11 15:34:43 +0000
@@ -4591,7 +4591,7 @@
     esac
     ;;
   linux* | k*bsd*-gnu | gnu*)
-    _LT_TAGVAR(link_all_deplibs, $1)=no
+    _LT_TAGVAR(link_all_deplibs, $1)=unknown
     ;;
   *)
     _LT_TAGVAR(export_symbols_cmds, $1)='$NM $libobjs $convenience | $global_symbol_pipe | $SED '\''s/.* //'\'' | sort | uniq > $export_symbols'
@@ -4656,7 +4656,7 @@
     with_gnu_ld=no
     ;;
   linux* | k*bsd*-gnu | gnu*)
-    _LT_TAGVAR(link_all_deplibs, $1)=no
+    _LT_TAGVAR(link_all_deplibs, $1)=unknown
     ;;
   esac
 
@@ -5056,7 +5056,7 @@
 	if test "$aix_use_runtimelinking" = yes; then
 	  shared_flag="$shared_flag "'${wl}-G'
 	fi
-	_LT_TAGVAR(link_all_deplibs, $1)=no
+	_LT_TAGVAR(link_all_deplibs, $1)=unknown
       else
 	# not using gcc
 	if test "$host_cpu" = ia64; then

=== modified file 'configure'
--- configure	2012-06-29 16:47:49 +0000
+++ configure	2012-09-11 15:34:43 +0000
@@ -1,13 +1,11 @@
 #! /bin/sh
 # Guess values for system-dependent variables and create Makefiles.
-# Generated by GNU Autoconf 2.68 for lttng-ust 2.0.4.
+# Generated by GNU Autoconf 2.69 for lttng-ust 2.1.0-rc1.
 #
 # Report bugs to <mathieu dot desnoyers at efficios dot com>.
 #
 #
-# Copyright (C) 1992, 1993, 1994, 1995, 1996, 1998, 1999, 2000, 2001,
-# 2002, 2003, 2004, 2005, 2006, 2007, 2008, 2009, 2010 Free Software
-# Foundation, Inc.
+# Copyright (C) 1992-1996, 1998-2012 Free Software Foundation, Inc.
 #
 #
 # This configure script is free software; the Free Software Foundation
@@ -136,6 +134,31 @@
 # CDPATH.
 (unset CDPATH) >/dev/null 2>&1 && unset CDPATH
 
+# Use a proper internal environment variable to ensure we don't fall
+  # into an infinite loop, continuously re-executing ourselves.
+  if test x"${_as_can_reexec}" != xno && test "x$CONFIG_SHELL" != x; then
+    _as_can_reexec=no; export _as_can_reexec;
+    # We cannot yet assume a decent shell, so we have to provide a
+# neutralization value for shells without unset; and this also
+# works around shells that cannot unset nonexistent variables.
+# Preserve -v and -x to the replacement shell.
+BASH_ENV=/dev/null
+ENV=/dev/null
+(unset BASH_ENV) >/dev/null 2>&1 && unset BASH_ENV ENV
+case $- in # ((((
+  *v*x* | *x*v* ) as_opts=-vx ;;
+  *v* ) as_opts=-v ;;
+  *x* ) as_opts=-x ;;
+  * ) as_opts= ;;
+esac
+exec $CONFIG_SHELL $as_opts "$as_myself" ${1+"$@"}
+# Admittedly, this is quite paranoid, since all the known shells bail
+# out after a failed `exec'.
+$as_echo "$0: could not re-execute with $CONFIG_SHELL" >&2
+as_fn_exit 255
+  fi
+  # We don't want this to propagate to other subprocesses.
+          { _as_can_reexec=; unset _as_can_reexec;}
 if test "x$CONFIG_SHELL" = x; then
   as_bourne_compatible="if test -n \"\${ZSH_VERSION+set}\" && (emulate sh) >/dev/null 2>&1; then :
   emulate sh
@@ -169,7 +192,8 @@
 else
   exitcode=1; echo positional parameters were not saved.
 fi
-test x\$exitcode = x0 || exit 1"
+test x\$exitcode = x0 || exit 1
+test -x / || exit 1"
   as_suggested="  as_lineno_1=";as_suggested=$as_suggested$LINENO;as_suggested=$as_suggested" as_lineno_1a=\$LINENO
   as_lineno_2=";as_suggested=$as_suggested$LINENO;as_suggested=$as_suggested" as_lineno_2a=\$LINENO
   eval 'test \"x\$as_lineno_1'\$as_run'\" != \"x\$as_lineno_2'\$as_run'\" &&
@@ -222,21 +246,25 @@
 
 
       if test "x$CONFIG_SHELL" != x; then :
-  # We cannot yet assume a decent shell, so we have to provide a
-	# neutralization value for shells without unset; and this also
-	# works around shells that cannot unset nonexistent variables.
-	# Preserve -v and -x to the replacement shell.
-	BASH_ENV=/dev/null
-	ENV=/dev/null
-	(unset BASH_ENV) >/dev/null 2>&1 && unset BASH_ENV ENV
-	export CONFIG_SHELL
-	case $- in # ((((
-	  *v*x* | *x*v* ) as_opts=-vx ;;
-	  *v* ) as_opts=-v ;;
-	  *x* ) as_opts=-x ;;
-	  * ) as_opts= ;;
-	esac
-	exec "$CONFIG_SHELL" $as_opts "$as_myself" ${1+"$@"}
+  export CONFIG_SHELL
+             # We cannot yet assume a decent shell, so we have to provide a
+# neutralization value for shells without unset; and this also
+# works around shells that cannot unset nonexistent variables.
+# Preserve -v and -x to the replacement shell.
+BASH_ENV=/dev/null
+ENV=/dev/null
+(unset BASH_ENV) >/dev/null 2>&1 && unset BASH_ENV ENV
+case $- in # ((((
+  *v*x* | *x*v* ) as_opts=-vx ;;
+  *v* ) as_opts=-v ;;
+  *x* ) as_opts=-x ;;
+  * ) as_opts= ;;
+esac
+exec $CONFIG_SHELL $as_opts "$as_myself" ${1+"$@"}
+# Admittedly, this is quite paranoid, since all the known shells bail
+# out after a failed `exec'.
+$as_echo "$0: could not re-execute with $CONFIG_SHELL" >&2
+exit 255
 fi
 
     if test x$as_have_required = xno; then :
@@ -339,6 +367,14 @@
 
 
 } # as_fn_mkdir_p
+
+# as_fn_executable_p FILE
+# -----------------------
+# Test if FILE is an executable regular file.
+as_fn_executable_p ()
+{
+  test -f "$1" && test -x "$1"
+} # as_fn_executable_p
 # as_fn_append VAR VALUE
 # ----------------------
 # Append the text in VALUE to the end of the definition contained in VAR. Take
@@ -460,6 +496,10 @@
   chmod +x "$as_me.lineno" ||
     { $as_echo "$as_me: error: cannot create $as_me.lineno; rerun with a POSIX shell" >&2; as_fn_exit 1; }
 
+  # If we had to re-execute with $CONFIG_SHELL, we're ensured to have
+  # already done that, so ensure we don't try to do so again and fall
+  # in an infinite loop.  This has already happened in practice.
+  _as_can_reexec=no; export _as_can_reexec
   # Don't try to exec as it changes $[0], causing all sort of problems
   # (the dirname of $[0] is not the place where we might find the
   # original and so on.  Autoconf is especially sensitive to this).
@@ -494,16 +534,16 @@
     # ... but there are two gotchas:
     # 1) On MSYS, both `ln -s file dir' and `ln file dir' fail.
     # 2) DJGPP < 2.04 has no symlinks; `ln -s' creates a wrapper executable.
-    # In both cases, we have to default to `cp -p'.
+    # In both cases, we have to default to `cp -pR'.
     ln -s conf$$.file conf$$.dir 2>/dev/null && test ! -f conf$$.exe ||
-      as_ln_s='cp -p'
+      as_ln_s='cp -pR'
   elif ln conf$$.file conf$$ 2>/dev/null; then
     as_ln_s=ln
   else
-    as_ln_s='cp -p'
+    as_ln_s='cp -pR'
   fi
 else
-  as_ln_s='cp -p'
+  as_ln_s='cp -pR'
 fi
 rm -f conf$$ conf$$.exe conf$$.dir/conf$$.file conf$$.file
 rmdir conf$$.dir 2>/dev/null
@@ -515,28 +555,8 @@
   as_mkdir_p=false
 fi
 
-if test -x / >/dev/null 2>&1; then
-  as_test_x='test -x'
-else
-  if ls -dL / >/dev/null 2>&1; then
-    as_ls_L_option=L
-  else
-    as_ls_L_option=
-  fi
-  as_test_x='
-    eval sh -c '\''
-      if test -d "$1"; then
-	test -d "$1/.";
-      else
-	case $1 in #(
-	-*)set "./$1";;
-	esac;
-	case `ls -ld'$as_ls_L_option' "$1" 2>/dev/null` in #((
-	???[sx]*):;;*)false;;esac;fi
-    '\'' sh
-  '
-fi
-as_executable_p=$as_test_x
+as_test_x='test -x'
+as_executable_p=as_fn_executable_p
 
 # Sed expression to map a string onto a valid CPP name.
 as_tr_cpp="eval sed 'y%*$as_cr_letters%P$as_cr_LETTERS%;s%[^_$as_cr_alnum]%_%g'"
@@ -570,8 +590,8 @@
 # Identity of this package.
 PACKAGE_NAME='lttng-ust'
 PACKAGE_TARNAME='lttng-ust'
-PACKAGE_VERSION='2.0.4'
-PACKAGE_STRING='lttng-ust 2.0.4'
+PACKAGE_VERSION='2.1.0-rc1'
+PACKAGE_STRING='lttng-ust 2.1.0-rc1'
 PACKAGE_BUGREPORT='mathieu dot desnoyers at efficios dot com'
 PACKAGE_URL=''
 
@@ -615,9 +635,18 @@
 ac_subst_vars='am__EXEEXT_FALSE
 am__EXEEXT_TRUE
 LTLIBOBJS
+BUILD_JNI_INTERFACE_FALSE
+BUILD_JNI_INTERFACE_TRUE
 LIBFORMAT
-TEXINFO
 LIBOBJS
+LTTNG_UST_BUILD_WITH_LIBC_UUID_FALSE
+LTTNG_UST_BUILD_WITH_LIBC_UUID_TRUE
+LTTNG_UST_BUILD_WITH_LIBUUID_FALSE
+LTTNG_UST_BUILD_WITH_LIBUUID_TRUE
+LTTNG_UST_BUILD_WITH_LIBC_DL_FALSE
+LTTNG_UST_BUILD_WITH_LIBC_DL_TRUE
+LTTNG_UST_BUILD_WITH_LIBDL_FALSE
+LTTNG_UST_BUILD_WITH_LIBDL_TRUE
 CXXCPP
 CPP
 OTOOL64
@@ -638,7 +667,6 @@
 LD
 FGREP
 EGREP
-GREP
 LIBTOOL
 am__fastdepCXX_FALSE
 am__fastdepCXX_TRUE
@@ -663,6 +691,7 @@
 LDFLAGS
 CFLAGS
 CC
+GREP
 PATCHLEVEL_VERSION
 MINOR_VERSION
 MAJOR_VERSION
@@ -749,6 +778,7 @@
 ac_user_opts='
 enable_option_checking
 enable_silent_rules
+enable_libtool_linkdep_fixup
 enable_dependency_tracking
 enable_shared
 enable_static
@@ -758,6 +788,7 @@
 with_sysroot
 enable_libtool_lock
 with_java_jdk
+with_jni_interface
 with_sdt
 '
       ac_precious_vars='build_alias
@@ -1228,8 +1259,6 @@
 if test "x$host_alias" != x; then
   if test "x$build_alias" = x; then
     cross_compiling=maybe
-    $as_echo "$as_me: WARNING: if you wanted to set the --build type, don't use --host.
-    If a cross compiler is detected then cross compile mode will be used" >&2
   elif test "x$build_alias" != "x$host_alias"; then
     cross_compiling=yes
   fi
@@ -1315,7 +1344,7 @@
   # Omit some internal or obsolete options to make the list less imposing.
   # This message is too long to be a string in the A/UX 3.1 sh.
   cat <<_ACEOF
-\`configure' configures lttng-ust 2.0.4 to adapt to many kinds of systems.
+\`configure' configures lttng-ust 2.1.0-rc1 to adapt to many kinds of systems.
 
 Usage: $0 [OPTION]... [VAR=VALUE]...
 
@@ -1386,7 +1415,7 @@
 
 if test -n "$ac_init_help"; then
   case $ac_init_help in
-     short | recursive ) echo "Configuration of lttng-ust 2.0.4:";;
+     short | recursive ) echo "Configuration of lttng-ust 2.1.0-rc1:";;
    esac
   cat <<\_ACEOF
 
@@ -1396,6 +1425,9 @@
   --enable-FEATURE[=ARG]  include FEATURE [ARG=yes]
   --enable-silent-rules          less verbose build output (undo: `make V=1')
   --disable-silent-rules         verbose build output (undo: `make V=0')
+  --disable-libtool-linkdep-fixup
+                          disable the libtool fixup for linking all dependent
+                          libraries (link_all_deplibs)
   --disable-dependency-tracking  speeds up one-time build
   --enable-dependency-tracking   do not reject slow dependency extractors
   --enable-shared[=PKGS]  build shared libraries [default=yes]
@@ -1413,6 +1445,8 @@
   --with-sysroot=DIR Search for dependent libraries within DIR
                         (or the compiler's sysroot if not specified).
   --with-java-jdk=DIR     use the Java JDK in DIR. Ex : $JAVA_HOME.
+  --with-jni-interface    build JNI interface between C and Java. Needs Java
+                          include files [default=no]
   --with-sdt              provide SystemTap integration via sdt.h [default=no]
 
 Some influential environment variables:
@@ -1494,10 +1528,10 @@
 test -n "$ac_init_help" && exit $ac_status
 if $ac_init_version; then
   cat <<\_ACEOF
-lttng-ust configure 2.0.4
-generated by GNU Autoconf 2.68
+lttng-ust configure 2.1.0-rc1
+generated by GNU Autoconf 2.69
 
-Copyright (C) 2010 Free Software Foundation, Inc.
+Copyright (C) 2012 Free Software Foundation, Inc.
 This configure script is free software; the Free Software Foundation
 gives unlimited permission to copy, distribute and modify it.
 _ACEOF
@@ -1611,7 +1645,7 @@
 	 test ! -s conftest.err
        } && test -s conftest$ac_exeext && {
 	 test "$cross_compiling" = yes ||
-	 $as_test_x conftest$ac_exeext
+	 test -x conftest$ac_exeext
        }; then :
   ac_retval=0
 else
@@ -1871,7 +1905,7 @@
 	 test ! -s conftest.err
        } && test -s conftest$ac_exeext && {
 	 test "$cross_compiling" = yes ||
-	 $as_test_x conftest$ac_exeext
+	 test -x conftest$ac_exeext
        }; then :
   ac_retval=0
 else
@@ -1984,8 +2018,8 @@
 This file contains any messages produced by compilers while
 running configure, to aid debugging if configure makes a mistake.
 
-It was created by lttng-ust $as_me 2.0.4, which was
-generated by GNU Autoconf 2.68.  Invocation command line was
+It was created by lttng-ust $as_me 2.1.0-rc1, which was
+generated by GNU Autoconf 2.69.  Invocation command line was
 
   $ $0 $@
 
@@ -2520,7 +2554,7 @@
     # by default.
     for ac_prog in ginstall scoinst install; do
       for ac_exec_ext in '' $ac_executable_extensions; do
-	if { test -f "$as_dir/$ac_prog$ac_exec_ext" && $as_test_x "$as_dir/$ac_prog$ac_exec_ext"; }; then
+	if as_fn_executable_p "$as_dir/$ac_prog$ac_exec_ext"; then
 	  if test $ac_prog = install &&
 	    grep dspmsg "$as_dir/$ac_prog$ac_exec_ext" >/dev/null 2>&1; then
 	    # AIX install.  It has an incompatible calling convention.
@@ -2689,7 +2723,7 @@
   IFS=$as_save_IFS
   test -z "$as_dir" && as_dir=.
     for ac_exec_ext in '' $ac_executable_extensions; do
-  if { test -f "$as_dir/$ac_word$ac_exec_ext" && $as_test_x "$as_dir/$ac_word$ac_exec_ext"; }; then
+  if as_fn_executable_p "$as_dir/$ac_word$ac_exec_ext"; then
     ac_cv_prog_STRIP="${ac_tool_prefix}strip"
     $as_echo "$as_me:${as_lineno-$LINENO}: found $as_dir/$ac_word$ac_exec_ext" >&5
     break 2
@@ -2729,7 +2763,7 @@
   IFS=$as_save_IFS
   test -z "$as_dir" && as_dir=.
     for ac_exec_ext in '' $ac_executable_extensions; do
-  if { test -f "$as_dir/$ac_word$ac_exec_ext" && $as_test_x "$as_dir/$ac_word$ac_exec_ext"; }; then
+  if as_fn_executable_p "$as_dir/$ac_word$ac_exec_ext"; then
     ac_cv_prog_ac_ct_STRIP="strip"
     $as_echo "$as_me:${as_lineno-$LINENO}: found $as_dir/$ac_word$ac_exec_ext" >&5
     break 2
@@ -2780,7 +2814,7 @@
   test -z "$as_dir" && as_dir=.
     for ac_prog in mkdir gmkdir; do
 	 for ac_exec_ext in '' $ac_executable_extensions; do
-	   { test -f "$as_dir/$ac_prog$ac_exec_ext" && $as_test_x "$as_dir/$ac_prog$ac_exec_ext"; } || continue
+	   as_fn_executable_p "$as_dir/$ac_prog$ac_exec_ext" || continue
 	   case `"$as_dir/$ac_prog$ac_exec_ext" --version 2>&1` in #(
 	     'mkdir (GNU coreutils) '* | \
 	     'mkdir (coreutils) '* | \
@@ -2833,7 +2867,7 @@
   IFS=$as_save_IFS
   test -z "$as_dir" && as_dir=.
     for ac_exec_ext in '' $ac_executable_extensions; do
-  if { test -f "$as_dir/$ac_word$ac_exec_ext" && $as_test_x "$as_dir/$ac_word$ac_exec_ext"; }; then
+  if as_fn_executable_p "$as_dir/$ac_word$ac_exec_ext"; then
     ac_cv_prog_AWK="$ac_prog"
     $as_echo "$as_me:${as_lineno-$LINENO}: found $as_dir/$ac_word$ac_exec_ext" >&5
     break 2
@@ -2919,7 +2953,7 @@
 
 # Define the identity of the package.
  PACKAGE='lttng-ust'
- VERSION='2.0.4'
+ VERSION='2.1.0-rc1'
 
 
 cat >>confdefs.h <<_ACEOF
@@ -3029,7 +3063,7 @@
     for ac_prog in sed gsed; do
     for ac_exec_ext in '' $ac_executable_extensions; do
       ac_path_SED="$as_dir/$ac_prog$ac_exec_ext"
-      { test -f "$ac_path_SED" && $as_test_x "$ac_path_SED"; } || continue
+      as_fn_executable_p "$ac_path_SED" || continue
 # Check for GNU ac_path_SED and select it if it is found.
   # Check for GNU $ac_path_SED
 case `"$ac_path_SED" --version 2>&1` in
@@ -3076,9 +3110,9 @@
  SED="$ac_cv_path_SED"
   rm -f conftest.sed
 
-major_version=$(echo 2.0.4 | sed 's/^\([0-9]\)*\.[0-9]*\.[0-9]*.*$/\1/')
-minor_version=$(echo 2.0.4 | sed 's/^[0-9]*\.\([0-9]*\)\.[0-9]*.*$/\1/')
-patchlevel_version=$(echo 2.0.4 | sed 's/^[0-9]*\.[0-9]*\.\([0-9]*\).*$/\1/')
+major_version=$(echo 2.1.0-rc1 | sed 's/^\([0-9]\)*\.[0-9]*\.[0-9]*.*$/\1/')
+minor_version=$(echo 2.1.0-rc1 | sed 's/^[0-9]*\.\([0-9]*\)\.[0-9]*.*$/\1/')
+patchlevel_version=$(echo 2.1.0-rc1 | sed 's/^[0-9]*\.[0-9]*\.\([0-9]*\).*$/\1/')
 MAJOR_VERSION=$major_version
 
 MINOR_VERSION=$minor_version
@@ -3101,18 +3135,114 @@
 _ACEOF
 
 
-version_name="Annedd'ale"
-version_description="New type of beer, 100% from Quebec, flavored with sapin beaumier needles, with a touch of hops."
-
-cat >>confdefs.h <<_ACEOF
-#define VERSION_NAME $version_name
-_ACEOF
-
-
-cat >>confdefs.h <<_ACEOF
-#define VERSION_DESCRIPTION $version_description
-_ACEOF
-
+version_name="Basse Messe"
+version_description="Light coloured German ale whose style was named after the city Cologne (Koln) where it was first brewed. It is a rather simple beer with lightly fruity aromas and a delicate hoppy fragrance. The beer has a pronounced malty taste with a subtle bitter aftertaste"
+
+cat >>confdefs.h <<_ACEOF
+#define VERSION_NAME "$version_name"
+_ACEOF
+
+
+cat >>confdefs.h <<_ACEOF
+#define VERSION_DESCRIPTION "$version_description"
+_ACEOF
+
+
+{ $as_echo "$as_me:${as_lineno-$LINENO}: checking for grep that handles long lines and -e" >&5
+$as_echo_n "checking for grep that handles long lines and -e... " >&6; }
+if ${ac_cv_path_GREP+:} false; then :
+  $as_echo_n "(cached) " >&6
+else
+  if test -z "$GREP"; then
+  ac_path_GREP_found=false
+  # Loop through the user's path and test for each of PROGNAME-LIST
+  as_save_IFS=$IFS; IFS=$PATH_SEPARATOR
+for as_dir in $PATH$PATH_SEPARATOR/usr/xpg4/bin
+do
+  IFS=$as_save_IFS
+  test -z "$as_dir" && as_dir=.
+    for ac_prog in grep ggrep; do
+    for ac_exec_ext in '' $ac_executable_extensions; do
+      ac_path_GREP="$as_dir/$ac_prog$ac_exec_ext"
+      as_fn_executable_p "$ac_path_GREP" || continue
+# Check for GNU ac_path_GREP and select it if it is found.
+  # Check for GNU $ac_path_GREP
+case `"$ac_path_GREP" --version 2>&1` in
+*GNU*)
+  ac_cv_path_GREP="$ac_path_GREP" ac_path_GREP_found=:;;
+*)
+  ac_count=0
+  $as_echo_n 0123456789 >"conftest.in"
+  while :
+  do
+    cat "conftest.in" "conftest.in" >"conftest.tmp"
+    mv "conftest.tmp" "conftest.in"
+    cp "conftest.in" "conftest.nl"
+    $as_echo 'GREP' >> "conftest.nl"
+    "$ac_path_GREP" -e 'GREP$' -e '-(cannot match)-' < "conftest.nl" >"conftest.out" 2>/dev/null || break
+    diff "conftest.out" "conftest.nl" >/dev/null 2>&1 || break
+    as_fn_arith $ac_count + 1 && ac_count=$as_val
+    if test $ac_count -gt ${ac_path_GREP_max-0}; then
+      # Best one so far, save it but keep looking for a better one
+      ac_cv_path_GREP="$ac_path_GREP"
+      ac_path_GREP_max=$ac_count
+    fi
+    # 10*(2^10) chars as input seems more than enough
+    test $ac_count -gt 10 && break
+  done
+  rm -f conftest.in conftest.tmp conftest.nl conftest.out;;
+esac
+
+      $ac_path_GREP_found && break 3
+    done
+  done
+  done
+IFS=$as_save_IFS
+  if test -z "$ac_cv_path_GREP"; then
+    as_fn_error $? "no acceptable grep could be found in $PATH$PATH_SEPARATOR/usr/xpg4/bin" "$LINENO" 5
+  fi
+else
+  ac_cv_path_GREP=$GREP
+fi
+
+fi
+{ $as_echo "$as_me:${as_lineno-$LINENO}: result: $ac_cv_path_GREP" >&5
+$as_echo "$ac_cv_path_GREP" >&6; }
+ GREP="$ac_cv_path_GREP"
+
+
+# libtool link_all_deplibs fixup. See http://bugs.lttng.org/issues/321.
+# Check whether --enable-libtool-linkdep-fixup was given.
+if test "${enable_libtool_linkdep_fixup+set}" = set; then :
+  enableval=$enable_libtool_linkdep_fixup; libtool_fixup=$enableval
+else
+  libtool_fixup=yes
+fi
+
+
+if test "x$libtool_fixup" = "xyes"; then :
+
+	    libtool_m4="$srcdir/config/libtool.m4"
+	    libtool_flag_pattern=".*link_all_deplibs\s*,\s*\$1\s*)"
+	    { $as_echo "$as_me:${as_lineno-$LINENO}: checking for occurence(s) of link_all_deplibs = no in $libtool_m4" >&5
+$as_echo_n "checking for occurence(s) of link_all_deplibs = no in $libtool_m4... " >&6; }
+	    libtool_flag_pattern_count=$(grep -c "$libtool_flag_pattern\s*=\s*no" $libtool_m4)
+	    if test $libtool_flag_pattern_count -ne 0; then :
+
+		  { $as_echo "$as_me:${as_lineno-$LINENO}: result: $libtool_flag_pattern_count" >&5
+$as_echo "$libtool_flag_pattern_count" >&6; }
+		  { $as_echo "$as_me:${as_lineno-$LINENO}: WARNING: the detected libtool will not link all dependencies, forcing link_all_deplibs = unknown" >&5
+$as_echo "$as_me: WARNING: the detected libtool will not link all dependencies, forcing link_all_deplibs = unknown" >&2;}
+		  sed -i "s/\($libtool_flag_pattern\)\s*=\s*no/\1=unknown/g" $libtool_m4
+
+else
+
+		  { $as_echo "$as_me:${as_lineno-$LINENO}: result: none" >&5
+$as_echo "none" >&6; }
+
+fi
+
+fi
 
 # Checks for programs.
 ac_ext=c
@@ -3137,7 +3267,7 @@
   IFS=$as_save_IFS
   test -z "$as_dir" && as_dir=.
     for ac_exec_ext in '' $ac_executable_extensions; do
-  if { test -f "$as_dir/$ac_word$ac_exec_ext" && $as_test_x "$as_dir/$ac_word$ac_exec_ext"; }; then
+  if as_fn_executable_p "$as_dir/$ac_word$ac_exec_ext"; then
     ac_cv_prog_CC="${ac_tool_prefix}gcc"
     $as_echo "$as_me:${as_lineno-$LINENO}: found $as_dir/$ac_word$ac_exec_ext" >&5
     break 2
@@ -3177,7 +3307,7 @@
   IFS=$as_save_IFS
   test -z "$as_dir" && as_dir=.
     for ac_exec_ext in '' $ac_executable_extensions; do
-  if { test -f "$as_dir/$ac_word$ac_exec_ext" && $as_test_x "$as_dir/$ac_word$ac_exec_ext"; }; then
+  if as_fn_executable_p "$as_dir/$ac_word$ac_exec_ext"; then
     ac_cv_prog_ac_ct_CC="gcc"
     $as_echo "$as_me:${as_lineno-$LINENO}: found $as_dir/$ac_word$ac_exec_ext" >&5
     break 2
@@ -3230,7 +3360,7 @@
   IFS=$as_save_IFS
   test -z "$as_dir" && as_dir=.
     for ac_exec_ext in '' $ac_executable_extensions; do
-  if { test -f "$as_dir/$ac_word$ac_exec_ext" && $as_test_x "$as_dir/$ac_word$ac_exec_ext"; }; then
+  if as_fn_executable_p "$as_dir/$ac_word$ac_exec_ext"; then
     ac_cv_prog_CC="${ac_tool_prefix}cc"
     $as_echo "$as_me:${as_lineno-$LINENO}: found $as_dir/$ac_word$ac_exec_ext" >&5
     break 2
@@ -3271,7 +3401,7 @@
   IFS=$as_save_IFS
   test -z "$as_dir" && as_dir=.
     for ac_exec_ext in '' $ac_executable_extensions; do
-  if { test -f "$as_dir/$ac_word$ac_exec_ext" && $as_test_x "$as_dir/$ac_word$ac_exec_ext"; }; then
+  if as_fn_executable_p "$as_dir/$ac_word$ac_exec_ext"; then
     if test "$as_dir/$ac_word$ac_exec_ext" = "/usr/ucb/cc"; then
        ac_prog_rejected=yes
        continue
@@ -3329,7 +3459,7 @@
   IFS=$as_save_IFS
   test -z "$as_dir" && as_dir=.
     for ac_exec_ext in '' $ac_executable_extensions; do
-  if { test -f "$as_dir/$ac_word$ac_exec_ext" && $as_test_x "$as_dir/$ac_word$ac_exec_ext"; }; then
+  if as_fn_executable_p "$as_dir/$ac_word$ac_exec_ext"; then
     ac_cv_prog_CC="$ac_tool_prefix$ac_prog"
     $as_echo "$as_me:${as_lineno-$LINENO}: found $as_dir/$ac_word$ac_exec_ext" >&5
     break 2
@@ -3373,7 +3503,7 @@
   IFS=$as_save_IFS
   test -z "$as_dir" && as_dir=.
     for ac_exec_ext in '' $ac_executable_extensions; do
-  if { test -f "$as_dir/$ac_word$ac_exec_ext" && $as_test_x "$as_dir/$ac_word$ac_exec_ext"; }; then
+  if as_fn_executable_p "$as_dir/$ac_word$ac_exec_ext"; then
     ac_cv_prog_ac_ct_CC="$ac_prog"
     $as_echo "$as_me:${as_lineno-$LINENO}: found $as_dir/$ac_word$ac_exec_ext" >&5
     break 2
@@ -3819,8 +3949,7 @@
 /* end confdefs.h.  */
 #include <stdarg.h>
 #include <stdio.h>
-#include <sys/types.h>
-#include <sys/stat.h>
+struct stat;
 /* Most of the following tests are stolen from RCS 5.7's src/conf.sh.  */
 struct buf { int x; };
 FILE * (*rcsopen) (struct buf *, struct stat *, int);
@@ -4124,7 +4253,7 @@
   IFS=$as_save_IFS
   test -z "$as_dir" && as_dir=.
     for ac_exec_ext in '' $ac_executable_extensions; do
-  if { test -f "$as_dir/$ac_word$ac_exec_ext" && $as_test_x "$as_dir/$ac_word$ac_exec_ext"; }; then
+  if as_fn_executable_p "$as_dir/$ac_word$ac_exec_ext"; then
     ac_cv_prog_CXX="$ac_tool_prefix$ac_prog"
     $as_echo "$as_me:${as_lineno-$LINENO}: found $as_dir/$ac_word$ac_exec_ext" >&5
     break 2
@@ -4168,7 +4297,7 @@
   IFS=$as_save_IFS
   test -z "$as_dir" && as_dir=.
     for ac_exec_ext in '' $ac_executable_extensions; do
-  if { test -f "$as_dir/$ac_word$ac_exec_ext" && $as_test_x "$as_dir/$ac_word$ac_exec_ext"; }; then
+  if as_fn_executable_p "$as_dir/$ac_word$ac_exec_ext"; then
     ac_cv_prog_ac_ct_CXX="$ac_prog"
     $as_echo "$as_me:${as_lineno-$LINENO}: found $as_dir/$ac_word$ac_exec_ext" >&5
     break 2
@@ -4628,7 +4757,7 @@
     for ac_prog in sed gsed; do
     for ac_exec_ext in '' $ac_executable_extensions; do
       ac_path_SED="$as_dir/$ac_prog$ac_exec_ext"
-      { test -f "$ac_path_SED" && $as_test_x "$ac_path_SED"; } || continue
+      as_fn_executable_p "$ac_path_SED" || continue
 # Check for GNU ac_path_SED and select it if it is found.
   # Check for GNU $ac_path_SED
 case `"$ac_path_SED" --version 2>&1` in
@@ -4688,69 +4817,6 @@
 
 
 
-{ $as_echo "$as_me:${as_lineno-$LINENO}: checking for grep that handles long lines and -e" >&5
-$as_echo_n "checking for grep that handles long lines and -e... " >&6; }
-if ${ac_cv_path_GREP+:} false; then :
-  $as_echo_n "(cached) " >&6
-else
-  if test -z "$GREP"; then
-  ac_path_GREP_found=false
-  # Loop through the user's path and test for each of PROGNAME-LIST
-  as_save_IFS=$IFS; IFS=$PATH_SEPARATOR
-for as_dir in $PATH$PATH_SEPARATOR/usr/xpg4/bin
-do
-  IFS=$as_save_IFS
-  test -z "$as_dir" && as_dir=.
-    for ac_prog in grep ggrep; do
-    for ac_exec_ext in '' $ac_executable_extensions; do
-      ac_path_GREP="$as_dir/$ac_prog$ac_exec_ext"
-      { test -f "$ac_path_GREP" && $as_test_x "$ac_path_GREP"; } || continue
-# Check for GNU ac_path_GREP and select it if it is found.
-  # Check for GNU $ac_path_GREP
-case `"$ac_path_GREP" --version 2>&1` in
-*GNU*)
-  ac_cv_path_GREP="$ac_path_GREP" ac_path_GREP_found=:;;
-*)
-  ac_count=0
-  $as_echo_n 0123456789 >"conftest.in"
-  while :
-  do
-    cat "conftest.in" "conftest.in" >"conftest.tmp"
-    mv "conftest.tmp" "conftest.in"
-    cp "conftest.in" "conftest.nl"
-    $as_echo 'GREP' >> "conftest.nl"
-    "$ac_path_GREP" -e 'GREP$' -e '-(cannot match)-' < "conftest.nl" >"conftest.out" 2>/dev/null || break
-    diff "conftest.out" "conftest.nl" >/dev/null 2>&1 || break
-    as_fn_arith $ac_count + 1 && ac_count=$as_val
-    if test $ac_count -gt ${ac_path_GREP_max-0}; then
-      # Best one so far, save it but keep looking for a better one
-      ac_cv_path_GREP="$ac_path_GREP"
-      ac_path_GREP_max=$ac_count
-    fi
-    # 10*(2^10) chars as input seems more than enough
-    test $ac_count -gt 10 && break
-  done
-  rm -f conftest.in conftest.tmp conftest.nl conftest.out;;
-esac
-
-      $ac_path_GREP_found && break 3
-    done
-  done
-  done
-IFS=$as_save_IFS
-  if test -z "$ac_cv_path_GREP"; then
-    as_fn_error $? "no acceptable grep could be found in $PATH$PATH_SEPARATOR/usr/xpg4/bin" "$LINENO" 5
-  fi
-else
-  ac_cv_path_GREP=$GREP
-fi
-
-fi
-{ $as_echo "$as_me:${as_lineno-$LINENO}: result: $ac_cv_path_GREP" >&5
-$as_echo "$ac_cv_path_GREP" >&6; }
- GREP="$ac_cv_path_GREP"
-
-
 { $as_echo "$as_me:${as_lineno-$LINENO}: checking for egrep" >&5
 $as_echo_n "checking for egrep... " >&6; }
 if ${ac_cv_path_EGREP+:} false; then :
@@ -4770,7 +4836,7 @@
     for ac_prog in egrep; do
     for ac_exec_ext in '' $ac_executable_extensions; do
       ac_path_EGREP="$as_dir/$ac_prog$ac_exec_ext"
-      { test -f "$ac_path_EGREP" && $as_test_x "$ac_path_EGREP"; } || continue
+      as_fn_executable_p "$ac_path_EGREP" || continue
 # Check for GNU ac_path_EGREP and select it if it is found.
   # Check for GNU $ac_path_EGREP
 case `"$ac_path_EGREP" --version 2>&1` in
@@ -4837,7 +4903,7 @@
     for ac_prog in fgrep; do
     for ac_exec_ext in '' $ac_executable_extensions; do
       ac_path_FGREP="$as_dir/$ac_prog$ac_exec_ext"
-      { test -f "$ac_path_FGREP" && $as_test_x "$ac_path_FGREP"; } || continue
+      as_fn_executable_p "$ac_path_FGREP" || continue
 # Check for GNU ac_path_FGREP and select it if it is found.
   # Check for GNU $ac_path_FGREP
 case `"$ac_path_FGREP" --version 2>&1` in
@@ -5093,7 +5159,7 @@
   IFS=$as_save_IFS
   test -z "$as_dir" && as_dir=.
     for ac_exec_ext in '' $ac_executable_extensions; do
-  if { test -f "$as_dir/$ac_word$ac_exec_ext" && $as_test_x "$as_dir/$ac_word$ac_exec_ext"; }; then
+  if as_fn_executable_p "$as_dir/$ac_word$ac_exec_ext"; then
     ac_cv_prog_DUMPBIN="$ac_tool_prefix$ac_prog"
     $as_echo "$as_me:${as_lineno-$LINENO}: found $as_dir/$ac_word$ac_exec_ext" >&5
     break 2
@@ -5137,7 +5203,7 @@
   IFS=$as_save_IFS
   test -z "$as_dir" && as_dir=.
     for ac_exec_ext in '' $ac_executable_extensions; do
-  if { test -f "$as_dir/$ac_word$ac_exec_ext" && $as_test_x "$as_dir/$ac_word$ac_exec_ext"; }; then
+  if as_fn_executable_p "$as_dir/$ac_word$ac_exec_ext"; then
     ac_cv_prog_ac_ct_DUMPBIN="$ac_prog"
     $as_echo "$as_me:${as_lineno-$LINENO}: found $as_dir/$ac_word$ac_exec_ext" >&5
     break 2
@@ -5561,7 +5627,7 @@
   IFS=$as_save_IFS
   test -z "$as_dir" && as_dir=.
     for ac_exec_ext in '' $ac_executable_extensions; do
-  if { test -f "$as_dir/$ac_word$ac_exec_ext" && $as_test_x "$as_dir/$ac_word$ac_exec_ext"; }; then
+  if as_fn_executable_p "$as_dir/$ac_word$ac_exec_ext"; then
     ac_cv_prog_OBJDUMP="${ac_tool_prefix}objdump"
     $as_echo "$as_me:${as_lineno-$LINENO}: found $as_dir/$ac_word$ac_exec_ext" >&5
     break 2
@@ -5601,7 +5667,7 @@
   IFS=$as_save_IFS
   test -z "$as_dir" && as_dir=.
     for ac_exec_ext in '' $ac_executable_extensions; do
-  if { test -f "$as_dir/$ac_word$ac_exec_ext" && $as_test_x "$as_dir/$ac_word$ac_exec_ext"; }; then
+  if as_fn_executable_p "$as_dir/$ac_word$ac_exec_ext"; then
     ac_cv_prog_ac_ct_OBJDUMP="objdump"
     $as_echo "$as_me:${as_lineno-$LINENO}: found $as_dir/$ac_word$ac_exec_ext" >&5
     break 2
@@ -5907,7 +5973,7 @@
   IFS=$as_save_IFS
   test -z "$as_dir" && as_dir=.
     for ac_exec_ext in '' $ac_executable_extensions; do
-  if { test -f "$as_dir/$ac_word$ac_exec_ext" && $as_test_x "$as_dir/$ac_word$ac_exec_ext"; }; then
+  if as_fn_executable_p "$as_dir/$ac_word$ac_exec_ext"; then
     ac_cv_prog_DLLTOOL="${ac_tool_prefix}dlltool"
     $as_echo "$as_me:${as_lineno-$LINENO}: found $as_dir/$ac_word$ac_exec_ext" >&5
     break 2
@@ -5947,7 +6013,7 @@
   IFS=$as_save_IFS
   test -z "$as_dir" && as_dir=.
     for ac_exec_ext in '' $ac_executable_extensions; do
-  if { test -f "$as_dir/$ac_word$ac_exec_ext" && $as_test_x "$as_dir/$ac_word$ac_exec_ext"; }; then
+  if as_fn_executable_p "$as_dir/$ac_word$ac_exec_ext"; then
     ac_cv_prog_ac_ct_DLLTOOL="dlltool"
     $as_echo "$as_me:${as_lineno-$LINENO}: found $as_dir/$ac_word$ac_exec_ext" >&5
     break 2
@@ -6051,7 +6117,7 @@
   IFS=$as_save_IFS
   test -z "$as_dir" && as_dir=.
     for ac_exec_ext in '' $ac_executable_extensions; do
-  if { test -f "$as_dir/$ac_word$ac_exec_ext" && $as_test_x "$as_dir/$ac_word$ac_exec_ext"; }; then
+  if as_fn_executable_p "$as_dir/$ac_word$ac_exec_ext"; then
     ac_cv_prog_AR="$ac_tool_prefix$ac_prog"
     $as_echo "$as_me:${as_lineno-$LINENO}: found $as_dir/$ac_word$ac_exec_ext" >&5
     break 2
@@ -6095,7 +6161,7 @@
   IFS=$as_save_IFS
   test -z "$as_dir" && as_dir=.
     for ac_exec_ext in '' $ac_executable_extensions; do
-  if { test -f "$as_dir/$ac_word$ac_exec_ext" && $as_test_x "$as_dir/$ac_word$ac_exec_ext"; }; then
+  if as_fn_executable_p "$as_dir/$ac_word$ac_exec_ext"; then
     ac_cv_prog_ac_ct_AR="$ac_prog"
     $as_echo "$as_me:${as_lineno-$LINENO}: found $as_dir/$ac_word$ac_exec_ext" >&5
     break 2
@@ -6220,7 +6286,7 @@
   IFS=$as_save_IFS
   test -z "$as_dir" && as_dir=.
     for ac_exec_ext in '' $ac_executable_extensions; do
-  if { test -f "$as_dir/$ac_word$ac_exec_ext" && $as_test_x "$as_dir/$ac_word$ac_exec_ext"; }; then
+  if as_fn_executable_p "$as_dir/$ac_word$ac_exec_ext"; then
     ac_cv_prog_STRIP="${ac_tool_prefix}strip"
     $as_echo "$as_me:${as_lineno-$LINENO}: found $as_dir/$ac_word$ac_exec_ext" >&5
     break 2
@@ -6260,7 +6326,7 @@
   IFS=$as_save_IFS
   test -z "$as_dir" && as_dir=.
     for ac_exec_ext in '' $ac_executable_extensions; do
-  if { test -f "$as_dir/$ac_word$ac_exec_ext" && $as_test_x "$as_dir/$ac_word$ac_exec_ext"; }; then
+  if as_fn_executable_p "$as_dir/$ac_word$ac_exec_ext"; then
     ac_cv_prog_ac_ct_STRIP="strip"
     $as_echo "$as_me:${as_lineno-$LINENO}: found $as_dir/$ac_word$ac_exec_ext" >&5
     break 2
@@ -6319,7 +6385,7 @@
   IFS=$as_save_IFS
   test -z "$as_dir" && as_dir=.
     for ac_exec_ext in '' $ac_executable_extensions; do
-  if { test -f "$as_dir/$ac_word$ac_exec_ext" && $as_test_x "$as_dir/$ac_word$ac_exec_ext"; }; then
+  if as_fn_executable_p "$as_dir/$ac_word$ac_exec_ext"; then
     ac_cv_prog_RANLIB="${ac_tool_prefix}ranlib"
     $as_echo "$as_me:${as_lineno-$LINENO}: found $as_dir/$ac_word$ac_exec_ext" >&5
     break 2
@@ -6359,7 +6425,7 @@
   IFS=$as_save_IFS
   test -z "$as_dir" && as_dir=.
     for ac_exec_ext in '' $ac_executable_extensions; do
-  if { test -f "$as_dir/$ac_word$ac_exec_ext" && $as_test_x "$as_dir/$ac_word$ac_exec_ext"; }; then
+  if as_fn_executable_p "$as_dir/$ac_word$ac_exec_ext"; then
     ac_cv_prog_ac_ct_RANLIB="ranlib"
     $as_echo "$as_me:${as_lineno-$LINENO}: found $as_dir/$ac_word$ac_exec_ext" >&5
     break 2
@@ -7008,7 +7074,7 @@
   IFS=$as_save_IFS
   test -z "$as_dir" && as_dir=.
     for ac_exec_ext in '' $ac_executable_extensions; do
-  if { test -f "$as_dir/$ac_word$ac_exec_ext" && $as_test_x "$as_dir/$ac_word$ac_exec_ext"; }; then
+  if as_fn_executable_p "$as_dir/$ac_word$ac_exec_ext"; then
     ac_cv_prog_MANIFEST_TOOL="${ac_tool_prefix}mt"
     $as_echo "$as_me:${as_lineno-$LINENO}: found $as_dir/$ac_word$ac_exec_ext" >&5
     break 2
@@ -7048,7 +7114,7 @@
   IFS=$as_save_IFS
   test -z "$as_dir" && as_dir=.
     for ac_exec_ext in '' $ac_executable_extensions; do
-  if { test -f "$as_dir/$ac_word$ac_exec_ext" && $as_test_x "$as_dir/$ac_word$ac_exec_ext"; }; then
+  if as_fn_executable_p "$as_dir/$ac_word$ac_exec_ext"; then
     ac_cv_prog_ac_ct_MANIFEST_TOOL="mt"
     $as_echo "$as_me:${as_lineno-$LINENO}: found $as_dir/$ac_word$ac_exec_ext" >&5
     break 2
@@ -7128,7 +7194,7 @@
   IFS=$as_save_IFS
   test -z "$as_dir" && as_dir=.
     for ac_exec_ext in '' $ac_executable_extensions; do
-  if { test -f "$as_dir/$ac_word$ac_exec_ext" && $as_test_x "$as_dir/$ac_word$ac_exec_ext"; }; then
+  if as_fn_executable_p "$as_dir/$ac_word$ac_exec_ext"; then
     ac_cv_prog_DSYMUTIL="${ac_tool_prefix}dsymutil"
     $as_echo "$as_me:${as_lineno-$LINENO}: found $as_dir/$ac_word$ac_exec_ext" >&5
     break 2
@@ -7168,7 +7234,7 @@
   IFS=$as_save_IFS
   test -z "$as_dir" && as_dir=.
     for ac_exec_ext in '' $ac_executable_extensions; do
-  if { test -f "$as_dir/$ac_word$ac_exec_ext" && $as_test_x "$as_dir/$ac_word$ac_exec_ext"; }; then
+  if as_fn_executable_p "$as_dir/$ac_word$ac_exec_ext"; then
     ac_cv_prog_ac_ct_DSYMUTIL="dsymutil"
     $as_echo "$as_me:${as_lineno-$LINENO}: found $as_dir/$ac_word$ac_exec_ext" >&5
     break 2
@@ -7220,7 +7286,7 @@
   IFS=$as_save_IFS
   test -z "$as_dir" && as_dir=.
     for ac_exec_ext in '' $ac_executable_extensions; do
-  if { test -f "$as_dir/$ac_word$ac_exec_ext" && $as_test_x "$as_dir/$ac_word$ac_exec_ext"; }; then
+  if as_fn_executable_p "$as_dir/$ac_word$ac_exec_ext"; then
     ac_cv_prog_NMEDIT="${ac_tool_prefix}nmedit"
     $as_echo "$as_me:${as_lineno-$LINENO}: found $as_dir/$ac_word$ac_exec_ext" >&5
     break 2
@@ -7260,7 +7326,7 @@
   IFS=$as_save_IFS
   test -z "$as_dir" && as_dir=.
     for ac_exec_ext in '' $ac_executable_extensions; do
-  if { test -f "$as_dir/$ac_word$ac_exec_ext" && $as_test_x "$as_dir/$ac_word$ac_exec_ext"; }; then
+  if as_fn_executable_p "$as_dir/$ac_word$ac_exec_ext"; then
     ac_cv_prog_ac_ct_NMEDIT="nmedit"
     $as_echo "$as_me:${as_lineno-$LINENO}: found $as_dir/$ac_word$ac_exec_ext" >&5
     break 2
@@ -7312,7 +7378,7 @@
   IFS=$as_save_IFS
   test -z "$as_dir" && as_dir=.
     for ac_exec_ext in '' $ac_executable_extensions; do
-  if { test -f "$as_dir/$ac_word$ac_exec_ext" && $as_test_x "$as_dir/$ac_word$ac_exec_ext"; }; then
+  if as_fn_executable_p "$as_dir/$ac_word$ac_exec_ext"; then
     ac_cv_prog_LIPO="${ac_tool_prefix}lipo"
     $as_echo "$as_me:${as_lineno-$LINENO}: found $as_dir/$ac_word$ac_exec_ext" >&5
     break 2
@@ -7352,7 +7418,7 @@
   IFS=$as_save_IFS
   test -z "$as_dir" && as_dir=.
     for ac_exec_ext in '' $ac_executable_extensions; do
-  if { test -f "$as_dir/$ac_word$ac_exec_ext" && $as_test_x "$as_dir/$ac_word$ac_exec_ext"; }; then
+  if as_fn_executable_p "$as_dir/$ac_word$ac_exec_ext"; then
     ac_cv_prog_ac_ct_LIPO="lipo"
     $as_echo "$as_me:${as_lineno-$LINENO}: found $as_dir/$ac_word$ac_exec_ext" >&5
     break 2
@@ -7404,7 +7470,7 @@
   IFS=$as_save_IFS
   test -z "$as_dir" && as_dir=.
     for ac_exec_ext in '' $ac_executable_extensions; do
-  if { test -f "$as_dir/$ac_word$ac_exec_ext" && $as_test_x "$as_dir/$ac_word$ac_exec_ext"; }; then
+  if as_fn_executable_p "$as_dir/$ac_word$ac_exec_ext"; then
     ac_cv_prog_OTOOL="${ac_tool_prefix}otool"
     $as_echo "$as_me:${as_lineno-$LINENO}: found $as_dir/$ac_word$ac_exec_ext" >&5
     break 2
@@ -7444,7 +7510,7 @@
   IFS=$as_save_IFS
   test -z "$as_dir" && as_dir=.
     for ac_exec_ext in '' $ac_executable_extensions; do
-  if { test -f "$as_dir/$ac_word$ac_exec_ext" && $as_test_x "$as_dir/$ac_word$ac_exec_ext"; }; then
+  if as_fn_executable_p "$as_dir/$ac_word$ac_exec_ext"; then
     ac_cv_prog_ac_ct_OTOOL="otool"
     $as_echo "$as_me:${as_lineno-$LINENO}: found $as_dir/$ac_word$ac_exec_ext" >&5
     break 2
@@ -7496,7 +7562,7 @@
   IFS=$as_save_IFS
   test -z "$as_dir" && as_dir=.
     for ac_exec_ext in '' $ac_executable_extensions; do
-  if { test -f "$as_dir/$ac_word$ac_exec_ext" && $as_test_x "$as_dir/$ac_word$ac_exec_ext"; }; then
+  if as_fn_executable_p "$as_dir/$ac_word$ac_exec_ext"; then
     ac_cv_prog_OTOOL64="${ac_tool_prefix}otool64"
     $as_echo "$as_me:${as_lineno-$LINENO}: found $as_dir/$ac_word$ac_exec_ext" >&5
     break 2
@@ -7536,7 +7602,7 @@
   IFS=$as_save_IFS
   test -z "$as_dir" && as_dir=.
     for ac_exec_ext in '' $ac_executable_extensions; do
-  if { test -f "$as_dir/$ac_word$ac_exec_ext" && $as_test_x "$as_dir/$ac_word$ac_exec_ext"; }; then
+  if as_fn_executable_p "$as_dir/$ac_word$ac_exec_ext"; then
     ac_cv_prog_ac_ct_OTOOL64="otool64"
     $as_echo "$as_me:${as_lineno-$LINENO}: found $as_dir/$ac_word$ac_exec_ext" >&5
     break 2
@@ -9186,7 +9252,7 @@
     with_gnu_ld=no
     ;;
   linux* | k*bsd*-gnu | gnu*)
-    link_all_deplibs=no
+    link_all_deplibs=unknown
     ;;
   esac
 
@@ -9586,7 +9652,7 @@
 	if test "$aix_use_runtimelinking" = yes; then
 	  shared_flag="$shared_flag "'${wl}-G'
 	fi
-	link_all_deplibs=no
+	link_all_deplibs=unknown
       else
 	# not using gcc
 	if test "$host_cpu" = ia64; then
@@ -14287,7 +14353,7 @@
     esac
     ;;
   linux* | k*bsd*-gnu | gnu*)
-    link_all_deplibs_CXX=no
+    link_all_deplibs_CXX=unknown
     ;;
   *)
     export_symbols_cmds_CXX='$NM $libobjs $convenience | $global_symbol_pipe | $SED '\''s/.* //'\'' | sort | uniq > $export_symbols'
@@ -15292,13 +15358,77 @@
 { $as_echo "$as_me:${as_lineno-$LINENO}: result: $ac_cv_lib_dl_dlopen" >&5
 $as_echo "$ac_cv_lib_dl_dlopen" >&6; }
 if test "x$ac_cv_lib_dl_dlopen" = xyes; then :
-  cat >>confdefs.h <<_ACEOF
-#define HAVE_LIBDL 1
+
+	have_libdl=yes
+
+else
+
+	#libdl not found, check for dlopen in libc.
+	{ $as_echo "$as_me:${as_lineno-$LINENO}: checking for dlopen in -lc" >&5
+$as_echo_n "checking for dlopen in -lc... " >&6; }
+if ${ac_cv_lib_c_dlopen+:} false; then :
+  $as_echo_n "(cached) " >&6
+else
+  ac_check_lib_save_LIBS=$LIBS
+LIBS="-lc  $LIBS"
+cat confdefs.h - <<_ACEOF >conftest.$ac_ext
+/* end confdefs.h.  */
+
+/* Override any GCC internal prototype to avoid an error.
+   Use char because int might match the return type of a GCC
+   builtin and then its argument prototype would still apply.  */
+#ifdef __cplusplus
+extern "C"
+#endif
+char dlopen ();
+int
+main ()
+{
+return dlopen ();
+  ;
+  return 0;
+}
 _ACEOF
-
-  LIBS="-ldl $LIBS"
-
-fi
+if ac_fn_c_try_link "$LINENO"; then :
+  ac_cv_lib_c_dlopen=yes
+else
+  ac_cv_lib_c_dlopen=no
+fi
+rm -f core conftest.err conftest.$ac_objext \
+    conftest$ac_exeext conftest.$ac_ext
+LIBS=$ac_check_lib_save_LIBS
+fi
+{ $as_echo "$as_me:${as_lineno-$LINENO}: result: $ac_cv_lib_c_dlopen" >&5
+$as_echo "$ac_cv_lib_c_dlopen" >&6; }
+if test "x$ac_cv_lib_c_dlopen" = xyes; then :
+
+		have_libc_dl=yes
+
+else
+
+		as_fn_error $? "Cannot find dlopen in libdl nor libc. Use LDFLAGS=-Ldir to specify their location." "$LINENO" 5
+
+fi
+
+
+fi
+
+ if test "x$have_libdl" = "xyes"; then
+  LTTNG_UST_BUILD_WITH_LIBDL_TRUE=
+  LTTNG_UST_BUILD_WITH_LIBDL_FALSE='#'
+else
+  LTTNG_UST_BUILD_WITH_LIBDL_TRUE='#'
+  LTTNG_UST_BUILD_WITH_LIBDL_FALSE=
+fi
+
+ if test "x$have_libc_dl" = "xyes"; then
+  LTTNG_UST_BUILD_WITH_LIBC_DL_TRUE=
+  LTTNG_UST_BUILD_WITH_LIBC_DL_FALSE='#'
+else
+  LTTNG_UST_BUILD_WITH_LIBC_DL_TRUE='#'
+  LTTNG_UST_BUILD_WITH_LIBC_DL_FALSE=
+fi
+
 
 { $as_echo "$as_me:${as_lineno-$LINENO}: checking for pthread_create in -lpthread" >&5
 $as_echo_n "checking for pthread_create in -lpthread... " >&6; }
@@ -15384,15 +15514,86 @@
 { $as_echo "$as_me:${as_lineno-$LINENO}: result: $ac_cv_lib_uuid_uuid_generate" >&5
 $as_echo "$ac_cv_lib_uuid_uuid_generate" >&6; }
 if test "x$ac_cv_lib_uuid_uuid_generate" = xyes; then :
-  cat >>confdefs.h <<_ACEOF
-#define HAVE_LIBUUID 1
-_ACEOF
-
-  LIBS="-luuid $LIBS"
-
-else
-  as_fn_error $? "Cannot find libuuid. Use LDFLAGS=-Ldir to specify its location." "$LINENO" 5
-
+
+
+cat >>confdefs.h <<_ACEOF
+#define LTTNG_UST_HAVE_LIBUUID 1
+_ACEOF
+
+	have_libuuid=yes
+
+else
+
+	# libuuid not found, check for uuid_create in libc.
+	{ $as_echo "$as_me:${as_lineno-$LINENO}: checking for uuid_create in -lc" >&5
+$as_echo_n "checking for uuid_create in -lc... " >&6; }
+if ${ac_cv_lib_c_uuid_create+:} false; then :
+  $as_echo_n "(cached) " >&6
+else
+  ac_check_lib_save_LIBS=$LIBS
+LIBS="-lc  $LIBS"
+cat confdefs.h - <<_ACEOF >conftest.$ac_ext
+/* end confdefs.h.  */
+
+/* Override any GCC internal prototype to avoid an error.
+   Use char because int might match the return type of a GCC
+   builtin and then its argument prototype would still apply.  */
+#ifdef __cplusplus
+extern "C"
+#endif
+char uuid_create ();
+int
+main ()
+{
+return uuid_create ();
+  ;
+  return 0;
+}
+_ACEOF
+if ac_fn_c_try_link "$LINENO"; then :
+  ac_cv_lib_c_uuid_create=yes
+else
+  ac_cv_lib_c_uuid_create=no
+fi
+rm -f core conftest.err conftest.$ac_objext \
+    conftest$ac_exeext conftest.$ac_ext
+LIBS=$ac_check_lib_save_LIBS
+fi
+{ $as_echo "$as_me:${as_lineno-$LINENO}: result: $ac_cv_lib_c_uuid_create" >&5
+$as_echo "$ac_cv_lib_c_uuid_create" >&6; }
+if test "x$ac_cv_lib_c_uuid_create" = xyes; then :
+
+
+cat >>confdefs.h <<_ACEOF
+#define LTTNG_UST_HAVE_LIBC_UUID 1
+_ACEOF
+
+		have_libc_uuid=yes
+
+else
+
+		as_fn_error $? "Cannot find libuuid uuid_generate nor libc uuid_create. Use LDFLAGS=-Ldir to specify their location." "$LINENO" 5
+
+fi
+
+
+
+fi
+
+ if test "x$have_libuuid" = "xyes"; then
+  LTTNG_UST_BUILD_WITH_LIBUUID_TRUE=
+  LTTNG_UST_BUILD_WITH_LIBUUID_FALSE='#'
+else
+  LTTNG_UST_BUILD_WITH_LIBUUID_TRUE='#'
+  LTTNG_UST_BUILD_WITH_LIBUUID_FALSE=
+fi
+
+ if test "x$have_libc_uuid" = "xyes"; then
+  LTTNG_UST_BUILD_WITH_LIBC_UUID_TRUE=
+  LTTNG_UST_BUILD_WITH_LIBC_UUID_FALSE='#'
+else
+  LTTNG_UST_BUILD_WITH_LIBC_UUID_TRUE='#'
+  LTTNG_UST_BUILD_WITH_LIBC_UUID_FALSE=
 fi
 
 
@@ -15538,51 +15739,6 @@
 
 CFLAGS="-Wall $CFLAGS"
 
-# Check for texinfo, required for building the documentation
-# TODO: make this (and building the documentation) optional
-# Extract the first word of "makeinfo", so it can be a program name with args.
-set dummy makeinfo; ac_word=$2
-{ $as_echo "$as_me:${as_lineno-$LINENO}: checking for $ac_word" >&5
-$as_echo_n "checking for $ac_word... " >&6; }
-if ${ac_cv_prog_TEXINFO+:} false; then :
-  $as_echo_n "(cached) " >&6
-else
-  if test -n "$TEXINFO"; then
-  ac_cv_prog_TEXINFO="$TEXINFO" # Let the user override the test.
-else
-as_save_IFS=$IFS; IFS=$PATH_SEPARATOR
-for as_dir in $PATH
-do
-  IFS=$as_save_IFS
-  test -z "$as_dir" && as_dir=.
-    for ac_exec_ext in '' $ac_executable_extensions; do
-  if { test -f "$as_dir/$ac_word$ac_exec_ext" && $as_test_x "$as_dir/$ac_word$ac_exec_ext"; }; then
-    ac_cv_prog_TEXINFO="yes"
-    $as_echo "$as_me:${as_lineno-$LINENO}: found $as_dir/$ac_word$ac_exec_ext" >&5
-    break 2
-  fi
-done
-  done
-IFS=$as_save_IFS
-
-fi
-fi
-TEXINFO=$ac_cv_prog_TEXINFO
-if test -n "$TEXINFO"; then
-  { $as_echo "$as_me:${as_lineno-$LINENO}: result: $TEXINFO" >&5
-$as_echo "$TEXINFO" >&6; }
-else
-  { $as_echo "$as_me:${as_lineno-$LINENO}: result: no" >&5
-$as_echo "no" >&6; }
-fi
-
-
-if test "x$TEXINFO" != "xyes"; then :
-
-	as_fn_error $? "Please install the 'texinfo' program and make sure 'makeinfo' is in the PATH." "$LINENO" 5
-
-fi
-
 # URCU
 
 # urcu - check if we just find the headers it out of the box.
@@ -15602,6 +15758,57 @@
 done
 
 
+# urcu-cds - check that URCU Concurrent Data Structure lib is available to compilation
+# Part of Userspace RCU library 0.7.2 or better.
+{ $as_echo "$as_me:${as_lineno-$LINENO}: checking for _cds_lfht_new in -lurcu-cds" >&5
+$as_echo_n "checking for _cds_lfht_new in -lurcu-cds... " >&6; }
+if ${ac_cv_lib_urcu_cds__cds_lfht_new+:} false; then :
+  $as_echo_n "(cached) " >&6
+else
+  ac_check_lib_save_LIBS=$LIBS
+LIBS="-lurcu-cds  $LIBS"
+cat confdefs.h - <<_ACEOF >conftest.$ac_ext
+/* end confdefs.h.  */
+
+/* Override any GCC internal prototype to avoid an error.
+   Use char because int might match the return type of a GCC
+   builtin and then its argument prototype would still apply.  */
+#ifdef __cplusplus
+extern "C"
+#endif
+char _cds_lfht_new ();
+int
+main ()
+{
+return _cds_lfht_new ();
+  ;
+  return 0;
+}
+_ACEOF
+if ac_fn_c_try_link "$LINENO"; then :
+  ac_cv_lib_urcu_cds__cds_lfht_new=yes
+else
+  ac_cv_lib_urcu_cds__cds_lfht_new=no
+fi
+rm -f core conftest.err conftest.$ac_objext \
+    conftest$ac_exeext conftest.$ac_ext
+LIBS=$ac_check_lib_save_LIBS
+fi
+{ $as_echo "$as_me:${as_lineno-$LINENO}: result: $ac_cv_lib_urcu_cds__cds_lfht_new" >&5
+$as_echo "$ac_cv_lib_urcu_cds__cds_lfht_new" >&6; }
+if test "x$ac_cv_lib_urcu_cds__cds_lfht_new" = xyes; then :
+  cat >>confdefs.h <<_ACEOF
+#define HAVE_LIBURCU_CDS 1
+_ACEOF
+
+  LIBS="-lurcu-cds $LIBS"
+
+else
+  as_fn_error $? "Cannot find
+liburcu-cds lib, part of Userspace RCU 0.7 or better. Use LDFLAGS=-Ldir to specify its location." "$LINENO" 5
+fi
+
+
 { $as_echo "$as_me:${as_lineno-$LINENO}: checking caa_likely()" >&5
 $as_echo_n "checking caa_likely()... " >&6; }
 cat confdefs.h - <<_ACEOF >conftest.$ac_ext
@@ -15776,6 +15983,7 @@
 	  fi
 	  ;;
 	x86_64) LIBFORMAT="elf64-x86-64" ;;
+	amd64) LIBFORMAT="elf64-x86-64" ;;
 	powerpc) LIBFORMAT="elf32-powerpc" ;;
 	ppc64) LIBFORMAT="elf64-powerpc" ;;
 	powerpc64) LIBFORMAT="elf64-powerpc" ;;
@@ -15851,6 +16059,48 @@
 
 fi
 
+# Check for JNI header files if requested
+
+# Check whether --with-jni-interface was given.
+if test "${with_jni_interface+set}" = set; then :
+  withval=$with_jni_interface; jni_interface=$withval
+else
+  jni_interface=no
+
+fi
+
+
+if test "x$jni_interface" = "xyes"; then :
+
+        for ac_header in jni.h
+do :
+  ac_fn_c_check_header_mongrel "$LINENO" "jni.h" "ac_cv_header_jni_h" "$ac_includes_default"
+if test "x$ac_cv_header_jni_h" = xyes; then :
+  cat >>confdefs.h <<_ACEOF
+#define HAVE_JNI_H 1
+_ACEOF
+
+else
+
+        as_fn_error $? "missing jni.h
+Make sure Sun Java, OpenJDK or GCJ is installed and that this header file exists in the system path.
+Use the --with-java-jdk=DIR flag to point to your Java include files, or disable the JNI interface." "$LINENO" 5
+
+fi
+
+done
+
+
+fi
+ if test "x$jni_interface" = "xyes"; then
+  BUILD_JNI_INTERFACE_TRUE=
+  BUILD_JNI_INTERFACE_FALSE='#'
+else
+  BUILD_JNI_INTERFACE_TRUE='#'
+  BUILD_JNI_INTERFACE_FALSE=
+fi
+
+
 # sdt.h integration
 
 # Check whether --with-sdt was given.
@@ -15912,9 +16162,7 @@
 	#tests/exit-fast/Makefile
 	#tests/basic_long/Makefile
 
-#	liblttng-ust-java/Makefile
-
-ac_config_files="$ac_config_files Makefile doc/Makefile doc/examples/Makefile include/Makefile include/lttng/ust-version.h snprintf/Makefile libringbuffer/Makefile liblttng-ust-comm/Makefile liblttng-ust/Makefile liblttng-ust-ctl/Makefile liblttng-ust-fork/Makefile liblttng-ust-libc-wrapper/Makefile tools/Makefile tests/Makefile tests/hello/Makefile tests/hello-static-lib/Makefile tests/hello.cxx/Makefile tests/demo/Makefile tests/fork/Makefile tests/ust-basic-tracing/Makefile tests/ust-multi-test/Makefile lttng-ust.pc"
+ac_config_files="$ac_config_files Makefile doc/Makefile doc/examples/Makefile include/Makefile include/lttng/ust-version.h snprintf/Makefile libringbuffer/Makefile liblttng-ust-comm/Makefile liblttng-ust/Makefile liblttng-ust-ctl/Makefile liblttng-ust-fork/Makefile liblttng-ust-java/Makefile liblttng-ust-libc-wrapper/Makefile tools/Makefile tests/Makefile tests/hello/Makefile tests/hello-static-lib/Makefile tests/hello.cxx/Makefile tests/demo/Makefile tests/fork/Makefile tests/ust-basic-tracing/Makefile tests/ust-multi-test/Makefile lttng-ust.pc"
 
 
 cat >confcache <<\_ACEOF
@@ -16046,6 +16294,26 @@
   as_fn_error $? "conditional \"am__fastdepCXX\" was never defined.
 Usually this means the macro was only invoked conditionally." "$LINENO" 5
 fi
+if test -z "${LTTNG_UST_BUILD_WITH_LIBDL_TRUE}" && test -z "${LTTNG_UST_BUILD_WITH_LIBDL_FALSE}"; then
+  as_fn_error $? "conditional \"LTTNG_UST_BUILD_WITH_LIBDL\" was never defined.
+Usually this means the macro was only invoked conditionally." "$LINENO" 5
+fi
+if test -z "${LTTNG_UST_BUILD_WITH_LIBC_DL_TRUE}" && test -z "${LTTNG_UST_BUILD_WITH_LIBC_DL_FALSE}"; then
+  as_fn_error $? "conditional \"LTTNG_UST_BUILD_WITH_LIBC_DL\" was never defined.
+Usually this means the macro was only invoked conditionally." "$LINENO" 5
+fi
+if test -z "${LTTNG_UST_BUILD_WITH_LIBUUID_TRUE}" && test -z "${LTTNG_UST_BUILD_WITH_LIBUUID_FALSE}"; then
+  as_fn_error $? "conditional \"LTTNG_UST_BUILD_WITH_LIBUUID\" was never defined.
+Usually this means the macro was only invoked conditionally." "$LINENO" 5
+fi
+if test -z "${LTTNG_UST_BUILD_WITH_LIBC_UUID_TRUE}" && test -z "${LTTNG_UST_BUILD_WITH_LIBC_UUID_FALSE}"; then
+  as_fn_error $? "conditional \"LTTNG_UST_BUILD_WITH_LIBC_UUID\" was never defined.
+Usually this means the macro was only invoked conditionally." "$LINENO" 5
+fi
+if test -z "${BUILD_JNI_INTERFACE_TRUE}" && test -z "${BUILD_JNI_INTERFACE_FALSE}"; then
+  as_fn_error $? "conditional \"BUILD_JNI_INTERFACE\" was never defined.
+Usually this means the macro was only invoked conditionally." "$LINENO" 5
+fi
 
 : "${CONFIG_STATUS=./config.status}"
 ac_write_fail=0
@@ -16344,16 +16612,16 @@
     # ... but there are two gotchas:
     # 1) On MSYS, both `ln -s file dir' and `ln file dir' fail.
     # 2) DJGPP < 2.04 has no symlinks; `ln -s' creates a wrapper executable.
-    # In both cases, we have to default to `cp -p'.
+    # In both cases, we have to default to `cp -pR'.
     ln -s conf$$.file conf$$.dir 2>/dev/null && test ! -f conf$$.exe ||
-      as_ln_s='cp -p'
+      as_ln_s='cp -pR'
   elif ln conf$$.file conf$$ 2>/dev/null; then
     as_ln_s=ln
   else
-    as_ln_s='cp -p'
+    as_ln_s='cp -pR'
   fi
 else
-  as_ln_s='cp -p'
+  as_ln_s='cp -pR'
 fi
 rm -f conf$$ conf$$.exe conf$$.dir/conf$$.file conf$$.file
 rmdir conf$$.dir 2>/dev/null
@@ -16413,28 +16681,16 @@
   as_mkdir_p=false
 fi
 
-if test -x / >/dev/null 2>&1; then
-  as_test_x='test -x'
-else
-  if ls -dL / >/dev/null 2>&1; then
-    as_ls_L_option=L
-  else
-    as_ls_L_option=
-  fi
-  as_test_x='
-    eval sh -c '\''
-      if test -d "$1"; then
-	test -d "$1/.";
-      else
-	case $1 in #(
-	-*)set "./$1";;
-	esac;
-	case `ls -ld'$as_ls_L_option' "$1" 2>/dev/null` in #((
-	???[sx]*):;;*)false;;esac;fi
-    '\'' sh
-  '
-fi
-as_executable_p=$as_test_x
+
+# as_fn_executable_p FILE
+# -----------------------
+# Test if FILE is an executable regular file.
+as_fn_executable_p ()
+{
+  test -f "$1" && test -x "$1"
+} # as_fn_executable_p
+as_test_x='test -x'
+as_executable_p=as_fn_executable_p
 
 # Sed expression to map a string onto a valid CPP name.
 as_tr_cpp="eval sed 'y%*$as_cr_letters%P$as_cr_LETTERS%;s%[^_$as_cr_alnum]%_%g'"
@@ -16455,8 +16711,8 @@
 # report actual input values of CONFIG_FILES etc. instead of their
 # values after options handling.
 ac_log="
-This file was extended by lttng-ust $as_me 2.0.4, which was
-generated by GNU Autoconf 2.68.  Invocation command line was
+This file was extended by lttng-ust $as_me 2.1.0-rc1, which was
+generated by GNU Autoconf 2.69.  Invocation command line was
 
   CONFIG_FILES    = $CONFIG_FILES
   CONFIG_HEADERS  = $CONFIG_HEADERS
@@ -16521,11 +16777,11 @@
 cat >>$CONFIG_STATUS <<_ACEOF || ac_write_fail=1
 ac_cs_config="`$as_echo "$ac_configure_args" | sed 's/^ //; s/[\\""\`\$]/\\\\&/g'`"
 ac_cs_version="\\
-lttng-ust config.status 2.0.4
-configured by $0, generated by GNU Autoconf 2.68,
+lttng-ust config.status 2.1.0-rc1
+configured by $0, generated by GNU Autoconf 2.69,
   with options \\"\$ac_cs_config\\"
 
-Copyright (C) 2010 Free Software Foundation, Inc.
+Copyright (C) 2012 Free Software Foundation, Inc.
 This config.status script is free software; the Free Software Foundation
 gives unlimited permission to copy, distribute and modify it."
 
@@ -16616,7 +16872,7 @@
 _ACEOF
 cat >>$CONFIG_STATUS <<_ACEOF || ac_write_fail=1
 if \$ac_cs_recheck; then
-  set X '$SHELL' '$0' $ac_configure_args \$ac_configure_extra_args --no-create --no-recursion
+  set X $SHELL '$0' $ac_configure_args \$ac_configure_extra_args --no-create --no-recursion
   shift
   \$as_echo "running CONFIG_SHELL=$SHELL \$*" >&6
   CONFIG_SHELL='$SHELL'
@@ -17040,6 +17296,7 @@
     "liblttng-ust/Makefile") CONFIG_FILES="$CONFIG_FILES liblttng-ust/Makefile" ;;
     "liblttng-ust-ctl/Makefile") CONFIG_FILES="$CONFIG_FILES liblttng-ust-ctl/Makefile" ;;
     "liblttng-ust-fork/Makefile") CONFIG_FILES="$CONFIG_FILES liblttng-ust-fork/Makefile" ;;
+    "liblttng-ust-java/Makefile") CONFIG_FILES="$CONFIG_FILES liblttng-ust-java/Makefile" ;;
     "liblttng-ust-libc-wrapper/Makefile") CONFIG_FILES="$CONFIG_FILES liblttng-ust-libc-wrapper/Makefile" ;;
     "tools/Makefile") CONFIG_FILES="$CONFIG_FILES tools/Makefile" ;;
     "tests/Makefile") CONFIG_FILES="$CONFIG_FILES tests/Makefile" ;;
@@ -18587,6 +18844,13 @@
 $as_echo "Library format: $LIBFORMAT"
 
 $as_echo
+$as_echo_n "Java support (JNI): "
+if test "x$jni_interface" = "xyes"; then :
+  $as_echo "Enabled"
+else
+  $as_echo "Disabled"
+fi
+
 $as_echo_n "sdt.h integration:  "
 if test "x$with_sdt" = "xyes"; then :
   $as_echo "Enabled"

=== modified file 'configure.ac'
--- configure.ac	2012-06-29 16:47:49 +0000
+++ configure.ac	2012-09-11 15:34:43 +0000
@@ -1,7 +1,7 @@
 #                                               -*- Autoconf -*-
 # Process this file with autoconf to produce a configure script.
 
-AC_INIT([lttng-ust],[2.0.4],[mathieu dot desnoyers at efficios dot com])
+AC_INIT([lttng-ust],[2.1.0-rc1],[mathieu dot desnoyers at efficios dot com])
 
 # Following the numbering scheme proposed by libtool for the library version
 # http://www.gnu.org/software/libtool/manual/html_node/Updating-version-info.html
@@ -34,10 +34,35 @@
 AC_DEFINE_UNQUOTED([VERSION_MINOR], $minor_version, [UST minor version number])
 AC_DEFINE_UNQUOTED([VERSION_PATCHLEVEL], $patchlevel_version, [UST patchlevel version number])
 
-version_name="Annedd'ale"
-version_description="New type of beer, 100% from Quebec, flavored with sapin beaumier needles, with a touch of hops."
-AC_DEFINE_UNQUOTED([VERSION_NAME], [$version_name], [UST version name])
-AC_DEFINE_UNQUOTED([VERSION_DESCRIPTION], [$version_description], [UST version description])
+version_name="Basse Messe"
+version_description="Light coloured German ale whose style was named after the city Cologne (Koln) where it was first brewed. It is a rather simple beer with lightly fruity aromas and a delicate hoppy fragrance. The beer has a pronounced malty taste with a subtle bitter aftertaste"
+AC_DEFINE_UNQUOTED([VERSION_NAME], ["$version_name"], [UST version name])
+AC_DEFINE_UNQUOTED([VERSION_DESCRIPTION], ["$version_description"], [UST version description])
+
+AC_PROG_GREP
+# libtool link_all_deplibs fixup. See http://bugs.lttng.org/issues/321.
+AC_ARG_ENABLE(libtool-linkdep-fixup,
+	AS_HELP_STRING([--disable-libtool-linkdep-fixup],
+			[disable the libtool fixup for linking all dependent libraries (link_all_deplibs)]),
+	libtool_fixup=$enableval,
+	libtool_fixup=yes)
+
+AS_IF([test "x$libtool_fixup" = "xyes"],
+	    [
+	    libtool_m4="$srcdir/config/libtool.m4"
+	    libtool_flag_pattern=".*link_all_deplibs\s*,\s*\$1\s*)"
+	    AC_MSG_CHECKING([for occurence(s) of link_all_deplibs = no in $libtool_m4])
+	    libtool_flag_pattern_count=$(grep -c "$libtool_flag_pattern\s*=\s*no" $libtool_m4)
+	    AS_IF([test $libtool_flag_pattern_count -ne 0],
+	    [
+		  AC_MSG_RESULT([$libtool_flag_pattern_count])
+		  AC_MSG_WARN([the detected libtool will not link all dependencies, forcing link_all_deplibs = unknown])
+		  sed -i "s/\($libtool_flag_pattern\)\s*=\s*no/\1=unknown/g" $libtool_m4
+		  ],
+		  [
+		  AC_MSG_RESULT([none])
+		  ])
+	    ])
 
 # Checks for programs.
 AC_PROG_CC
@@ -46,13 +71,45 @@
 LT_INIT
 
 ## Checks for libraries.
-AC_CHECK_LIB([dl], [dlopen])
+AC_CHECK_LIB([dl], [dlopen],
+[
+	have_libdl=yes
+],
+[
+	#libdl not found, check for dlopen in libc.
+	AC_CHECK_LIB([c], [dlopen],
+	[
+		have_libc_dl=yes
+	],
+	[
+		AC_MSG_ERROR([Cannot find dlopen in libdl nor libc. Use [LDFLAGS]=-Ldir to specify their location.])
+	])
+])
+AM_CONDITIONAL([LTTNG_UST_BUILD_WITH_LIBDL], [test "x$have_libdl" = "xyes"])
+AM_CONDITIONAL([LTTNG_UST_BUILD_WITH_LIBC_DL], [test "x$have_libc_dl" = "xyes"])
+
 AC_CHECK_LIB([pthread], [pthread_create])
 
 # Check for libuuid
-AC_CHECK_LIB([uuid], [uuid_generate], [],
-	[AC_MSG_ERROR([Cannot find libuuid. Use [LDFLAGS]=-Ldir to specify its location.])]
+AC_CHECK_LIB([uuid], [uuid_generate],
+[
+	AC_DEFINE_UNQUOTED([LTTNG_UST_HAVE_LIBUUID], 1, [Has libuuid support.])
+	have_libuuid=yes
+],
+[
+	# libuuid not found, check for uuid_create in libc.
+	AC_CHECK_LIB([c], [uuid_create],
+	[
+		AC_DEFINE_UNQUOTED([LTTNG_UST_HAVE_LIBC_UUID], 1, [Has libc uuid support.])
+		have_libc_uuid=yes
+	],
+	[
+		AC_MSG_ERROR([Cannot find libuuid uuid_generate nor libc uuid_create. Use [LDFLAGS]=-Ldir to specify their location.])
+	])
+]
 )
+AM_CONDITIONAL([LTTNG_UST_BUILD_WITH_LIBUUID], [test "x$have_libuuid" = "xyes"])
+AM_CONDITIONAL([LTTNG_UST_BUILD_WITH_LIBC_UUID], [test "x$have_libc_uuid" = "xyes"])
 
 # Checks for header files.
 #AC_CHECK_HEADERS([fcntl.h stdint.h stdlib.h string.h sys/socket.h sys/time.h unistd.h])
@@ -78,19 +135,17 @@
 
 CFLAGS="-Wall $CFLAGS"
 
-# Check for texinfo, required for building the documentation
-# TODO: make this (and building the documentation) optional
-AC_CHECK_PROG([TEXINFO], [makeinfo], [yes])
-AS_IF([test "x$TEXINFO" != "xyes"],[
-	AC_MSG_ERROR([Please install the 'texinfo' program and make sure 'makeinfo' is in the PATH.])
-])
-
 # URCU
 
 # urcu - check if we just find the headers it out of the box.
 AC_CHECK_HEADERS([urcu-bp.h], [], [AC_MSG_ERROR([Cannot find [URCU] headers (urcu-bp.h). Use [CPPFLAGS]=-Idir to specify their location.
 This error can also occur when the liburcu package's configure script has not been run.])])
 
+# urcu-cds - check that URCU Concurrent Data Structure lib is available to compilation
+# Part of Userspace RCU library 0.7.2 or better.
+AC_CHECK_LIB([urcu-cds], [_cds_lfht_new], [], [AC_MSG_ERROR([Cannot find
+liburcu-cds lib, part of Userspace RCU 0.7 or better. Use [LDFLAGS]=-Ldir to specify its location.])])
+
 AC_MSG_CHECKING([caa_likely()])
 AC_COMPILE_IFELSE([AC_LANG_SOURCE([[
 #include <urcu/compiler.h>
@@ -147,6 +202,7 @@
 	  fi
 	  ;;
 	x86_64) LIBFORMAT="elf64-x86-64" ;;
+	amd64) LIBFORMAT="elf64-x86-64" ;;
 	powerpc) LIBFORMAT="elf32-powerpc" ;;
 	ppc64) LIBFORMAT="elf64-powerpc" ;;
 	powerpc64) LIBFORMAT="elf64-powerpc" ;;
@@ -197,6 +253,22 @@
         ])
 ])
 
+# Check for JNI header files if requested
+AC_ARG_WITH([jni-interface],
+	[AS_HELP_STRING([--with-jni-interface],[build JNI interface between C and Java. Needs Java include files [default=no]])],
+	[jni_interface=$withval],
+	[jni_interface=no]
+)
+
+AS_IF([test "x$jni_interface" = "xyes"],[
+        AC_CHECK_HEADERS([jni.h],[],[
+        AC_MSG_ERROR([missing jni.h
+Make sure Sun Java, OpenJDK or GCJ is installed and that this header file exists in the system path.
+Use the --with-java-jdk=DIR flag to point to your Java include files, or disable the JNI interface.])
+	])
+])
+AM_CONDITIONAL([BUILD_JNI_INTERFACE], [test "x$jni_interface" = "xyes"])
+
 # sdt.h integration
 AC_ARG_WITH([sdt],
 	[AS_HELP_STRING([--with-sdt],[provide SystemTap integration via sdt.h [default=no]])],
@@ -239,8 +311,6 @@
 	#tests/exit-fast/Makefile
 	#tests/basic_long/Makefile
 
-#	liblttng-ust-java/Makefile
-
 AC_CONFIG_FILES([
 	Makefile
 	doc/Makefile
@@ -253,6 +323,7 @@
 	liblttng-ust/Makefile
 	liblttng-ust-ctl/Makefile
 	liblttng-ust-fork/Makefile
+	liblttng-ust-java/Makefile
 	liblttng-ust-libc-wrapper/Makefile
 	tools/Makefile
 	tests/Makefile
@@ -278,6 +349,9 @@
 AS_ECHO("Library format: $LIBFORMAT")
 
 AS_ECHO()
+AS_ECHO_N("Java support (JNI): ")
+AS_IF([test "x$jni_interface" = "xyes"], [AS_ECHO("Enabled")], [AS_ECHO("Disabled")])
+
 AS_ECHO_N("sdt.h integration:  ")
 AS_IF([test "x$with_sdt" = "xyes"], [AS_ECHO("Enabled")], [AS_ECHO("Disabled")])
 

=== modified file 'doc/Makefile.in'
--- doc/Makefile.in	2012-06-29 16:47:49 +0000
+++ doc/Makefile.in	2012-09-11 15:34:43 +0000
@@ -1,4 +1,4 @@
-# Makefile.in generated by automake 1.11.3 from Makefile.am.
+# Makefile.in generated by automake 1.11.6 from Makefile.am.
 # @configure_input@
 
 # Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2000, 2001, 2002,
@@ -15,6 +15,23 @@
 
 @SET_MAKE@
 VPATH = @srcdir@
+am__make_dryrun = \
+  { \
+    am__dry=no; \
+    case $$MAKEFLAGS in \
+      *\\[\ \	]*) \
+        echo 'am--echo: ; @echo "AM"  OK' | $(MAKE) -f - 2>/dev/null \
+          | grep '^AM OK$$' >/dev/null || am__dry=yes;; \
+      *) \
+        for am__flg in $$MAKEFLAGS; do \
+          case $$am__flg in \
+            *=*|--*) ;; \
+            *n*) am__dry=yes; break;; \
+          esac; \
+        done;; \
+    esac; \
+    test $$am__dry = yes; \
+  }
 pkgdatadir = $(datadir)/@PACKAGE@
 pkgincludedir = $(includedir)/@PACKAGE@
 pkglibdir = $(libdir)/@PACKAGE@
@@ -65,6 +82,11 @@
 	install-pdf-recursive install-ps-recursive install-recursive \
 	installcheck-recursive installdirs-recursive pdf-recursive \
 	ps-recursive uninstall-recursive
+am__can_run_installinfo = \
+  case $$AM_UPDATE_INFO_DIR in \
+    n|no|NO) false;; \
+    *) (install-info --version) >/dev/null 2>&1;; \
+  esac
 am__vpath_adj_setup = srcdirstrip=`echo "$(srcdir)" | sed 's|.|.|g'`;
 am__vpath_adj = case $$p in \
     $(srcdir)/*) f=`echo "$$p" | sed "s|^$$srcdirstrip/||"`;; \
@@ -201,7 +223,6 @@
 SET_MAKE = @SET_MAKE@
 SHELL = @SHELL@
 STRIP = @STRIP@
-TEXINFO = @TEXINFO@
 VERSION = @VERSION@
 abs_builddir = @abs_builddir@
 abs_srcdir = @abs_srcdir@
@@ -305,11 +326,18 @@
 	-rm -rf .libs _libs
 install-man1: $(dist_man_MANS)
 	@$(NORMAL_INSTALL)
-	test -z "$(man1dir)" || $(MKDIR_P) "$(DESTDIR)$(man1dir)"
-	@list=''; test -n "$(man1dir)" || exit 0; \
-	{ for i in $$list; do echo "$$i"; done; \
-	l2='$(dist_man_MANS)'; for i in $$l2; do echo "$$i"; done | \
-	  sed -n '/\.1[a-z]*$$/p'; \
+	@list1=''; \
+	list2='$(dist_man_MANS)'; \
+	test -n "$(man1dir)" \
+	  && test -n "`echo $$list1$$list2`" \
+	  || exit 0; \
+	echo " $(MKDIR_P) '$(DESTDIR)$(man1dir)'"; \
+	$(MKDIR_P) "$(DESTDIR)$(man1dir)" || exit 1; \
+	{ for i in $$list1; do echo "$$i"; done;  \
+	if test -n "$$list2"; then \
+	  for i in $$list2; do echo "$$i"; done \
+	    | sed -n '/\.1[a-z]*$$/p'; \
+	fi; \
 	} | while read p; do \
 	  if test -f $$p; then d=; else d="$(srcdir)/"; fi; \
 	  echo "$$d$$p"; echo "$$p"; \
@@ -341,11 +369,18 @@
 	dir='$(DESTDIR)$(man1dir)'; $(am__uninstall_files_from_dir)
 install-man3: $(dist_man_MANS)
 	@$(NORMAL_INSTALL)
-	test -z "$(man3dir)" || $(MKDIR_P) "$(DESTDIR)$(man3dir)"
-	@list=''; test -n "$(man3dir)" || exit 0; \
-	{ for i in $$list; do echo "$$i"; done; \
-	l2='$(dist_man_MANS)'; for i in $$l2; do echo "$$i"; done | \
-	  sed -n '/\.3[a-z]*$$/p'; \
+	@list1=''; \
+	list2='$(dist_man_MANS)'; \
+	test -n "$(man3dir)" \
+	  && test -n "`echo $$list1$$list2`" \
+	  || exit 0; \
+	echo " $(MKDIR_P) '$(DESTDIR)$(man3dir)'"; \
+	$(MKDIR_P) "$(DESTDIR)$(man3dir)" || exit 1; \
+	{ for i in $$list1; do echo "$$i"; done;  \
+	if test -n "$$list2"; then \
+	  for i in $$list2; do echo "$$i"; done \
+	    | sed -n '/\.3[a-z]*$$/p'; \
+	fi; \
 	} | while read p; do \
 	  if test -f $$p; then d=; else d="$(srcdir)/"; fi; \
 	  echo "$$d$$p"; echo "$$p"; \
@@ -556,13 +591,10 @@
 	done
 	@list='$(DIST_SUBDIRS)'; for subdir in $$list; do \
 	  if test "$$subdir" = .; then :; else \
-	    test -d "$(distdir)/$$subdir" \
-	    || $(MKDIR_P) "$(distdir)/$$subdir" \
-	    || exit 1; \
-	  fi; \
-	done
-	@list='$(DIST_SUBDIRS)'; for subdir in $$list; do \
-	  if test "$$subdir" = .; then :; else \
+	    $(am__make_dryrun) \
+	      || test -d "$(distdir)/$$subdir" \
+	      || $(MKDIR_P) "$(distdir)/$$subdir" \
+	      || exit 1; \
 	    dir1=$$subdir; dir2="$(distdir)/$$subdir"; \
 	    $(am__relativize); \
 	    new_distdir=$$reldir; \

=== modified file 'doc/examples/Makefile.in'
--- doc/examples/Makefile.in	2012-06-29 16:47:49 +0000
+++ doc/examples/Makefile.in	2012-09-11 15:34:43 +0000
@@ -1,4 +1,4 @@
-# Makefile.in generated by automake 1.11.3 from Makefile.am.
+# Makefile.in generated by automake 1.11.6 from Makefile.am.
 # @configure_input@
 
 # Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2000, 2001, 2002,
@@ -16,6 +16,23 @@
 @SET_MAKE@
 
 VPATH = @srcdir@
+am__make_dryrun = \
+  { \
+    am__dry=no; \
+    case $$MAKEFLAGS in \
+      *\\[\ \	]*) \
+        echo 'am--echo: ; @echo "AM"  OK' | $(MAKE) -f - 2>/dev/null \
+          | grep '^AM OK$$' >/dev/null || am__dry=yes;; \
+      *) \
+        for am__flg in $$MAKEFLAGS; do \
+          case $$am__flg in \
+            *=*|--*) ;; \
+            *n*) am__dry=yes; break;; \
+          esac; \
+        done;; \
+    esac; \
+    test $$am__dry = yes; \
+  }
 pkgdatadir = $(datadir)/@PACKAGE@
 pkgincludedir = $(includedir)/@PACKAGE@
 pkglibdir = $(libdir)/@PACKAGE@
@@ -60,6 +77,11 @@
 am__v_at_0 = @
 SOURCES =
 DIST_SOURCES =
+am__can_run_installinfo = \
+  case $$AM_UPDATE_INFO_DIR in \
+    n|no|NO) false;; \
+    *) (install-info --version) >/dev/null 2>&1;; \
+  esac
 am__vpath_adj_setup = srcdirstrip=`echo "$(srcdir)" | sed 's|.|.|g'`;
 am__vpath_adj = case $$p in \
     $(srcdir)/*) f=`echo "$$p" | sed "s|^$$srcdirstrip/||"`;; \
@@ -162,7 +184,6 @@
 SET_MAKE = @SET_MAKE@
 SHELL = @SHELL@
 STRIP = @STRIP@
-TEXINFO = @TEXINFO@
 VERSION = @VERSION@
 abs_builddir = @abs_builddir@
 abs_srcdir = @abs_srcdir@
@@ -271,8 +292,11 @@
 	-rm -rf .libs _libs
 install-dist_doc_examples_easy_ustDATA: $(dist_doc_examples_easy_ust_DATA)
 	@$(NORMAL_INSTALL)
-	test -z "$(doc_examples_easy_ustdir)" || $(MKDIR_P) "$(DESTDIR)$(doc_examples_easy_ustdir)"
 	@list='$(dist_doc_examples_easy_ust_DATA)'; test -n "$(doc_examples_easy_ustdir)" || list=; \
+	if test -n "$$list"; then \
+	  echo " $(MKDIR_P) '$(DESTDIR)$(doc_examples_easy_ustdir)'"; \
+	  $(MKDIR_P) "$(DESTDIR)$(doc_examples_easy_ustdir)" || exit 1; \
+	fi; \
 	for p in $$list; do \
 	  if test -f "$$p"; then d=; else d="$(srcdir)/"; fi; \
 	  echo "$$d$$p"; \
@@ -289,8 +313,11 @@
 	dir='$(DESTDIR)$(doc_examples_easy_ustdir)'; $(am__uninstall_files_from_dir)
 install-dist_doc_examples_gen_tpDATA: $(dist_doc_examples_gen_tp_DATA)
 	@$(NORMAL_INSTALL)
-	test -z "$(doc_examples_gen_tpdir)" || $(MKDIR_P) "$(DESTDIR)$(doc_examples_gen_tpdir)"
 	@list='$(dist_doc_examples_gen_tp_DATA)'; test -n "$(doc_examples_gen_tpdir)" || list=; \
+	if test -n "$$list"; then \
+	  echo " $(MKDIR_P) '$(DESTDIR)$(doc_examples_gen_tpdir)'"; \
+	  $(MKDIR_P) "$(DESTDIR)$(doc_examples_gen_tpdir)" || exit 1; \
+	fi; \
 	for p in $$list; do \
 	  if test -f "$$p"; then d=; else d="$(srcdir)/"; fi; \
 	  echo "$$d$$p"; \

=== modified file 'doc/examples/easy-ust/Makefile'
--- doc/examples/easy-ust/Makefile	2012-06-29 16:47:49 +0000
+++ doc/examples/easy-ust/Makefile	2012-09-11 15:34:43 +0000
@@ -16,7 +16,8 @@
 # the "html" target helps for documentation (req. code2html)
 
 CC = gcc
-LIBS = -ldl -llttng-ust
+LIBS = -ldl -llttng-ust		# On Linux
+#LIBS = -lc -llttng-ust		# On BSD
 CFLAGS = -I.
 
 all: sample

=== modified file 'doc/examples/gen-tp/Makefile'
--- doc/examples/gen-tp/Makefile	2012-06-29 16:47:49 +0000
+++ doc/examples/gen-tp/Makefile	2012-09-11 15:34:43 +0000
@@ -16,7 +16,9 @@
 # provider probe.
 
 CC = gcc
-LIBS = -ldl -llttng-ust
+
+LIBS = -ldl -llttng-ust		#On Linux
+#LIBS = -lc -llttng-ust		#On BSD
 
 all: sample
 

=== modified file 'include/Makefile.am'
--- include/Makefile.am	2012-06-29 16:47:49 +0000
+++ include/Makefile.am	2012-09-11 15:34:43 +0000
@@ -5,6 +5,8 @@
 	lttng/tracepoint-event.h \
 	lttng/ust-tracepoint-event.h \
 	lttng/ust-tracepoint-event-reset.h \
+	lttng/ust-tracepoint-event-write.h \
+	lttng/ust-tracepoint-event-nowrite.h \
 	lttng/ust-events.h \
 	lttng/ust-ctl.h \
 	lttng/ust-version.h \
@@ -12,7 +14,9 @@
 	lttng/ringbuffer-abi.h \
 	lttng/ust-tracer.h \
 	lttng/ust-config.h \
+	lttng/ust-compiler.h \
 	lttng/ust.h \
+	lttng/ust-endian.h \
 	lttng/ringbuffer-config.h \
 	lttng/align.h \
 	lttng/bug.h
@@ -24,6 +28,7 @@
 	usterr-signal-safe.h \
 	ust_snprintf.h \
 	ust-comm.h \
+	lttng/ust-tid.h \
 	lttng/bitfield.h \
 	helper.h \
 	share.h

=== modified file 'include/Makefile.in'
--- include/Makefile.in	2012-06-29 16:47:49 +0000
+++ include/Makefile.in	2012-09-11 15:34:43 +0000
@@ -1,4 +1,4 @@
-# Makefile.in generated by automake 1.11.3 from Makefile.am.
+# Makefile.in generated by automake 1.11.6 from Makefile.am.
 # @configure_input@
 
 # Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2000, 2001, 2002,
@@ -16,6 +16,23 @@
 @SET_MAKE@
 
 VPATH = @srcdir@
+am__make_dryrun = \
+  { \
+    am__dry=no; \
+    case $$MAKEFLAGS in \
+      *\\[\ \	]*) \
+        echo 'am--echo: ; @echo "AM"  OK' | $(MAKE) -f - 2>/dev/null \
+          | grep '^AM OK$$' >/dev/null || am__dry=yes;; \
+      *) \
+        for am__flg in $$MAKEFLAGS; do \
+          case $$am__flg in \
+            *=*|--*) ;; \
+            *n*) am__dry=yes; break;; \
+          esac; \
+        done;; \
+    esac; \
+    test $$am__dry = yes; \
+  }
 pkgdatadir = $(datadir)/@PACKAGE@
 pkgincludedir = $(includedir)/@PACKAGE@
 pkglibdir = $(libdir)/@PACKAGE@
@@ -59,6 +76,11 @@
 am__v_at_0 = @
 SOURCES =
 DIST_SOURCES =
+am__can_run_installinfo = \
+  case $$AM_UPDATE_INFO_DIR in \
+    n|no|NO) false;; \
+    *) (install-info --version) >/dev/null 2>&1;; \
+  esac
 am__vpath_adj_setup = srcdirstrip=`echo "$(srcdir)" | sed 's|.|.|g'`;
 am__vpath_adj = case $$p in \
     $(srcdir)/*) f=`echo "$$p" | sed "s|^$$srcdirstrip/||"`;; \
@@ -161,7 +183,6 @@
 SET_MAKE = @SET_MAKE@
 SHELL = @SHELL@
 STRIP = @STRIP@
-TEXINFO = @TEXINFO@
 VERSION = @VERSION@
 abs_builddir = @abs_builddir@
 abs_srcdir = @abs_srcdir@
@@ -227,6 +248,8 @@
 	lttng/tracepoint-event.h \
 	lttng/ust-tracepoint-event.h \
 	lttng/ust-tracepoint-event-reset.h \
+	lttng/ust-tracepoint-event-write.h \
+	lttng/ust-tracepoint-event-nowrite.h \
 	lttng/ust-events.h \
 	lttng/ust-ctl.h \
 	lttng/ust-version.h \
@@ -234,7 +257,9 @@
 	lttng/ringbuffer-abi.h \
 	lttng/ust-tracer.h \
 	lttng/ust-config.h \
+	lttng/ust-compiler.h \
 	lttng/ust.h \
+	lttng/ust-endian.h \
 	lttng/ringbuffer-config.h \
 	lttng/align.h \
 	lttng/bug.h
@@ -246,6 +271,7 @@
 	usterr-signal-safe.h \
 	ust_snprintf.h \
 	ust-comm.h \
+	lttng/ust-tid.h \
 	lttng/bitfield.h \
 	helper.h \
 	share.h
@@ -291,15 +317,18 @@
 	-rm -rf .libs _libs
 install-nobase_includeHEADERS: $(nobase_include_HEADERS)
 	@$(NORMAL_INSTALL)
-	test -z "$(includedir)" || $(MKDIR_P) "$(DESTDIR)$(includedir)"
 	@list='$(nobase_include_HEADERS)'; test -n "$(includedir)" || list=; \
+	if test -n "$$list"; then \
+	  echo " $(MKDIR_P) '$(DESTDIR)$(includedir)'"; \
+	  $(MKDIR_P) "$(DESTDIR)$(includedir)" || exit 1; \
+	fi; \
 	$(am__nobase_list) | while read dir files; do \
 	  xfiles=; for file in $$files; do \
 	    if test -f "$$file"; then xfiles="$$xfiles $$file"; \
 	    else xfiles="$$xfiles $(srcdir)/$$file"; fi; done; \
 	  test -z "$$xfiles" || { \
 	    test "x$$dir" = x. || { \
-	      echo "$(MKDIR_P) '$(DESTDIR)$(includedir)/$$dir'"; \
+	      echo " $(MKDIR_P) '$(DESTDIR)$(includedir)/$$dir'"; \
 	      $(MKDIR_P) "$(DESTDIR)$(includedir)/$$dir"; }; \
 	    echo " $(INSTALL_HEADER) $$xfiles '$(DESTDIR)$(includedir)/$$dir'"; \
 	    $(INSTALL_HEADER) $$xfiles "$(DESTDIR)$(includedir)/$$dir" || exit $$?; }; \

=== modified file 'include/lttng/align.h'
--- include/lttng/align.h	2012-06-29 16:47:49 +0000
+++ include/lttng/align.h	2012-09-11 15:34:43 +0000
@@ -19,11 +19,15 @@
 
 #include <lttng/bug.h>
 #include <unistd.h>
+#include <limits.h>
 
+#ifndef PAGE_SIZE	/* Cygwin limits.h defines its own PAGE_SIZE */
 #define PAGE_SIZE		sysconf(_SC_PAGE_SIZE)
+#endif
+
 #define PAGE_MASK		(~(PAGE_SIZE - 1))
 #define __ALIGN_MASK(v, mask)	(((v) + (mask)) & ~(mask))
-#define ALIGN(v, align)		__ALIGN_MASK(v, (typeof(v)) (align) - 1)
+#define ALIGN(v, align)		__ALIGN_MASK(v, (__typeof__(v)) (align) - 1)
 #define PAGE_ALIGN(addr)	ALIGN(addr, PAGE_SIZE)
 
 /**

=== modified file 'include/lttng/bitfield.h'
--- include/lttng/bitfield.h	2012-06-29 16:47:49 +0000
+++ include/lttng/bitfield.h	2012-09-11 15:34:43 +0000
@@ -21,14 +21,14 @@
 
 #include <stdint.h>	/* C99 5.2.4.2 Numerical limits */
 #include <limits.h>	/* C99 5.2.4.2 Numerical limits */
-#include <endian.h>	/* Non-standard BIG_ENDIAN, LITTLE_ENDIAN, BYTE_ORDER */
+#include <lttng/ust-endian.h>	/* Non-standard BIG_ENDIAN, LITTLE_ENDIAN, BYTE_ORDER */
 #include <assert.h>
 
 /* We can't shift a int from 32 bit, >> 32 and << 32 on int is undefined */
 #define _bt_piecewise_rshift(_v, _shift)				\
 ({									\
-	typeof(_v) ___v = (_v);						\
-	typeof(_shift) ___shift = (_shift);				\
+	__typeof__(_v) ___v = (_v);						\
+	__typeof__(_shift) ___shift = (_shift);				\
 	unsigned long sb = (___shift) / (sizeof(___v) * CHAR_BIT - 1);	\
 	unsigned long final = (___shift) % (sizeof(___v) * CHAR_BIT - 1); \
 									\
@@ -39,8 +39,8 @@
 
 #define _bt_piecewise_lshift(_v, _shift)				\
 ({									\
-	typeof(_v) ___v = (_v);						\
-	typeof(_shift) ___shift = (_shift);				\
+	__typeof__(_v) ___v = (_v);						\
+	__typeof__(_shift) ___shift = (_shift);				\
 	unsigned long sb = (___shift) / (sizeof(___v) * CHAR_BIT - 1);	\
 	unsigned long final = (___shift) % (sizeof(___v) * CHAR_BIT - 1); \
 									\
@@ -78,7 +78,7 @@
 
 #define _bt_bitfield_write_le(_ptr, type, _start, _length, _v)		\
 do {									\
-	typeof(_v) __v = (_v);						\
+	__typeof__(_v) __v = (_v);						\
 	type *__ptr = (void *) (_ptr);					\
 	unsigned long __start = (_start), __length = (_length);		\
 	type mask, cmask;						\
@@ -95,7 +95,7 @@
 									\
 	/* Trim v high bits */						\
 	if (__length < sizeof(__v) * CHAR_BIT)				\
-		__v &= ~((~(typeof(__v)) 0) << __length);		\
+		__v &= ~((~(__typeof__(__v)) 0) << __length);		\
 									\
 	/* We can now append v with a simple "or", shift it piece-wise */ \
 	this_unit = start_unit;						\
@@ -137,7 +137,7 @@
 
 #define _bt_bitfield_write_be(_ptr, type, _start, _length, _v)		\
 do {									\
-	typeof(_v) __v = (_v);						\
+	__typeof__(_v) __v = (_v);						\
 	type *__ptr = (void *) (_ptr);					\
 	unsigned long __start = (_start), __length = (_length);		\
 	type mask, cmask;						\
@@ -154,7 +154,7 @@
 									\
 	/* Trim v high bits */						\
 	if (__length < sizeof(__v) * CHAR_BIT)				\
-		__v &= ~((~(typeof(__v)) 0) << __length);		\
+		__v &= ~((~(__typeof__(__v)) 0) << __length);		\
 									\
 	/* We can now append v with a simple "or", shift it piece-wise */ \
 	this_unit = end_unit - 1;					\
@@ -230,8 +230,8 @@
 
 #define _bt_bitfield_read_le(_ptr, type, _start, _length, _vptr)	\
 do {									\
-	typeof(*(_vptr)) *__vptr = (_vptr);				\
-	typeof(*__vptr) __v;						\
+	__typeof__(*(_vptr)) *__vptr = (_vptr);				\
+	__typeof__(*__vptr) __v;						\
 	type *__ptr = (void *) (_ptr);					\
 	unsigned long __start = (_start), __length = (_length);		\
 	type mask, cmask;						\
@@ -249,9 +249,9 @@
 	end_unit = (end + (ts - 1)) / ts;				\
 									\
 	this_unit = end_unit - 1;					\
-	if (_bt_is_signed_type(typeof(__v))				\
+	if (_bt_is_signed_type(__typeof__(__v))				\
 	    && (__ptr[this_unit] & ((type) 1 << ((end % ts ? : ts) - 1)))) \
-		__v = ~(typeof(__v)) 0;					\
+		__v = ~(__typeof__(__v)) 0;					\
 	else								\
 		__v = 0;						\
 	if (start_unit == end_unit - 1) {				\
@@ -262,7 +262,7 @@
 			cmask &= mask;					\
 		}							\
 		__v = _bt_piecewise_lshift(__v, end - __start);		\
-		__v |= _bt_unsigned_cast(typeof(__v), cmask);		\
+		__v |= _bt_unsigned_cast(__typeof__(__v), cmask);		\
 		*__vptr = __v;						\
 		break;							\
 	}								\
@@ -272,13 +272,13 @@
 		cmask = __ptr[this_unit];				\
 		cmask &= mask;						\
 		__v = _bt_piecewise_lshift(__v, cshift);		\
-		__v |= _bt_unsigned_cast(typeof(__v), cmask);		\
+		__v |= _bt_unsigned_cast(__typeof__(__v), cmask);		\
 		end -= cshift;						\
 		this_unit--;						\
 	}								\
 	for (; (long) this_unit >= (long) start_unit + 1; this_unit--) { \
 		__v = _bt_piecewise_lshift(__v, ts);			\
-		__v |= _bt_unsigned_cast(typeof(__v), __ptr[this_unit]);\
+		__v |= _bt_unsigned_cast(__typeof__(__v), __ptr[this_unit]);\
 		end -= ts;						\
 	}								\
 	if (__start % ts) {						\
@@ -287,18 +287,18 @@
 		cmask >>= (__start % ts);				\
 		cmask &= mask;						\
 		__v = _bt_piecewise_lshift(__v, ts - (__start % ts));	\
-		__v |= _bt_unsigned_cast(typeof(__v), cmask);		\
+		__v |= _bt_unsigned_cast(__typeof__(__v), cmask);		\
 	} else {							\
 		__v = _bt_piecewise_lshift(__v, ts);			\
-		__v |= _bt_unsigned_cast(typeof(__v), __ptr[this_unit]);\
+		__v |= _bt_unsigned_cast(__typeof__(__v), __ptr[this_unit]);\
 	}								\
 	*__vptr = __v;							\
 } while (0)
 
 #define _bt_bitfield_read_be(_ptr, type, _start, _length, _vptr)	\
 do {									\
-	typeof(*(_vptr)) *__vptr = (_vptr);				\
-	typeof(*__vptr) __v;						\
+	__typeof__(*(_vptr)) *__vptr = (_vptr);				\
+	__typeof__(*__vptr) __v;						\
 	type *__ptr = (void *) (_ptr);					\
 	unsigned long __start = (_start), __length = (_length);		\
 	type mask, cmask;						\
@@ -316,9 +316,9 @@
 	end_unit = (end + (ts - 1)) / ts;				\
 									\
 	this_unit = start_unit;						\
-	if (_bt_is_signed_type(typeof(__v))				\
+	if (_bt_is_signed_type(__typeof__(__v))				\
 	    && (__ptr[this_unit] & ((type) 1 << (ts - (__start % ts) - 1)))) \
-		__v = ~(typeof(__v)) 0;					\
+		__v = ~(__typeof__(__v)) 0;					\
 	else								\
 		__v = 0;						\
 	if (start_unit == end_unit - 1) {				\
@@ -329,7 +329,7 @@
 			cmask &= mask;					\
 		}							\
 		__v = _bt_piecewise_lshift(__v, end - __start);		\
-		__v |= _bt_unsigned_cast(typeof(__v), cmask);		\
+		__v |= _bt_unsigned_cast(__typeof__(__v), cmask);		\
 		*__vptr = __v;						\
 		break;							\
 	}								\
@@ -339,13 +339,13 @@
 		cmask = __ptr[this_unit];				\
 		cmask &= mask;						\
 		__v = _bt_piecewise_lshift(__v, ts - cshift);		\
-		__v |= _bt_unsigned_cast(typeof(__v), cmask);		\
+		__v |= _bt_unsigned_cast(__typeof__(__v), cmask);		\
 		__start += ts - cshift;					\
 		this_unit++;						\
 	}								\
 	for (; this_unit < end_unit - 1; this_unit++) {			\
 		__v = _bt_piecewise_lshift(__v, ts);			\
-		__v |= _bt_unsigned_cast(typeof(__v), __ptr[this_unit]);\
+		__v |= _bt_unsigned_cast(__typeof__(__v), __ptr[this_unit]);\
 		__start += ts;						\
 	}								\
 	if (end % ts) {							\
@@ -354,10 +354,10 @@
 		cmask >>= ts - (end % ts);				\
 		cmask &= mask;						\
 		__v = _bt_piecewise_lshift(__v, end % ts);		\
-		__v |= _bt_unsigned_cast(typeof(__v), cmask);		\
+		__v |= _bt_unsigned_cast(__typeof__(__v), cmask);		\
 	} else {							\
 		__v = _bt_piecewise_lshift(__v, ts);			\
-		__v |= _bt_unsigned_cast(typeof(__v), __ptr[this_unit]);\
+		__v |= _bt_unsigned_cast(__typeof__(__v), __ptr[this_unit]);\
 	}								\
 	*__vptr = __v;							\
 } while (0)

=== modified file 'include/lttng/ringbuffer-config.h'
--- include/lttng/ringbuffer-config.h	2012-06-29 16:47:49 +0000
+++ include/lttng/ringbuffer-config.h	2012-09-11 15:34:43 +0000
@@ -27,6 +27,7 @@
 #include <urcu/arch.h>
 #include <string.h>
 #include "lttng/align.h"
+#include <lttng/ust-compiler.h>
 
 struct lttng_ust_lib_ring_buffer;
 struct channel;
@@ -187,6 +188,10 @@
  * Context passed to lib_ring_buffer_reserve(), lib_ring_buffer_commit(),
  * lib_ring_buffer_try_discard_reserve(), lib_ring_buffer_align_ctx() and
  * lib_ring_buffer_write().
+ *
+ * IMPORTANT: this structure is part of the ABI between the probe and
+ * UST. Fields need to be only added at the end, never reordered, never
+ * removed.
  */
 #define LTTNG_UST_RING_BUFFER_CTX_PADDING	24
 struct lttng_ust_lib_ring_buffer_ctx {
@@ -228,6 +233,11 @@
  * @largest_align: largest alignment within data payload types
  * @cpu: processor id
  */
+static inline lttng_ust_notrace
+void lib_ring_buffer_ctx_init(struct lttng_ust_lib_ring_buffer_ctx *ctx,
+			      struct channel *chan, void *priv,
+			      size_t data_size, int largest_align,
+			      int cpu, struct lttng_ust_shm_handle *handle);
 static inline
 void lib_ring_buffer_ctx_init(struct lttng_ust_lib_ring_buffer_ctx *ctx,
 			      struct channel *chan, void *priv,
@@ -275,6 +285,8 @@
  * Calculate the offset needed to align the type.
  * size_of_type must be non-zero.
  */
+static inline lttng_ust_notrace
+unsigned int lib_ring_buffer_align(size_t align_drift, size_t size_of_type);
 static inline
 unsigned int lib_ring_buffer_align(size_t align_drift, size_t size_of_type)
 {
@@ -289,6 +301,8 @@
  * Calculate the offset needed to align the type.
  * size_of_type must be non-zero.
  */
+static inline lttng_ust_notrace
+unsigned int lib_ring_buffer_align(size_t align_drift, size_t size_of_type);
 static inline
 unsigned int lib_ring_buffer_align(size_t align_drift, size_t size_of_type)
 {
@@ -301,6 +315,9 @@
  * lib_ring_buffer_align_ctx - Align context offset on "alignment"
  * @ctx: ring buffer context.
  */
+static inline lttng_ust_notrace
+void lib_ring_buffer_align_ctx(struct lttng_ust_lib_ring_buffer_ctx *ctx,
+			   size_t alignment);
 static inline
 void lib_ring_buffer_align_ctx(struct lttng_ust_lib_ring_buffer_ctx *ctx,
 			   size_t alignment)
@@ -313,6 +330,10 @@
  * lib_ring_buffer_check_config() returns 0 on success.
  * Used internally to check for valid configurations at channel creation.
  */
+static inline lttng_ust_notrace
+int lib_ring_buffer_check_config(const struct lttng_ust_lib_ring_buffer_config *config,
+			     unsigned int switch_timer_interval,
+			     unsigned int read_timer_interval);
 static inline
 int lib_ring_buffer_check_config(const struct lttng_ust_lib_ring_buffer_config *config,
 			     unsigned int switch_timer_interval,

=== modified file 'include/lttng/tracepoint-rcu.h'
--- include/lttng/tracepoint-rcu.h	2012-06-29 16:47:49 +0000
+++ include/lttng/tracepoint-rcu.h	2012-09-11 15:34:43 +0000
@@ -31,12 +31,9 @@
 #define tp_rcu_read_lock_bp	tracepoint_dlopen.rcu_read_lock_sym_bp
 #define tp_rcu_read_unlock_bp	tracepoint_dlopen.rcu_read_unlock_sym_bp
 
-#define tp_rcu_dereference_bp(p)					     \
-	({								     \
-		typeof(p) _________p1 =	URCU_FORCE_CAST(typeof(p),	     \
-			tracepoint_dlopen.rcu_dereference_sym_bp(URCU_FORCE_CAST(void *, p))); \
-		(_________p1);						     \
-	})
+#define tp_rcu_dereference_bp(p)					   \
+		URCU_FORCE_CAST(__typeof__(p),				   \
+			tracepoint_dlopen.rcu_dereference_sym_bp(URCU_FORCE_CAST(void *, p)))
 
 #define TP_RCU_LINK_TEST()	tp_rcu_read_lock_bp
 

=== modified file 'include/lttng/tracepoint-types.h'
--- include/lttng/tracepoint-types.h	2012-06-29 16:47:49 +0000
+++ include/lttng/tracepoint-types.h	2012-09-11 15:34:43 +0000
@@ -16,7 +16,7 @@
  */
 
 struct tracepoint_probe {
-	void *func;
+	void (*func)(void);
 	void *data;
 };
 

=== modified file 'include/lttng/tracepoint.h'
--- include/lttng/tracepoint.h	2012-06-29 16:47:49 +0000
+++ include/lttng/tracepoint.h	2012-09-11 15:34:43 +0000
@@ -22,6 +22,7 @@
 #include <string.h>	/* for memset */
 #include <assert.h>
 #include <lttng/ust-config.h>	/* for sdt */
+#include <lttng/ust-compiler.h>
 
 #ifdef LTTNG_UST_HAVE_SDT_INTEGRATION
 #define SDT_USE_VARIADIC
@@ -137,7 +138,10 @@
 
 #define _DECLARE_TRACEPOINT(_provider, _name, ...)			 		\
 extern struct tracepoint __tracepoint_##_provider##___##_name;				\
-static inline void __tracepoint_cb_##_provider##___##_name(_TP_ARGS_PROTO(__VA_ARGS__))	\
+static inline lttng_ust_notrace								\
+void __tracepoint_cb_##_provider##___##_name(_TP_ARGS_PROTO(__VA_ARGS__));		\
+static inline										\
+void __tracepoint_cb_##_provider##___##_name(_TP_ARGS_PROTO(__VA_ARGS__))		\
 {											\
 	struct tracepoint_probe *__tp_probe;						\
 											\
@@ -148,7 +152,7 @@
 	if (caa_unlikely(!__tp_probe))							\
 		goto end;								\
 	do {										\
-		void *__tp_cb =	__tp_probe->func;					\
+		void (*__tp_cb)(void) = __tp_probe->func;					\
 		void *__tp_data = __tp_probe->data;					\
 											\
 		URCU_FORCE_CAST(void (*)(_TP_ARGS_DATA_PROTO(__VA_ARGS__)), __tp_cb)	\
@@ -157,21 +161,30 @@
 end:											\
 	tp_rcu_read_unlock_bp();							\
 }											\
-static inline void __tracepoint_register_##_provider##___##_name(char *name,		\
-		void *func, void *data)							\
+static inline lttng_ust_notrace								\
+void __tracepoint_register_##_provider##___##_name(char *name,				\
+		void (*func)(void), void *data);					\
+static inline										\
+void __tracepoint_register_##_provider##___##_name(char *name,				\
+		void (*func)(void), void *data)						\
 {											\
 	__tracepoint_probe_register(name, func, data,					\
 		__tracepoint_##_provider##___##_name.signature);			\
 }											\
-static inline void __tracepoint_unregister_##_provider##___##_name(char *name,		\
-		void *func, void *data)							\
+static inline lttng_ust_notrace								\
+void __tracepoint_unregister_##_provider##___##_name(char *name,			\
+		void (*func)(void), void *data);					\
+static inline										\
+void __tracepoint_unregister_##_provider##___##_name(char *name,			\
+		void (*func)(void), void *data)						\
 {											\
 	__tracepoint_probe_unregister(name, func, data);				\
 }
 
-extern int __tracepoint_probe_register(const char *name, void *func, void *data,
-		const char *signature);
-extern int __tracepoint_probe_unregister(const char *name, void *func, void *data);
+extern int __tracepoint_probe_register(const char *name, void (*func)(void),
+		void *data, const char *signature);
+extern int __tracepoint_probe_unregister(const char *name, void (*func)(void),
+		void *data);
 
 /*
  * tracepoint dynamic linkage handling (callbacks). Hidden visibility:
@@ -248,7 +261,10 @@
 struct tracepoint_dlopen tracepoint_dlopen
 	__attribute__((weak, visibility("hidden")));
 
-static void __attribute__((constructor)) __tracepoints__init(void)
+static void lttng_ust_notrace __attribute__((constructor))
+__tracepoints__init(void);
+static void
+__tracepoints__init(void)
 {
 	if (__tracepoint_registered++)
 		return;
@@ -284,7 +300,10 @@
 				__start___tracepoints_ptrs);
 }
 
-static void __attribute__((destructor)) __tracepoints__destroy(void)
+static void lttng_ust_notrace __attribute__((destructor))
+__tracepoints__destroy(void);
+static void
+__tracepoints__destroy(void)
 {
 	int ret;
 

=== modified file 'include/lttng/ust-abi.h'
--- include/lttng/ust-abi.h	2012-06-29 16:47:49 +0000
+++ include/lttng/ust-abi.h	2012-09-11 15:34:43 +0000
@@ -23,9 +23,15 @@
 
 #define LTTNG_UST_SYM_NAME_LEN	256
 
+/* Version for comm protocol between sessiond and ust */
 #define LTTNG_UST_COMM_VERSION_MAJOR		2
 #define LTTNG_UST_COMM_VERSION_MINOR		0
 
+/* Version for ABI between liblttng-ust, sessiond, consumerd */
+#define LTTNG_UST_INTERNAL_MAJOR_VERSION	3
+#define LTTNG_UST_INTERNAL_MINOR_VERSION	0
+#define LTTNG_UST_INTERNAL_PATCHLEVEL_VERSION	0
+
 enum lttng_ust_instrumentation {
 	LTTNG_UST_TRACEPOINT		= 0,
 	LTTNG_UST_PROBE			= 1,
@@ -85,6 +91,24 @@
 	} u;
 };
 
+enum lttng_ust_field_type {
+	LTTNG_UST_FIELD_OTHER			= 0,
+	LTTNG_UST_FIELD_INTEGER			= 1,
+	LTTNG_UST_FIELD_ENUM			= 2,
+	LTTNG_UST_FIELD_FLOAT			= 3,
+	LTTNG_UST_FIELD_STRING			= 4,
+};
+
+#define LTTNG_UST_FIELD_ITER_PADDING		LTTNG_UST_SYM_NAME_LEN + 28
+struct lttng_ust_field_iter {
+	char event_name[LTTNG_UST_SYM_NAME_LEN];
+	char field_name[LTTNG_UST_SYM_NAME_LEN];
+	enum lttng_ust_field_type type;
+	int loglevel;				/* event loglevel */
+	int nowrite;
+	char padding[LTTNG_UST_FIELD_ITER_PADDING];
+};
+
 enum lttng_ust_context_type {
 	LTTNG_UST_CONTEXT_VTID			= 0,
 	LTTNG_UST_CONTEXT_VPID			= 1,
@@ -148,6 +172,13 @@
 	} u;
 };
 
+#define FILTER_BYTECODE_MAX_LEN		65536
+struct lttng_ust_filter_bytecode {
+	uint32_t len;
+	uint32_t reloc_offset;
+	char data[0];
+};
+
 #define _UST_CMD(minor)				(minor)
 #define _UST_CMDR(minor, type)			(minor)
 #define _UST_CMDW(minor, type)			(minor)
@@ -164,6 +195,7 @@
 #define LTTNG_UST_TRACEPOINT_LIST		_UST_CMD(0x42)
 #define LTTNG_UST_WAIT_QUIESCENT		_UST_CMD(0x43)
 #define LTTNG_UST_REGISTER_DONE			_UST_CMD(0x44)
+#define LTTNG_UST_TRACEPOINT_FIELD_LIST		_UST_CMD(0x45)
 
 /* Session FD commands */
 #define LTTNG_UST_METADATA			\
@@ -190,6 +222,10 @@
 
 /* Tracepoint list commands */
 #define LTTNG_UST_TRACEPOINT_LIST_GET		_UST_CMD(0x90)
+#define LTTNG_UST_TRACEPOINT_FIELD_LIST_GET	_UST_CMD(0x91)
+
+/* Event FD commands */
+#define LTTNG_UST_FILTER			_UST_CMD(0xA0)
 
 #define LTTNG_UST_ROOT_HANDLE	0
 
@@ -206,6 +242,9 @@
 		int *wait_fd;
 		uint64_t *memory_map_size;
 	} stream;
+	struct {
+		struct lttng_ust_field_iter entry;
+	} field_list;
 };
 
 struct lttng_ust_objd_ops {

=== added file 'include/lttng/ust-compiler.h'
--- include/lttng/ust-compiler.h	1970-01-01 00:00:00 +0000
+++ include/lttng/ust-compiler.h	2012-09-11 15:34:43 +0000
@@ -0,0 +1,21 @@
+#ifndef _LTTNG_UST_COMPILER_H
+#define _LTTNG_UST_COMPILER_H
+
+/*
+ * Copyright 2011-2012 - Mathieu Desnoyers <mathieu.desnoyers@efficios.com>
+ *                       Paul Woegerer <paul_woegerer@mentor.com>
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ */
+
+#define lttng_ust_notrace __attribute__((no_instrument_function))
+
+#endif /* _LTTNG_UST_COMPILER_H */

=== modified file 'include/lttng/ust-ctl.h'
--- include/lttng/ust-ctl.h	2012-06-29 16:47:49 +0000
+++ include/lttng/ust-ctl.h	2012-09-11 15:34:43 +0000
@@ -37,6 +37,8 @@
 int ustctl_add_context(int sock, struct lttng_ust_context *ctx,
 		struct lttng_ust_object_data *obj_data,
 		struct lttng_ust_object_data **context_data);
+int ustctl_set_filter(int sock, struct lttng_ust_filter_bytecode *bytecode,
+		struct lttng_ust_object_data *obj_data);
 
 int ustctl_enable(int sock, struct lttng_ust_object_data *object);
 int ustctl_disable(int sock, struct lttng_ust_object_data *object);
@@ -55,6 +57,19 @@
 int ustctl_tracepoint_list_get(int sock, int tp_list_handle,
 		struct lttng_ust_tracepoint_iter *iter);
 
+/*
+ * ustctl_tracepoint_field_list returns a tracepoint field list handle,
+ * or negative error value.
+ */
+int ustctl_tracepoint_field_list(int sock);
+
+/*
+ * ustctl_tracepoint_field_list_get is used to iterate on the tp field
+ * list handle. End is iteration is reached when -ENOENT is returned.
+ */
+int ustctl_tracepoint_field_list_get(int sock, int tp_field_list_handle,
+		struct lttng_ust_field_iter *iter);
+
 int ustctl_tracer_version(int sock, struct lttng_ust_tracer_version *v);
 int ustctl_wait_quiescent(int sock);
 

=== added file 'include/lttng/ust-endian.h'
--- include/lttng/ust-endian.h	1970-01-01 00:00:00 +0000
+++ include/lttng/ust-endian.h	2012-09-11 15:34:43 +0000
@@ -0,0 +1,37 @@
+#ifndef _LTTNG_UST_ENDIAN_H
+#define _LTTNG_UST_ENDIAN_H
+
+/*
+ * lttng/ust-endian.h
+ *
+ * Copyright 2012 (c) - Mathieu Desnoyers <mathieu.desnoyers@efficios.com>
+ *
+ * endian.h compatibility layer.
+ *
+ * THIS MATERIAL IS PROVIDED AS IS, WITH ABSOLUTELY NO WARRANTY EXPRESSED
+ * OR IMPLIED.  ANY USE IS AT YOUR OWN RISK.
+ *
+ * Permission is hereby granted to use or copy this program
+ * for any purpose,  provided the above notices are retained on all copies.
+ * Permission to modify the code and to distribute modified code is granted,
+ * provided the above notices are retained, and a notice that the code was
+ * modified is included with the above copyright notice.
+ */
+
+#if (defined(__linux__) || defined(__CYGWIN__))
+#include <endian.h>
+#elif defined(__FreeBSD__)
+#include <machine/endian.h>
+#else
+#error "Please add support for your OS."
+#endif
+
+#ifndef FLOAT_WORD_ORDER
+#ifdef __FLOAT_WORD_ORDER
+#define FLOAT_WORD_ORDER	__FLOAT_WORD_ORDER
+#else /* __FLOAT_WORD_ORDER */
+#define FLOAT_WORD_ORDER	BYTE_ORDER
+#endif /* __FLOAT_WORD_ORDER */
+#endif /* FLOAT_WORD_ORDER */
+
+#endif /* _LTTNG_UST_ENDIAN_H */

=== modified file 'include/lttng/ust-events.h'
--- include/lttng/ust-events.h	2012-06-29 16:47:49 +0000
+++ include/lttng/ust-events.h	2012-09-11 15:34:43 +0000
@@ -21,13 +21,14 @@
 
 #include <urcu/list.h>
 #include <urcu/hlist.h>
-#include <uuid/uuid.h>
 #include <stdint.h>
 #include <lttng/ust-abi.h>
 #include <lttng/ust-tracer.h>
-#include <endian.h>
+#include <lttng/ust-endian.h>
 #include <float.h>
 
+#define LTTNG_UST_UUID_LEN		16
+
 struct ltt_channel;
 struct ltt_session;
 struct lttng_ust_lib_ring_buffer_ctx;
@@ -84,7 +85,7 @@
 		  .size = sizeof(_type) * CHAR_BIT,		\
 		  .alignment = lttng_alignof(_type) * CHAR_BIT,	\
 		  .signedness = lttng_is_signed_type(_type),	\
-		  .reverse_byte_order = _byte_order != __BYTE_ORDER,	\
+		  .reverse_byte_order = _byte_order != BYTE_ORDER,	\
 		  .base = _base,				\
 		  .encoding = lttng_encode_##_encoding,		\
 		},						\
@@ -119,7 +120,7 @@
 				- _float_mant_dig(_type),	\
 		  .mant_dig = _float_mant_dig(_type),		\
 		  .alignment = lttng_alignof(_type) * CHAR_BIT,	\
-		  .reverse_byte_order = __BYTE_ORDER != __FLOAT_WORD_ORDER, \
+		  .reverse_byte_order = BYTE_ORDER != FLOAT_WORD_ORDER, \
 		},						\
 	}							\
 
@@ -178,12 +179,19 @@
 	char padding[LTTNG_UST_ENUM_TYPE_PADDING];
 };
 
-/* Event field description */
+/*
+ * Event field description
+ *
+ * IMPORTANT: this structure is part of the ABI between the probe and
+ * UST. Fields need to be only added at the end, never reordered, never
+ * removed.
+ */
 
-#define LTTNG_UST_EVENT_FIELD_PADDING	32
+#define LTTNG_UST_EVENT_FIELD_PADDING	28
 struct lttng_event_field {
 	const char *name;
 	struct lttng_type type;
+	unsigned int nowrite;	/* do not write into trace */
 	char padding[LTTNG_UST_EVENT_FIELD_PADDING];
 };
 
@@ -211,7 +219,7 @@
 #define LTTNG_UST_EVENT_DESC_PADDING	40
 struct lttng_event_desc {
 	const char *name;
-	void *probe_callback;
+	void (*probe_callback)(void);
 	const struct lttng_event_ctx *ctx;	/* context */
 	const struct lttng_event_field *fields;	/* event payload */
 	unsigned int nr_fields;
@@ -244,6 +252,7 @@
 	struct cds_list_head list;	/* per-session list of wildcards */
 	struct cds_list_head session_list; /* node of session wildcard list */
 	struct wildcard_entry *entry;
+	struct lttng_ust_filter_bytecode *filter_bytecode;
 	unsigned int enabled:1;
 };
 
@@ -256,6 +265,7 @@
 	/* head of session list to which this wildcard apply */
 	struct cds_list_head session_list;
 	enum lttng_ust_loglevel_type loglevel_type;
+	struct lttng_ust_filter_bytecode *filter_bytecode;
 	int loglevel;
 	char name[0];
 };
@@ -270,18 +280,35 @@
 	struct cds_list_head head;
 };
 
+struct tp_field_list_entry {
+	struct lttng_ust_field_iter field;
+	struct cds_list_head head;
+};
+
+struct lttng_ust_field_list {
+	struct tp_field_list_entry *iter;
+	struct cds_list_head head;
+};
+
 struct ust_pending_probe;
+struct ltt_event;
+struct lttng_ust_filter_bytecode;
 
 /*
  * ltt_event structure is referred to by the tracing fast path. It must be
  * kept small.
+ *
+ * IMPORTANT: this structure is part of the ABI between the probe and
+ * UST. Fields need to be only added at the end, never reordered, never
+ * removed.
  */
 struct ltt_event {
+	/* LTTng-UST 2.0 starts here */
 	unsigned int id;
 	struct ltt_channel *chan;
 	int enabled;
 	const struct lttng_event_desc *desc;
-	void *filter;
+	int (*filter)(void *filter_data, const char *filter_stack_data);
 	struct lttng_ctx *ctx;
 	enum lttng_ust_instrumentation instrumentation;
 	union {
@@ -290,11 +317,19 @@
 	struct cds_list_head wildcard_list;	/* Event list for wildcard */
 	struct ust_pending_probe *pending_probe;
 	unsigned int metadata_dumped:1;
+	/* LTTng-UST 2.1 starts here */
+	struct lttng_ust_filter_bytecode *filter_bytecode;
+	void *filter_data;
 };
 
 struct channel;
 struct lttng_ust_shm_handle;
 
+/*
+ * IMPORTANT: this structure is part of the ABI between the probe and
+ * UST. Fields need to be only added at the end, never reordered, never
+ * removed.
+ */
 struct ltt_channel_ops {
 	struct ltt_channel *(*channel_create)(const char *name,
 				void *buf_addr,
@@ -330,6 +365,11 @@
 	int (*flush_buffer)(struct channel *chan, struct lttng_ust_shm_handle *handle);
 };
 
+/*
+ * IMPORTANT: this structure is part of the ABI between the probe and
+ * UST. Fields need to be only added at the end, never reordered, never
+ * removed.
+ */
 struct ltt_channel {
 	/*
 	 * The pointers located in this private data are NOT safe to be
@@ -354,9 +394,14 @@
 	/* Channel ID, available for consumer too */
 	unsigned int id;
 	/* Copy of session UUID for consumer (availability through shm) */
-	uuid_t uuid;			/* Trace session unique ID */
+	unsigned char uuid[LTTNG_UST_UUID_LEN]; /* Trace session unique ID */
 };
 
+/*
+ * IMPORTANT: this structure is part of the ABI between the probe and
+ * UST. Fields need to be only added at the end, never reordered, never
+ * removed.
+ */
 struct ltt_session {
 	int active;			/* Is trace session active ? */
 	int been_active;		/* Has trace session been active ? */
@@ -367,7 +412,7 @@
 	struct cds_list_head wildcards;	/* Wildcard list head */
 	struct cds_list_head list;	/* Session list */
 	unsigned int free_chan_id;	/* Next chan ID to allocate */
-	uuid_t uuid;			/* Trace session unique ID */
+	unsigned char uuid[LTTNG_UST_UUID_LEN]; /* Trace session unique ID */
 	unsigned int metadata_dumped:1;
 };
 
@@ -401,7 +446,6 @@
 
 int ltt_event_create(struct ltt_channel *chan,
 		struct lttng_ust_event *event_param,
-		void *filter,
 		struct ltt_event **event);
 
 int ltt_channel_enable(struct ltt_channel *channel);
@@ -443,6 +487,10 @@
 void ltt_probes_prune_event_list(struct lttng_ust_tracepoint_list *list);
 struct lttng_ust_tracepoint_iter *
 	lttng_ust_tracepoint_list_get_iter_next(struct lttng_ust_tracepoint_list *list);
+int ltt_probes_get_field_list(struct lttng_ust_field_list *list);
+void ltt_probes_prune_field_list(struct lttng_ust_field_list *list);
+struct lttng_ust_field_iter *
+	lttng_ust_field_list_get_iter_next(struct lttng_ust_field_list *list);
 
 int ltt_wildcard_enable(struct session_wildcard *wildcard);
 int ltt_wildcard_disable(struct session_wildcard *wildcard);
@@ -454,5 +502,12 @@
 		int req_loglevel);
 void ltt_probes_create_wildcard_events(struct wildcard_entry *entry,
 				struct session_wildcard *wildcard);
+int lttng_filter_event_attach_bytecode(struct ltt_event *event,
+                struct lttng_ust_filter_bytecode *filter);
+int lttng_filter_wildcard_attach_bytecode(struct session_wildcard *wildcard,
+                struct lttng_ust_filter_bytecode *filter);
+void lttng_filter_event_link_bytecode(struct ltt_event *event,
+		struct lttng_ust_filter_bytecode *filter_bytecode);
+void lttng_filter_wildcard_link_bytecode(struct session_wildcard *wildcard);
 
 #endif /* _LTTNG_UST_EVENTS_H */

=== added file 'include/lttng/ust-tid.h'
--- include/lttng/ust-tid.h	1970-01-01 00:00:00 +0000
+++ include/lttng/ust-tid.h	2012-09-11 15:34:43 +0000
@@ -0,0 +1,44 @@
+#ifndef _LTTNG_UST_TID_H
+#define _LTTNG_UST_TID_H
+
+/*
+ * lttng/ust-tid.h
+ *
+ * Copyright 2012 (c) - Mathieu Desnoyers <mathieu.desnoyers@efficios.com>
+ *
+ * gettid compatibility layer.
+ *
+ * THIS MATERIAL IS PROVIDED AS IS, WITH ABSOLUTELY NO WARRANTY EXPRESSED
+ * OR IMPLIED.  ANY USE IS AT YOUR OWN RISK.
+ *
+ * Permission is hereby granted to use or copy this program
+ * for any purpose,  provided the above notices are retained on all copies.
+ * Permission to modify the code and to distribute modified code is granted,
+ * provided the above notices are retained, and a notice that the code was
+ * modified is included with the above copyright notice.
+ */
+
+#ifdef __linux__
+#include <syscall.h>
+#endif
+
+#if defined(_syscall0)
+_syscall0(pid_t, gettid)
+#elif defined(__NR_gettid)
+#include <unistd.h>
+static inline pid_t gettid(void)
+{
+	return syscall(__NR_gettid);
+}
+#else
+#include <sys/types.h>
+#include <unistd.h>
+
+/* Fall-back on getpid for tid if not available. */
+static inline pid_t gettid(void)
+{
+	return getpid();
+}
+#endif
+
+#endif /* _LTTNG_UST_TID_H */

=== added file 'include/lttng/ust-tracepoint-event-nowrite.h'
--- include/lttng/ust-tracepoint-event-nowrite.h	1970-01-01 00:00:00 +0000
+++ include/lttng/ust-tracepoint-event-nowrite.h	2012-09-11 15:34:43 +0000
@@ -0,0 +1,43 @@
+/*
+ * Copyright (c) 2011 - Mathieu Desnoyers <mathieu.desnoyers@efficios.com>
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ */
+
+#undef ctf_integer_nowrite
+#define ctf_integer_nowrite(_type, _item, _src)			\
+	_ctf_integer_ext(_type, _item, _src, BYTE_ORDER, 10, 1)
+
+#undef ctf_float_nowrite
+#define ctf_float_nowrite(_type, _item, _src)			\
+	_ctf_float(_type, _item, _src, 1)
+
+#undef ctf_array_nowrite
+#define ctf_array_nowrite(_type, _item, _src, _length)		\
+	_ctf_array_encoded(_type, _item, _src, _length, none, 1)
+
+#undef ctf_array_text_nowrite
+#define ctf_array_text_nowrite(_type, _item, _src, _length)	\
+	_ctf_array_encoded(_type, _item, _src, _length, UTF8, 1)
+
+#undef ctf_sequence_nowrite
+#define ctf_sequence_nowrite(_type, _item, _src, _length_type, _src_length) \
+	_ctf_sequence_encoded(_type, _item, _src,		\
+			_length_type, _src_length, none, 1)
+
+#undef ctf_sequence_text_nowrite
+#define ctf_sequence_text_nowrite(_type, _item, _src, _length_type, _src_length) \
+	_ctf_sequence_encoded(_type, _item, _src,		\
+			_length_type, _src_length, UTF8, 1)
+
+#undef ctf_string_nowrite
+#define ctf_string_nowrite(_item, _src)				\
+	_ctf_string(_item, _src, 1)

=== modified file 'include/lttng/ust-tracepoint-event-reset.h'
--- include/lttng/ust-tracepoint-event-reset.h	2012-06-29 16:47:49 +0000
+++ include/lttng/ust-tracepoint-event-reset.h	2012-09-11 15:34:43 +0000
@@ -26,24 +26,79 @@
 #undef TP_FIELDS
 #define TP_FIELDS(...)
 
-#undef ctf_integer_ext
-#define ctf_integer_ext(_type, _item, _src, _byte_order, _base)
+#undef  TRACEPOINT_LOGLEVEL_ENUM
+#define TRACEPOINT_LOGLEVEL_ENUM(...)
+
+#undef TRACEPOINT_LOGLEVEL
+#define TRACEPOINT_LOGLEVEL(provider, name, loglevel)
+
+#undef _ctf_integer_ext
+#define _ctf_integer_ext(_type, _item, _src, _byte_order, _base, \
+			_nowrite)
+
+#undef _ctf_float
+#define _ctf_float(_type, _item, _src, _nowrite)
+
+#undef _ctf_array_encoded
+#define _ctf_array_encoded(_type, _item, _src, _length, _encoding, \
+			_nowrite)
+
+#undef _ctf_sequence_encoded
+#define _ctf_sequence_encoded(_type, _item, _src, _length_type, \
+			_src_length, _encoding, _nowrite)
+
+#undef _ctf_string
+#define _ctf_string(_item, _src, _nowrite)
+
+/* "write" */
+#undef ctf_integer
+#define ctf_integer(_type, _item, _src)
+
+#undef ctf_integer_hex
+#define ctf_integer_hex(_type, _item, _src)
+
+#undef ctf_integer_network
+#define ctf_integer_network(_type, _item, _src)
+
+#undef ctf_integer_network_hex
+#define ctf_integer_network_hex(_type, _item, _src)
 
 #undef ctf_float
 #define ctf_float(_type, _item, _src)
 
-#undef ctf_array_encoded
-#define ctf_array_encoded(_type, _item, _src, _length, _encoding)
-
-#undef ctf_sequence_encoded
-#define ctf_sequence_encoded(_type, _item, _src, _length_type, \
-			_src_length, _encoding)
+#undef ctf_array
+#define ctf_array(_type, _item, _src, _length)
+
+#undef ctf_array_text
+#define ctf_array_text(_type, _item, _src, _length)
+
+#undef ctf_sequence
+#define ctf_sequence(_type, _item, _src, _length_type, _src_length)
+
+#undef ctf_sequence_text
+#define ctf_sequence_text(_type, _item, _src, _length_type, _src_length)
 
 #undef ctf_string
 #define ctf_string(_item, _src)
 
-#undef  TRACEPOINT_LOGLEVEL_ENUM
-#define TRACEPOINT_LOGLEVEL_ENUM(...)
-
-#undef TRACEPOINT_LOGLEVEL
-#define TRACEPOINT_LOGLEVEL(provider, name, loglevel)
+/* "nowrite" */
+#undef ctf_integer_nowrite
+#define ctf_integer_nowrite(_type, _item, _src)
+
+#undef ctf_float_nowrite
+#define ctf_float_nowrite(_type, _item, _src)
+
+#undef ctf_array_nowrite
+#define ctf_array_nowrite(_type, _item, _src, _length)
+
+#undef ctf_array_text_nowrite
+#define ctf_array_text_nowrite(_type, _item, _src, _length)
+
+#undef ctf_sequence_nowrite
+#define ctf_sequence_nowrite(_type, _item, _src, _length_type, _src_length)
+
+#undef ctf_sequence_text_nowrite
+#define ctf_sequence_text_nowrite(_type, _item, _src, _length_type, _src_length)
+
+#undef ctf_string_nowrite
+#define ctf_string_nowrite(_item, _src)

=== added file 'include/lttng/ust-tracepoint-event-write.h'
--- include/lttng/ust-tracepoint-event-write.h	1970-01-01 00:00:00 +0000
+++ include/lttng/ust-tracepoint-event-write.h	2012-09-11 15:34:43 +0000
@@ -0,0 +1,55 @@
+/*
+ * Copyright (c) 2011 - Mathieu Desnoyers <mathieu.desnoyers@efficios.com>
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ */
+
+#undef ctf_integer
+#define ctf_integer(_type, _item, _src)				\
+	_ctf_integer_ext(_type, _item, _src, BYTE_ORDER, 10, 0)
+
+#undef ctf_integer_hex
+#define ctf_integer_hex(_type, _item, _src)			\
+	_ctf_integer_ext(_type, _item, _src, BYTE_ORDER, 16, 0)
+
+#undef ctf_integer_network
+#define ctf_integer_network(_type, _item, _src)			\
+	_ctf_integer_ext(_type, _item, _src, BIG_ENDIAN, 10, 0)
+
+#undef ctf_integer_network_hex
+#define ctf_integer_network_hex(_type, _item, _src)		\
+	_ctf_integer_ext(_type, _item, _src, BIG_ENDIAN, 16, 0)
+
+#undef ctf_float
+#define ctf_float(_type, _item, _src)				\
+	_ctf_float(_type, _item, _src, 0)
+
+#undef ctf_array
+#define ctf_array(_type, _item, _src, _length)			\
+	_ctf_array_encoded(_type, _item, _src, _length, none, 0)
+
+#undef ctf_array_text
+#define ctf_array_text(_type, _item, _src, _length)		\
+	_ctf_array_encoded(_type, _item, _src, _length, UTF8, 0)
+
+#undef ctf_sequence
+#define ctf_sequence(_type, _item, _src, _length_type, _src_length) \
+	_ctf_sequence_encoded(_type, _item, _src,		\
+			_length_type, _src_length, none, 0)
+
+#undef ctf_sequence_text
+#define ctf_sequence_text(_type, _item, _src, _length_type, _src_length) \
+	_ctf_sequence_encoded(_type, _item, _src,		\
+			_length_type, _src_length, UTF8, 0)
+
+#undef ctf_string
+#define ctf_string(_item, _src)					\
+	_ctf_string(_item, _src, 0)

=== modified file 'include/lttng/ust-tracepoint-event.h'
--- include/lttng/ust-tracepoint-event.h	2012-06-29 16:47:49 +0000
+++ include/lttng/ust-tracepoint-event.h	2012-09-11 15:34:43 +0000
@@ -16,51 +16,10 @@
 #include <urcu/compiler.h>
 #include <lttng/ust-events.h>
 #include <lttng/ringbuffer-config.h>
+#include <lttng/ust-compiler.h>
 #include <string.h>
 
 /*
- * Macro declarations used for all stages.
- */
-
-#undef ctf_integer
-#define ctf_integer(_type, _item, _src)				\
-	ctf_integer_ext(_type, _item, _src, BYTE_ORDER, 10)
-
-#undef ctf_integer_hex
-#define ctf_integer_hex(_type, _item, _src)			\
-	ctf_integer_ext(_type, _item, _src, BYTE_ORDER, 16)
-
-#undef ctf_integer_network
-#define ctf_integer_network(_type, _item, _src)			\
-	ctf_integer_ext(_type, _item, _src, BIG_ENDIAN, 10)
-
-#undef ctf_integer_network_hex
-#define ctf_integer_network_hex(_type, _item, _src)		\
-	ctf_integer_ext(_type, _item, _src, BIG_ENDIAN, 16)
-
-/* ctf_float is redefined at each step */
-
-#undef ctf_array
-#define ctf_array(_type, _item, _src, _length)			\
-	ctf_array_encoded(_type, _item, _src, _length, none)
-
-#undef ctf_array_text
-#define ctf_array_text(_type, _item, _src, _length)		\
-	ctf_array_encoded(_type, _item, _src, _length, UTF8)
-
-#undef ctf_sequence
-#define ctf_sequence(_type, _item, _src, _length_type, _src_length)	\
-	ctf_sequence_encoded(_type, _item, _src,			\
-			_length_type, _src_length, none)
-
-#undef ctf_sequence_text
-#define ctf_sequence_text(_type, _item, _src, _length_type, _src_length) \
-	ctf_sequence_encoded(_type, _item, _src,			 \
-			_length_type, _src_length, UTF8)
-
-/* ctf_string is redefined at each step */
-
-/*
  * TRACEPOINT_EVENT_CLASS declares a class of tracepoints receiving the
  * same arguments and having the same field layout.
  *
@@ -146,23 +105,27 @@
 
 /* Reset all macros within TRACEPOINT_EVENT */
 #include <lttng/ust-tracepoint-event-reset.h>
+#include <lttng/ust-tracepoint-event-write.h>
+#include <lttng/ust-tracepoint-event-nowrite.h>
 
-#undef ctf_integer_ext
-#define ctf_integer_ext(_type, _item, _src, _byte_order, _base)	\
+#undef _ctf_integer_ext
+#define _ctf_integer_ext(_type, _item, _src, _byte_order, _base, _nowrite)	\
 	{							\
 	  .name = #_item,					\
 	  .type = __type_integer(_type, _byte_order, _base, none),\
+	  .nowrite = _nowrite,					\
 	},
 
-#undef ctf_float
-#define ctf_float(_type, _item, _src)				\
+#undef _ctf_float
+#define _ctf_float(_type, _item, _src, _nowrite)		\
 	{							\
 	  .name = #_item,					\
 	  .type = __type_float(_type),				\
+	  .nowrite = _nowrite,					\
 	},
 
-#undef ctf_array_encoded
-#define ctf_array_encoded(_type, _item, _src, _length, _encoding) \
+#undef _ctf_array_encoded
+#define _ctf_array_encoded(_type, _item, _src, _length, _encoding, _nowrite) \
 	{							\
 	  .name = #_item,					\
 	  .type =						\
@@ -174,11 +137,12 @@
 			    .elem_type = __type_integer(_type, BYTE_ORDER, 10, _encoding), \
 			},					\
 		},						\
+	  .nowrite = _nowrite,					\
 	},
 
-#undef ctf_sequence_encoded
-#define ctf_sequence_encoded(_type, _item, _src,	\
-			_length_type, _src_length, _encoding)	\
+#undef _ctf_sequence_encoded
+#define _ctf_sequence_encoded(_type, _item, _src,	\
+			_length_type, _src_length, _encoding, _nowrite)	\
 	{							\
 	  .name = #_item,					\
 	  .type =						\
@@ -190,10 +154,11 @@
 			    .elem_type = __type_integer(_type, BYTE_ORDER, 10, _encoding), \
 			},					\
 		},						\
+	  .nowrite = _nowrite,					\
 	},
 
-#undef ctf_string
-#define ctf_string(_item, _src)					\
+#undef _ctf_string
+#define _ctf_string(_item, _src, _nowrite)			\
 	{							\
 	  .name = #_item,					\
 	  .type =						\
@@ -201,6 +166,7 @@
 		  .atype = atype_string,			\
 		  .u.basic.string.encoding = lttng_encode_UTF8,	\
 		},						\
+	  .nowrite = _nowrite,					\
 	},
 
 #undef TP_FIELDS
@@ -240,25 +206,26 @@
 
 /* Reset all macros within TRACEPOINT_EVENT */
 #include <lttng/ust-tracepoint-event-reset.h>
-
-#undef ctf_integer_ext
-#define ctf_integer_ext(_type, _item, _src, _byte_order, _base)		       \
-	__event_len += lib_ring_buffer_align(__event_len, lttng_alignof(_type)); \
-	__event_len += sizeof(_type);
-
-#undef ctf_float
-#define ctf_float(_type, _item, _src)		      			       \
-	__event_len += lib_ring_buffer_align(__event_len, lttng_alignof(_type)); \
-	__event_len += sizeof(_type);
-
-#undef ctf_array_encoded
-#define ctf_array_encoded(_type, _item, _src, _length, _encoding)	       \
+#include <lttng/ust-tracepoint-event-write.h>
+
+#undef _ctf_integer_ext
+#define _ctf_integer_ext(_type, _item, _src, _byte_order, _base, _nowrite)       \
+	__event_len += lib_ring_buffer_align(__event_len, lttng_alignof(_type)); \
+	__event_len += sizeof(_type);
+
+#undef _ctf_float
+#define _ctf_float(_type, _item, _src, _nowrite)				 \
+	__event_len += lib_ring_buffer_align(__event_len, lttng_alignof(_type)); \
+	__event_len += sizeof(_type);
+
+#undef _ctf_array_encoded
+#define _ctf_array_encoded(_type, _item, _src, _length, _encoding, _nowrite)     \
 	__event_len += lib_ring_buffer_align(__event_len, lttng_alignof(_type)); \
 	__event_len += sizeof(_type) * (_length);
 
-#undef ctf_sequence_encoded
-#define ctf_sequence_encoded(_type, _item, _src, _length_type,	\
-			_src_length, _encoding)			\
+#undef _ctf_sequence_encoded
+#define _ctf_sequence_encoded(_type, _item, _src, _length_type,	\
+			_src_length, _encoding, _nowrite)	\
 	__event_len += lib_ring_buffer_align(__event_len, lttng_alignof(_length_type));   \
 	__event_len += sizeof(_length_type);				       \
 	__event_len += lib_ring_buffer_align(__event_len, lttng_alignof(_type)); \
@@ -266,8 +233,8 @@
 	__event_len += sizeof(_type) * __dynamic_len[__dynamic_len_idx];       \
 	__dynamic_len_idx++;
 
-#undef ctf_string
-#define ctf_string(_item, _src)						       \
+#undef _ctf_string
+#define _ctf_string(_item, _src, _nowrite)				       \
 	__event_len += __dynamic_len[__dynamic_len_idx++] = strlen(_src) + 1;
 
 #undef TP_ARGS
@@ -277,8 +244,11 @@
 #define TP_FIELDS(...) __VA_ARGS__
 
 #undef TRACEPOINT_EVENT_CLASS
-#define TRACEPOINT_EVENT_CLASS(_provider, _name, _args, _fields)      \
-static inline size_t __event_get_size__##_provider##___##_name(size_t *__dynamic_len, _TP_ARGS_DATA_PROTO(_args)) \
+#define TRACEPOINT_EVENT_CLASS(_provider, _name, _args, _fields)	      \
+static inline lttng_ust_notrace						      \
+size_t __event_get_size__##_provider##___##_name(size_t *__dynamic_len, _TP_ARGS_DATA_PROTO(_args)); \
+static inline								      \
+size_t __event_get_size__##_provider##___##_name(size_t *__dynamic_len, _TP_ARGS_DATA_PROTO(_args)) \
 {									      \
 	size_t __event_len = 0;						      \
 	unsigned int __dynamic_len_idx = 0;				      \
@@ -292,6 +262,84 @@
 #include TRACEPOINT_INCLUDE
 
 /*
+ * Stage 3.1 of tracepoint event generation.
+ *
+ * Create static inline function that layout the filter stack data.
+ * We make both write and nowrite data available to the filter.
+ */
+
+/* Reset all macros within TRACEPOINT_EVENT */
+#include <lttng/ust-tracepoint-event-reset.h>
+#include <lttng/ust-tracepoint-event-write.h>
+#include <lttng/ust-tracepoint-event-nowrite.h>
+
+#undef _ctf_integer_ext
+#define _ctf_integer_ext(_type, _item, _src, _byte_order, _base, _nowrite)     \
+	if (lttng_is_signed_type(_type)) {				       \
+		int64_t __ctf_tmp_int64 = (int64_t) (_type) (_src);	       \
+		memcpy(__stack_data, &__ctf_tmp_int64, sizeof(int64_t));       \
+	} else {							       \
+		uint64_t __ctf_tmp_uint64 = (uint64_t) (_type) (_src);	       \
+		memcpy(__stack_data, &__ctf_tmp_uint64, sizeof(uint64_t));     \
+	}								       \
+	__stack_data += sizeof(int64_t);
+
+#undef _ctf_float
+#define _ctf_float(_type, _item, _src, _nowrite)			       \
+	{								       \
+		double __ctf_tmp_double = (double) (_type) (_src);	       \
+		memcpy(__stack_data, &__ctf_tmp_double, sizeof(double));       \
+		__stack_data += sizeof(double);				       \
+	}
+
+#undef _ctf_array_encoded
+#define _ctf_array_encoded(_type, _item, _src, _length, _encoding, _nowrite)   \
+	{								       \
+		unsigned long __ctf_tmp_ulong = (unsigned long) (_length);     \
+		memcpy(__stack_data, &__ctf_tmp_ulong, sizeof(unsigned long)); \
+		__stack_data += sizeof(unsigned long);			       \
+		memcpy(__stack_data, &(_src), sizeof(void **));		       \
+		__stack_data += sizeof(void **);			       \
+	}
+
+#undef _ctf_sequence_encoded
+#define _ctf_sequence_encoded(_type, _item, _src, _length_type,		       \
+			_src_length, _encoding, _nowrite)		       \
+	{								       \
+		unsigned long __ctf_tmp_ulong = (unsigned long) (_src_length); \
+		memcpy(__stack_data, &__ctf_tmp_ulong, sizeof(unsigned long)); \
+		__stack_data += sizeof(unsigned long);			       \
+		memcpy(__stack_data, &(_src), sizeof(void **));		       \
+		__stack_data += sizeof(void **);			       \
+	}
+
+#undef _ctf_string
+#define _ctf_string(_item, _src, _nowrite)				       \
+	{								       \
+		memcpy(__stack_data, &(_src), sizeof(void **));		       \
+		__stack_data += sizeof(void **);			       \
+	}
+
+#undef TP_ARGS
+#define TP_ARGS(...) __VA_ARGS__
+
+#undef TP_FIELDS
+#define TP_FIELDS(...) __VA_ARGS__
+
+#undef TRACEPOINT_EVENT_CLASS
+#define TRACEPOINT_EVENT_CLASS(_provider, _name, _args, _fields)	      \
+static inline								      \
+void __event_prepare_filter_stack__##_provider##___##_name(char *__stack_data,\
+						 _TP_ARGS_DATA_PROTO(_args))  \
+{									      \
+	_fields								      \
+}
+
+#include TRACEPOINT_INCLUDE
+
+
+
+/*
  * Stage 4 of tracepoint event generation.
  *
  * Create static inline function that calculates event payload alignment.
@@ -299,27 +347,28 @@
 
 /* Reset all macros within TRACEPOINT_EVENT */
 #include <lttng/ust-tracepoint-event-reset.h>
-
-#undef ctf_integer_ext
-#define ctf_integer_ext(_type, _item, _src, _byte_order, _base)		       \
-	__event_align = _tp_max_t(size_t, __event_align, lttng_alignof(_type));
-
-#undef ctf_float
-#define ctf_float(_type, _item, _src)					       \
-	__event_align = _tp_max_t(size_t, __event_align, lttng_alignof(_type));
-
-#undef ctf_array_encoded
-#define ctf_array_encoded(_type, _item, _src, _length, _encoding)	       \
-	__event_align = _tp_max_t(size_t, __event_align, lttng_alignof(_type));
-
-#undef ctf_sequence_encoded
-#define ctf_sequence_encoded(_type, _item, _src, _length_type,	\
-			_src_length, _encoding)			\
+#include <lttng/ust-tracepoint-event-write.h>
+
+#undef _ctf_integer_ext
+#define _ctf_integer_ext(_type, _item, _src, _byte_order, _base, _nowrite)     \
+	__event_align = _tp_max_t(size_t, __event_align, lttng_alignof(_type));
+
+#undef _ctf_float
+#define _ctf_float(_type, _item, _src, _nowrite)			       \
+	__event_align = _tp_max_t(size_t, __event_align, lttng_alignof(_type));
+
+#undef _ctf_array_encoded
+#define _ctf_array_encoded(_type, _item, _src, _length, _encoding, _nowrite)   \
+	__event_align = _tp_max_t(size_t, __event_align, lttng_alignof(_type));
+
+#undef _ctf_sequence_encoded
+#define _ctf_sequence_encoded(_type, _item, _src, _length_type,	\
+			_src_length, _encoding, _nowrite)	\
 	__event_align = _tp_max_t(size_t, __event_align, lttng_alignof(_length_type));	  \
 	__event_align = _tp_max_t(size_t, __event_align, lttng_alignof(_type));
 
-#undef ctf_string
-#define ctf_string(_item, _src)
+#undef _ctf_string
+#define _ctf_string(_item, _src, _nowrite)
 
 #undef TP_ARGS
 #define TP_ARGS(...) __VA_ARGS__
@@ -329,6 +378,8 @@
 
 #undef TRACEPOINT_EVENT_CLASS
 #define TRACEPOINT_EVENT_CLASS(_provider, _name, _args, _fields)	      \
+static inline lttng_ust_notrace						      \
+size_t __event_get_align__##_provider##___##_name(_TP_ARGS_PROTO(_args));     \
 static inline								      \
 size_t __event_get_align__##_provider##___##_name(_TP_ARGS_PROTO(_args))      \
 {									      \
@@ -349,33 +400,34 @@
 
 /* Reset all macros within TRACEPOINT_EVENT */
 #include <lttng/ust-tracepoint-event-reset.h>
-
-#undef ctf_integer_ext
-#define ctf_integer_ext(_type, _item, _src, _byte_order, _base)	        \
-	{								\
-		_type __tmp = (_src);					\
-		lib_ring_buffer_align_ctx(&__ctx, lttng_alignof(__tmp));\
-		__chan->ops->event_write(&__ctx, &__tmp, sizeof(__tmp));\
-	}
-
-#undef ctf_float
-#define ctf_float(_type, _item, _src)				        \
-	{								\
-		_type __tmp = (_src);					\
-		lib_ring_buffer_align_ctx(&__ctx, lttng_alignof(__tmp));\
-		__chan->ops->event_write(&__ctx, &__tmp, sizeof(__tmp));\
-	}
-
-#undef ctf_array_encoded
-#define ctf_array_encoded(_type, _item, _src, _length, _encoding)       \
+#include <lttng/ust-tracepoint-event-write.h>
+
+#undef _ctf_integer_ext
+#define _ctf_integer_ext(_type, _item, _src, _byte_order, _base, _nowrite) \
+	{								\
+		_type __tmp = (_src);					\
+		lib_ring_buffer_align_ctx(&__ctx, lttng_alignof(__tmp));\
+		__chan->ops->event_write(&__ctx, &__tmp, sizeof(__tmp));\
+	}
+
+#undef _ctf_float
+#define _ctf_float(_type, _item, _src, _nowrite)		        \
+	{								\
+		_type __tmp = (_src);					\
+		lib_ring_buffer_align_ctx(&__ctx, lttng_alignof(__tmp));\
+		__chan->ops->event_write(&__ctx, &__tmp, sizeof(__tmp));\
+	}
+
+#undef _ctf_array_encoded
+#define _ctf_array_encoded(_type, _item, _src, _length, _encoding, _nowrite) \
 	lib_ring_buffer_align_ctx(&__ctx, lttng_alignof(_type));	\
 	__chan->ops->event_write(&__ctx, _src, sizeof(_type) * (_length));
 
-#undef ctf_sequence_encoded
-#define ctf_sequence_encoded(_type, _item, _src, _length_type,		\
-			_src_length, _encoding)			\
+#undef _ctf_sequence_encoded
+#define _ctf_sequence_encoded(_type, _item, _src, _length_type,		\
+			_src_length, _encoding, _nowrite)		\
 	{								\
-		_length_type __tmpl = __dynamic_len[__dynamic_len_idx];	\
+		_length_type __tmpl = __stackvar.__dynamic_len[__dynamic_len_idx]; \
 		lib_ring_buffer_align_ctx(&__ctx, lttng_alignof(_length_type));\
 		__chan->ops->event_write(&__ctx, &__tmpl, sizeof(_length_type));\
 	}								\
@@ -383,14 +435,14 @@
 	__chan->ops->event_write(&__ctx, _src,				\
 		sizeof(_type) * __get_dynamic_len(dest));
 
-#undef ctf_string
-#define ctf_string(_item, _src)					        \
+#undef _ctf_string
+#define _ctf_string(_item, _src, _nowrite)			        \
 	lib_ring_buffer_align_ctx(&__ctx, lttng_alignof(*(_src)));	\
 	__chan->ops->event_write(&__ctx, _src, __get_dynamic_len(dest));
 
 /* Beware: this get len actually consumes the len value */
 #undef __get_dynamic_len
-#define __get_dynamic_len(field)	__dynamic_len[__dynamic_len_idx++]
+#define __get_dynamic_len(field)	__stackvar.__dynamic_len[__dynamic_len_idx++]
 
 #undef TP_ARGS
 #define TP_ARGS(...) __VA_ARGS__
@@ -398,16 +450,28 @@
 #undef TP_FIELDS
 #define TP_FIELDS(...) __VA_ARGS__
 
+/*
+ * Using twice size for filter stack data to hold size and pointer for
+ * each field (worse case). For integers, max size required is 64-bit.
+ * Same for double-precision floats. Those fit within
+ * 2*sizeof(unsigned long) for all supported architectures.
+ */
 #undef TRACEPOINT_EVENT_CLASS
 #define TRACEPOINT_EVENT_CLASS(_provider, _name, _args, _fields)	      \
-static void __event_probe__##_provider##___##_name(_TP_ARGS_DATA_PROTO(_args))\
+static lttng_ust_notrace						      \
+void __event_probe__##_provider##___##_name(_TP_ARGS_DATA_PROTO(_args));      \
+static									      \
+void __event_probe__##_provider##___##_name(_TP_ARGS_DATA_PROTO(_args))	      \
 {									      \
 	struct ltt_event *__event = __tp_data;				      \
 	struct ltt_channel *__chan = __event->chan;			      \
 	struct lttng_ust_lib_ring_buffer_ctx __ctx;			      \
 	size_t __event_len, __event_align;				      \
 	size_t __dynamic_len_idx = 0;					      \
-	size_t __dynamic_len[_TP_ARRAY_SIZE(__event_fields___##_provider##___##_name)];	      \
+	union {								      \
+		size_t __dynamic_len[_TP_ARRAY_SIZE(__event_fields___##_provider##___##_name)]; \
+		char __filter_stack_data[2 * sizeof(unsigned long) * _TP_ARRAY_SIZE(__event_fields___##_provider##___##_name)]; \
+	} __stackvar;							      \
 	int __ret;							      \
 									      \
 	if (0)								      \
@@ -418,7 +482,13 @@
 		return;							      \
 	if (caa_unlikely(!CMM_ACCESS_ONCE(__event->enabled)))		      \
 		return;							      \
-	__event_len = __event_get_size__##_provider##___##_name(__dynamic_len,\
+	if (caa_unlikely(__event->filter)) {				      \
+		__event_prepare_filter_stack__##_provider##___##_name(__stackvar.__filter_stack_data, \
+			_TP_ARGS_DATA_VAR(_args));				      \
+		if (caa_likely(!__event->filter(__event->filter_data, __stackvar.__filter_stack_data))) \
+			return;						      \
+	}								      \
+	__event_len = __event_get_size__##_provider##___##_name(__stackvar.__dynamic_len, \
 		 _TP_ARGS_DATA_VAR(_args));				      \
 	__event_align = __event_get_align__##_provider##___##_name(_TP_ARGS_VAR(_args)); \
 	lib_ring_buffer_ctx_init(&__ctx, __chan->chan, __event, __event_len,  \
@@ -496,7 +566,7 @@
 const struct lttng_event_desc __event_desc___##_provider##_##_name = {	       \
 	.fields = __event_fields___##_provider##___##_template,		       \
 	.name = #_provider ":" #_name,					       \
-	.probe_callback = (void *) &__event_probe__##_provider##___##_template,\
+	.probe_callback = (void (*)(void)) &__event_probe__##_provider##___##_template,\
 	.nr_fields = _TP_ARRAY_SIZE(__event_fields___##_provider##___##_template), \
 	.loglevel = &__ref_loglevel___##_provider##___##_name,		       \
 	.signature = __tp_event_signature___##_provider##___##_template,       \
@@ -546,7 +616,9 @@
 
 /* Reset all macros within TRACEPOINT_EVENT */
 #include <lttng/ust-tracepoint-event-reset.h>
-static void __attribute__((constructor))
+static void lttng_ust_notrace __attribute__((constructor))
+_TP_COMBINE_TOKENS(__lttng_events_init__, TRACEPOINT_PROVIDER)(void);
+static void
 _TP_COMBINE_TOKENS(__lttng_events_init__, TRACEPOINT_PROVIDER)(void)
 {
 	int ret;
@@ -555,7 +627,9 @@
 	assert(!ret);
 }
 
-static void __attribute__((destructor))
+static void lttng_ust_notrace __attribute__((destructor))
+_TP_COMBINE_TOKENS(__lttng_events_exit__, TRACEPOINT_PROVIDER)(void);
+static void
 _TP_COMBINE_TOKENS(__lttng_events_exit__, TRACEPOINT_PROVIDER)(void)
 {
 	ltt_probe_unregister(&_TP_COMBINE_TOKENS(__probe_desc___, TRACEPOINT_PROVIDER));

=== modified file 'include/lttng/ust-version.h'
--- include/lttng/ust-version.h	2012-06-29 16:47:49 +0000
+++ include/lttng/ust-version.h	2012-09-11 15:34:43 +0000
@@ -17,8 +17,8 @@
  */
 
 #define LTTNG_UST_MAJOR_VERSION 2
-#define LTTNG_UST_MINOR_VERSION 0
-#define LTTNG_UST_PATCHLEVEL_VERSION 4
-#define LTTNG_UST_VERSION 2.0.4
+#define LTTNG_UST_MINOR_VERSION 1
+#define LTTNG_UST_PATCHLEVEL_VERSION 0
+#define LTTNG_UST_VERSION 2.1.0-rc1
 
 #endif  /* _LTTNG_UST_VERSION_H */

=== modified file 'include/ust-comm.h'
--- include/ust-comm.h	2012-06-29 16:47:49 +0000
+++ include/ust-comm.h	2012-09-11 15:34:43 +0000
@@ -131,6 +131,10 @@
 		struct lttng_ust_context context;
 		struct lttng_ust_tracer_version version;
 		struct lttng_ust_tracepoint_iter tracepoint;
+		struct {
+			uint32_t data_size;	/* following filter data */
+			uint32_t reloc_offset;
+		} filter;
 	} u;
 };
 
@@ -155,6 +159,11 @@
 	} u;
 };
 
+/*
+ * LTTNG_UST_TRACEPOINT_FIELD_LIST reply is followed by a
+ * struct lttng_ust_field_iter field.
+ */
+
 extern int ustcomm_create_unix_sock(const char *pathname);
 extern int ustcomm_connect_unix_sock(const char *pathname);
 extern int ustcomm_accept_unix_sock(int sock);

=== modified file 'include/usterr-signal-safe.h'
--- include/usterr-signal-safe.h	2012-06-29 16:47:49 +0000
+++ include/usterr-signal-safe.h	2012-09-11 15:34:43 +0000
@@ -22,12 +22,11 @@
 
 #include <string.h>
 #include <sys/types.h>
-#include <sys/syscall.h>
 #include <errno.h>
 #include <stdarg.h>
 #include <stdio.h>
-
 #include <share.h>
+#include "lttng/ust-tid.h"
 
 enum ust_loglevel {
 	UST_LOGLEVEL_UNKNOWN = 0,
@@ -85,7 +84,7 @@
 	do {					\
 		sigsafe_print_err(UST_STR_COMPONENT "[%ld/%ld]: " fmt " (in %s() at " __FILE__ ":" UST_XSTR(__LINE__) ")\n",	\
 		(long) getpid(),		\
-		(long) syscall(SYS_gettid),	\
+		(long) gettid(),		\
 		## args, __func__);		\
 		fflush(stderr);			\
 	} while(0)
@@ -115,7 +114,10 @@
 #define ERR(fmt, args...) ERRMSG("Error: " fmt, ## args)
 #define BUG(fmt, args...) ERRMSG("BUG: " fmt, ## args)
 
-#if (_POSIX_C_SOURCE >= 200112L || _XOPEN_SOURCE >= 600) && !defined(_GNU_SOURCE)
+#if !defined(__linux__) || ((_POSIX_C_SOURCE >= 200112L || _XOPEN_SOURCE >= 600) && !defined(_GNU_SOURCE))
+/*
+ * Version using XSI strerror_r.
+ */
 #define PERROR(call, args...)\
 	do { \
 		char buf[200] = "Error in strerror_r()"; \
@@ -123,6 +125,9 @@
 		ERRMSG("Error: " call ": %s", ## args, buf); \
 	} while(0);
 #else
+/*
+ * Version using GNU strerror_r, for linux with appropriate defines.
+ */
 #define PERROR(call, args...)\
 	do { \
 		char *buf; \

=== modified file 'include/usterr.h'
--- include/usterr.h	2012-06-29 16:47:49 +0000
+++ include/usterr.h	2012-09-11 15:34:43 +0000
@@ -22,11 +22,11 @@
 
 #include <string.h>
 #include <sys/types.h>
-#include <sys/syscall.h>
 #include <errno.h>
 #include <stdarg.h>
 #include <stdio.h>
 
+#include "lttng/ust-tid.h"
 #include "share.h"
 
 enum ust_loglevel {
@@ -57,7 +57,7 @@
 	do {							\
 		fprintf(stderr, UST_STR_COMPONENT "[%ld/%ld]: " fmt " (in %s() at " __FILE__ ":" XSTR(__LINE__) ")\n",				\
 			(long) getpid(),			\
-			(long) syscall(SYS_gettid),		\
+			(long) gettid(),			\
 			## args,				\
 			__func__);				\
 	} while(0)
@@ -86,7 +86,10 @@
 #define ERR(fmt, args...) ERRMSG("Error: " fmt, ## args)
 #define BUG(fmt, args...) ERRMSG("BUG: " fmt, ## args)
 
-#if (_POSIX_C_SOURCE >= 200112L || _XOPEN_SOURCE >= 600) && !defined(_GNU_SOURCE)
+#if !defined(__linux__) || ((_POSIX_C_SOURCE >= 200112L || _XOPEN_SOURCE >= 600) && !defined(_GNU_SOURCE))
+/*
+ * Version using XSI strerror_r.
+ */
 #define PERROR(call, args...)\
 	do { \
 		char buf[200] = "Error in strerror_r()"; \
@@ -94,6 +97,9 @@
 		ERRMSG("Error: " call ": %s", ## args, buf); \
 	} while(0);
 #else
+/*
+ * Version using GNU strerror_r, for linux with appropriate defines.
+ */
 #define PERROR(call, args...)\
 	do { \
 		char *buf; \

=== modified file 'liblttng-ust-comm/Makefile.in'
--- liblttng-ust-comm/Makefile.in	2012-06-29 16:47:49 +0000
+++ liblttng-ust-comm/Makefile.in	2012-09-11 15:34:43 +0000
@@ -1,4 +1,4 @@
-# Makefile.in generated by automake 1.11.3 from Makefile.am.
+# Makefile.in generated by automake 1.11.6 from Makefile.am.
 # @configure_input@
 
 # Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2000, 2001, 2002,
@@ -16,6 +16,23 @@
 @SET_MAKE@
 
 VPATH = @srcdir@
+am__make_dryrun = \
+  { \
+    am__dry=no; \
+    case $$MAKEFLAGS in \
+      *\\[\ \	]*) \
+        echo 'am--echo: ; @echo "AM"  OK' | $(MAKE) -f - 2>/dev/null \
+          | grep '^AM OK$$' >/dev/null || am__dry=yes;; \
+      *) \
+        for am__flg in $$MAKEFLAGS; do \
+          case $$am__flg in \
+            *=*|--*) ;; \
+            *n*) am__dry=yes; break;; \
+          esac; \
+        done;; \
+    esac; \
+    test $$am__dry = yes; \
+  }
 pkgdatadir = $(datadir)/@PACKAGE@
 pkgincludedir = $(includedir)/@PACKAGE@
 pkglibdir = $(libdir)/@PACKAGE@
@@ -85,6 +102,11 @@
 am__v_GEN_0 = @echo "  GEN   " $@;
 SOURCES = $(liblttng_ust_comm_la_SOURCES)
 DIST_SOURCES = $(liblttng_ust_comm_la_SOURCES)
+am__can_run_installinfo = \
+  case $$AM_UPDATE_INFO_DIR in \
+    n|no|NO) false;; \
+    *) (install-info --version) >/dev/null 2>&1;; \
+  esac
 ETAGS = etags
 CTAGS = ctags
 DISTFILES = $(DIST_COMMON) $(DIST_SOURCES) $(TEXINFOS) $(EXTRA_DIST)
@@ -158,7 +180,6 @@
 SET_MAKE = @SET_MAKE@
 SHELL = @SHELL@
 STRIP = @STRIP@
-TEXINFO = @TEXINFO@
 VERSION = @VERSION@
 abs_builddir = @abs_builddir@
 abs_srcdir = @abs_srcdir@

=== modified file 'liblttng-ust-comm/lttng-ust-comm.c'
--- liblttng-ust-comm/lttng-ust-comm.c	2012-06-29 16:47:49 +0000
+++ liblttng-ust-comm/lttng-ust-comm.c	2012-09-11 15:34:43 +0000
@@ -172,13 +172,9 @@
 	new_fd = accept(sock, (struct sockaddr *) &sun, &len);
 	if (new_fd < 0) {
 		perror("accept");
-		goto error;
+		return -1;
 	}
-
 	return new_fd;
-
-error:
-	return -1;
 }
 
 /*

=== modified file 'liblttng-ust-ctl/Makefile.in'
--- liblttng-ust-ctl/Makefile.in	2012-06-29 16:47:49 +0000
+++ liblttng-ust-ctl/Makefile.in	2012-09-11 15:34:43 +0000
@@ -1,4 +1,4 @@
-# Makefile.in generated by automake 1.11.3 from Makefile.am.
+# Makefile.in generated by automake 1.11.6 from Makefile.am.
 # @configure_input@
 
 # Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2000, 2001, 2002,
@@ -16,6 +16,23 @@
 @SET_MAKE@
 
 VPATH = @srcdir@
+am__make_dryrun = \
+  { \
+    am__dry=no; \
+    case $$MAKEFLAGS in \
+      *\\[\ \	]*) \
+        echo 'am--echo: ; @echo "AM"  OK' | $(MAKE) -f - 2>/dev/null \
+          | grep '^AM OK$$' >/dev/null || am__dry=yes;; \
+      *) \
+        for am__flg in $$MAKEFLAGS; do \
+          case $$am__flg in \
+            *=*|--*) ;; \
+            *n*) am__dry=yes; break;; \
+          esac; \
+        done;; \
+    esac; \
+    test $$am__dry = yes; \
+  }
 pkgdatadir = $(datadir)/@PACKAGE@
 pkgincludedir = $(includedir)/@PACKAGE@
 pkglibdir = $(libdir)/@PACKAGE@
@@ -116,6 +133,11 @@
 am__v_GEN_0 = @echo "  GEN   " $@;
 SOURCES = $(liblttng_ust_ctl_la_SOURCES)
 DIST_SOURCES = $(liblttng_ust_ctl_la_SOURCES)
+am__can_run_installinfo = \
+  case $$AM_UPDATE_INFO_DIR in \
+    n|no|NO) false;; \
+    *) (install-info --version) >/dev/null 2>&1;; \
+  esac
 ETAGS = etags
 CTAGS = ctags
 DISTFILES = $(DIST_COMMON) $(DIST_SOURCES) $(TEXINFOS) $(EXTRA_DIST)
@@ -189,7 +211,6 @@
 SET_MAKE = @SET_MAKE@
 SHELL = @SHELL@
 STRIP = @STRIP@
-TEXINFO = @TEXINFO@
 VERSION = @VERSION@
 abs_builddir = @abs_builddir@
 abs_srcdir = @abs_srcdir@
@@ -293,7 +314,6 @@
 $(am__aclocal_m4_deps):
 install-libLTLIBRARIES: $(lib_LTLIBRARIES)
 	@$(NORMAL_INSTALL)
-	test -z "$(libdir)" || $(MKDIR_P) "$(DESTDIR)$(libdir)"
 	@list='$(lib_LTLIBRARIES)'; test -n "$(libdir)" || list=; \
 	list2=; for p in $$list; do \
 	  if test -f $$p; then \
@@ -301,6 +321,8 @@
 	  else :; fi; \
 	done; \
 	test -z "$$list2" || { \
+	  echo " $(MKDIR_P) '$(DESTDIR)$(libdir)'"; \
+	  $(MKDIR_P) "$(DESTDIR)$(libdir)" || exit 1; \
 	  echo " $(LIBTOOL) $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=install $(INSTALL) $(INSTALL_STRIP_FLAG) $$list2 '$(DESTDIR)$(libdir)'"; \
 	  $(LIBTOOL) $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=install $(INSTALL) $(INSTALL_STRIP_FLAG) $$list2 "$(DESTDIR)$(libdir)"; \
 	}

=== modified file 'liblttng-ust-ctl/ustctl.c'
--- liblttng-ust-ctl/ustctl.c	2012-06-29 16:47:49 +0000
+++ liblttng-ust-ctl/ustctl.c	2012-09-11 15:34:43 +0000
@@ -390,6 +390,40 @@
 	return ret;
 }
 
+int ustctl_set_filter(int sock, struct lttng_ust_filter_bytecode *bytecode,
+		struct lttng_ust_object_data *obj_data)
+{
+	struct ustcomm_ust_msg lum;
+	struct ustcomm_ust_reply lur;
+	int ret;
+
+	if (!obj_data)
+		return -EINVAL;
+
+	memset(&lum, 0, sizeof(lum));
+	lum.handle = obj_data->handle;
+	lum.cmd = LTTNG_UST_FILTER;
+	lum.u.filter.data_size = bytecode->len;
+	lum.u.filter.reloc_offset = bytecode->reloc_offset;
+
+	ret = ustcomm_send_app_msg(sock, &lum);
+	if (ret)
+		return ret;
+	if (ret) {
+		return ret;
+	}
+	/* send var len bytecode */
+	ret = ustcomm_send_unix_sock(sock, bytecode->data,
+				bytecode->len);
+	if (ret < 0) {
+		return ret;
+	}
+	ret = ustcomm_recv_app_reply(sock, &lur, lum.handle, lum.cmd);
+	if (ret)
+		return ret;
+	return ret;
+}
+
 /* Enable event, channel and session ioctl */
 int ustctl_enable(int sock, struct lttng_ust_object_data *object)
 {
@@ -486,6 +520,56 @@
 	return 0;
 }
 
+int ustctl_tracepoint_field_list(int sock)
+{
+	struct ustcomm_ust_msg lum;
+	struct ustcomm_ust_reply lur;
+	int ret, tp_field_list_handle;
+
+	memset(&lum, 0, sizeof(lum));
+	lum.handle = LTTNG_UST_ROOT_HANDLE;
+	lum.cmd = LTTNG_UST_TRACEPOINT_FIELD_LIST;
+	ret = ustcomm_send_app_cmd(sock, &lum, &lur);
+	if (ret)
+		return ret;
+	tp_field_list_handle = lur.ret_val;
+	DBG("received tracepoint field list handle %u", tp_field_list_handle);
+	return tp_field_list_handle;
+}
+
+int ustctl_tracepoint_field_list_get(int sock, int tp_field_list_handle,
+		struct lttng_ust_field_iter *iter)
+{
+	struct ustcomm_ust_msg lum;
+	struct ustcomm_ust_reply lur;
+	int ret;
+	ssize_t len;
+
+	if (!iter)
+		return -EINVAL;
+
+	memset(&lum, 0, sizeof(lum));
+	lum.handle = tp_field_list_handle;
+	lum.cmd = LTTNG_UST_TRACEPOINT_FIELD_LIST_GET;
+	ret = ustcomm_send_app_cmd(sock, &lum, &lur);
+	if (ret)
+		return ret;
+	if (lur.ret_code != USTCOMM_OK) {
+		DBG("Return code: %s", ustcomm_get_readable_code(lur.ret_code));
+		return -EINVAL;
+	}
+	len = ustcomm_recv_unix_sock(sock, iter, sizeof(*iter));
+	if (len != sizeof(*iter)) {
+		return -EINVAL;
+	}
+	DBG("received tracepoint field list entry event_name %s event_loglevel %d field_name %s field_type %d",
+		iter->event_name,
+		iter->loglevel,
+		iter->field_name,
+		iter->type);
+	return 0;
+}
+
 int ustctl_tracer_version(int sock, struct lttng_ust_tracer_version *v)
 {
 	struct ustcomm_ust_msg lum;

=== modified file 'liblttng-ust-fork/Makefile.am'
--- liblttng-ust-fork/Makefile.am	2012-06-29 16:47:49 +0000
+++ liblttng-ust-fork/Makefile.am	2012-09-11 15:34:43 +0000
@@ -4,6 +4,13 @@
 lib_LTLIBRARIES = liblttng-ust-fork.la
 liblttng_ust_fork_la_SOURCES = ustfork.c
 liblttng_ust_fork_la_LIBADD = \
-	-ldl \
 	$(top_builddir)/liblttng-ust/liblttng-ust.la
+
+if LTTNG_UST_BUILD_WITH_LIBDL
+liblttng_ust_fork_la_LIBADD += -ldl
+endif
+if LTTNG_UST_BUILD_WITH_LIBC_DL
+liblttng_ust_fork_la_LIBADD += -lc
+endif
+
 libustfork_CFLAGS = -DUST_COMPONENT=liblttng-ust-fork -fno-strict-aliasing

=== modified file 'liblttng-ust-fork/Makefile.in'
--- liblttng-ust-fork/Makefile.in	2012-06-29 16:47:49 +0000
+++ liblttng-ust-fork/Makefile.in	2012-09-11 15:34:43 +0000
@@ -1,4 +1,4 @@
-# Makefile.in generated by automake 1.11.3 from Makefile.am.
+# Makefile.in generated by automake 1.11.6 from Makefile.am.
 # @configure_input@
 
 # Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2000, 2001, 2002,
@@ -16,6 +16,23 @@
 @SET_MAKE@
 
 VPATH = @srcdir@
+am__make_dryrun = \
+  { \
+    am__dry=no; \
+    case $$MAKEFLAGS in \
+      *\\[\ \	]*) \
+        echo 'am--echo: ; @echo "AM"  OK' | $(MAKE) -f - 2>/dev/null \
+          | grep '^AM OK$$' >/dev/null || am__dry=yes;; \
+      *) \
+        for am__flg in $$MAKEFLAGS; do \
+          case $$am__flg in \
+            *=*|--*) ;; \
+            *n*) am__dry=yes; break;; \
+          esac; \
+        done;; \
+    esac; \
+    test $$am__dry = yes; \
+  }
 pkgdatadir = $(datadir)/@PACKAGE@
 pkgincludedir = $(includedir)/@PACKAGE@
 pkglibdir = $(libdir)/@PACKAGE@
@@ -35,6 +52,8 @@
 build_triplet = @build@
 host_triplet = @host@
 target_triplet = @target@
+@LTTNG_UST_BUILD_WITH_LIBDL_TRUE@am__append_1 = -ldl
+@LTTNG_UST_BUILD_WITH_LIBC_DL_TRUE@am__append_2 = -lc
 subdir = liblttng-ust-fork
 DIST_COMMON = $(srcdir)/Makefile.am $(srcdir)/Makefile.in
 ACLOCAL_M4 = $(top_srcdir)/aclocal.m4
@@ -79,8 +98,10 @@
   }
 am__installdirs = "$(DESTDIR)$(libdir)"
 LTLIBRARIES = $(lib_LTLIBRARIES)
+am__DEPENDENCIES_1 =
 liblttng_ust_fork_la_DEPENDENCIES =  \
-	$(top_builddir)/liblttng-ust/liblttng-ust.la
+	$(top_builddir)/liblttng-ust/liblttng-ust.la \
+	$(am__DEPENDENCIES_1) $(am__DEPENDENCIES_1)
 am_liblttng_ust_fork_la_OBJECTS = ustfork.lo
 liblttng_ust_fork_la_OBJECTS = $(am_liblttng_ust_fork_la_OBJECTS)
 AM_V_lt = $(am__v_lt_@AM_V@)
@@ -114,6 +135,11 @@
 am__v_GEN_0 = @echo "  GEN   " $@;
 SOURCES = $(liblttng_ust_fork_la_SOURCES)
 DIST_SOURCES = $(liblttng_ust_fork_la_SOURCES)
+am__can_run_installinfo = \
+  case $$AM_UPDATE_INFO_DIR in \
+    n|no|NO) false;; \
+    *) (install-info --version) >/dev/null 2>&1;; \
+  esac
 ETAGS = etags
 CTAGS = ctags
 DISTFILES = $(DIST_COMMON) $(DIST_SOURCES) $(TEXINFOS) $(EXTRA_DIST)
@@ -187,7 +213,6 @@
 SET_MAKE = @SET_MAKE@
 SHELL = @SHELL@
 STRIP = @STRIP@
-TEXINFO = @TEXINFO@
 VERSION = @VERSION@
 abs_builddir = @abs_builddir@
 abs_srcdir = @abs_srcdir@
@@ -250,10 +275,9 @@
 AM_CFLAGS = -fno-strict-aliasing
 lib_LTLIBRARIES = liblttng-ust-fork.la
 liblttng_ust_fork_la_SOURCES = ustfork.c
-liblttng_ust_fork_la_LIBADD = \
-	-ldl \
-	$(top_builddir)/liblttng-ust/liblttng-ust.la
-
+liblttng_ust_fork_la_LIBADD =  \
+	$(top_builddir)/liblttng-ust/liblttng-ust.la $(am__append_1) \
+	$(am__append_2)
 libustfork_CFLAGS = -DUST_COMPONENT=liblttng-ust-fork -fno-strict-aliasing
 all: all-am
 
@@ -291,7 +315,6 @@
 $(am__aclocal_m4_deps):
 install-libLTLIBRARIES: $(lib_LTLIBRARIES)
 	@$(NORMAL_INSTALL)
-	test -z "$(libdir)" || $(MKDIR_P) "$(DESTDIR)$(libdir)"
 	@list='$(lib_LTLIBRARIES)'; test -n "$(libdir)" || list=; \
 	list2=; for p in $$list; do \
 	  if test -f $$p; then \
@@ -299,6 +322,8 @@
 	  else :; fi; \
 	done; \
 	test -z "$$list2" || { \
+	  echo " $(MKDIR_P) '$(DESTDIR)$(libdir)'"; \
+	  $(MKDIR_P) "$(DESTDIR)$(libdir)" || exit 1; \
 	  echo " $(LIBTOOL) $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=install $(INSTALL) $(INSTALL_STRIP_FLAG) $$list2 '$(DESTDIR)$(libdir)'"; \
 	  $(LIBTOOL) $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=install $(INSTALL) $(INSTALL_STRIP_FLAG) $$list2 "$(DESTDIR)$(libdir)"; \
 	}

=== modified file 'liblttng-ust-fork/ustfork.c'
--- liblttng-ust-fork/ustfork.c	2012-06-29 16:47:49 +0000
+++ liblttng-ust-fork/ustfork.c	2012-09-11 15:34:43 +0000
@@ -28,8 +28,6 @@
 
 #include <lttng/ust.h>
 
-struct user_desc;
-
 pid_t fork(void)
 {
 	static pid_t (*plibc_func)(void) = NULL;
@@ -56,6 +54,10 @@
 	return retval;
 }
 
+#ifdef __linux__
+
+struct user_desc;
+
 struct ustfork_clone_info {
 	int (*fn)(void *);
 	void *arg;
@@ -117,3 +119,41 @@
 	}
 	return retval;
 }
+
+#elif defined (__FreeBSD__)
+
+pid_t rfork(int flags)
+{
+	static pid_t (*plibc_func)(void) = NULL;
+	sigset_t sigset;
+	pid_t retval;
+
+	if (plibc_func == NULL) {
+		plibc_func = dlsym(RTLD_NEXT, "rfork");
+		if (plibc_func == NULL) {
+			fprintf(stderr, "libustfork: unable to find \"rfork\" symbol\n");
+			return -1;
+		}
+	}
+
+	ust_before_fork(&sigset);
+	/* Do the real rfork */
+	retval = plibc_func();
+	if (retval == 0) {
+		/* child */
+		ust_after_fork_child(&sigset);
+	} else {
+		ust_after_fork_parent(&sigset);
+	}
+	return retval;
+}
+
+/*
+ * On BSD, no need to override vfork, because it runs in the context of
+ * the parent, with parent waiting until execve or exit is executed in
+ * the child.
+ */
+
+#else
+#warning "Unknown OS. You might want to ensure that fork/clone/vfork/fork handling is complete."
+#endif

=== added directory 'liblttng-ust-java'
=== added file 'liblttng-ust-java/LTTngUst.c'
--- liblttng-ust-java/LTTngUst.c	1970-01-01 00:00:00 +0000
+++ liblttng-ust-java/LTTngUst.c	2012-09-11 15:34:43 +0000
@@ -0,0 +1,93 @@
+/*
+ * Copyright (C) 2011-2012 Mathieu Desnoyers <mathieu.desnoyers@efficios.com>
+ *
+ * This library is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU Lesser General Public
+ * License as published by the Free Software Foundation; only
+ * version 2.1 of the License.
+ *
+ * This library is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with this library; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#include "org_lttng_ust_LTTngUst.h"
+
+#define TRACEPOINT_DEFINE
+#define TRACEPOINT_CREATE_PROBES
+#include "lttng_ust_java.h"
+
+JNIEXPORT void JNICALL Java_org_lttng_ust_LTTngUst_tracepointInt(JNIEnv *env,
+						jobject jobj,
+						jstring ev_name,
+						jint payload)
+{
+	jboolean iscopy;
+	const char *ev_name_cstr = (*env)->GetStringUTFChars(env, ev_name, &iscopy);
+
+	tracepoint(lttng_ust_java, int_event, ev_name_cstr, payload);
+
+	(*env)->ReleaseStringUTFChars(env, ev_name, ev_name_cstr);
+}
+
+JNIEXPORT void JNICALL Java_org_lttng_ust_LTTngUst_tracepointIntInt(JNIEnv *env,
+						jobject jobj,
+						jstring ev_name,
+						jint payload1,
+						jint payload2)
+{
+	jboolean iscopy;
+	const char *ev_name_cstr = (*env)->GetStringUTFChars(env, ev_name, &iscopy);
+
+	tracepoint(lttng_ust_java, int_int_event, ev_name_cstr, payload1, payload2);
+
+	(*env)->ReleaseStringUTFChars(env, ev_name, ev_name_cstr);
+}
+
+JNIEXPORT void JNICALL Java_org_lttng_ust_LTTngUst_tracepointLong(JNIEnv *env,
+						jobject jobj,
+						jstring ev_name,
+						jlong payload)
+{
+	jboolean iscopy;
+	const char *ev_name_cstr = (*env)->GetStringUTFChars(env, ev_name, &iscopy);
+
+	tracepoint(lttng_ust_java, long_event, ev_name_cstr, payload);
+
+	(*env)->ReleaseStringUTFChars(env, ev_name, ev_name_cstr);
+}
+
+JNIEXPORT void JNICALL Java_org_lttng_ust_LTTngUst_tracepointLongLong(JNIEnv *env,
+						jobject jobj,
+						jstring ev_name,
+						jlong payload1,
+						jlong payload2)
+{
+	jboolean iscopy;
+	const char *ev_name_cstr = (*env)->GetStringUTFChars(env, ev_name, &iscopy);
+
+	tracepoint(lttng_ust_java, long_long_event, ev_name_cstr, payload1, payload2);
+
+	(*env)->ReleaseStringUTFChars(env, ev_name, ev_name_cstr);
+}
+
+JNIEXPORT void JNICALL Java_org_lttng_ust_LTTngUst_tracepointString(JNIEnv *env,
+						jobject jobj,
+						jstring ev_name,
+						jstring payload)
+{
+	jboolean iscopy;
+	const char *ev_name_cstr = (*env)->GetStringUTFChars(env, ev_name, &iscopy);
+	const char *payload_cstr = (*env)->GetStringUTFChars(env, payload, &iscopy);
+
+	tracepoint(lttng_ust_java, string_event, ev_name_cstr, payload_cstr);
+
+	(*env)->ReleaseStringUTFChars(env, ev_name, ev_name_cstr);
+	(*env)->ReleaseStringUTFChars(env, payload, payload_cstr);
+}
+

=== added file 'liblttng-ust-java/LTTngUst.java'
--- liblttng-ust-java/LTTngUst.java	1970-01-01 00:00:00 +0000
+++ liblttng-ust-java/LTTngUst.java	2012-09-11 15:34:43 +0000
@@ -0,0 +1,110 @@
+/**
+ * Copyright (C) 2011-2012 Mathieu Desnoyers <mathieu.desnoyers@efficios.com>
+ * Copyright (C) 2012 Alexandre Montplaisir <alexandre.montplaisir@polymtl.ca>
+ *
+ * This library is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU Lesser General Public
+ * License as published by the Free Software Foundation; only
+ * version 2.1 of the License.
+ *
+ * This library is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with this library; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+package org.lttng.ust;
+
+/**
+ * This class implements the the Java side of the LTTng-UST Java interface.
+ *
+ * First, make sure you have installed "liblttng-ust-java.so" where the linker
+ * can find it. You can then call LTTngUst.init() from your Java program to
+ * connect the methods exposed here to the native library.
+ *
+ * Because of limitations in the probe declaration, all trace events generated
+ * by this library will have "lttng_ust_java" for domain, and "<type>_event" for
+ * event name in the CTF trace files. The "name" parameter will instead appear
+ * as the first element of the event's payload.
+ *
+ * @author Mathieu Desnoyers
+ * @author Alexandre Montplaisir
+ *
+ */
+public abstract class LTTngUst {
+
+    /**
+     * Initialize the UST tracer. This should always be called first, before any
+     * tracepoint* method.
+     */
+    public static void init() {
+        System.loadLibrary("lttng-ust-java"); //$NON-NLS-1$
+    }
+
+    /**
+     * Insert a tracepoint with a payload of type Integer.
+     *
+     * @param name
+     *            The name assigned to this event. For best performance, this
+     *            should be a statically-defined String, or a literal.
+     * @param payload
+     *            The int payload
+     */
+    public static native void tracepointInt(String name, int payload);
+
+    /**
+     * Insert a tracepoint with a payload consisting of two integers.
+     *
+     * @param name
+     *            The name assigned to this event. For best performance, this
+     *            should be a statically-defined String, or a literal.
+     * @param payload1
+     *            The first int payload
+     * @param payload2
+     *            The second int payload
+     */
+    public static native void
+    tracepointIntInt(String name, int payload1, int payload2);
+
+    /**
+     * Insert a tracepoint with a payload of type Long
+     *
+     * @param name
+     *            The name assigned to this event. For best performance, this
+     *            should be a statically-defined String, or a literal.
+     * @param payload
+     *            The long payload
+     */
+    public static native void tracepointLong(String name, long payload);
+
+    /**
+     * Insert a tracepoint with a payload consisting of two longs.
+     *
+     * @param name
+     *            The name assigned to this event. For best performance, this
+     *            should be a statically-defined String, or a literal.
+     * @param payload1
+     *            The first long payload
+     * @param payload2
+     *            The second long payload
+     */
+    public static native void
+    tracepointLongLong(String name, long payload1, long payload2);
+
+    /**
+     * Insert a tracepoint with a String payload.
+     *
+     * @param name
+     *            The name assigned to this event. For best performance, this
+     *            should be a statically-defined String, or a literal.
+     * @param payload
+     *            The String payload
+     */
+    public static native void tracepointString(String name, String payload);
+
+}
+

=== added file 'liblttng-ust-java/Makefile.am'
--- liblttng-ust-java/Makefile.am	1970-01-01 00:00:00 +0000
+++ liblttng-ust-java/Makefile.am	2012-09-11 15:34:43 +0000
@@ -0,0 +1,29 @@
+if BUILD_JNI_INTERFACE
+
+AM_CPPFLAGS = -I$(top_srcdir)/include
+
+lib_LTLIBRARIES = liblttng-ust-java.la
+liblttng_ust_java_la_SOURCES = LTTngUst.c lttng_ust_java.h
+nodist_liblttng_ust_java_la_SOURCES = org_lttng_ust_LTTngUst.h
+dist_noinst_DATA = LTTngUst.java
+liblttng_ust_java_la_LIBADD = -lc -L$(top_builddir)/liblttng-ust/.libs -llttng-ust
+
+all: LTTngUst.class org_lttng_ust_LTTngUst.h liblttng-ust-java.jar
+
+clean-local:
+	rm org_lttng_ust_LTTngUst.h
+	rm liblttng-ust-java.jar
+	rm -rf org/
+
+LTTngUst.c: org_lttng_ust_LTTngUst.h
+
+LTTngUst.class: LTTngUst.java
+	javac -d "$(builddir)" "$(srcdir)/LTTngUst.java"
+
+org_lttng_ust_LTTngUst.h: LTTngUst.class
+	javah org.lttng.ust.LTTngUst
+
+liblttng-ust-java.jar: LTTngUst.class
+	jar cf liblttng-ust-java.jar org/*
+
+endif

=== added file 'liblttng-ust-java/Makefile.in'
--- liblttng-ust-java/Makefile.in	1970-01-01 00:00:00 +0000
+++ liblttng-ust-java/Makefile.in	2012-09-11 15:34:43 +0000
@@ -0,0 +1,618 @@
+# Makefile.in generated by automake 1.11.6 from Makefile.am.
+# @configure_input@
+
+# Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2000, 2001, 2002,
+# 2003, 2004, 2005, 2006, 2007, 2008, 2009, 2010, 2011 Free Software
+# Foundation, Inc.
+# This Makefile.in is free software; the Free Software Foundation
+# gives unlimited permission to copy and/or distribute it,
+# with or without modifications, as long as this notice is preserved.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY, to the extent permitted by law; without
+# even the implied warranty of MERCHANTABILITY or FITNESS FOR A
+# PARTICULAR PURPOSE.
+
+@SET_MAKE@
+
+
+VPATH = @srcdir@
+am__make_dryrun = \
+  { \
+    am__dry=no; \
+    case $$MAKEFLAGS in \
+      *\\[\ \	]*) \
+        echo 'am--echo: ; @echo "AM"  OK' | $(MAKE) -f - 2>/dev/null \
+          | grep '^AM OK$$' >/dev/null || am__dry=yes;; \
+      *) \
+        for am__flg in $$MAKEFLAGS; do \
+          case $$am__flg in \
+            *=*|--*) ;; \
+            *n*) am__dry=yes; break;; \
+          esac; \
+        done;; \
+    esac; \
+    test $$am__dry = yes; \
+  }
+pkgdatadir = $(datadir)/@PACKAGE@
+pkgincludedir = $(includedir)/@PACKAGE@
+pkglibdir = $(libdir)/@PACKAGE@
+pkglibexecdir = $(libexecdir)/@PACKAGE@
+am__cd = CDPATH="$${ZSH_VERSION+.}$(PATH_SEPARATOR)" && cd
+install_sh_DATA = $(install_sh) -c -m 644
+install_sh_PROGRAM = $(install_sh) -c
+install_sh_SCRIPT = $(install_sh) -c
+INSTALL_HEADER = $(INSTALL_DATA)
+transform = $(program_transform_name)
+NORMAL_INSTALL = :
+PRE_INSTALL = :
+POST_INSTALL = :
+NORMAL_UNINSTALL = :
+PRE_UNINSTALL = :
+POST_UNINSTALL = :
+build_triplet = @build@
+host_triplet = @host@
+target_triplet = @target@
+subdir = liblttng-ust-java
+DIST_COMMON = README $(am__dist_noinst_DATA_DIST) \
+	$(srcdir)/Makefile.am $(srcdir)/Makefile.in
+ACLOCAL_M4 = $(top_srcdir)/aclocal.m4
+am__aclocal_m4_deps = $(top_srcdir)/config/libtool.m4 \
+	$(top_srcdir)/config/ltoptions.m4 \
+	$(top_srcdir)/config/ltsugar.m4 \
+	$(top_srcdir)/config/ltversion.m4 \
+	$(top_srcdir)/config/lt~obsolete.m4 $(top_srcdir)/configure.ac
+am__configure_deps = $(am__aclocal_m4_deps) $(CONFIGURE_DEPENDENCIES) \
+	$(ACLOCAL_M4)
+mkinstalldirs = $(install_sh) -d
+CONFIG_HEADER = $(top_builddir)/config.h \
+	$(top_builddir)/include/lttng/ust-config.h
+CONFIG_CLEAN_FILES =
+CONFIG_CLEAN_VPATH_FILES =
+am__vpath_adj_setup = srcdirstrip=`echo "$(srcdir)" | sed 's|.|.|g'`;
+am__vpath_adj = case $$p in \
+    $(srcdir)/*) f=`echo "$$p" | sed "s|^$$srcdirstrip/||"`;; \
+    *) f=$$p;; \
+  esac;
+am__strip_dir = f=`echo $$p | sed -e 's|^.*/||'`;
+am__install_max = 40
+am__nobase_strip_setup = \
+  srcdirstrip=`echo "$(srcdir)" | sed 's/[].[^$$\\*|]/\\\\&/g'`
+am__nobase_strip = \
+  for p in $$list; do echo "$$p"; done | sed -e "s|$$srcdirstrip/||"
+am__nobase_list = $(am__nobase_strip_setup); \
+  for p in $$list; do echo "$$p $$p"; done | \
+  sed "s| $$srcdirstrip/| |;"' / .*\//!s/ .*/ ./; s,\( .*\)/[^/]*$$,\1,' | \
+  $(AWK) 'BEGIN { files["."] = "" } { files[$$2] = files[$$2] " " $$1; \
+    if (++n[$$2] == $(am__install_max)) \
+      { print $$2, files[$$2]; n[$$2] = 0; files[$$2] = "" } } \
+    END { for (dir in files) print dir, files[dir] }'
+am__base_list = \
+  sed '$$!N;$$!N;$$!N;$$!N;$$!N;$$!N;$$!N;s/\n/ /g' | \
+  sed '$$!N;$$!N;$$!N;$$!N;s/\n/ /g'
+am__uninstall_files_from_dir = { \
+  test -z "$$files" \
+    || { test ! -d "$$dir" && test ! -f "$$dir" && test ! -r "$$dir"; } \
+    || { echo " ( cd '$$dir' && rm -f" $$files ")"; \
+         $(am__cd) "$$dir" && rm -f $$files; }; \
+  }
+am__installdirs = "$(DESTDIR)$(libdir)"
+LTLIBRARIES = $(lib_LTLIBRARIES)
+liblttng_ust_java_la_DEPENDENCIES =
+am__liblttng_ust_java_la_SOURCES_DIST = LTTngUst.c lttng_ust_java.h
+@BUILD_JNI_INTERFACE_TRUE@am_liblttng_ust_java_la_OBJECTS =  \
+@BUILD_JNI_INTERFACE_TRUE@	LTTngUst.lo
+nodist_liblttng_ust_java_la_OBJECTS =
+liblttng_ust_java_la_OBJECTS = $(am_liblttng_ust_java_la_OBJECTS) \
+	$(nodist_liblttng_ust_java_la_OBJECTS)
+AM_V_lt = $(am__v_lt_@AM_V@)
+am__v_lt_ = $(am__v_lt_@AM_DEFAULT_V@)
+am__v_lt_0 = --silent
+@BUILD_JNI_INTERFACE_TRUE@am_liblttng_ust_java_la_rpath = -rpath \
+@BUILD_JNI_INTERFACE_TRUE@	$(libdir)
+DEFAULT_INCLUDES = -I.@am__isrc@ -I$(top_builddir) -I$(top_builddir)/include/lttng
+depcomp = $(SHELL) $(top_srcdir)/config/depcomp
+am__depfiles_maybe = depfiles
+am__mv = mv -f
+COMPILE = $(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) \
+	$(CPPFLAGS) $(AM_CFLAGS) $(CFLAGS)
+LTCOMPILE = $(LIBTOOL) $(AM_V_lt) --tag=CC $(AM_LIBTOOLFLAGS) \
+	$(LIBTOOLFLAGS) --mode=compile $(CC) $(DEFS) \
+	$(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) \
+	$(AM_CFLAGS) $(CFLAGS)
+AM_V_CC = $(am__v_CC_@AM_V@)
+am__v_CC_ = $(am__v_CC_@AM_DEFAULT_V@)
+am__v_CC_0 = @echo "  CC    " $@;
+AM_V_at = $(am__v_at_@AM_V@)
+am__v_at_ = $(am__v_at_@AM_DEFAULT_V@)
+am__v_at_0 = @
+CCLD = $(CC)
+LINK = $(LIBTOOL) $(AM_V_lt) --tag=CC $(AM_LIBTOOLFLAGS) \
+	$(LIBTOOLFLAGS) --mode=link $(CCLD) $(AM_CFLAGS) $(CFLAGS) \
+	$(AM_LDFLAGS) $(LDFLAGS) -o $@
+AM_V_CCLD = $(am__v_CCLD_@AM_V@)
+am__v_CCLD_ = $(am__v_CCLD_@AM_DEFAULT_V@)
+am__v_CCLD_0 = @echo "  CCLD  " $@;
+AM_V_GEN = $(am__v_GEN_@AM_V@)
+am__v_GEN_ = $(am__v_GEN_@AM_DEFAULT_V@)
+am__v_GEN_0 = @echo "  GEN   " $@;
+SOURCES = $(liblttng_ust_java_la_SOURCES) \
+	$(nodist_liblttng_ust_java_la_SOURCES)
+DIST_SOURCES = $(am__liblttng_ust_java_la_SOURCES_DIST)
+am__can_run_installinfo = \
+  case $$AM_UPDATE_INFO_DIR in \
+    n|no|NO) false;; \
+    *) (install-info --version) >/dev/null 2>&1;; \
+  esac
+am__dist_noinst_DATA_DIST = LTTngUst.java
+DATA = $(dist_noinst_DATA)
+ETAGS = etags
+CTAGS = ctags
+DISTFILES = $(DIST_COMMON) $(DIST_SOURCES) $(TEXINFOS) $(EXTRA_DIST)
+ACLOCAL = @ACLOCAL@
+AMTAR = @AMTAR@
+AM_DEFAULT_VERBOSITY = @AM_DEFAULT_VERBOSITY@
+AR = @AR@
+AUTOCONF = @AUTOCONF@
+AUTOHEADER = @AUTOHEADER@
+AUTOMAKE = @AUTOMAKE@
+AWK = @AWK@
+CC = @CC@
+CCDEPMODE = @CCDEPMODE@
+CFLAGS = @CFLAGS@
+CPP = @CPP@
+CPPFLAGS = @CPPFLAGS@
+CXX = @CXX@
+CXXCPP = @CXXCPP@
+CXXDEPMODE = @CXXDEPMODE@
+CXXFLAGS = @CXXFLAGS@
+CYGPATH_W = @CYGPATH_W@
+DEFS = @DEFS@
+DEPDIR = @DEPDIR@
+DLLTOOL = @DLLTOOL@
+DSYMUTIL = @DSYMUTIL@
+DUMPBIN = @DUMPBIN@
+ECHO_C = @ECHO_C@
+ECHO_N = @ECHO_N@
+ECHO_T = @ECHO_T@
+EGREP = @EGREP@
+EXEEXT = @EXEEXT@
+FGREP = @FGREP@
+GREP = @GREP@
+INSTALL = @INSTALL@
+INSTALL_DATA = @INSTALL_DATA@
+INSTALL_PROGRAM = @INSTALL_PROGRAM@
+INSTALL_SCRIPT = @INSTALL_SCRIPT@
+INSTALL_STRIP_PROGRAM = @INSTALL_STRIP_PROGRAM@
+LD = @LD@
+LDFLAGS = @LDFLAGS@
+LIBFORMAT = @LIBFORMAT@
+LIBOBJS = @LIBOBJS@
+LIBS = @LIBS@
+LIBTOOL = @LIBTOOL@
+LIPO = @LIPO@
+LN_S = @LN_S@
+LTLIBOBJS = @LTLIBOBJS@
+LTTNG_UST_LIBRARY_VERSION = @LTTNG_UST_LIBRARY_VERSION@
+MAJOR_VERSION = @MAJOR_VERSION@
+MAKEINFO = @MAKEINFO@
+MANIFEST_TOOL = @MANIFEST_TOOL@
+MINOR_VERSION = @MINOR_VERSION@
+MKDIR_P = @MKDIR_P@
+NM = @NM@
+NMEDIT = @NMEDIT@
+OBJDUMP = @OBJDUMP@
+OBJEXT = @OBJEXT@
+OTOOL = @OTOOL@
+OTOOL64 = @OTOOL64@
+PACKAGE = @PACKAGE@
+PACKAGE_BUGREPORT = @PACKAGE_BUGREPORT@
+PACKAGE_NAME = @PACKAGE_NAME@
+PACKAGE_STRING = @PACKAGE_STRING@
+PACKAGE_TARNAME = @PACKAGE_TARNAME@
+PACKAGE_URL = @PACKAGE_URL@
+PACKAGE_VERSION = @PACKAGE_VERSION@
+PATCHLEVEL_VERSION = @PATCHLEVEL_VERSION@
+PATH_SEPARATOR = @PATH_SEPARATOR@
+RANLIB = @RANLIB@
+SED = @SED@
+SET_MAKE = @SET_MAKE@
+SHELL = @SHELL@
+STRIP = @STRIP@
+VERSION = @VERSION@
+abs_builddir = @abs_builddir@
+abs_srcdir = @abs_srcdir@
+abs_top_builddir = @abs_top_builddir@
+abs_top_srcdir = @abs_top_srcdir@
+ac_ct_AR = @ac_ct_AR@
+ac_ct_CC = @ac_ct_CC@
+ac_ct_CXX = @ac_ct_CXX@
+ac_ct_DUMPBIN = @ac_ct_DUMPBIN@
+am__include = @am__include@
+am__leading_dot = @am__leading_dot@
+am__quote = @am__quote@
+am__tar = @am__tar@
+am__untar = @am__untar@
+bindir = @bindir@
+build = @build@
+build_alias = @build_alias@
+build_cpu = @build_cpu@
+build_os = @build_os@
+build_vendor = @build_vendor@
+builddir = @builddir@
+datadir = @datadir@
+datarootdir = @datarootdir@
+docdir = @docdir@
+dvidir = @dvidir@
+exec_prefix = @exec_prefix@
+host = @host@
+host_alias = @host_alias@
+host_cpu = @host_cpu@
+host_os = @host_os@
+host_vendor = @host_vendor@
+htmldir = @htmldir@
+includedir = @includedir@
+infodir = @infodir@
+install_sh = @install_sh@
+libdir = @libdir@
+libexecdir = @libexecdir@
+localedir = @localedir@
+localstatedir = @localstatedir@
+mandir = @mandir@
+mkdir_p = @mkdir_p@
+oldincludedir = @oldincludedir@
+pdfdir = @pdfdir@
+prefix = @prefix@
+program_transform_name = @program_transform_name@
+psdir = @psdir@
+sbindir = @sbindir@
+sharedstatedir = @sharedstatedir@
+srcdir = @srcdir@
+sysconfdir = @sysconfdir@
+target = @target@
+target_alias = @target_alias@
+target_cpu = @target_cpu@
+target_os = @target_os@
+target_vendor = @target_vendor@
+top_build_prefix = @top_build_prefix@
+top_builddir = @top_builddir@
+top_srcdir = @top_srcdir@
+@BUILD_JNI_INTERFACE_TRUE@AM_CPPFLAGS = -I$(top_srcdir)/include
+@BUILD_JNI_INTERFACE_TRUE@lib_LTLIBRARIES = liblttng-ust-java.la
+@BUILD_JNI_INTERFACE_TRUE@liblttng_ust_java_la_SOURCES = LTTngUst.c lttng_ust_java.h
+@BUILD_JNI_INTERFACE_TRUE@nodist_liblttng_ust_java_la_SOURCES = org_lttng_ust_LTTngUst.h
+@BUILD_JNI_INTERFACE_TRUE@dist_noinst_DATA = LTTngUst.java
+@BUILD_JNI_INTERFACE_TRUE@liblttng_ust_java_la_LIBADD = -lc -L$(top_builddir)/liblttng-ust/.libs -llttng-ust
+all: all-am
+
+.SUFFIXES:
+.SUFFIXES: .c .lo .o .obj
+$(srcdir)/Makefile.in:  $(srcdir)/Makefile.am  $(am__configure_deps)
+	@for dep in $?; do \
+	  case '$(am__configure_deps)' in \
+	    *$$dep*) \
+	      ( cd $(top_builddir) && $(MAKE) $(AM_MAKEFLAGS) am--refresh ) \
+	        && { if test -f $@; then exit 0; else break; fi; }; \
+	      exit 1;; \
+	  esac; \
+	done; \
+	echo ' cd $(top_srcdir) && $(AUTOMAKE) --foreign liblttng-ust-java/Makefile'; \
+	$(am__cd) $(top_srcdir) && \
+	  $(AUTOMAKE) --foreign liblttng-ust-java/Makefile
+.PRECIOUS: Makefile
+Makefile: $(srcdir)/Makefile.in $(top_builddir)/config.status
+	@case '$?' in \
+	  *config.status*) \
+	    cd $(top_builddir) && $(MAKE) $(AM_MAKEFLAGS) am--refresh;; \
+	  *) \
+	    echo ' cd $(top_builddir) && $(SHELL) ./config.status $(subdir)/$@ $(am__depfiles_maybe)'; \
+	    cd $(top_builddir) && $(SHELL) ./config.status $(subdir)/$@ $(am__depfiles_maybe);; \
+	esac;
+
+$(top_builddir)/config.status: $(top_srcdir)/configure $(CONFIG_STATUS_DEPENDENCIES)
+	cd $(top_builddir) && $(MAKE) $(AM_MAKEFLAGS) am--refresh
+
+$(top_srcdir)/configure:  $(am__configure_deps)
+	cd $(top_builddir) && $(MAKE) $(AM_MAKEFLAGS) am--refresh
+$(ACLOCAL_M4):  $(am__aclocal_m4_deps)
+	cd $(top_builddir) && $(MAKE) $(AM_MAKEFLAGS) am--refresh
+$(am__aclocal_m4_deps):
+install-libLTLIBRARIES: $(lib_LTLIBRARIES)
+	@$(NORMAL_INSTALL)
+	@list='$(lib_LTLIBRARIES)'; test -n "$(libdir)" || list=; \
+	list2=; for p in $$list; do \
+	  if test -f $$p; then \
+	    list2="$$list2 $$p"; \
+	  else :; fi; \
+	done; \
+	test -z "$$list2" || { \
+	  echo " $(MKDIR_P) '$(DESTDIR)$(libdir)'"; \
+	  $(MKDIR_P) "$(DESTDIR)$(libdir)" || exit 1; \
+	  echo " $(LIBTOOL) $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=install $(INSTALL) $(INSTALL_STRIP_FLAG) $$list2 '$(DESTDIR)$(libdir)'"; \
+	  $(LIBTOOL) $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=install $(INSTALL) $(INSTALL_STRIP_FLAG) $$list2 "$(DESTDIR)$(libdir)"; \
+	}
+
+uninstall-libLTLIBRARIES:
+	@$(NORMAL_UNINSTALL)
+	@list='$(lib_LTLIBRARIES)'; test -n "$(libdir)" || list=; \
+	for p in $$list; do \
+	  $(am__strip_dir) \
+	  echo " $(LIBTOOL) $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=uninstall rm -f '$(DESTDIR)$(libdir)/$$f'"; \
+	  $(LIBTOOL) $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=uninstall rm -f "$(DESTDIR)$(libdir)/$$f"; \
+	done
+
+clean-libLTLIBRARIES:
+	-test -z "$(lib_LTLIBRARIES)" || rm -f $(lib_LTLIBRARIES)
+	@list='$(lib_LTLIBRARIES)'; for p in $$list; do \
+	  dir="`echo $$p | sed -e 's|/[^/]*$$||'`"; \
+	  test "$$dir" != "$$p" || dir=.; \
+	  echo "rm -f \"$${dir}/so_locations\""; \
+	  rm -f "$${dir}/so_locations"; \
+	done
+liblttng-ust-java.la: $(liblttng_ust_java_la_OBJECTS) $(liblttng_ust_java_la_DEPENDENCIES) $(EXTRA_liblttng_ust_java_la_DEPENDENCIES) 
+	$(AM_V_CCLD)$(LINK) $(am_liblttng_ust_java_la_rpath) $(liblttng_ust_java_la_OBJECTS) $(liblttng_ust_java_la_LIBADD) $(LIBS)
+
+mostlyclean-compile:
+	-rm -f *.$(OBJEXT)
+
+distclean-compile:
+	-rm -f *.tab.c
+
+@AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/LTTngUst.Plo@am__quote@
+
+.c.o:
+@am__fastdepCC_TRUE@	$(AM_V_CC)$(COMPILE) -MT $@ -MD -MP -MF $(DEPDIR)/$*.Tpo -c -o $@ $<
+@am__fastdepCC_TRUE@	$(AM_V_at)$(am__mv) $(DEPDIR)/$*.Tpo $(DEPDIR)/$*.Po
+@AMDEP_TRUE@@am__fastdepCC_FALSE@	$(AM_V_CC)source='$<' object='$@' libtool=no @AMDEPBACKSLASH@
+@AMDEP_TRUE@@am__fastdepCC_FALSE@	DEPDIR=$(DEPDIR) $(CCDEPMODE) $(depcomp) @AMDEPBACKSLASH@
+@am__fastdepCC_FALSE@	$(AM_V_CC@am__nodep@)$(COMPILE) -c $<
+
+.c.obj:
+@am__fastdepCC_TRUE@	$(AM_V_CC)$(COMPILE) -MT $@ -MD -MP -MF $(DEPDIR)/$*.Tpo -c -o $@ `$(CYGPATH_W) '$<'`
+@am__fastdepCC_TRUE@	$(AM_V_at)$(am__mv) $(DEPDIR)/$*.Tpo $(DEPDIR)/$*.Po
+@AMDEP_TRUE@@am__fastdepCC_FALSE@	$(AM_V_CC)source='$<' object='$@' libtool=no @AMDEPBACKSLASH@
+@AMDEP_TRUE@@am__fastdepCC_FALSE@	DEPDIR=$(DEPDIR) $(CCDEPMODE) $(depcomp) @AMDEPBACKSLASH@
+@am__fastdepCC_FALSE@	$(AM_V_CC@am__nodep@)$(COMPILE) -c `$(CYGPATH_W) '$<'`
+
+.c.lo:
+@am__fastdepCC_TRUE@	$(AM_V_CC)$(LTCOMPILE) -MT $@ -MD -MP -MF $(DEPDIR)/$*.Tpo -c -o $@ $<
+@am__fastdepCC_TRUE@	$(AM_V_at)$(am__mv) $(DEPDIR)/$*.Tpo $(DEPDIR)/$*.Plo
+@AMDEP_TRUE@@am__fastdepCC_FALSE@	$(AM_V_CC)source='$<' object='$@' libtool=yes @AMDEPBACKSLASH@
+@AMDEP_TRUE@@am__fastdepCC_FALSE@	DEPDIR=$(DEPDIR) $(CCDEPMODE) $(depcomp) @AMDEPBACKSLASH@
+@am__fastdepCC_FALSE@	$(AM_V_CC@am__nodep@)$(LTCOMPILE) -c -o $@ $<
+
+mostlyclean-libtool:
+	-rm -f *.lo
+
+clean-libtool:
+	-rm -rf .libs _libs
+
+ID: $(HEADERS) $(SOURCES) $(LISP) $(TAGS_FILES)
+	list='$(SOURCES) $(HEADERS) $(LISP) $(TAGS_FILES)'; \
+	unique=`for i in $$list; do \
+	    if test -f "$$i"; then echo $$i; else echo $(srcdir)/$$i; fi; \
+	  done | \
+	  $(AWK) '{ files[$$0] = 1; nonempty = 1; } \
+	      END { if (nonempty) { for (i in files) print i; }; }'`; \
+	mkid -fID $$unique
+tags: TAGS
+
+TAGS:  $(HEADERS) $(SOURCES)  $(TAGS_DEPENDENCIES) \
+		$(TAGS_FILES) $(LISP)
+	set x; \
+	here=`pwd`; \
+	list='$(SOURCES) $(HEADERS)  $(LISP) $(TAGS_FILES)'; \
+	unique=`for i in $$list; do \
+	    if test -f "$$i"; then echo $$i; else echo $(srcdir)/$$i; fi; \
+	  done | \
+	  $(AWK) '{ files[$$0] = 1; nonempty = 1; } \
+	      END { if (nonempty) { for (i in files) print i; }; }'`; \
+	shift; \
+	if test -z "$(ETAGS_ARGS)$$*$$unique"; then :; else \
+	  test -n "$$unique" || unique=$$empty_fix; \
+	  if test $$# -gt 0; then \
+	    $(ETAGS) $(ETAGSFLAGS) $(AM_ETAGSFLAGS) $(ETAGS_ARGS) \
+	      "$$@" $$unique; \
+	  else \
+	    $(ETAGS) $(ETAGSFLAGS) $(AM_ETAGSFLAGS) $(ETAGS_ARGS) \
+	      $$unique; \
+	  fi; \
+	fi
+ctags: CTAGS
+CTAGS:  $(HEADERS) $(SOURCES)  $(TAGS_DEPENDENCIES) \
+		$(TAGS_FILES) $(LISP)
+	list='$(SOURCES) $(HEADERS)  $(LISP) $(TAGS_FILES)'; \
+	unique=`for i in $$list; do \
+	    if test -f "$$i"; then echo $$i; else echo $(srcdir)/$$i; fi; \
+	  done | \
+	  $(AWK) '{ files[$$0] = 1; nonempty = 1; } \
+	      END { if (nonempty) { for (i in files) print i; }; }'`; \
+	test -z "$(CTAGS_ARGS)$$unique" \
+	  || $(CTAGS) $(CTAGSFLAGS) $(AM_CTAGSFLAGS) $(CTAGS_ARGS) \
+	     $$unique
+
+GTAGS:
+	here=`$(am__cd) $(top_builddir) && pwd` \
+	  && $(am__cd) $(top_srcdir) \
+	  && gtags -i $(GTAGS_ARGS) "$$here"
+
+distclean-tags:
+	-rm -f TAGS ID GTAGS GRTAGS GSYMS GPATH tags
+
+distdir: $(DISTFILES)
+	@srcdirstrip=`echo "$(srcdir)" | sed 's/[].[^$$\\*]/\\\\&/g'`; \
+	topsrcdirstrip=`echo "$(top_srcdir)" | sed 's/[].[^$$\\*]/\\\\&/g'`; \
+	list='$(DISTFILES)'; \
+	  dist_files=`for file in $$list; do echo $$file; done | \
+	  sed -e "s|^$$srcdirstrip/||;t" \
+	      -e "s|^$$topsrcdirstrip/|$(top_builddir)/|;t"`; \
+	case $$dist_files in \
+	  */*) $(MKDIR_P) `echo "$$dist_files" | \
+			   sed '/\//!d;s|^|$(distdir)/|;s,/[^/]*$$,,' | \
+			   sort -u` ;; \
+	esac; \
+	for file in $$dist_files; do \
+	  if test -f $$file || test -d $$file; then d=.; else d=$(srcdir); fi; \
+	  if test -d $$d/$$file; then \
+	    dir=`echo "/$$file" | sed -e 's,/[^/]*$$,,'`; \
+	    if test -d "$(distdir)/$$file"; then \
+	      find "$(distdir)/$$file" -type d ! -perm -700 -exec chmod u+rwx {} \;; \
+	    fi; \
+	    if test -d $(srcdir)/$$file && test $$d != $(srcdir); then \
+	      cp -fpR $(srcdir)/$$file "$(distdir)$$dir" || exit 1; \
+	      find "$(distdir)/$$file" -type d ! -perm -700 -exec chmod u+rwx {} \;; \
+	    fi; \
+	    cp -fpR $$d/$$file "$(distdir)$$dir" || exit 1; \
+	  else \
+	    test -f "$(distdir)/$$file" \
+	    || cp -p $$d/$$file "$(distdir)/$$file" \
+	    || exit 1; \
+	  fi; \
+	done
+check-am: all-am
+check: check-am
+all-am: Makefile $(LTLIBRARIES) $(DATA)
+installdirs:
+	for dir in "$(DESTDIR)$(libdir)"; do \
+	  test -z "$$dir" || $(MKDIR_P) "$$dir"; \
+	done
+install: install-am
+install-exec: install-exec-am
+install-data: install-data-am
+uninstall: uninstall-am
+
+install-am: all-am
+	@$(MAKE) $(AM_MAKEFLAGS) install-exec-am install-data-am
+
+installcheck: installcheck-am
+install-strip:
+	if test -z '$(STRIP)'; then \
+	  $(MAKE) $(AM_MAKEFLAGS) INSTALL_PROGRAM="$(INSTALL_STRIP_PROGRAM)" \
+	    install_sh_PROGRAM="$(INSTALL_STRIP_PROGRAM)" INSTALL_STRIP_FLAG=-s \
+	      install; \
+	else \
+	  $(MAKE) $(AM_MAKEFLAGS) INSTALL_PROGRAM="$(INSTALL_STRIP_PROGRAM)" \
+	    install_sh_PROGRAM="$(INSTALL_STRIP_PROGRAM)" INSTALL_STRIP_FLAG=-s \
+	    "INSTALL_PROGRAM_ENV=STRIPPROG='$(STRIP)'" install; \
+	fi
+mostlyclean-generic:
+
+clean-generic:
+
+distclean-generic:
+	-test -z "$(CONFIG_CLEAN_FILES)" || rm -f $(CONFIG_CLEAN_FILES)
+	-test . = "$(srcdir)" || test -z "$(CONFIG_CLEAN_VPATH_FILES)" || rm -f $(CONFIG_CLEAN_VPATH_FILES)
+
+maintainer-clean-generic:
+	@echo "This command is intended for maintainers to use"
+	@echo "it deletes files that may require special tools to rebuild."
+@BUILD_JNI_INTERFACE_FALSE@clean-local:
+clean: clean-am
+
+clean-am: clean-generic clean-libLTLIBRARIES clean-libtool clean-local \
+	mostlyclean-am
+
+distclean: distclean-am
+	-rm -rf ./$(DEPDIR)
+	-rm -f Makefile
+distclean-am: clean-am distclean-compile distclean-generic \
+	distclean-tags
+
+dvi: dvi-am
+
+dvi-am:
+
+html: html-am
+
+html-am:
+
+info: info-am
+
+info-am:
+
+install-data-am:
+
+install-dvi: install-dvi-am
+
+install-dvi-am:
+
+install-exec-am: install-libLTLIBRARIES
+
+install-html: install-html-am
+
+install-html-am:
+
+install-info: install-info-am
+
+install-info-am:
+
+install-man:
+
+install-pdf: install-pdf-am
+
+install-pdf-am:
+
+install-ps: install-ps-am
+
+install-ps-am:
+
+installcheck-am:
+
+maintainer-clean: maintainer-clean-am
+	-rm -rf ./$(DEPDIR)
+	-rm -f Makefile
+maintainer-clean-am: distclean-am maintainer-clean-generic
+
+mostlyclean: mostlyclean-am
+
+mostlyclean-am: mostlyclean-compile mostlyclean-generic \
+	mostlyclean-libtool
+
+pdf: pdf-am
+
+pdf-am:
+
+ps: ps-am
+
+ps-am:
+
+uninstall-am: uninstall-libLTLIBRARIES
+
+.MAKE: install-am install-strip
+
+.PHONY: CTAGS GTAGS all all-am check check-am clean clean-generic \
+	clean-libLTLIBRARIES clean-libtool clean-local ctags distclean \
+	distclean-compile distclean-generic distclean-libtool \
+	distclean-tags distdir dvi dvi-am html html-am info info-am \
+	install install-am install-data install-data-am install-dvi \
+	install-dvi-am install-exec install-exec-am install-html \
+	install-html-am install-info install-info-am \
+	install-libLTLIBRARIES install-man install-pdf install-pdf-am \
+	install-ps install-ps-am install-strip installcheck \
+	installcheck-am installdirs maintainer-clean \
+	maintainer-clean-generic mostlyclean mostlyclean-compile \
+	mostlyclean-generic mostlyclean-libtool pdf pdf-am ps ps-am \
+	tags uninstall uninstall-am uninstall-libLTLIBRARIES
+
+
+@BUILD_JNI_INTERFACE_TRUE@all: LTTngUst.class org_lttng_ust_LTTngUst.h liblttng-ust-java.jar
+
+@BUILD_JNI_INTERFACE_TRUE@clean-local:
+@BUILD_JNI_INTERFACE_TRUE@	rm org_lttng_ust_LTTngUst.h
+@BUILD_JNI_INTERFACE_TRUE@	rm liblttng-ust-java.jar
+@BUILD_JNI_INTERFACE_TRUE@	rm -rf org/
+
+@BUILD_JNI_INTERFACE_TRUE@LTTngUst.c: org_lttng_ust_LTTngUst.h
+
+@BUILD_JNI_INTERFACE_TRUE@LTTngUst.class: LTTngUst.java
+@BUILD_JNI_INTERFACE_TRUE@	javac -d "$(builddir)" "$(srcdir)/LTTngUst.java"
+
+@BUILD_JNI_INTERFACE_TRUE@org_lttng_ust_LTTngUst.h: LTTngUst.class
+@BUILD_JNI_INTERFACE_TRUE@	javah org.lttng.ust.LTTngUst
+
+@BUILD_JNI_INTERFACE_TRUE@liblttng-ust-java.jar: LTTngUst.class
+@BUILD_JNI_INTERFACE_TRUE@	jar cf liblttng-ust-java.jar org/*
+
+# Tell versions [3.59,3.63) of GNU make to not export all variables.
+# Otherwise a system limit (for SysV at least) may be exceeded.
+.NOEXPORT:

=== added file 'liblttng-ust-java/README'
--- liblttng-ust-java/README	1970-01-01 00:00:00 +0000
+++ liblttng-ust-java/README	2012-09-11 15:34:43 +0000
@@ -0,0 +1,17 @@
+This directory contains a simple API for instrumenting java applications.
+
+Configuration examples to build this library:
+
+dependency: sun-java6-jdk
+./configure --with-java-jdk=/usr/lib/jvm/java-6-sun --with-jni-interface
+
+dependency: openjdk-6-jdk
+./configure --with-java-jdk=/usr/lib/jvm/java-6-openjdk --with-jni-interface
+
+dependency: gcj-4.4-jdk
+./configure --with-java-jdk=/usr/lib/jvm/java-gcj --with-jni-interface
+
+
+After building, you can use the liblttng-ust-java.jar file in a Java project.
+It requires the liblttng-ust-java.so* files (which get installed when doing
+`make install') so make sure those are in the linker's library path.

=== added file 'liblttng-ust-java/lttng_ust_java.h'
--- liblttng-ust-java/lttng_ust_java.h	1970-01-01 00:00:00 +0000
+++ liblttng-ust-java/lttng_ust_java.h	2012-09-11 15:34:43 +0000
@@ -0,0 +1,75 @@
+#undef TRACEPOINT_PROVIDER
+#define TRACEPOINT_PROVIDER lttng_ust_java
+
+#if !defined(_TRACEPOINT_LTTNG_UST_JAVA_H) || defined(TRACEPOINT_HEADER_MULTI_READ)
+#define _TRACEPOINT_LTTNG_UST_JAVA_H
+
+/*
+ * Copyright (C) 2011  Mathieu Desnoyers <mathieu.desnoyers@efficios.com>
+ *
+ * This library is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU Lesser General Public
+ * License as published by the Free Software Foundation; version 2.1 of
+ * the License.
+ *
+ * This library is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with this library; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301 USA
+ */
+
+#include <lttng/tracepoint.h>
+
+TRACEPOINT_EVENT(lttng_ust_java, int_event,
+	TP_ARGS(const char *, name, int, payload),
+	TP_FIELDS(
+		ctf_string(name, name)
+		ctf_integer(int, int_payload, payload)
+	)
+)
+
+TRACEPOINT_EVENT(lttng_ust_java, int_int_event,
+	TP_ARGS(const char *, name, int, payload1, int, payload2),
+	TP_FIELDS(
+		ctf_string(name, name)
+		ctf_integer(int, int_payload1, payload1)
+		ctf_integer(int, int_payload2, payload2)
+	)
+)
+
+TRACEPOINT_EVENT(lttng_ust_java, long_event,
+	TP_ARGS(const char *, name, long, payload),
+	TP_FIELDS(
+		ctf_string(name, name)
+		ctf_integer(long, long_payload, payload)
+	)
+)
+
+TRACEPOINT_EVENT(lttng_ust_java, long_long_event,
+	TP_ARGS(const char *, name, long, payload1, long, payload2),
+	TP_FIELDS(
+		ctf_string(name, name)
+		ctf_integer(long, long_payload1, payload1)
+		ctf_integer(long, long_payload2, payload2)
+	)
+)
+
+TRACEPOINT_EVENT(lttng_ust_java, string_event,
+	TP_ARGS(const char *, name, const char *, payload),
+	TP_FIELDS(
+		ctf_string(name, name)
+		ctf_string(string_payload, payload)
+	)
+)
+
+#endif /* _TRACEPOINT_LTTNG_UST_JAVA_H */
+
+#undef TRACEPOINT_INCLUDE_FILE
+#define TRACEPOINT_INCLUDE_FILE ./lttng_ust_java.h
+
+/* This part must be outside protection */
+#include <lttng/tracepoint-event.h>

=== modified file 'liblttng-ust-libc-wrapper/Makefile.am'
--- liblttng-ust-libc-wrapper/Makefile.am	2012-06-29 16:47:49 +0000
+++ liblttng-ust-libc-wrapper/Makefile.am	2012-09-11 15:34:43 +0000
@@ -5,9 +5,16 @@
 liblttng_ust_libc_wrapper_la_SOURCES = \
 	lttng-ust-malloc.c \
 	ust_libc.h
-liblttng_ust_libc_wrapper_la_LIBADD = -ldl \
+liblttng_ust_libc_wrapper_la_LIBADD = \
 	-L$(top_builddir)/liblttng-ust/.libs \
 	-llttng-ust
 
+if LTTNG_UST_BUILD_WITH_LIBDL
+liblttng_ust_libc_wrapper_la_LIBADD += -ldl
+endif
+if LTTNG_UST_BUILD_WITH_LIBC_DL
+liblttng_ust_libc_wrapper_la_LIBADD += -lc
+endif
+
 noinst_SCRIPTS = run
 EXTRA_DIST = run

=== modified file 'liblttng-ust-libc-wrapper/Makefile.in'
--- liblttng-ust-libc-wrapper/Makefile.in	2012-06-29 16:47:49 +0000
+++ liblttng-ust-libc-wrapper/Makefile.in	2012-09-11 15:34:43 +0000
@@ -1,4 +1,4 @@
-# Makefile.in generated by automake 1.11.3 from Makefile.am.
+# Makefile.in generated by automake 1.11.6 from Makefile.am.
 # @configure_input@
 
 # Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2000, 2001, 2002,
@@ -17,6 +17,23 @@
 
 
 VPATH = @srcdir@
+am__make_dryrun = \
+  { \
+    am__dry=no; \
+    case $$MAKEFLAGS in \
+      *\\[\ \	]*) \
+        echo 'am--echo: ; @echo "AM"  OK' | $(MAKE) -f - 2>/dev/null \
+          | grep '^AM OK$$' >/dev/null || am__dry=yes;; \
+      *) \
+        for am__flg in $$MAKEFLAGS; do \
+          case $$am__flg in \
+            *=*|--*) ;; \
+            *n*) am__dry=yes; break;; \
+          esac; \
+        done;; \
+    esac; \
+    test $$am__dry = yes; \
+  }
 pkgdatadir = $(datadir)/@PACKAGE@
 pkgincludedir = $(includedir)/@PACKAGE@
 pkglibdir = $(libdir)/@PACKAGE@
@@ -36,6 +53,8 @@
 build_triplet = @build@
 host_triplet = @host@
 target_triplet = @target@
+@LTTNG_UST_BUILD_WITH_LIBDL_TRUE@am__append_1 = -ldl
+@LTTNG_UST_BUILD_WITH_LIBC_DL_TRUE@am__append_2 = -lc
 subdir = liblttng-ust-libc-wrapper
 DIST_COMMON = README $(srcdir)/Makefile.am $(srcdir)/Makefile.in
 ACLOCAL_M4 = $(top_srcdir)/aclocal.m4
@@ -80,7 +99,9 @@
   }
 am__installdirs = "$(DESTDIR)$(libdir)"
 LTLIBRARIES = $(lib_LTLIBRARIES)
-liblttng_ust_libc_wrapper_la_DEPENDENCIES =
+am__DEPENDENCIES_1 =
+liblttng_ust_libc_wrapper_la_DEPENDENCIES = $(am__DEPENDENCIES_1) \
+	$(am__DEPENDENCIES_1)
 am_liblttng_ust_libc_wrapper_la_OBJECTS = lttng-ust-malloc.lo
 liblttng_ust_libc_wrapper_la_OBJECTS =  \
 	$(am_liblttng_ust_libc_wrapper_la_OBJECTS)
@@ -116,6 +137,11 @@
 am__v_GEN_0 = @echo "  GEN   " $@;
 SOURCES = $(liblttng_ust_libc_wrapper_la_SOURCES)
 DIST_SOURCES = $(liblttng_ust_libc_wrapper_la_SOURCES)
+am__can_run_installinfo = \
+  case $$AM_UPDATE_INFO_DIR in \
+    n|no|NO) false;; \
+    *) (install-info --version) >/dev/null 2>&1;; \
+  esac
 ETAGS = etags
 CTAGS = ctags
 DISTFILES = $(DIST_COMMON) $(DIST_SOURCES) $(TEXINFOS) $(EXTRA_DIST)
@@ -189,7 +215,6 @@
 SET_MAKE = @SET_MAKE@
 SHELL = @SHELL@
 STRIP = @STRIP@
-TEXINFO = @TEXINFO@
 VERSION = @VERSION@
 abs_builddir = @abs_builddir@
 abs_srcdir = @abs_srcdir@
@@ -255,10 +280,9 @@
 	lttng-ust-malloc.c \
 	ust_libc.h
 
-liblttng_ust_libc_wrapper_la_LIBADD = -ldl \
-	-L$(top_builddir)/liblttng-ust/.libs \
-	-llttng-ust
-
+liblttng_ust_libc_wrapper_la_LIBADD =  \
+	-L$(top_builddir)/liblttng-ust/.libs -llttng-ust \
+	$(am__append_1) $(am__append_2)
 noinst_SCRIPTS = run
 EXTRA_DIST = run
 all: all-am
@@ -297,7 +321,6 @@
 $(am__aclocal_m4_deps):
 install-libLTLIBRARIES: $(lib_LTLIBRARIES)
 	@$(NORMAL_INSTALL)
-	test -z "$(libdir)" || $(MKDIR_P) "$(DESTDIR)$(libdir)"
 	@list='$(lib_LTLIBRARIES)'; test -n "$(libdir)" || list=; \
 	list2=; for p in $$list; do \
 	  if test -f $$p; then \
@@ -305,6 +328,8 @@
 	  else :; fi; \
 	done; \
 	test -z "$$list2" || { \
+	  echo " $(MKDIR_P) '$(DESTDIR)$(libdir)'"; \
+	  $(MKDIR_P) "$(DESTDIR)$(libdir)" || exit 1; \
 	  echo " $(LIBTOOL) $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=install $(INSTALL) $(INSTALL_STRIP_FLAG) $$list2 '$(DESTDIR)$(libdir)'"; \
 	  $(LIBTOOL) $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=install $(INSTALL) $(INSTALL_STRIP_FLAG) $$list2 "$(DESTDIR)$(libdir)"; \
 	}

=== modified file 'liblttng-ust/Makefile.am'
--- liblttng-ust/Makefile.am	2012-06-29 16:47:49 +0000
+++ liblttng-ust/Makefile.am	2012-09-11 15:34:43 +0000
@@ -28,12 +28,20 @@
 	lttng-context-procname.c \
 	ltt-context.c \
 	ltt-events.c \
+	lttng-filter.c \
+	lttng-filter.h \
+	lttng-filter-validator.c \
+	lttng-filter-specialize.c \
+	lttng-filter-interpreter.c \
+	filter-bytecode.h \
+	lttng-hash-helper.h \
 	tracepoint-internal.h \
 	clock.h \
 	compat.h \
 	wait.h \
 	jhash.h \
-	error.h
+	error.h \
+	lttng-ust-uuid.h
 
 liblttng_ust_support_la_SOURCES = \
 	ltt-tracer.h \
@@ -55,10 +63,17 @@
 liblttng_ust_la_LIBADD = \
 	-lpthread \
 	-lrt \
-	-luuid \
+	-lurcu-cds \
 	-llttng-ust-tracepoint \
 	$(top_builddir)/snprintf/libustsnprintf.la \
 	$(top_builddir)/liblttng-ust-comm/liblttng-ust-comm.la \
 	liblttng-ust-runtime.la liblttng-ust-support.la
 
+if LTTNG_UST_BUILD_WITH_LIBUUID
+liblttng_ust_la_LIBADD += -luuid
+endif
+if LTTNG_UST_BUILD_WITH_LIBC_UUID
+liblttng_ust_la_LIBADD += -lc
+endif
+
 liblttng_ust_la_CFLAGS = -DUST_COMPONENT="liblttng_ust" -fno-strict-aliasing

=== modified file 'liblttng-ust/Makefile.in'
--- liblttng-ust/Makefile.in	2012-06-29 16:47:49 +0000
+++ liblttng-ust/Makefile.in	2012-09-11 15:34:43 +0000
@@ -1,4 +1,4 @@
-# Makefile.in generated by automake 1.11.3 from Makefile.am.
+# Makefile.in generated by automake 1.11.6 from Makefile.am.
 # @configure_input@
 
 # Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2000, 2001, 2002,
@@ -16,6 +16,23 @@
 @SET_MAKE@
 
 VPATH = @srcdir@
+am__make_dryrun = \
+  { \
+    am__dry=no; \
+    case $$MAKEFLAGS in \
+      *\\[\ \	]*) \
+        echo 'am--echo: ; @echo "AM"  OK' | $(MAKE) -f - 2>/dev/null \
+          | grep '^AM OK$$' >/dev/null || am__dry=yes;; \
+      *) \
+        for am__flg in $$MAKEFLAGS; do \
+          case $$am__flg in \
+            *=*|--*) ;; \
+            *n*) am__dry=yes; break;; \
+          esac; \
+        done;; \
+    esac; \
+    test $$am__dry = yes; \
+  }
 pkgdatadir = $(datadir)/@PACKAGE@
 pkgincludedir = $(includedir)/@PACKAGE@
 pkglibdir = $(libdir)/@PACKAGE@
@@ -35,6 +52,8 @@
 build_triplet = @build@
 host_triplet = @host@
 target_triplet = @target@
+@LTTNG_UST_BUILD_WITH_LIBUUID_TRUE@am__append_1 = -luuid
+@LTTNG_UST_BUILD_WITH_LIBC_UUID_TRUE@am__append_2 = -lc
 subdir = liblttng-ust
 DIST_COMMON = $(srcdir)/Makefile.am $(srcdir)/Makefile.in
 ACLOCAL_M4 = $(top_srcdir)/aclocal.m4
@@ -84,7 +103,9 @@
 	lttng-ust-abi.lo ltt-probes.lo lttng-probe-ust.lo \
 	lttng-context-vtid.lo lttng-context-vpid.lo \
 	lttng-context-pthread-id.lo lttng-context-procname.lo \
-	ltt-context.lo ltt-events.lo
+	ltt-context.lo ltt-events.lo lttng-filter.lo \
+	lttng-filter-validator.lo lttng-filter-specialize.lo \
+	lttng-filter-interpreter.lo
 liblttng_ust_runtime_la_OBJECTS =  \
 	$(am_liblttng_ust_runtime_la_OBJECTS)
 AM_V_lt = $(am__v_lt_@AM_V@)
@@ -107,10 +128,12 @@
 	$(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=link $(CCLD) \
 	$(liblttng_ust_tracepoint_la_CFLAGS) $(CFLAGS) \
 	$(liblttng_ust_tracepoint_la_LDFLAGS) $(LDFLAGS) -o $@
+am__DEPENDENCIES_1 =
 liblttng_ust_la_DEPENDENCIES =  \
 	$(top_builddir)/snprintf/libustsnprintf.la \
 	$(top_builddir)/liblttng-ust-comm/liblttng-ust-comm.la \
-	liblttng-ust-runtime.la liblttng-ust-support.la
+	liblttng-ust-runtime.la liblttng-ust-support.la \
+	$(am__DEPENDENCIES_1) $(am__DEPENDENCIES_1)
 am_liblttng_ust_la_OBJECTS =
 liblttng_ust_la_OBJECTS = $(am_liblttng_ust_la_OBJECTS)
 liblttng_ust_la_LINK = $(LIBTOOL) $(AM_V_lt) --tag=CC \
@@ -151,6 +174,11 @@
 	$(liblttng_ust_support_la_SOURCES) \
 	$(liblttng_ust_tracepoint_la_SOURCES) \
 	$(liblttng_ust_la_SOURCES)
+am__can_run_installinfo = \
+  case $$AM_UPDATE_INFO_DIR in \
+    n|no|NO) false;; \
+    *) (install-info --version) >/dev/null 2>&1;; \
+  esac
 ETAGS = etags
 CTAGS = ctags
 DISTFILES = $(DIST_COMMON) $(DIST_SOURCES) $(TEXINFOS) $(EXTRA_DIST)
@@ -224,7 +252,6 @@
 SET_MAKE = @SET_MAKE@
 SHELL = @SHELL@
 STRIP = @STRIP@
-TEXINFO = @TEXINFO@
 VERSION = @VERSION@
 abs_builddir = @abs_builddir@
 abs_srcdir = @abs_srcdir@
@@ -311,12 +338,20 @@
 	lttng-context-procname.c \
 	ltt-context.c \
 	ltt-events.c \
+	lttng-filter.c \
+	lttng-filter.h \
+	lttng-filter-validator.c \
+	lttng-filter-specialize.c \
+	lttng-filter-interpreter.c \
+	filter-bytecode.h \
+	lttng-hash-helper.h \
 	tracepoint-internal.h \
 	clock.h \
 	compat.h \
 	wait.h \
 	jhash.h \
-	error.h
+	error.h \
+	lttng-ust-uuid.h
 
 liblttng_ust_support_la_SOURCES = \
 	ltt-tracer.h \
@@ -333,15 +368,12 @@
 liblttng_ust_support_la_LIBADD = \
 	$(top_builddir)/libringbuffer/libringbuffer.la
 
-liblttng_ust_la_LIBADD = \
-	-lpthread \
-	-lrt \
-	-luuid \
+liblttng_ust_la_LIBADD = -lpthread -lrt -lurcu-cds \
 	-llttng-ust-tracepoint \
 	$(top_builddir)/snprintf/libustsnprintf.la \
 	$(top_builddir)/liblttng-ust-comm/liblttng-ust-comm.la \
-	liblttng-ust-runtime.la liblttng-ust-support.la
-
+	liblttng-ust-runtime.la liblttng-ust-support.la \
+	$(am__append_1) $(am__append_2)
 liblttng_ust_la_CFLAGS = -DUST_COMPONENT="liblttng_ust" -fno-strict-aliasing
 all: all-am
 
@@ -379,7 +411,6 @@
 $(am__aclocal_m4_deps):
 install-libLTLIBRARIES: $(lib_LTLIBRARIES)
 	@$(NORMAL_INSTALL)
-	test -z "$(libdir)" || $(MKDIR_P) "$(DESTDIR)$(libdir)"
 	@list='$(lib_LTLIBRARIES)'; test -n "$(libdir)" || list=; \
 	list2=; for p in $$list; do \
 	  if test -f $$p; then \
@@ -387,6 +418,8 @@
 	  else :; fi; \
 	done; \
 	test -z "$$list2" || { \
+	  echo " $(MKDIR_P) '$(DESTDIR)$(libdir)'"; \
+	  $(MKDIR_P) "$(DESTDIR)$(libdir)" || exit 1; \
 	  echo " $(LIBTOOL) $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=install $(INSTALL) $(INSTALL_STRIP_FLAG) $$list2 '$(DESTDIR)$(libdir)'"; \
 	  $(LIBTOOL) $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=install $(INSTALL) $(INSTALL_STRIP_FLAG) $$list2 "$(DESTDIR)$(libdir)"; \
 	}
@@ -443,6 +476,10 @@
 @AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/lttng-context-pthread-id.Plo@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/lttng-context-vpid.Plo@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/lttng-context-vtid.Plo@am__quote@
+@AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/lttng-filter-interpreter.Plo@am__quote@
+@AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/lttng-filter-specialize.Plo@am__quote@
+@AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/lttng-filter-validator.Plo@am__quote@
+@AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/lttng-filter.Plo@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/lttng-probe-ust.Plo@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/lttng-ust-abi.Plo@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/lttng-ust-comm.Plo@am__quote@

=== modified file 'liblttng-ust/clock.h'
--- liblttng-ust/clock.h	2012-06-29 16:47:49 +0000
+++ liblttng-ust/clock.h	2012-09-11 15:34:43 +0000
@@ -25,11 +25,7 @@
 #include <stdint.h>
 #include <stddef.h>
 #include <stdio.h>
-
-/*
- * Includes final \0.
- */
-#define CLOCK_UUID_LEN		37
+#include "lttng-ust-uuid.h"
 
 /* TRACE CLOCK */
 
@@ -56,7 +52,7 @@
 }
 
 static __inline__
-const int trace_clock_uuid(char *uuid)
+int trace_clock_uuid(char *uuid)
 {
 	int ret = 0;
 	size_t len;
@@ -71,12 +67,12 @@
 	if (!fp) {
 		return -ENOENT;
 	}
-	len = fread(uuid, 1, CLOCK_UUID_LEN - 1, fp);
-	if (len < CLOCK_UUID_LEN - 1) {
+	len = fread(uuid, 1, LTTNG_UST_UUID_STR_LEN - 1, fp);
+	if (len < LTTNG_UST_UUID_STR_LEN - 1) {
 		ret = -EINVAL;
 		goto end;
 	}
-	uuid[CLOCK_UUID_LEN - 1] = '\0';
+	uuid[LTTNG_UST_UUID_STR_LEN - 1] = '\0';
 end:
 	fclose(fp);
 	return ret;

=== modified file 'liblttng-ust/compat.h'
--- liblttng-ust/compat.h	2012-06-29 16:47:49 +0000
+++ liblttng-ust/compat.h	2012-09-11 15:34:43 +0000
@@ -19,17 +19,51 @@
  * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
  */
 
-#include <sys/syscall.h>
-
-#ifdef __UCLIBC__
-#define __getcpu(cpu, node, cache)	syscall(__NR_getcpu, cpu, node, cache)
-static inline
-int sched_getcpu(void)
-{
-	int c, s;
-
-	s = __getcpu(&c, NULL, NULL);
-	return (s == -1) ? s : c;
-}
-#endif	/* __UCLIBC__ */
+/*
+ * lttng_ust_getprocname.
+ */
+#ifdef __linux__
+
+#include <sys/prctl.h>
+
+#define LTTNG_UST_PROCNAME_LEN 17
+
+static inline
+void lttng_ust_getprocname(char *name)
+{
+	(void) prctl(PR_GET_NAME, (unsigned long) name, 0, 0, 0);
+}
+
+#elif defined(__FreeBSD__)
+#include <stdlib.h>
+#include <string.h>
+
+/*
+ * Limit imposed by Linux UST-sessiond ABI.
+ */
+#define LTTNG_UST_PROCNAME_LEN 17
+
+/*
+ * Acts like linux prctl, the string is not necessarily 0-terminated if
+ * 16-byte long.
+ */
+static inline
+void lttng_ust_getprocname(char *name)
+{
+	const char *bsd_name;
+
+	bsd_name = getprogname();
+	if (!bsd_name)
+		name[0] = '\0';
+	memcpy(name, bsd_name, LTTNG_UST_PROCNAME_LEN - 1);
+}
+
+#endif
+
+#include <errno.h>
+
+#ifndef ENODATA
+#define ENODATA	ENOMSG
+#endif
+
 #endif /* _UST_COMPAT_H */

=== added file 'liblttng-ust/filter-bytecode.h'
--- liblttng-ust/filter-bytecode.h	1970-01-01 00:00:00 +0000
+++ liblttng-ust/filter-bytecode.h	2012-09-11 15:34:43 +0000
@@ -0,0 +1,176 @@
+#ifndef _FILTER_BYTECODE_H
+#define _FILTER_BYTECODE_H
+
+/*
+ * filter-bytecode.h
+ *
+ * LTTng filter bytecode
+ *
+ * Copyright 2012 - Mathieu Desnoyers <mathieu.desnoyers@efficios.com>
+ *
+ * This library is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU Lesser General Public License, version 2.1 only,
+ * as published by the Free Software Foundation.
+ *
+ * This library is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public License
+ * along with this library; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#include <lttng/ust-abi.h>
+
+/*
+ * offsets are absolute from start of bytecode.
+ */
+
+struct field_ref {
+	/* Initially, symbol offset. After link, field offset. */
+	uint16_t offset;
+} __attribute__((packed));
+
+struct literal_numeric {
+	int64_t v;
+} __attribute__((packed));
+
+struct literal_double {
+	double v;
+} __attribute__((packed));
+
+struct literal_string {
+	char string[0];
+} __attribute__((packed));
+
+enum filter_op {
+	FILTER_OP_UNKNOWN = 0,
+
+	FILTER_OP_RETURN,
+
+	/* binary */
+	FILTER_OP_MUL,
+	FILTER_OP_DIV,
+	FILTER_OP_MOD,
+	FILTER_OP_PLUS,
+	FILTER_OP_MINUS,
+	FILTER_OP_RSHIFT,
+	FILTER_OP_LSHIFT,
+	FILTER_OP_BIN_AND,
+	FILTER_OP_BIN_OR,
+	FILTER_OP_BIN_XOR,
+
+	/* binary comparators */
+	FILTER_OP_EQ,
+	FILTER_OP_NE,
+	FILTER_OP_GT,
+	FILTER_OP_LT,
+	FILTER_OP_GE,
+	FILTER_OP_LE,
+
+	/* string binary comparator */
+	FILTER_OP_EQ_STRING,
+	FILTER_OP_NE_STRING,
+	FILTER_OP_GT_STRING,
+	FILTER_OP_LT_STRING,
+	FILTER_OP_GE_STRING,
+	FILTER_OP_LE_STRING,
+
+	/* s64 binary comparator */
+	FILTER_OP_EQ_S64,
+	FILTER_OP_NE_S64,
+	FILTER_OP_GT_S64,
+	FILTER_OP_LT_S64,
+	FILTER_OP_GE_S64,
+	FILTER_OP_LE_S64,
+
+	/* double binary comparator */
+	FILTER_OP_EQ_DOUBLE,
+	FILTER_OP_NE_DOUBLE,
+	FILTER_OP_GT_DOUBLE,
+	FILTER_OP_LT_DOUBLE,
+	FILTER_OP_GE_DOUBLE,
+	FILTER_OP_LE_DOUBLE,
+
+	/* Mixed S64-double binary comparators */
+	FILTER_OP_EQ_DOUBLE_S64,
+	FILTER_OP_NE_DOUBLE_S64,
+	FILTER_OP_GT_DOUBLE_S64,
+	FILTER_OP_LT_DOUBLE_S64,
+	FILTER_OP_GE_DOUBLE_S64,
+	FILTER_OP_LE_DOUBLE_S64,
+
+	FILTER_OP_EQ_S64_DOUBLE,
+	FILTER_OP_NE_S64_DOUBLE,
+	FILTER_OP_GT_S64_DOUBLE,
+	FILTER_OP_LT_S64_DOUBLE,
+	FILTER_OP_GE_S64_DOUBLE,
+	FILTER_OP_LE_S64_DOUBLE,
+
+	/* unary */
+	FILTER_OP_UNARY_PLUS,
+	FILTER_OP_UNARY_MINUS,
+	FILTER_OP_UNARY_NOT,
+	FILTER_OP_UNARY_PLUS_S64,
+	FILTER_OP_UNARY_MINUS_S64,
+	FILTER_OP_UNARY_NOT_S64,
+	FILTER_OP_UNARY_PLUS_DOUBLE,
+	FILTER_OP_UNARY_MINUS_DOUBLE,
+	FILTER_OP_UNARY_NOT_DOUBLE,
+
+	/* logical */
+	FILTER_OP_AND,
+	FILTER_OP_OR,
+
+	/* load */
+	FILTER_OP_LOAD_FIELD_REF,
+	FILTER_OP_LOAD_FIELD_REF_STRING,
+	FILTER_OP_LOAD_FIELD_REF_SEQUENCE,
+	FILTER_OP_LOAD_FIELD_REF_S64,
+	FILTER_OP_LOAD_FIELD_REF_DOUBLE,
+
+	FILTER_OP_LOAD_STRING,
+	FILTER_OP_LOAD_S64,
+	FILTER_OP_LOAD_DOUBLE,
+
+	/* cast */
+	FILTER_OP_CAST_TO_S64,
+	FILTER_OP_CAST_DOUBLE_TO_S64,
+	FILTER_OP_CAST_NOP,
+
+	NR_FILTER_OPS,
+};
+
+typedef uint8_t filter_opcode_t;
+
+struct load_op {
+	filter_opcode_t op;
+	char data[0];
+	/* data to load. Size known by enum filter_opcode and null-term char. */
+} __attribute__((packed));
+
+struct binary_op {
+	filter_opcode_t op;
+} __attribute__((packed));
+
+struct unary_op {
+	filter_opcode_t op;
+} __attribute__((packed));
+
+/* skip_offset is absolute from start of bytecode */
+struct logical_op {
+	filter_opcode_t op;
+	uint16_t skip_offset;	/* bytecode insn, if skip second test */
+} __attribute__((packed));
+
+struct cast_op {
+	filter_opcode_t op;
+} __attribute__((packed));
+
+struct return_op {
+	filter_opcode_t op;
+} __attribute__((packed));
+
+#endif /* _FILTER_BYTECODE_H */

=== modified file 'liblttng-ust/jhash.h'
--- liblttng-ust/jhash.h	2012-06-29 16:47:49 +0000
+++ liblttng-ust/jhash.h	2012-09-11 15:34:43 +0000
@@ -17,7 +17,7 @@
  */
 
 #include <urcu/compiler.h>
-#include <endian.h>
+#include <lttng/ust-endian.h>
 
 /*
  * Hash function

=== modified file 'liblttng-ust/ltt-events.c'
--- liblttng-ust/ltt-events.c	2012-06-29 16:47:49 +0000
+++ liblttng-ust/ltt-events.c	2012-09-11 15:34:43 +0000
@@ -22,11 +22,9 @@
 
 #define _GNU_SOURCE
 #include <stdio.h>
-#include <endian.h>
 #include <urcu/list.h>
 #include <urcu/hlist.h>
 #include <pthread.h>
-#include <uuid/uuid.h>
 #include <errno.h>
 #include <sys/shm.h>
 #include <sys/ipc.h>
@@ -34,7 +32,7 @@
 #include <stddef.h>
 #include <inttypes.h>
 #include <time.h>
-#include <sys/prctl.h>
+#include <lttng/ust-endian.h>
 #include "clock.h"
 
 #include <urcu-bp.h>
@@ -48,6 +46,8 @@
 #include <usterr-signal-safe.h>
 #include <helper.h>
 #include "error.h"
+#include "compat.h"
+#include "lttng-ust-uuid.h"
 
 #include "tracepoint-internal.h"
 #include "ltt-tracer.h"
@@ -56,8 +56,6 @@
 #include "../libringbuffer/shm.h"
 #include "jhash.h"
 
-#define PROCNAME_LEN 17
-
 /*
  * The sessions mutex is the centralized mutex across UST tracing
  * control and probe registration. All operations within this file are
@@ -253,14 +251,15 @@
 					sizeof(event_param.name));
 				/* create event */
 				ret = ltt_event_create(sw->chan,
-					&event_param, NULL,
-					&ev);
+					&event_param, &ev);
 				if (ret) {
 					DBG("Error creating event");
 					continue;
 				}
 				cds_list_add(&ev->wildcard_list,
 					&sw->events);
+				lttng_filter_event_link_bytecode(ev,
+					sw->filter_bytecode);
 			}
 		}
 	}
@@ -297,6 +296,8 @@
 		event->id = chan->free_event_id++;
 		ret |= _ltt_event_metadata_statedump(chan->session, chan,
 				event);
+		lttng_filter_event_link_bytecode(event,
+			event->filter_bytecode);
 	}
 	return ret;
 }
@@ -309,6 +310,7 @@
 struct ltt_session *ltt_session_create(void)
 {
 	struct ltt_session *session;
+	int ret;
 
 	session = zmalloc(sizeof(struct ltt_session));
 	if (!session)
@@ -316,7 +318,10 @@
 	CDS_INIT_LIST_HEAD(&session->chan);
 	CDS_INIT_LIST_HEAD(&session->events);
 	CDS_INIT_LIST_HEAD(&session->wildcards);
-	uuid_generate(session->uuid);
+	ret = lttng_ust_uuid_generate(session->uuid);
+	if (ret != 0) {
+		session->uuid[0] = '\0';
+	}
 	cds_list_add(&session->list, &sessions);
 	return session;
 }
@@ -498,7 +503,6 @@
  */
 int ltt_event_create(struct ltt_channel *chan,
 		struct lttng_ust_event *event_param,
-		void *filter,
 		struct ltt_event **_event)
 {
 	const struct lttng_event_desc *desc = NULL;	/* silence gcc */
@@ -546,7 +550,6 @@
 		goto cache_error;
 	}
 	event->chan = chan;
-	event->filter = filter;
 	/*
 	 * used_event_id counts the maximum number of event IDs that can
 	 * register if all probes register.
@@ -651,6 +654,8 @@
 	}
 	cds_list_del(&event->list);
 	lttng_destroy_context(event->ctx);
+	free(event->filter_bytecode);
+	free(event->filter_data);
 	free(event);
 }
 
@@ -721,6 +726,9 @@
 {
 	int ret = 0;
 
+	if (field->nowrite)
+		return 0;
+
 	switch (field->type.atype) {
 	case atype_integer:
 		ret = lttng_metadata_printf(session,
@@ -1018,7 +1026,7 @@
 		"struct packet_context {\n"
 		"	uint64_clock_monotonic_t timestamp_begin;\n"
 		"	uint64_clock_monotonic_t timestamp_end;\n"
-		"	uint32_t events_discarded;\n"
+		"	unsigned long events_discarded;\n"
 		"	uint32_t content_size;\n"
 		"	uint32_t packet_size;\n"
 		"	uint32_t cpu_id;\n"
@@ -1101,11 +1109,13 @@
 int _ltt_session_metadata_statedump(struct ltt_session *session)
 {
 	unsigned char *uuid_c = session->uuid;
-	char uuid_s[37], clock_uuid_s[CLOCK_UUID_LEN];
+	char uuid_s[LTTNG_UST_UUID_STR_LEN],
+		clock_uuid_s[LTTNG_UST_UUID_STR_LEN];
 	struct ltt_channel *chan;
 	struct ltt_event *event;
 	int ret = 0;
-	char procname[PROCNAME_LEN] = "";
+	char procname[LTTNG_UST_PROCNAME_LEN] = "";
+	char hostname[HOST_NAME_MAX];
 
 	if (!CMM_ACCESS_ONCE(session->active))
 		return 0;
@@ -1128,6 +1138,7 @@
 		"typealias integer { size = 16; align = %u; signed = false; } := uint16_t;\n"
 		"typealias integer { size = 32; align = %u; signed = false; } := uint32_t;\n"
 		"typealias integer { size = 64; align = %u; signed = false; } := uint64_t;\n"
+		"typealias integer { size = %u; align = %u; signed = false; } := unsigned long;\n"
 		"typealias integer { size = 5; align = 1; signed = false; } := uint5_t;\n"
 		"typealias integer { size = 27; align = 1; signed = false; } := uint27_t;\n"
 		"\n"
@@ -1146,6 +1157,8 @@
 		lttng_alignof(uint16_t) * CHAR_BIT,
 		lttng_alignof(uint32_t) * CHAR_BIT,
 		lttng_alignof(uint64_t) * CHAR_BIT,
+		sizeof(unsigned long) * CHAR_BIT,
+		lttng_alignof(unsigned long) * CHAR_BIT,
 		CTF_SPEC_MAJOR,
 		CTF_SPEC_MINOR,
 		uuid_s,
@@ -1159,10 +1172,15 @@
 		goto end;
 
 	/* ignore error, just use empty string if error. */
-	(void) prctl(PR_GET_NAME, (unsigned long) procname, 0, 0, 0);
-	procname[PROCNAME_LEN - 1] = '\0';
+	hostname[0] = '\0';
+	ret = gethostname(hostname, sizeof(hostname));
+	if (ret && errno == ENAMETOOLONG)
+		hostname[HOST_NAME_MAX - 1] = '\0';
+	lttng_ust_getprocname(procname);
+	procname[LTTNG_UST_PROCNAME_LEN - 1] = '\0';
 	ret = lttng_metadata_printf(session,
 		"env {\n"
+		"	hostname = \"%s\";\n"
 		"	vpid = %d;\n"
 		"	procname = \"%s\";\n"
 		"	domain = \"ust\";\n"
@@ -1171,6 +1189,7 @@
 		"	tracer_minor = %u;\n"
 		"	tracer_patchlevel = %u;\n"
 		"};\n\n",
+		hostname,
 		(int) getpid(),
 		procname,
 		LTTNG_UST_MAJOR_VERSION,
@@ -1411,6 +1430,7 @@
 		cds_list_del(&wildcard->entry->list);
 		free(wildcard->entry);
 	}
+	free(wildcard->filter_bytecode);
 	free(wildcard);
 }
 
@@ -1478,7 +1498,7 @@
  */
 void lttng_fixup_event_tls(void)
 {
-	unsigned char uuid[37];
+	unsigned char uuid[LTTNG_UST_UUID_STR_LEN];
 
-	(void) uuid_generate(uuid);
+	(void) lttng_ust_uuid_generate(uuid);
 }

=== modified file 'liblttng-ust/ltt-probes.c'
--- liblttng-ust/ltt-probes.c	2012-06-29 16:47:49 +0000
+++ liblttng-ust/ltt-probes.c	2012-09-11 15:34:43 +0000
@@ -219,6 +219,120 @@
 	return &entry->tp;
 }
 
+void ltt_probes_prune_field_list(struct lttng_ust_field_list *list)
+{
+	struct tp_field_list_entry *list_entry, *tmp;
+
+	cds_list_for_each_entry_safe(list_entry, tmp, &list->head, head) {
+		cds_list_del(&list_entry->head);
+		free(list_entry);
+	}
+}
+
+/*
+ * called with UST lock held.
+ */
+int ltt_probes_get_field_list(struct lttng_ust_field_list *list)
+{
+	struct lttng_probe_desc *probe_desc;
+	int i;
+
+	CDS_INIT_LIST_HEAD(&list->head);
+	cds_list_for_each_entry(probe_desc, &probe_list, head) {
+		for (i = 0; i < probe_desc->nr_events; i++) {
+			const struct lttng_event_desc *event_desc =
+				probe_desc->event_desc[i];
+			int j;
+
+			for (j = 0; j < event_desc->nr_fields; j++) {
+				const struct lttng_event_field *event_field =
+					&event_desc->fields[j];
+				struct tp_field_list_entry *list_entry;
+
+				list_entry = zmalloc(sizeof(*list_entry));
+				if (!list_entry)
+					goto err_nomem;
+				cds_list_add(&list_entry->head, &list->head);
+				strncpy(list_entry->field.event_name,
+					event_desc->name,
+					LTTNG_UST_SYM_NAME_LEN);
+				list_entry->field.event_name[LTTNG_UST_SYM_NAME_LEN - 1] = '\0';
+				strncpy(list_entry->field.field_name,
+					event_field->name,
+					LTTNG_UST_SYM_NAME_LEN);
+				list_entry->field.field_name[LTTNG_UST_SYM_NAME_LEN - 1] = '\0';
+				switch (event_field->type.atype) {
+				case atype_integer:
+					list_entry->field.type = LTTNG_UST_FIELD_INTEGER;
+					break;
+				case atype_string:
+					list_entry->field.type = LTTNG_UST_FIELD_STRING;
+					break;
+				case atype_array:
+					if (event_field->type.u.array.elem_type.atype != atype_integer
+						|| event_field->type.u.array.elem_type.u.basic.integer.encoding == lttng_encode_none)
+						list_entry->field.type = LTTNG_UST_FIELD_OTHER;
+					else
+						list_entry->field.type = LTTNG_UST_FIELD_STRING;
+					break;
+				case atype_sequence:
+					if (event_field->type.u.sequence.elem_type.atype != atype_integer
+						|| event_field->type.u.sequence.elem_type.u.basic.integer.encoding == lttng_encode_none)
+						list_entry->field.type = LTTNG_UST_FIELD_OTHER;
+					else
+						list_entry->field.type = LTTNG_UST_FIELD_STRING;
+					break;
+				case atype_float:
+					list_entry->field.type = LTTNG_UST_FIELD_FLOAT;
+					break;
+				case atype_enum:
+					list_entry->field.type = LTTNG_UST_FIELD_ENUM;
+					break;
+				default:
+					list_entry->field.type = LTTNG_UST_FIELD_OTHER;
+				}
+				if (!event_desc->loglevel) {
+					list_entry->field.loglevel = TRACE_DEFAULT;
+				} else {
+					list_entry->field.loglevel = *(*event_desc->loglevel);
+				}
+				list_entry->field.nowrite = event_field->nowrite;
+			}
+		}
+	}
+	if (cds_list_empty(&list->head))
+		list->iter = NULL;
+	else
+		list->iter =
+			cds_list_first_entry(&list->head,
+				struct tp_field_list_entry, head);
+	return 0;
+
+err_nomem:
+	ltt_probes_prune_field_list(list);
+	return -ENOMEM;
+}
+
+/*
+ * Return current iteration position, advance internal iterator to next.
+ * Return NULL if end of list.
+ */
+struct lttng_ust_field_iter *
+	lttng_ust_field_list_get_iter_next(struct lttng_ust_field_list *list)
+{
+	struct tp_field_list_entry *entry;
+
+	if (!list->iter)
+		return NULL;
+	entry = list->iter;
+	if (entry->head.next == &list->head)
+		list->iter = NULL;
+	else
+		list->iter = cds_list_entry(entry->head.next,
+				struct tp_field_list_entry, head);
+	return &entry->field;
+}
+
 /*
  * marshall all probes/all events and create those that fit the
  * wildcard. Add them to the events list as created.
@@ -259,8 +373,7 @@
 					sizeof(event_param.name));
 				/* create event */
 				ret = ltt_event_create(wildcard->chan,
-					&event_param, NULL,
-					&ev);
+					&event_param, &ev);
 				if (ret) {
 					DBG("Error creating event");
 					continue;
@@ -270,5 +383,6 @@
 			}
 		}
 	}
+	lttng_filter_wildcard_link_bytecode(wildcard);
 }
 

=== modified file 'liblttng-ust/ltt-ring-buffer-client.h'
--- liblttng-ust/ltt-ring-buffer-client.h	2012-06-29 16:47:49 +0000
+++ liblttng-ust/ltt-ring-buffer-client.h	2012-09-11 15:34:43 +0000
@@ -24,6 +24,7 @@
 #include <lttng/ust-events.h>
 #include "lttng/bitfield.h"
 #include "clock.h"
+#include "lttng-ust-uuid.h"
 #include "ltt-tracer.h"
 #include "../libringbuffer/frontend_types.h"
 
@@ -43,14 +44,14 @@
 					 * Trace magic number.
 					 * contains endianness information.
 					 */
-	uint8_t uuid[16];
+	uint8_t uuid[LTTNG_UST_UUID_LEN];
 	uint32_t stream_id;
 
 	struct {
 		/* Stream packet context */
 		uint64_t timestamp_begin;	/* Cycle count at subbuffer start */
 		uint64_t timestamp_end;		/* Cycle count at subbuffer end */
-		uint32_t events_discarded;	/*
+		unsigned long events_discarded;	/*
 						 * Events lost in this subbuffer since
 						 * the beginning of the trace.
 						 * (may overflow)

=== modified file 'liblttng-ust/ltt-ring-buffer-metadata-client.h'
--- liblttng-ust/ltt-ring-buffer-metadata-client.h	2012-06-29 16:47:49 +0000
+++ liblttng-ust/ltt-ring-buffer-metadata-client.h	2012-09-11 15:34:43 +0000
@@ -28,7 +28,7 @@
 
 struct metadata_packet_header {
 	uint32_t magic;			/* 0x75D11D57 */
-	uint8_t  uuid[16];		/* Unique Universal Identifier */
+	uint8_t  uuid[LTTNG_UST_UUID_LEN]; /* Unique Universal Identifier */
 	uint32_t checksum;		/* 0 if unused */
 	uint32_t content_size;		/* in bits */
 	uint32_t packet_size;		/* in bits */

=== modified file 'liblttng-ust/lttng-context-procname.c'
--- liblttng-ust/lttng-context-procname.c	2012-06-29 16:47:49 +0000
+++ liblttng-ust/lttng-context-procname.c	2012-09-11 15:34:43 +0000
@@ -20,13 +20,11 @@
  * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
  */
 
-#include <sys/prctl.h>
 #include <lttng/ust-events.h>
 #include <lttng/ust-tracer.h>
 #include <lttng/ringbuffer-config.h>
 #include <assert.h>
-
-#define PROCNAME_LEN	17	/* includes \0 */
+#include "compat.h"
 
 /*
  * We cache the result to ensure we don't trigger a system call for
@@ -39,12 +37,9 @@
 static inline
 char *wrapper_getprocname(void)
 {
-	int ret;
-
 	if (caa_unlikely(!cached_procname[0])) {
-		ret = prctl(PR_GET_NAME, (unsigned long) cached_procname,
-			0, 0, 0);
-		assert(!ret);
+		lttng_ust_getprocname(cached_procname);
+		cached_procname[LTTNG_UST_PROCNAME_LEN - 1] = '\0';
 	}
 	return cached_procname;
 }
@@ -59,7 +54,7 @@
 {
 	size_t size = 0;
 
-	size += PROCNAME_LEN;
+	size += LTTNG_UST_PROCNAME_LEN;
 	return size;
 }
 
@@ -71,7 +66,7 @@
 	char *procname;
 
 	procname = wrapper_getprocname();
-	chan->ops->event_write(ctx, procname, PROCNAME_LEN);
+	chan->ops->event_write(ctx, procname, LTTNG_UST_PROCNAME_LEN);
 }
 
 int lttng_add_procname_to_ctx(struct lttng_ctx **ctx)
@@ -94,7 +89,7 @@
 	field->event_field.type.u.array.elem_type.u.basic.integer.reverse_byte_order = 0;
 	field->event_field.type.u.array.elem_type.u.basic.integer.base = 10;
 	field->event_field.type.u.array.elem_type.u.basic.integer.encoding = lttng_encode_UTF8;
-	field->event_field.type.u.array.length = PROCNAME_LEN;
+	field->event_field.type.u.array.length = LTTNG_UST_PROCNAME_LEN;
 	field->get_size = procname_get_size;
 	field->record = procname_record;
 	return 0;

=== modified file 'liblttng-ust/lttng-context-vtid.c'
--- liblttng-ust/lttng-context-vtid.c	2012-06-29 16:47:49 +0000
+++ liblttng-ust/lttng-context-vtid.c	2012-09-11 15:34:43 +0000
@@ -25,27 +25,9 @@
 #include <lttng/ust-events.h>
 #include <lttng/ust-tracer.h>
 #include <lttng/ringbuffer-config.h>
+#include <lttng/ust-tid.h>
 #include "ltt-tracer-core.h"
 
-#ifdef __linux__
-#include <syscall.h>
-#endif
-
-#if defined(_syscall0)
-_syscall0(pid_t, gettid)
-#elif defined(__NR_gettid)
-static inline pid_t gettid(void)
-{
-	return syscall(__NR_gettid);
-}
-#else
-#warning "use pid as tid"
-static inline pid_t gettid(void)
-{
-	return getpid();
-}
-#endif
-
 /*
  * We cache the result to ensure we don't trigger a system call for
  * each event.

=== added file 'liblttng-ust/lttng-filter-interpreter.c'
--- liblttng-ust/lttng-filter-interpreter.c	1970-01-01 00:00:00 +0000
+++ liblttng-ust/lttng-filter-interpreter.c	2012-09-11 15:34:43 +0000
@@ -0,0 +1,842 @@
+/*
+ * lttng-filter-interpreter.c
+ *
+ * LTTng UST filter interpreter.
+ *
+ * Copyright (C) 2010-2012 Mathieu Desnoyers <mathieu.desnoyers@efficios.com>
+ *
+ * This library is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU Lesser General Public
+ * License as published by the Free Software Foundation; only
+ * version 2.1 of the License.
+ *
+ * This library is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with this library; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#include "lttng-filter.h"
+
+/*
+ * -1: wildcard found.
+ * -2: unknown escape char.
+ * 0: normal char.
+ */
+
+static
+int parse_char(const char **p)
+{
+	switch (**p) {
+	case '\\':
+		(*p)++;
+		switch (**p) {
+		case '\\':
+		case '*':
+			return 0;
+		default:
+			return -2;
+		}
+	case '*':
+		return -1;
+	default:
+		return 0;
+	}
+}
+
+static
+int stack_strcmp(struct estack *stack, int top, const char *cmp_type)
+{
+	const char *p = estack_bx(stack, top)->u.s.str, *q = estack_ax(stack, top)->u.s.str;
+	int ret;
+	int diff;
+
+	for (;;) {
+		int escaped_r0 = 0;
+
+		if (unlikely(p - estack_bx(stack, top)->u.s.str > estack_bx(stack, top)->u.s.seq_len || *p == '\0')) {
+			if (q - estack_ax(stack, top)->u.s.str > estack_ax(stack, top)->u.s.seq_len || *q == '\0')
+				diff = 0;
+			else
+				diff = -1;
+			break;
+		}
+		if (unlikely(q - estack_ax(stack, top)->u.s.str > estack_ax(stack, top)->u.s.seq_len || *q == '\0')) {
+			if (p - estack_bx(stack, top)->u.s.str > estack_bx(stack, top)->u.s.seq_len || *p == '\0')
+				diff = 0;
+			else
+				diff = 1;
+			break;
+		}
+		if (estack_bx(stack, top)->u.s.literal) {
+			ret = parse_char(&p);
+			if (ret == -1) {
+				return 0;
+			} else if (ret == -2) {
+				escaped_r0 = 1;
+			}
+			/* else compare both char */
+		}
+		if (estack_ax(stack, top)->u.s.literal) {
+			ret = parse_char(&q);
+			if (ret == -1) {
+				return 0;
+			} else if (ret == -2) {
+				if (!escaped_r0)
+					return -1;
+			} else {
+				if (escaped_r0)
+					return 1;
+			}
+		} else {
+			if (escaped_r0)
+				return 1;
+		}
+		diff = *p - *q;
+		if (diff != 0)
+			break;
+		p++;
+		q++;
+	}
+	return diff;
+}
+
+int lttng_filter_false(void *filter_data,
+		const char *filter_stack_data)
+{
+	return 0;
+}
+
+#ifdef INTERPRETER_USE_SWITCH
+
+/*
+ * Fallback for compilers that do not support taking address of labels.
+ */
+
+#define START_OP							\
+	start_pc = &bytecode->data[0];					\
+	for (pc = next_pc = start_pc; pc - start_pc < bytecode->len;	\
+			pc = next_pc) {					\
+		dbg_printf("Executing op %s (%u)\n",			\
+			print_op((unsigned int) *(filter_opcode_t *) pc), \
+			(unsigned int) *(filter_opcode_t *) pc); 	\
+		switch (*(filter_opcode_t *) pc)	{
+
+#define OP(name)	case name
+
+#define PO		break
+
+#define END_OP		}						\
+	}
+
+#else
+
+/*
+ * Dispatch-table based interpreter.
+ */
+
+#define START_OP							\
+	start_pc = &bytecode->data[0];					\
+	pc = next_pc = start_pc;					\
+	if (unlikely(pc - start_pc >= bytecode->len))			\
+		goto end;						\
+	goto *dispatch[*(filter_opcode_t *) pc];
+
+#define OP(name)							\
+LABEL_##name
+
+#define PO								\
+		pc = next_pc;						\
+		goto *dispatch[*(filter_opcode_t *) pc];
+
+#define END_OP
+
+#endif
+
+int lttng_filter_interpret_bytecode(void *filter_data,
+		const char *filter_stack_data)
+{
+	struct bytecode_runtime *bytecode = filter_data;
+	void *pc, *next_pc, *start_pc;
+	int ret = -EINVAL;
+	int retval = 0;
+	struct estack _stack;
+	struct estack *stack = &_stack;
+	register int64_t ax = 0, bx = 0;
+	register int top = FILTER_STACK_EMPTY;
+#ifndef INTERPRETER_USE_SWITCH
+	static void *dispatch[NR_FILTER_OPS] = {
+		[ FILTER_OP_UNKNOWN ] = &&LABEL_FILTER_OP_UNKNOWN,
+
+		[ FILTER_OP_RETURN ] = &&LABEL_FILTER_OP_RETURN,
+
+		/* binary */
+		[ FILTER_OP_MUL ] = &&LABEL_FILTER_OP_MUL,
+		[ FILTER_OP_DIV ] = &&LABEL_FILTER_OP_DIV,
+		[ FILTER_OP_MOD ] = &&LABEL_FILTER_OP_MOD,
+		[ FILTER_OP_PLUS ] = &&LABEL_FILTER_OP_PLUS,
+		[ FILTER_OP_MINUS ] = &&LABEL_FILTER_OP_MINUS,
+		[ FILTER_OP_RSHIFT ] = &&LABEL_FILTER_OP_RSHIFT,
+		[ FILTER_OP_LSHIFT ] = &&LABEL_FILTER_OP_LSHIFT,
+		[ FILTER_OP_BIN_AND ] = &&LABEL_FILTER_OP_BIN_AND,
+		[ FILTER_OP_BIN_OR ] = &&LABEL_FILTER_OP_BIN_OR,
+		[ FILTER_OP_BIN_XOR ] = &&LABEL_FILTER_OP_BIN_XOR,
+
+		/* binary comparators */
+		[ FILTER_OP_EQ ] = &&LABEL_FILTER_OP_EQ,
+		[ FILTER_OP_NE ] = &&LABEL_FILTER_OP_NE,
+		[ FILTER_OP_GT ] = &&LABEL_FILTER_OP_GT,
+		[ FILTER_OP_LT ] = &&LABEL_FILTER_OP_LT,
+		[ FILTER_OP_GE ] = &&LABEL_FILTER_OP_GE,
+		[ FILTER_OP_LE ] = &&LABEL_FILTER_OP_LE,
+
+		/* string binary comparator */
+		[ FILTER_OP_EQ_STRING ] = &&LABEL_FILTER_OP_EQ_STRING,
+		[ FILTER_OP_NE_STRING ] = &&LABEL_FILTER_OP_NE_STRING,
+		[ FILTER_OP_GT_STRING ] = &&LABEL_FILTER_OP_GT_STRING,
+		[ FILTER_OP_LT_STRING ] = &&LABEL_FILTER_OP_LT_STRING,
+		[ FILTER_OP_GE_STRING ] = &&LABEL_FILTER_OP_GE_STRING,
+		[ FILTER_OP_LE_STRING ] = &&LABEL_FILTER_OP_LE_STRING,
+
+		/* s64 binary comparator */
+		[ FILTER_OP_EQ_S64 ] = &&LABEL_FILTER_OP_EQ_S64,
+		[ FILTER_OP_NE_S64 ] = &&LABEL_FILTER_OP_NE_S64,
+		[ FILTER_OP_GT_S64 ] = &&LABEL_FILTER_OP_GT_S64,
+		[ FILTER_OP_LT_S64 ] = &&LABEL_FILTER_OP_LT_S64,
+		[ FILTER_OP_GE_S64 ] = &&LABEL_FILTER_OP_GE_S64,
+		[ FILTER_OP_LE_S64 ] = &&LABEL_FILTER_OP_LE_S64,
+
+		/* double binary comparator */
+		[ FILTER_OP_EQ_DOUBLE ] = &&LABEL_FILTER_OP_EQ_DOUBLE,
+		[ FILTER_OP_NE_DOUBLE ] = &&LABEL_FILTER_OP_NE_DOUBLE,
+		[ FILTER_OP_GT_DOUBLE ] = &&LABEL_FILTER_OP_GT_DOUBLE,
+		[ FILTER_OP_LT_DOUBLE ] = &&LABEL_FILTER_OP_LT_DOUBLE,
+		[ FILTER_OP_GE_DOUBLE ] = &&LABEL_FILTER_OP_GE_DOUBLE,
+		[ FILTER_OP_LE_DOUBLE ] = &&LABEL_FILTER_OP_LE_DOUBLE,
+
+		/* Mixed S64-double binary comparators */
+		[ FILTER_OP_EQ_DOUBLE_S64 ] = &&LABEL_FILTER_OP_EQ_DOUBLE_S64,
+		[ FILTER_OP_NE_DOUBLE_S64 ] = &&LABEL_FILTER_OP_NE_DOUBLE_S64,
+		[ FILTER_OP_GT_DOUBLE_S64 ] = &&LABEL_FILTER_OP_GT_DOUBLE_S64,
+		[ FILTER_OP_LT_DOUBLE_S64 ] = &&LABEL_FILTER_OP_LT_DOUBLE_S64,
+		[ FILTER_OP_GE_DOUBLE_S64 ] = &&LABEL_FILTER_OP_GE_DOUBLE_S64,
+		[ FILTER_OP_LE_DOUBLE_S64 ] = &&LABEL_FILTER_OP_LE_DOUBLE_S64,
+
+		[ FILTER_OP_EQ_S64_DOUBLE ] = &&LABEL_FILTER_OP_EQ_S64_DOUBLE,
+		[ FILTER_OP_NE_S64_DOUBLE ] = &&LABEL_FILTER_OP_NE_S64_DOUBLE,
+		[ FILTER_OP_GT_S64_DOUBLE ] = &&LABEL_FILTER_OP_GT_S64_DOUBLE,
+		[ FILTER_OP_LT_S64_DOUBLE ] = &&LABEL_FILTER_OP_LT_S64_DOUBLE,
+		[ FILTER_OP_GE_S64_DOUBLE ] = &&LABEL_FILTER_OP_GE_S64_DOUBLE,
+		[ FILTER_OP_LE_S64_DOUBLE ] = &&LABEL_FILTER_OP_LE_S64_DOUBLE,
+
+		/* unary */
+		[ FILTER_OP_UNARY_PLUS ] = &&LABEL_FILTER_OP_UNARY_PLUS,
+		[ FILTER_OP_UNARY_MINUS ] = &&LABEL_FILTER_OP_UNARY_MINUS,
+		[ FILTER_OP_UNARY_NOT ] = &&LABEL_FILTER_OP_UNARY_NOT,
+		[ FILTER_OP_UNARY_PLUS_S64 ] = &&LABEL_FILTER_OP_UNARY_PLUS_S64,
+		[ FILTER_OP_UNARY_MINUS_S64 ] = &&LABEL_FILTER_OP_UNARY_MINUS_S64,
+		[ FILTER_OP_UNARY_NOT_S64 ] = &&LABEL_FILTER_OP_UNARY_NOT_S64,
+		[ FILTER_OP_UNARY_PLUS_DOUBLE ] = &&LABEL_FILTER_OP_UNARY_PLUS_DOUBLE,
+		[ FILTER_OP_UNARY_MINUS_DOUBLE ] = &&LABEL_FILTER_OP_UNARY_MINUS_DOUBLE,
+		[ FILTER_OP_UNARY_NOT_DOUBLE ] = &&LABEL_FILTER_OP_UNARY_NOT_DOUBLE,
+
+		/* logical */
+		[ FILTER_OP_AND ] = &&LABEL_FILTER_OP_AND,
+		[ FILTER_OP_OR ] = &&LABEL_FILTER_OP_OR,
+
+		/* load */
+		[ FILTER_OP_LOAD_FIELD_REF ] = &&LABEL_FILTER_OP_LOAD_FIELD_REF,
+		[ FILTER_OP_LOAD_FIELD_REF_STRING ] = &&LABEL_FILTER_OP_LOAD_FIELD_REF_STRING,
+		[ FILTER_OP_LOAD_FIELD_REF_SEQUENCE ] = &&LABEL_FILTER_OP_LOAD_FIELD_REF_SEQUENCE,
+		[ FILTER_OP_LOAD_FIELD_REF_S64 ] = &&LABEL_FILTER_OP_LOAD_FIELD_REF_S64,
+		[ FILTER_OP_LOAD_FIELD_REF_DOUBLE ] = &&LABEL_FILTER_OP_LOAD_FIELD_REF_DOUBLE,
+
+		[ FILTER_OP_LOAD_STRING ] = &&LABEL_FILTER_OP_LOAD_STRING,
+		[ FILTER_OP_LOAD_S64 ] = &&LABEL_FILTER_OP_LOAD_S64,
+		[ FILTER_OP_LOAD_DOUBLE ] = &&LABEL_FILTER_OP_LOAD_DOUBLE,
+
+		/* cast */
+		[ FILTER_OP_CAST_TO_S64 ] = &&LABEL_FILTER_OP_CAST_TO_S64,
+		[ FILTER_OP_CAST_DOUBLE_TO_S64 ] = &&LABEL_FILTER_OP_CAST_DOUBLE_TO_S64,
+		[ FILTER_OP_CAST_NOP ] = &&LABEL_FILTER_OP_CAST_NOP,
+	};
+#endif /* #ifndef INTERPRETER_USE_SWITCH */
+
+	START_OP
+
+		OP(FILTER_OP_UNKNOWN):
+		OP(FILTER_OP_LOAD_FIELD_REF):
+#ifdef INTERPRETER_USE_SWITCH
+		default:
+#endif /* INTERPRETER_USE_SWITCH */
+			ERR("unknown bytecode op %u\n",
+				(unsigned int) *(filter_opcode_t *) pc);
+			ret = -EINVAL;
+			goto end;
+
+		OP(FILTER_OP_RETURN):
+			retval = !!estack_ax_v;
+			ret = 0;
+			goto end;
+
+		/* binary */
+		OP(FILTER_OP_MUL):
+		OP(FILTER_OP_DIV):
+		OP(FILTER_OP_MOD):
+		OP(FILTER_OP_PLUS):
+		OP(FILTER_OP_MINUS):
+		OP(FILTER_OP_RSHIFT):
+		OP(FILTER_OP_LSHIFT):
+		OP(FILTER_OP_BIN_AND):
+		OP(FILTER_OP_BIN_OR):
+		OP(FILTER_OP_BIN_XOR):
+			ERR("unsupported bytecode op %u\n",
+				(unsigned int) *(filter_opcode_t *) pc);
+			ret = -EINVAL;
+			goto end;
+
+		OP(FILTER_OP_EQ):
+		OP(FILTER_OP_NE):
+		OP(FILTER_OP_GT):
+		OP(FILTER_OP_LT):
+		OP(FILTER_OP_GE):
+		OP(FILTER_OP_LE):
+			ERR("unsupported non-specialized bytecode op %u\n",
+				(unsigned int) *(filter_opcode_t *) pc);
+			ret = -EINVAL;
+			goto end;
+
+		OP(FILTER_OP_EQ_STRING):
+		{
+			int res;
+
+			res = (stack_strcmp(stack, top, "==") == 0);
+			estack_pop(stack, top, ax, bx);
+			estack_ax_v = res;
+			next_pc += sizeof(struct binary_op);
+			PO;
+		}
+		OP(FILTER_OP_NE_STRING):
+		{
+			int res;
+
+			res = (stack_strcmp(stack, top, "!=") != 0);
+			estack_pop(stack, top, ax, bx);
+			estack_ax_v = res;
+			next_pc += sizeof(struct binary_op);
+			PO;
+		}
+		OP(FILTER_OP_GT_STRING):
+		{
+			int res;
+
+			res = (stack_strcmp(stack, top, ">") > 0);
+			estack_pop(stack, top, ax, bx);
+			estack_ax_v = res;
+			next_pc += sizeof(struct binary_op);
+			PO;
+		}
+		OP(FILTER_OP_LT_STRING):
+		{
+			int res;
+
+			res = (stack_strcmp(stack, top, "<") < 0);
+			estack_pop(stack, top, ax, bx);
+			estack_ax_v = res;
+			next_pc += sizeof(struct binary_op);
+			PO;
+		}
+		OP(FILTER_OP_GE_STRING):
+		{
+			int res;
+
+			res = (stack_strcmp(stack, top, ">=") >= 0);
+			estack_pop(stack, top, ax, bx);
+			estack_ax_v = res;
+			next_pc += sizeof(struct binary_op);
+			PO;
+		}
+		OP(FILTER_OP_LE_STRING):
+		{
+			int res;
+
+			res = (stack_strcmp(stack, top, "<=") <= 0);
+			estack_pop(stack, top, ax, bx);
+			estack_ax_v = res;
+			next_pc += sizeof(struct binary_op);
+			PO;
+		}
+
+		OP(FILTER_OP_EQ_S64):
+		{
+			int res;
+
+			res = (estack_bx_v == estack_ax_v);
+			estack_pop(stack, top, ax, bx);
+			estack_ax_v = res;
+			next_pc += sizeof(struct binary_op);
+			PO;
+		}
+		OP(FILTER_OP_NE_S64):
+		{
+			int res;
+
+			res = (estack_bx_v != estack_ax_v);
+			estack_pop(stack, top, ax, bx);
+			estack_ax_v = res;
+			next_pc += sizeof(struct binary_op);
+			PO;
+		}
+		OP(FILTER_OP_GT_S64):
+		{
+			int res;
+
+			res = (estack_bx_v > estack_ax_v);
+			estack_pop(stack, top, ax, bx);
+			estack_ax_v = res;
+			next_pc += sizeof(struct binary_op);
+			PO;
+		}
+		OP(FILTER_OP_LT_S64):
+		{
+			int res;
+
+			res = (estack_bx_v < estack_ax_v);
+			estack_pop(stack, top, ax, bx);
+			estack_ax_v = res;
+			next_pc += sizeof(struct binary_op);
+			PO;
+		}
+		OP(FILTER_OP_GE_S64):
+		{
+			int res;
+
+			res = (estack_bx_v >= estack_ax_v);
+			estack_pop(stack, top, ax, bx);
+			estack_ax_v = res;
+			next_pc += sizeof(struct binary_op);
+			PO;
+		}
+		OP(FILTER_OP_LE_S64):
+		{
+			int res;
+
+			res = (estack_bx_v <= estack_ax_v);
+			estack_pop(stack, top, ax, bx);
+			estack_ax_v = res;
+			next_pc += sizeof(struct binary_op);
+			PO;
+		}
+
+		OP(FILTER_OP_EQ_DOUBLE):
+		{
+			int res;
+
+			res = (estack_bx(stack, top)->u.d == estack_ax(stack, top)->u.d);
+			estack_pop(stack, top, ax, bx);
+			estack_ax_v = res;
+			next_pc += sizeof(struct binary_op);
+			PO;
+		}
+		OP(FILTER_OP_NE_DOUBLE):
+		{
+			int res;
+
+			res = (estack_bx(stack, top)->u.d != estack_ax(stack, top)->u.d);
+			estack_pop(stack, top, ax, bx);
+			estack_ax_v = res;
+			next_pc += sizeof(struct binary_op);
+			PO;
+		}
+		OP(FILTER_OP_GT_DOUBLE):
+		{
+			int res;
+
+			res = (estack_bx(stack, top)->u.d > estack_ax(stack, top)->u.d);
+			estack_pop(stack, top, ax, bx);
+			estack_ax_v = res;
+			next_pc += sizeof(struct binary_op);
+			PO;
+		}
+		OP(FILTER_OP_LT_DOUBLE):
+		{
+			int res;
+
+			res = (estack_bx(stack, top)->u.d < estack_ax(stack, top)->u.d);
+			estack_pop(stack, top, ax, bx);
+			estack_ax_v = res;
+			next_pc += sizeof(struct binary_op);
+			PO;
+		}
+		OP(FILTER_OP_GE_DOUBLE):
+		{
+			int res;
+
+			res = (estack_bx(stack, top)->u.d >= estack_ax(stack, top)->u.d);
+			estack_pop(stack, top, ax, bx);
+			estack_ax_v = res;
+			next_pc += sizeof(struct binary_op);
+			PO;
+		}
+		OP(FILTER_OP_LE_DOUBLE):
+		{
+			int res;
+
+			res = (estack_bx(stack, top)->u.d <= estack_ax(stack, top)->u.d);
+			estack_pop(stack, top, ax, bx);
+			estack_ax_v = res;
+			next_pc += sizeof(struct binary_op);
+			PO;
+		}
+
+		/* Mixed S64-double binary comparators */
+		OP(FILTER_OP_EQ_DOUBLE_S64):
+		{
+			int res;
+
+			res = (estack_bx(stack, top)->u.d == estack_ax_v);
+			estack_pop(stack, top, ax, bx);
+			estack_ax_v = res;
+			next_pc += sizeof(struct binary_op);
+			PO;
+		}
+		OP(FILTER_OP_NE_DOUBLE_S64):
+		{
+			int res;
+
+			res = (estack_bx(stack, top)->u.d != estack_ax_v);
+			estack_pop(stack, top, ax, bx);
+			estack_ax_v = res;
+			next_pc += sizeof(struct binary_op);
+			PO;
+		}
+		OP(FILTER_OP_GT_DOUBLE_S64):
+		{
+			int res;
+
+			res = (estack_bx(stack, top)->u.d > estack_ax_v);
+			estack_pop(stack, top, ax, bx);
+			estack_ax_v = res;
+			next_pc += sizeof(struct binary_op);
+			PO;
+		}
+		OP(FILTER_OP_LT_DOUBLE_S64):
+		{
+			int res;
+
+			res = (estack_bx(stack, top)->u.d < estack_ax_v);
+			estack_pop(stack, top, ax, bx);
+			estack_ax_v = res;
+			next_pc += sizeof(struct binary_op);
+			PO;
+		}
+		OP(FILTER_OP_GE_DOUBLE_S64):
+		{
+			int res;
+
+			res = (estack_bx(stack, top)->u.d >= estack_ax_v);
+			estack_pop(stack, top, ax, bx);
+			estack_ax_v = res;
+			next_pc += sizeof(struct binary_op);
+			PO;
+		}
+		OP(FILTER_OP_LE_DOUBLE_S64):
+		{
+			int res;
+
+			res = (estack_bx(stack, top)->u.d <= estack_ax_v);
+			estack_pop(stack, top, ax, bx);
+			estack_ax_v = res;
+			next_pc += sizeof(struct binary_op);
+			PO;
+		}
+
+		OP(FILTER_OP_EQ_S64_DOUBLE):
+		{
+			int res;
+
+			res = (estack_bx_v == estack_ax(stack, top)->u.d);
+			estack_pop(stack, top, ax, bx);
+			estack_ax_v = res;
+			next_pc += sizeof(struct binary_op);
+			PO;
+		}
+		OP(FILTER_OP_NE_S64_DOUBLE):
+		{
+			int res;
+
+			res = (estack_bx_v != estack_ax(stack, top)->u.d);
+			estack_pop(stack, top, ax, bx);
+			estack_ax_v = res;
+			next_pc += sizeof(struct binary_op);
+			PO;
+		}
+		OP(FILTER_OP_GT_S64_DOUBLE):
+		{
+			int res;
+
+			res = (estack_bx_v > estack_ax(stack, top)->u.d);
+			estack_pop(stack, top, ax, bx);
+			estack_ax_v = res;
+			next_pc += sizeof(struct binary_op);
+			PO;
+		}
+		OP(FILTER_OP_LT_S64_DOUBLE):
+		{
+			int res;
+
+			res = (estack_bx_v < estack_ax(stack, top)->u.d);
+			estack_pop(stack, top, ax, bx);
+			estack_ax_v = res;
+			next_pc += sizeof(struct binary_op);
+			PO;
+		}
+		OP(FILTER_OP_GE_S64_DOUBLE):
+		{
+			int res;
+
+			res = (estack_bx_v >= estack_ax(stack, top)->u.d);
+			estack_pop(stack, top, ax, bx);
+			estack_ax_v = res;
+			next_pc += sizeof(struct binary_op);
+			PO;
+		}
+		OP(FILTER_OP_LE_S64_DOUBLE):
+		{
+			int res;
+
+			res = (estack_bx_v <= estack_ax(stack, top)->u.d);
+			estack_pop(stack, top, ax, bx);
+			estack_ax_v = res;
+			next_pc += sizeof(struct binary_op);
+			PO;
+		}
+
+		/* unary */
+		OP(FILTER_OP_UNARY_PLUS):
+		OP(FILTER_OP_UNARY_MINUS):
+		OP(FILTER_OP_UNARY_NOT):
+			ERR("unsupported non-specialized bytecode op %u\n",
+				(unsigned int) *(filter_opcode_t *) pc);
+			ret = -EINVAL;
+			goto end;
+
+
+		OP(FILTER_OP_UNARY_PLUS_S64):
+		OP(FILTER_OP_UNARY_PLUS_DOUBLE):
+		{
+			next_pc += sizeof(struct unary_op);
+			PO;
+		}
+		OP(FILTER_OP_UNARY_MINUS_S64):
+		{
+			estack_ax_v = -estack_ax_v;
+			next_pc += sizeof(struct unary_op);
+			PO;
+		}
+		OP(FILTER_OP_UNARY_MINUS_DOUBLE):
+		{
+			estack_ax(stack, top)->u.d = -estack_ax(stack, top)->u.d;
+			next_pc += sizeof(struct unary_op);
+			PO;
+		}
+		OP(FILTER_OP_UNARY_NOT_S64):
+		{
+			estack_ax_v = !estack_ax_v;
+			next_pc += sizeof(struct unary_op);
+			PO;
+		}
+		OP(FILTER_OP_UNARY_NOT_DOUBLE):
+		{
+			estack_ax(stack, top)->u.d = !estack_ax(stack, top)->u.d;
+			next_pc += sizeof(struct unary_op);
+			PO;
+		}
+
+		/* logical */
+		OP(FILTER_OP_AND):
+		{
+			struct logical_op *insn = (struct logical_op *) pc;
+
+			/* If AX is 0, skip and evaluate to 0 */
+			if (unlikely(estack_ax_v == 0)) {
+				dbg_printf("Jumping to bytecode offset %u\n",
+					(unsigned int) insn->skip_offset);
+				next_pc = start_pc + insn->skip_offset;
+			} else {
+				/* Pop 1 when jump not taken */
+				estack_pop(stack, top, ax, bx);
+				next_pc += sizeof(struct logical_op);
+			}
+			PO;
+		}
+		OP(FILTER_OP_OR):
+		{
+			struct logical_op *insn = (struct logical_op *) pc;
+
+			/* If AX is nonzero, skip and evaluate to 1 */
+
+			if (unlikely(estack_ax_v != 0)) {
+				estack_ax_v = 1;
+				dbg_printf("Jumping to bytecode offset %u\n",
+					(unsigned int) insn->skip_offset);
+				next_pc = start_pc + insn->skip_offset;
+			} else {
+				/* Pop 1 when jump not taken */
+				estack_pop(stack, top, ax, bx);
+				next_pc += sizeof(struct logical_op);
+			}
+			PO;
+		}
+
+
+		/* load */
+		OP(FILTER_OP_LOAD_FIELD_REF_STRING):
+		{
+			struct load_op *insn = (struct load_op *) pc;
+			struct field_ref *ref = (struct field_ref *) insn->data;
+
+			dbg_printf("load field ref offset %u type string\n",
+				ref->offset);
+			estack_push(stack, top, ax, bx);
+			estack_ax(stack, top)->u.s.str =
+				*(const char * const *) &filter_stack_data[ref->offset];
+			if (unlikely(!estack_ax(stack, top)->u.s.str)) {
+				dbg_printf("Filter warning: loading a NULL string.\n");
+				ret = -EINVAL;
+				goto end;
+			}
+			estack_ax(stack, top)->u.s.seq_len = UINT_MAX;
+			estack_ax(stack, top)->u.s.literal = 0;
+			dbg_printf("ref load string %s\n", estack_ax(stack, top)->u.s.str);
+			next_pc += sizeof(struct load_op) + sizeof(struct field_ref);
+			PO;
+		}
+
+		OP(FILTER_OP_LOAD_FIELD_REF_SEQUENCE):
+		{
+			struct load_op *insn = (struct load_op *) pc;
+			struct field_ref *ref = (struct field_ref *) insn->data;
+
+			dbg_printf("load field ref offset %u type sequence\n",
+				ref->offset);
+			estack_push(stack, top, ax, bx);
+			estack_ax(stack, top)->u.s.seq_len =
+				*(unsigned long *) &filter_stack_data[ref->offset];
+			estack_ax(stack, top)->u.s.str =
+				*(const char **) (&filter_stack_data[ref->offset
+								+ sizeof(unsigned long)]);
+			if (unlikely(!estack_ax(stack, top)->u.s.str)) {
+				dbg_printf("Filter warning: loading a NULL sequence.\n");
+				ret = -EINVAL;
+				goto end;
+			}
+			estack_ax(stack, top)->u.s.literal = 0;
+			next_pc += sizeof(struct load_op) + sizeof(struct field_ref);
+			PO;
+		}
+
+		OP(FILTER_OP_LOAD_FIELD_REF_S64):
+		{
+			struct load_op *insn = (struct load_op *) pc;
+			struct field_ref *ref = (struct field_ref *) insn->data;
+
+			dbg_printf("load field ref offset %u type s64\n",
+				ref->offset);
+			estack_push(stack, top, ax, bx);
+			estack_ax_v =
+				((struct literal_numeric *) &filter_stack_data[ref->offset])->v;
+			dbg_printf("ref load s64 %" PRIi64 "\n", estack_ax_v);
+			next_pc += sizeof(struct load_op) + sizeof(struct field_ref);
+			PO;
+		}
+
+		OP(FILTER_OP_LOAD_FIELD_REF_DOUBLE):
+		{
+			struct load_op *insn = (struct load_op *) pc;
+			struct field_ref *ref = (struct field_ref *) insn->data;
+
+			dbg_printf("load field ref offset %u type double\n",
+				ref->offset);
+			estack_push(stack, top, ax, bx);
+			memcpy(&estack_ax(stack, top)->u.d, &filter_stack_data[ref->offset],
+				sizeof(struct literal_double));
+			dbg_printf("ref load double %g\n", estack_ax(stack, top)->u.d);
+			next_pc += sizeof(struct load_op) + sizeof(struct field_ref);
+			PO;
+		}
+
+		OP(FILTER_OP_LOAD_STRING):
+		{
+			struct load_op *insn = (struct load_op *) pc;
+
+			dbg_printf("load string %s\n", insn->data);
+			estack_push(stack, top, ax, bx);
+			estack_ax(stack, top)->u.s.str = insn->data;
+			estack_ax(stack, top)->u.s.seq_len = UINT_MAX;
+			estack_ax(stack, top)->u.s.literal = 1;
+			next_pc += sizeof(struct load_op) + strlen(insn->data) + 1;
+			PO;
+		}
+
+		OP(FILTER_OP_LOAD_S64):
+		{
+			struct load_op *insn = (struct load_op *) pc;
+
+			estack_push(stack, top, ax, bx);
+			estack_ax_v = ((struct literal_numeric *) insn->data)->v;
+			dbg_printf("load s64 %" PRIi64 "\n", estack_ax_v);
+			next_pc += sizeof(struct load_op)
+					+ sizeof(struct literal_numeric);
+			PO;
+		}
+
+		OP(FILTER_OP_LOAD_DOUBLE):
+		{
+			struct load_op *insn = (struct load_op *) pc;
+
+			estack_push(stack, top, ax, bx);
+			memcpy(&estack_ax(stack, top)->u.d, insn->data,
+				sizeof(struct literal_double));
+			dbg_printf("load s64 %g\n", estack_ax(stack, top)->u.d);
+			next_pc += sizeof(struct load_op)
+					+ sizeof(struct literal_double);
+			PO;
+		}
+
+		/* cast */
+		OP(FILTER_OP_CAST_TO_S64):
+			ERR("unsupported non-specialized bytecode op %u\n",
+				(unsigned int) *(filter_opcode_t *) pc);
+			ret = -EINVAL;
+			goto end;
+
+		OP(FILTER_OP_CAST_DOUBLE_TO_S64):
+		{
+			estack_ax_v = (int64_t) estack_ax(stack, top)->u.d;
+			next_pc += sizeof(struct cast_op);
+			PO;
+		}
+
+		OP(FILTER_OP_CAST_NOP):
+		{
+			next_pc += sizeof(struct cast_op);
+			PO;
+		}
+
+	END_OP
+end:
+	/* return 0 (discard) on error */
+	if (ret)
+		return 0;
+	return retval;
+}
+
+#undef START_OP
+#undef OP
+#undef PO
+#undef END_OP

=== added file 'liblttng-ust/lttng-filter-specialize.c'
--- liblttng-ust/lttng-filter-specialize.c	1970-01-01 00:00:00 +0000
+++ liblttng-ust/lttng-filter-specialize.c	2012-09-11 15:34:43 +0000
@@ -0,0 +1,524 @@
+/*
+ * lttng-filter-specialize.c
+ *
+ * LTTng UST filter code specializer.
+ *
+ * Copyright (C) 2010-2012 Mathieu Desnoyers <mathieu.desnoyers@efficios.com>
+ *
+ * This library is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU Lesser General Public
+ * License as published by the Free Software Foundation; only
+ * version 2.1 of the License.
+ *
+ * This library is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with this library; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#include "lttng-filter.h"
+
+int lttng_filter_specialize_bytecode(struct bytecode_runtime *bytecode)
+{
+	void *pc, *next_pc, *start_pc;
+	int ret = -EINVAL;
+	struct vstack _stack;
+	struct vstack *stack = &_stack;
+
+	vstack_init(stack);
+
+	start_pc = &bytecode->data[0];
+	for (pc = next_pc = start_pc; pc - start_pc < bytecode->len;
+			pc = next_pc) {
+		switch (*(filter_opcode_t *) pc) {
+		case FILTER_OP_UNKNOWN:
+		default:
+			ERR("unknown bytecode op %u\n",
+				(unsigned int) *(filter_opcode_t *) pc);
+			ret = -EINVAL;
+			goto end;
+
+		case FILTER_OP_RETURN:
+			ret = 0;
+			goto end;
+
+		/* binary */
+		case FILTER_OP_MUL:
+		case FILTER_OP_DIV:
+		case FILTER_OP_MOD:
+		case FILTER_OP_PLUS:
+		case FILTER_OP_MINUS:
+		case FILTER_OP_RSHIFT:
+		case FILTER_OP_LSHIFT:
+		case FILTER_OP_BIN_AND:
+		case FILTER_OP_BIN_OR:
+		case FILTER_OP_BIN_XOR:
+			ERR("unsupported bytecode op %u\n",
+				(unsigned int) *(filter_opcode_t *) pc);
+			ret = -EINVAL;
+			goto end;
+
+		case FILTER_OP_EQ:
+		{
+			struct binary_op *insn = (struct binary_op *) pc;
+
+			switch(vstack_ax(stack)->type) {
+			default:
+				ERR("unknown register type\n");
+				ret = -EINVAL;
+				goto end;
+
+			case REG_STRING:
+				insn->op = FILTER_OP_EQ_STRING;
+				break;
+			case REG_S64:
+				if (vstack_bx(stack)->type == REG_S64)
+					insn->op = FILTER_OP_EQ_S64;
+				else
+					insn->op = FILTER_OP_EQ_DOUBLE_S64;
+				break;
+			case REG_DOUBLE:
+				if (vstack_bx(stack)->type == REG_S64)
+					insn->op = FILTER_OP_EQ_S64_DOUBLE;
+				else
+					insn->op = FILTER_OP_EQ_DOUBLE;
+				break;
+			}
+			/* Pop 2, push 1 */
+			if (vstack_pop(stack)) {
+				ret = -EINVAL;
+				goto end;
+			}
+			vstack_ax(stack)->type = REG_S64;
+			next_pc += sizeof(struct binary_op);
+			break;
+		}
+
+		case FILTER_OP_NE:
+		{
+			struct binary_op *insn = (struct binary_op *) pc;
+
+			switch(vstack_ax(stack)->type) {
+			default:
+				ERR("unknown register type\n");
+				ret = -EINVAL;
+				goto end;
+
+			case REG_STRING:
+				insn->op = FILTER_OP_NE_STRING;
+				break;
+			case REG_S64:
+				if (vstack_bx(stack)->type == REG_S64)
+					insn->op = FILTER_OP_NE_S64;
+				else
+					insn->op = FILTER_OP_NE_DOUBLE_S64;
+				break;
+			case REG_DOUBLE:
+				if (vstack_bx(stack)->type == REG_S64)
+					insn->op = FILTER_OP_NE_S64_DOUBLE;
+				else
+					insn->op = FILTER_OP_NE_DOUBLE;
+				break;
+			}
+			/* Pop 2, push 1 */
+			if (vstack_pop(stack)) {
+				ret = -EINVAL;
+				goto end;
+			}
+			vstack_ax(stack)->type = REG_S64;
+			next_pc += sizeof(struct binary_op);
+			break;
+		}
+
+		case FILTER_OP_GT:
+		{
+			struct binary_op *insn = (struct binary_op *) pc;
+
+			switch(vstack_ax(stack)->type) {
+			default:
+				ERR("unknown register type\n");
+				ret = -EINVAL;
+				goto end;
+
+			case REG_STRING:
+				insn->op = FILTER_OP_GT_STRING;
+				break;
+			case REG_S64:
+				if (vstack_bx(stack)->type == REG_S64)
+					insn->op = FILTER_OP_GT_S64;
+				else
+					insn->op = FILTER_OP_GT_DOUBLE_S64;
+				break;
+			case REG_DOUBLE:
+				if (vstack_bx(stack)->type == REG_S64)
+					insn->op = FILTER_OP_GT_S64_DOUBLE;
+				else
+					insn->op = FILTER_OP_GT_DOUBLE;
+				break;
+			}
+			/* Pop 2, push 1 */
+			if (vstack_pop(stack)) {
+				ret = -EINVAL;
+				goto end;
+			}
+			vstack_ax(stack)->type = REG_S64;
+			next_pc += sizeof(struct binary_op);
+			break;
+		}
+
+		case FILTER_OP_LT:
+		{
+			struct binary_op *insn = (struct binary_op *) pc;
+
+			switch(vstack_ax(stack)->type) {
+			default:
+				ERR("unknown register type\n");
+				ret = -EINVAL;
+				goto end;
+
+			case REG_STRING:
+				insn->op = FILTER_OP_LT_STRING;
+				break;
+			case REG_S64:
+				if (vstack_bx(stack)->type == REG_S64)
+					insn->op = FILTER_OP_LT_S64;
+				else
+					insn->op = FILTER_OP_LT_DOUBLE_S64;
+				break;
+			case REG_DOUBLE:
+				if (vstack_bx(stack)->type == REG_S64)
+					insn->op = FILTER_OP_LT_S64_DOUBLE;
+				else
+					insn->op = FILTER_OP_LT_DOUBLE;
+				break;
+			}
+			/* Pop 2, push 1 */
+			if (vstack_pop(stack)) {
+				ret = -EINVAL;
+				goto end;
+			}
+			vstack_ax(stack)->type = REG_S64;
+			next_pc += sizeof(struct binary_op);
+			break;
+		}
+
+		case FILTER_OP_GE:
+		{
+			struct binary_op *insn = (struct binary_op *) pc;
+
+			switch(vstack_ax(stack)->type) {
+			default:
+				ERR("unknown register type\n");
+				ret = -EINVAL;
+				goto end;
+
+			case REG_STRING:
+				insn->op = FILTER_OP_GE_STRING;
+				break;
+			case REG_S64:
+				if (vstack_bx(stack)->type == REG_S64)
+					insn->op = FILTER_OP_GE_S64;
+				else
+					insn->op = FILTER_OP_GE_DOUBLE_S64;
+				break;
+			case REG_DOUBLE:
+				if (vstack_bx(stack)->type == REG_S64)
+					insn->op = FILTER_OP_GE_S64_DOUBLE;
+				else
+					insn->op = FILTER_OP_GE_DOUBLE;
+				break;
+			}
+			/* Pop 2, push 1 */
+			if (vstack_pop(stack)) {
+				ret = -EINVAL;
+				goto end;
+			}
+			vstack_ax(stack)->type = REG_S64;
+			next_pc += sizeof(struct binary_op);
+			break;
+		}
+		case FILTER_OP_LE:
+		{
+			struct binary_op *insn = (struct binary_op *) pc;
+
+			switch(vstack_ax(stack)->type) {
+			default:
+				ERR("unknown register type\n");
+				ret = -EINVAL;
+				goto end;
+
+			case REG_STRING:
+				insn->op = FILTER_OP_LE_STRING;
+				break;
+			case REG_S64:
+				if (vstack_bx(stack)->type == REG_S64)
+					insn->op = FILTER_OP_LE_S64;
+				else
+					insn->op = FILTER_OP_LE_DOUBLE_S64;
+				break;
+			case REG_DOUBLE:
+				if (vstack_bx(stack)->type == REG_S64)
+					insn->op = FILTER_OP_LE_S64_DOUBLE;
+				else
+					insn->op = FILTER_OP_LE_DOUBLE;
+				break;
+			}
+			vstack_ax(stack)->type = REG_S64;
+			next_pc += sizeof(struct binary_op);
+			break;
+		}
+
+		case FILTER_OP_EQ_STRING:
+		case FILTER_OP_NE_STRING:
+		case FILTER_OP_GT_STRING:
+		case FILTER_OP_LT_STRING:
+		case FILTER_OP_GE_STRING:
+		case FILTER_OP_LE_STRING:
+		case FILTER_OP_EQ_S64:
+		case FILTER_OP_NE_S64:
+		case FILTER_OP_GT_S64:
+		case FILTER_OP_LT_S64:
+		case FILTER_OP_GE_S64:
+		case FILTER_OP_LE_S64:
+		case FILTER_OP_EQ_DOUBLE:
+		case FILTER_OP_NE_DOUBLE:
+		case FILTER_OP_GT_DOUBLE:
+		case FILTER_OP_LT_DOUBLE:
+		case FILTER_OP_GE_DOUBLE:
+		case FILTER_OP_LE_DOUBLE:
+		case FILTER_OP_EQ_DOUBLE_S64:
+		case FILTER_OP_NE_DOUBLE_S64:
+		case FILTER_OP_GT_DOUBLE_S64:
+		case FILTER_OP_LT_DOUBLE_S64:
+		case FILTER_OP_GE_DOUBLE_S64:
+		case FILTER_OP_LE_DOUBLE_S64:
+		case FILTER_OP_EQ_S64_DOUBLE:
+		case FILTER_OP_NE_S64_DOUBLE:
+		case FILTER_OP_GT_S64_DOUBLE:
+		case FILTER_OP_LT_S64_DOUBLE:
+		case FILTER_OP_GE_S64_DOUBLE:
+		case FILTER_OP_LE_S64_DOUBLE:
+		{
+			/* Pop 2, push 1 */
+			if (vstack_pop(stack)) {
+				ret = -EINVAL;
+				goto end;
+			}
+			vstack_ax(stack)->type = REG_S64;
+			next_pc += sizeof(struct binary_op);
+			break;
+		}
+
+		/* unary */
+		case FILTER_OP_UNARY_PLUS:
+		{
+			struct unary_op *insn = (struct unary_op *) pc;
+
+			switch(vstack_ax(stack)->type) {
+			default:
+				ERR("unknown register type\n");
+				ret = -EINVAL;
+				goto end;
+
+			case REG_S64:
+				insn->op = FILTER_OP_UNARY_PLUS_S64;
+				break;
+			case REG_DOUBLE:
+				insn->op = FILTER_OP_UNARY_PLUS_DOUBLE;
+				break;
+			}
+			/* Pop 1, push 1 */
+			next_pc += sizeof(struct unary_op);
+			break;
+		}
+
+		case FILTER_OP_UNARY_MINUS:
+		{
+			struct unary_op *insn = (struct unary_op *) pc;
+
+			switch(vstack_ax(stack)->type) {
+			default:
+				ERR("unknown register type\n");
+				ret = -EINVAL;
+				goto end;
+
+			case REG_S64:
+				insn->op = FILTER_OP_UNARY_MINUS_S64;
+				break;
+			case REG_DOUBLE:
+				insn->op = FILTER_OP_UNARY_MINUS_DOUBLE;
+				break;
+			}
+			/* Pop 1, push 1 */
+			next_pc += sizeof(struct unary_op);
+			break;
+		}
+
+		case FILTER_OP_UNARY_NOT:
+		{
+			struct unary_op *insn = (struct unary_op *) pc;
+
+			switch(vstack_ax(stack)->type) {
+			default:
+				ERR("unknown register type\n");
+				ret = -EINVAL;
+				goto end;
+
+			case REG_S64:
+				insn->op = FILTER_OP_UNARY_NOT_S64;
+				break;
+			case REG_DOUBLE:
+				insn->op = FILTER_OP_UNARY_NOT_DOUBLE;
+				break;
+			}
+			/* Pop 1, push 1 */
+			next_pc += sizeof(struct unary_op);
+			break;
+		}
+
+		case FILTER_OP_UNARY_PLUS_S64:
+		case FILTER_OP_UNARY_MINUS_S64:
+		case FILTER_OP_UNARY_NOT_S64:
+		case FILTER_OP_UNARY_PLUS_DOUBLE:
+		case FILTER_OP_UNARY_MINUS_DOUBLE:
+		case FILTER_OP_UNARY_NOT_DOUBLE:
+		{
+			/* Pop 1, push 1 */
+			next_pc += sizeof(struct unary_op);
+			break;
+		}
+
+		/* logical */
+		case FILTER_OP_AND:
+		case FILTER_OP_OR:
+		{
+			next_pc += sizeof(struct logical_op);
+			break;
+		}
+
+		/* load */
+		case FILTER_OP_LOAD_FIELD_REF:
+		{
+			ERR("Unknown field ref type\n");
+			ret = -EINVAL;
+			goto end;
+		}
+		case FILTER_OP_LOAD_FIELD_REF_STRING:
+		case FILTER_OP_LOAD_FIELD_REF_SEQUENCE:
+		{
+			if (vstack_push(stack)) {
+				ret = -EINVAL;
+				goto end;
+			}
+			vstack_ax(stack)->type = REG_STRING;
+			next_pc += sizeof(struct load_op) + sizeof(struct field_ref);
+			break;
+		}
+		case FILTER_OP_LOAD_FIELD_REF_S64:
+		{
+			if (vstack_push(stack)) {
+				ret = -EINVAL;
+				goto end;
+			}
+			vstack_ax(stack)->type = REG_S64;
+			next_pc += sizeof(struct load_op) + sizeof(struct field_ref);
+			break;
+		}
+		case FILTER_OP_LOAD_FIELD_REF_DOUBLE:
+		{
+			if (vstack_push(stack)) {
+				ret = -EINVAL;
+				goto end;
+			}
+			vstack_ax(stack)->type = REG_DOUBLE;
+			next_pc += sizeof(struct load_op) + sizeof(struct field_ref);
+			break;
+		}
+
+		case FILTER_OP_LOAD_STRING:
+		{
+			struct load_op *insn = (struct load_op *) pc;
+
+			if (vstack_push(stack)) {
+				ret = -EINVAL;
+				goto end;
+			}
+			vstack_ax(stack)->type = REG_STRING;
+			next_pc += sizeof(struct load_op) + strlen(insn->data) + 1;
+			break;
+		}
+
+		case FILTER_OP_LOAD_S64:
+		{
+			if (vstack_push(stack)) {
+				ret = -EINVAL;
+				goto end;
+			}
+			vstack_ax(stack)->type = REG_S64;
+			next_pc += sizeof(struct load_op)
+					+ sizeof(struct literal_numeric);
+			break;
+		}
+
+		case FILTER_OP_LOAD_DOUBLE:
+		{
+			if (vstack_push(stack)) {
+				ret = -EINVAL;
+				goto end;
+			}
+			vstack_ax(stack)->type = REG_DOUBLE;
+			next_pc += sizeof(struct load_op)
+					+ sizeof(struct literal_double);
+			break;
+		}
+
+		/* cast */
+		case FILTER_OP_CAST_TO_S64:
+		{
+			struct cast_op *insn = (struct cast_op *) pc;
+
+			switch (vstack_ax(stack)->type) {
+			default:
+				ERR("unknown register type\n");
+				ret = -EINVAL;
+				goto end;
+
+			case REG_STRING:
+				ERR("Cast op can only be applied to numeric or floating point registers\n");
+				ret = -EINVAL;
+				goto end;
+			case REG_S64:
+				insn->op = FILTER_OP_CAST_NOP;
+				break;
+			case REG_DOUBLE:
+				insn->op = FILTER_OP_CAST_DOUBLE_TO_S64;
+				break;
+			}
+			/* Pop 1, push 1 */
+			vstack_ax(stack)->type = REG_S64;
+			next_pc += sizeof(struct cast_op);
+			break;
+		}
+		case FILTER_OP_CAST_DOUBLE_TO_S64:
+		{
+			/* Pop 1, push 1 */
+			vstack_ax(stack)->type = REG_S64;
+			next_pc += sizeof(struct cast_op);
+			break;
+		}
+		case FILTER_OP_CAST_NOP:
+		{
+			next_pc += sizeof(struct cast_op);
+			break;
+		}
+
+
+		}
+	}
+end:
+	return ret;
+}

=== added file 'liblttng-ust/lttng-filter-validator.c'
--- liblttng-ust/lttng-filter-validator.c	1970-01-01 00:00:00 +0000
+++ liblttng-ust/lttng-filter-validator.c	2012-09-11 15:34:43 +0000
@@ -0,0 +1,1135 @@
+/*
+ * lttng-filter-validator.c
+ *
+ * LTTng UST filter bytecode validator.
+ *
+ * Copyright (C) 2010-2012 Mathieu Desnoyers <mathieu.desnoyers@efficios.com>
+ *
+ * This library is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU Lesser General Public
+ * License as published by the Free Software Foundation; only
+ * version 2.1 of the License.
+ *
+ * This library is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with this library; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#define _LGPL_SOURCE
+#include <urcu-bp.h>
+#include <time.h>
+#include "lttng-filter.h"
+
+#include <urcu/rculfhash.h>
+#include "lttng-hash-helper.h"
+
+/*
+ * Number of merge points for hash table size. Hash table initialized to
+ * that size, and we do not resize, because we do not want to trigger
+ * RCU worker thread execution: fall-back on linear traversal if number
+ * of merge points exceeds this value.
+ */
+#define DEFAULT_NR_MERGE_POINTS		128
+#define MIN_NR_BUCKETS			128
+#define MAX_NR_BUCKETS			128
+
+/* merge point table node */
+struct lfht_mp_node {
+	struct cds_lfht_node node;
+
+	/* Context at merge point */
+	struct vstack stack;
+	unsigned long target_pc;
+};
+
+static unsigned long lttng_hash_seed;
+static unsigned int lttng_hash_seed_ready;
+
+static
+int lttng_hash_match(struct cds_lfht_node *node, const void *key)
+{
+	struct lfht_mp_node *mp_node =
+		caa_container_of(node, struct lfht_mp_node, node);
+	unsigned long key_pc = (unsigned long) key;
+
+	if (mp_node->target_pc == key_pc)
+		return 1;
+	else
+		return 0;
+}
+
+static
+int merge_points_compare(const struct vstack *stacka,
+			const struct vstack *stackb)
+{
+	int i, len;
+
+	if (stacka->top != stackb->top)
+		return 1;
+	len = stacka->top + 1;
+	assert(len >= 0);
+	for (i = 0; i < len; i++) {
+		if (stacka->e[i].type != stackb->e[i].type)
+			return 1;
+	}
+	return 0;
+}
+
+static
+int merge_point_add_check(struct cds_lfht *ht, unsigned long target_pc,
+		const struct vstack *stack)
+{
+	struct lfht_mp_node *node;
+	unsigned long hash = lttng_hash_mix((const void *) target_pc,
+				sizeof(target_pc),
+				lttng_hash_seed);
+	struct cds_lfht_node *ret;
+
+	dbg_printf("Filter: adding merge point at offset %lu, hash %lu\n",
+			target_pc, hash);
+	node = zmalloc(sizeof(struct lfht_mp_node));
+	if (!node)
+		return -ENOMEM;
+	node->target_pc = target_pc;
+	memcpy(&node->stack, stack, sizeof(node->stack));
+	ret = cds_lfht_add_unique(ht, hash, lttng_hash_match,
+		(const void *) target_pc, &node->node);
+	if (ret != &node->node) {
+		struct lfht_mp_node *ret_mp =
+			caa_container_of(ret, struct lfht_mp_node, node);
+
+		/* Key already present */
+		dbg_printf("Filter: compare merge points for offset %lu, hash %lu\n",
+				target_pc, hash);
+		free(node);
+		if (merge_points_compare(stack, &ret_mp->stack)) {
+			ERR("Merge points differ for offset %lu\n",
+				target_pc);
+			return -EINVAL;
+		}
+	}
+	return 0;
+}
+
+/*
+ * Binary comparators use top of stack and top of stack -1.
+ */
+static
+int bin_op_compare_check(struct vstack *stack, const char *str)
+{
+	if (unlikely(!vstack_ax(stack) || !vstack_bx(stack)))
+		goto error_unknown;
+
+	switch (vstack_ax(stack)->type) {
+	default:
+		goto error_unknown;
+
+	case REG_STRING:
+		switch (vstack_bx(stack)->type) {
+		default:
+			goto error_unknown;
+
+		case REG_STRING:
+			break;
+		case REG_S64:
+		case REG_DOUBLE:
+			goto error_mismatch;
+		}
+		break;
+	case REG_S64:
+	case REG_DOUBLE:
+		switch (vstack_bx(stack)->type) {
+		default:
+			goto error_unknown;
+
+		case REG_STRING:
+			goto error_mismatch;
+
+		case REG_S64:
+		case REG_DOUBLE:
+			break;
+		}
+		break;
+	}
+	return 0;
+
+error_unknown:
+	return -EINVAL;
+
+error_mismatch:
+	ERR("type mismatch for '%s' binary operator\n", str);
+	return -EINVAL;
+}
+
+/*
+ * Validate bytecode range overflow within the validation pass.
+ * Called for each instruction encountered.
+ */
+static
+int bytecode_validate_overflow(struct bytecode_runtime *bytecode,
+		void *start_pc, void *pc)
+{
+	int ret = 0;
+
+	switch (*(filter_opcode_t *) pc) {
+	case FILTER_OP_UNKNOWN:
+	default:
+	{
+		ERR("unknown bytecode op %u\n",
+			(unsigned int) *(filter_opcode_t *) pc);
+		ret = -EINVAL;
+		break;
+	}
+
+	case FILTER_OP_RETURN:
+	{
+		if (unlikely(pc + sizeof(struct return_op)
+				> start_pc + bytecode->len)) {
+			ret = -EINVAL;
+		}
+		break;
+	}
+
+	/* binary */
+	case FILTER_OP_MUL:
+	case FILTER_OP_DIV:
+	case FILTER_OP_MOD:
+	case FILTER_OP_PLUS:
+	case FILTER_OP_MINUS:
+	case FILTER_OP_RSHIFT:
+	case FILTER_OP_LSHIFT:
+	case FILTER_OP_BIN_AND:
+	case FILTER_OP_BIN_OR:
+	case FILTER_OP_BIN_XOR:
+	{
+		ERR("unsupported bytecode op %u\n",
+			(unsigned int) *(filter_opcode_t *) pc);
+		ret = -EINVAL;
+		break;
+	}
+
+	case FILTER_OP_EQ:
+	case FILTER_OP_NE:
+	case FILTER_OP_GT:
+	case FILTER_OP_LT:
+	case FILTER_OP_GE:
+	case FILTER_OP_LE:
+	case FILTER_OP_EQ_STRING:
+	case FILTER_OP_NE_STRING:
+	case FILTER_OP_GT_STRING:
+	case FILTER_OP_LT_STRING:
+	case FILTER_OP_GE_STRING:
+	case FILTER_OP_LE_STRING:
+	case FILTER_OP_EQ_S64:
+	case FILTER_OP_NE_S64:
+	case FILTER_OP_GT_S64:
+	case FILTER_OP_LT_S64:
+	case FILTER_OP_GE_S64:
+	case FILTER_OP_LE_S64:
+	case FILTER_OP_EQ_DOUBLE:
+	case FILTER_OP_NE_DOUBLE:
+	case FILTER_OP_GT_DOUBLE:
+	case FILTER_OP_LT_DOUBLE:
+	case FILTER_OP_GE_DOUBLE:
+	case FILTER_OP_LE_DOUBLE:
+	case FILTER_OP_EQ_DOUBLE_S64:
+	case FILTER_OP_NE_DOUBLE_S64:
+	case FILTER_OP_GT_DOUBLE_S64:
+	case FILTER_OP_LT_DOUBLE_S64:
+	case FILTER_OP_GE_DOUBLE_S64:
+	case FILTER_OP_LE_DOUBLE_S64:
+	case FILTER_OP_EQ_S64_DOUBLE:
+	case FILTER_OP_NE_S64_DOUBLE:
+	case FILTER_OP_GT_S64_DOUBLE:
+	case FILTER_OP_LT_S64_DOUBLE:
+	case FILTER_OP_GE_S64_DOUBLE:
+	case FILTER_OP_LE_S64_DOUBLE:
+	{
+		if (unlikely(pc + sizeof(struct binary_op)
+				> start_pc + bytecode->len)) {
+			ret = -EINVAL;
+		}
+		break;
+	}
+
+	/* unary */
+	case FILTER_OP_UNARY_PLUS:
+	case FILTER_OP_UNARY_MINUS:
+	case FILTER_OP_UNARY_NOT:
+	case FILTER_OP_UNARY_PLUS_S64:
+	case FILTER_OP_UNARY_MINUS_S64:
+	case FILTER_OP_UNARY_NOT_S64:
+	case FILTER_OP_UNARY_PLUS_DOUBLE:
+	case FILTER_OP_UNARY_MINUS_DOUBLE:
+	case FILTER_OP_UNARY_NOT_DOUBLE:
+	{
+		if (unlikely(pc + sizeof(struct unary_op)
+				> start_pc + bytecode->len)) {
+			ret = -EINVAL;
+		}
+		break;
+	}
+
+	/* logical */
+	case FILTER_OP_AND:
+	case FILTER_OP_OR:
+	{
+		if (unlikely(pc + sizeof(struct logical_op)
+				> start_pc + bytecode->len)) {
+			ret = -EINVAL;
+		}
+		break;
+	}
+
+	/* load */
+	case FILTER_OP_LOAD_FIELD_REF:
+	{
+		ERR("Unknown field ref type\n");
+		ret = -EINVAL;
+		break;
+	}
+	case FILTER_OP_LOAD_FIELD_REF_STRING:
+	case FILTER_OP_LOAD_FIELD_REF_SEQUENCE:
+	case FILTER_OP_LOAD_FIELD_REF_S64:
+	case FILTER_OP_LOAD_FIELD_REF_DOUBLE:
+	{
+		if (unlikely(pc + sizeof(struct load_op) + sizeof(struct field_ref)
+				> start_pc + bytecode->len)) {
+			ret = -EINVAL;
+		}
+		break;
+	}
+
+	case FILTER_OP_LOAD_STRING:
+	{
+		struct load_op *insn = (struct load_op *) pc;
+		uint32_t str_len, maxlen;
+
+		if (unlikely(pc + sizeof(struct load_op)
+				> start_pc + bytecode->len)) {
+			ret = -EINVAL;
+			break;
+		}
+
+		maxlen = start_pc + bytecode->len - pc - sizeof(struct load_op);
+		str_len = strnlen(insn->data, maxlen);
+		if (unlikely(str_len >= maxlen)) {
+			/* Final '\0' not found within range */
+			ret = -EINVAL;
+		}
+		break;
+	}
+
+	case FILTER_OP_LOAD_S64:
+	{
+		if (unlikely(pc + sizeof(struct load_op) + sizeof(struct literal_numeric)
+				> start_pc + bytecode->len)) {
+			ret = -EINVAL;
+		}
+		break;
+	}
+
+	case FILTER_OP_LOAD_DOUBLE:
+	{
+		if (unlikely(pc + sizeof(struct load_op) + sizeof(struct literal_double)
+				> start_pc + bytecode->len)) {
+			ret = -EINVAL;
+		}
+		break;
+	}
+
+	case FILTER_OP_CAST_TO_S64:
+	case FILTER_OP_CAST_DOUBLE_TO_S64:
+	case FILTER_OP_CAST_NOP:
+	{
+		if (unlikely(pc + sizeof(struct cast_op)
+				> start_pc + bytecode->len)) {
+			ret = -EINVAL;
+		}
+		break;
+	}
+	}
+
+	return ret;
+}
+
+static
+unsigned long delete_all_nodes(struct cds_lfht *ht)
+{
+	struct cds_lfht_iter iter;
+	struct lfht_mp_node *node;
+	unsigned long nr_nodes = 0;
+
+	cds_lfht_for_each_entry(ht, &iter, node, node) {
+		int ret;
+
+		ret = cds_lfht_del(ht, cds_lfht_iter_get_node(&iter));
+		assert(!ret);
+		/* note: this hash table is never used concurrently */
+		free(node);
+		nr_nodes++;
+	}
+	return nr_nodes;
+}
+
+/*
+ * Return value:
+ * 0: success
+ * <0: error
+ */
+static
+int validate_instruction_context(struct bytecode_runtime *bytecode,
+		struct vstack *stack,
+		void *start_pc,
+		void *pc)
+{
+	int ret = 0;
+
+	switch (*(filter_opcode_t *) pc) {
+	case FILTER_OP_UNKNOWN:
+	default:
+	{
+		ERR("unknown bytecode op %u\n",
+			(unsigned int) *(filter_opcode_t *) pc);
+		ret = -EINVAL;
+		goto end;
+	}
+
+	case FILTER_OP_RETURN:
+	{
+		goto end;
+	}
+
+	/* binary */
+	case FILTER_OP_MUL:
+	case FILTER_OP_DIV:
+	case FILTER_OP_MOD:
+	case FILTER_OP_PLUS:
+	case FILTER_OP_MINUS:
+	case FILTER_OP_RSHIFT:
+	case FILTER_OP_LSHIFT:
+	case FILTER_OP_BIN_AND:
+	case FILTER_OP_BIN_OR:
+	case FILTER_OP_BIN_XOR:
+	{
+		ERR("unsupported bytecode op %u\n",
+			(unsigned int) *(filter_opcode_t *) pc);
+		ret = -EINVAL;
+		goto end;
+	}
+
+	case FILTER_OP_EQ:
+	{
+		ret = bin_op_compare_check(stack, "==");
+		if (ret)
+			goto end;
+		break;
+	}
+	case FILTER_OP_NE:
+	{
+		ret = bin_op_compare_check(stack, "!=");
+		if (ret)
+			goto end;
+		break;
+	}
+	case FILTER_OP_GT:
+	{
+		ret = bin_op_compare_check(stack, ">");
+		if (ret)
+			goto end;
+		break;
+	}
+	case FILTER_OP_LT:
+	{
+		ret = bin_op_compare_check(stack, "<");
+		if (ret)
+			goto end;
+		break;
+	}
+	case FILTER_OP_GE:
+	{
+		ret = bin_op_compare_check(stack, ">=");
+		if (ret)
+			goto end;
+		break;
+	}
+	case FILTER_OP_LE:
+	{
+		ret = bin_op_compare_check(stack, "<=");
+		if (ret)
+			goto end;
+		break;
+	}
+
+	case FILTER_OP_EQ_STRING:
+	case FILTER_OP_NE_STRING:
+	case FILTER_OP_GT_STRING:
+	case FILTER_OP_LT_STRING:
+	case FILTER_OP_GE_STRING:
+	case FILTER_OP_LE_STRING:
+	{
+		if (!vstack_ax(stack) || !vstack_bx(stack)) {
+			ERR("Empty stack\n");
+			ret = -EINVAL;
+			goto end;
+		}
+		if (vstack_ax(stack)->type != REG_STRING
+				|| vstack_bx(stack)->type != REG_STRING) {
+			ERR("Unexpected register type for string comparator\n");
+			ret = -EINVAL;
+			goto end;
+		}
+		break;
+	}
+
+	case FILTER_OP_EQ_S64:
+	case FILTER_OP_NE_S64:
+	case FILTER_OP_GT_S64:
+	case FILTER_OP_LT_S64:
+	case FILTER_OP_GE_S64:
+	case FILTER_OP_LE_S64:
+	{
+		if (!vstack_ax(stack) || !vstack_bx(stack)) {
+			ERR("Empty stack\n");
+			ret = -EINVAL;
+			goto end;
+		}
+		if (vstack_ax(stack)->type != REG_S64
+				|| vstack_bx(stack)->type != REG_S64) {
+			ERR("Unexpected register type for s64 comparator\n");
+			ret = -EINVAL;
+			goto end;
+		}
+		break;
+	}
+
+	case FILTER_OP_EQ_DOUBLE:
+	case FILTER_OP_NE_DOUBLE:
+	case FILTER_OP_GT_DOUBLE:
+	case FILTER_OP_LT_DOUBLE:
+	case FILTER_OP_GE_DOUBLE:
+	case FILTER_OP_LE_DOUBLE:
+	{
+		if (!vstack_ax(stack) || !vstack_bx(stack)) {
+			ERR("Empty stack\n");
+			ret = -EINVAL;
+			goto end;
+		}
+		if (vstack_ax(stack)->type != REG_DOUBLE && vstack_bx(stack)->type != REG_DOUBLE) {
+			ERR("Double operator should have two double registers\n");
+			ret = -EINVAL;
+			goto end;
+		}
+		break;
+	}
+
+	case FILTER_OP_EQ_DOUBLE_S64:
+	case FILTER_OP_NE_DOUBLE_S64:
+	case FILTER_OP_GT_DOUBLE_S64:
+	case FILTER_OP_LT_DOUBLE_S64:
+	case FILTER_OP_GE_DOUBLE_S64:
+	case FILTER_OP_LE_DOUBLE_S64:
+	{
+		if (!vstack_ax(stack) || !vstack_bx(stack)) {
+			ERR("Empty stack\n");
+			ret = -EINVAL;
+			goto end;
+		}
+		if (vstack_ax(stack)->type != REG_S64 && vstack_bx(stack)->type != REG_DOUBLE) {
+			ERR("Double-S64 operator has unexpected register types\n");
+			ret = -EINVAL;
+			goto end;
+		}
+		break;
+	}
+
+	case FILTER_OP_EQ_S64_DOUBLE:
+	case FILTER_OP_NE_S64_DOUBLE:
+	case FILTER_OP_GT_S64_DOUBLE:
+	case FILTER_OP_LT_S64_DOUBLE:
+	case FILTER_OP_GE_S64_DOUBLE:
+	case FILTER_OP_LE_S64_DOUBLE:
+	{
+		if (!vstack_ax(stack) || !vstack_bx(stack)) {
+			ERR("Empty stack\n");
+			ret = -EINVAL;
+			goto end;
+		}
+		if (vstack_ax(stack)->type != REG_DOUBLE && vstack_bx(stack)->type != REG_S64) {
+			ERR("S64-Double operator has unexpected register types\n");
+			ret = -EINVAL;
+			goto end;
+		}
+		break;
+	}
+
+	/* unary */
+	case FILTER_OP_UNARY_PLUS:
+	case FILTER_OP_UNARY_MINUS:
+	case FILTER_OP_UNARY_NOT:
+	{
+		if (!vstack_ax(stack)) {
+			ERR("Empty stack\n");
+			ret = -EINVAL;
+			goto end;
+		}
+		switch (vstack_ax(stack)->type) {
+		default:
+			ERR("unknown register type\n");
+			ret = -EINVAL;
+			goto end;
+
+		case REG_STRING:
+			ERR("Unary op can only be applied to numeric or floating point registers\n");
+			ret = -EINVAL;
+			goto end;
+		case REG_S64:
+			break;
+		case REG_DOUBLE:
+			break;
+		}
+		break;
+	}
+
+	case FILTER_OP_UNARY_PLUS_S64:
+	case FILTER_OP_UNARY_MINUS_S64:
+	case FILTER_OP_UNARY_NOT_S64:
+	{
+		if (!vstack_ax(stack)) {
+			ERR("Empty stack\n");
+			ret = -EINVAL;
+			goto end;
+		}
+		if (vstack_ax(stack)->type != REG_S64) {
+			ERR("Invalid register type\n");
+			ret = -EINVAL;
+			goto end;
+		}
+		break;
+	}
+
+	case FILTER_OP_UNARY_PLUS_DOUBLE:
+	case FILTER_OP_UNARY_MINUS_DOUBLE:
+	case FILTER_OP_UNARY_NOT_DOUBLE:
+	{
+		if (!vstack_ax(stack)) {
+			ERR("Empty stack\n");
+			ret = -EINVAL;
+			goto end;
+		}
+		if (vstack_ax(stack)->type != REG_DOUBLE) {
+			ERR("Invalid register type\n");
+			ret = -EINVAL;
+			goto end;
+		}
+		break;
+	}
+
+	/* logical */
+	case FILTER_OP_AND:
+	case FILTER_OP_OR:
+	{
+		struct logical_op *insn = (struct logical_op *) pc;
+
+		if (!vstack_ax(stack)) {
+			ERR("Empty stack\n");
+			ret = -EINVAL;
+			goto end;
+		}
+		if (vstack_ax(stack)->type != REG_S64) {
+			ERR("Logical comparator expects S64 register\n");
+			ret = -EINVAL;
+			goto end;
+		}
+
+		dbg_printf("Validate jumping to bytecode offset %u\n",
+			(unsigned int) insn->skip_offset);
+		if (unlikely(start_pc + insn->skip_offset <= pc)) {
+			ERR("Loops are not allowed in bytecode\n");
+			ret = -EINVAL;
+			goto end;
+		}
+		break;
+	}
+
+	/* load */
+	case FILTER_OP_LOAD_FIELD_REF:
+	{
+		ERR("Unknown field ref type\n");
+		ret = -EINVAL;
+		goto end;
+	}
+	case FILTER_OP_LOAD_FIELD_REF_STRING:
+	case FILTER_OP_LOAD_FIELD_REF_SEQUENCE:
+	{
+		struct load_op *insn = (struct load_op *) pc;
+		struct field_ref *ref = (struct field_ref *) insn->data;
+
+		dbg_printf("Validate load field ref offset %u type string\n",
+			ref->offset);
+		break;
+	}
+	case FILTER_OP_LOAD_FIELD_REF_S64:
+	{
+		struct load_op *insn = (struct load_op *) pc;
+		struct field_ref *ref = (struct field_ref *) insn->data;
+
+		dbg_printf("Validate load field ref offset %u type s64\n",
+			ref->offset);
+		break;
+	}
+	case FILTER_OP_LOAD_FIELD_REF_DOUBLE:
+	{
+		struct load_op *insn = (struct load_op *) pc;
+		struct field_ref *ref = (struct field_ref *) insn->data;
+
+		dbg_printf("Validate load field ref offset %u type double\n",
+			ref->offset);
+		break;
+	}
+
+	case FILTER_OP_LOAD_STRING:
+	{
+		break;
+	}
+
+	case FILTER_OP_LOAD_S64:
+	{
+		break;
+	}
+
+	case FILTER_OP_LOAD_DOUBLE:
+	{
+		break;
+	}
+
+	case FILTER_OP_CAST_TO_S64:
+	case FILTER_OP_CAST_DOUBLE_TO_S64:
+	{
+		struct cast_op *insn = (struct cast_op *) pc;
+
+		if (!vstack_ax(stack)) {
+			ERR("Empty stack\n");
+			ret = -EINVAL;
+			goto end;
+		}
+		switch (vstack_ax(stack)->type) {
+		default:
+			ERR("unknown register type\n");
+			ret = -EINVAL;
+			goto end;
+
+		case REG_STRING:
+			ERR("Cast op can only be applied to numeric or floating point registers\n");
+			ret = -EINVAL;
+			goto end;
+		case REG_S64:
+			break;
+		case REG_DOUBLE:
+			break;
+		}
+		if (insn->op == FILTER_OP_CAST_DOUBLE_TO_S64) {
+			if (vstack_ax(stack)->type != REG_DOUBLE) {
+				ERR("Cast expects double\n");
+				ret = -EINVAL;
+				goto end;
+			}
+		}
+		break;
+	}
+	case FILTER_OP_CAST_NOP:
+	{
+		break;
+	}
+
+	}
+end:
+	return ret;
+}
+
+/*
+ * Return value:
+ * 0: success
+ * <0: error
+ */
+static
+int validate_instruction_all_contexts(struct bytecode_runtime *bytecode,
+		struct cds_lfht *merge_points,
+		struct vstack *stack,
+		void *start_pc,
+		void *pc)
+{
+	int ret;
+	unsigned long target_pc = pc - start_pc;
+	struct cds_lfht_iter iter;
+	struct cds_lfht_node *node;
+	struct lfht_mp_node *mp_node;
+	unsigned long hash;
+
+	/* Validate the context resulting from the previous instruction */
+	ret = validate_instruction_context(bytecode, stack, start_pc, pc);
+	if (ret)
+		return ret;
+
+	/* Validate merge points */
+	hash = lttng_hash_mix((const void *) target_pc, sizeof(target_pc),
+			lttng_hash_seed);
+	cds_lfht_lookup(merge_points, hash, lttng_hash_match,
+			(const void *) target_pc, &iter);
+	node = cds_lfht_iter_get_node(&iter);
+	if (node) {
+		mp_node = caa_container_of(node, struct lfht_mp_node, node);
+		
+		dbg_printf("Filter: validate merge point at offset %lu\n",
+				target_pc);
+		if (merge_points_compare(stack, &mp_node->stack)) {
+			ERR("Merge points differ for offset %lu\n",
+				target_pc);
+			return -EINVAL;
+		}
+		/* Once validated, we can remove the merge point */
+		dbg_printf("Filter: remove merge point at offset %lu\n",
+				target_pc);
+		ret = cds_lfht_del(merge_points, node);
+		assert(!ret);
+	}
+	return 0;
+}
+
+/*
+ * Return value:
+ * >0: going to next insn.
+ * 0: success, stop iteration.
+ * <0: error
+ */
+static
+int exec_insn(struct bytecode_runtime *bytecode,
+		struct cds_lfht *merge_points,
+		struct vstack *stack,
+		void **_next_pc,
+		void *pc)
+{
+	int ret = 1;
+	void *next_pc = *_next_pc;
+
+	switch (*(filter_opcode_t *) pc) {
+	case FILTER_OP_UNKNOWN:
+	default:
+	{
+		ERR("unknown bytecode op %u\n",
+			(unsigned int) *(filter_opcode_t *) pc);
+		ret = -EINVAL;
+		goto end;
+	}
+
+	case FILTER_OP_RETURN:
+	{
+		if (!vstack_ax(stack)) {
+			ERR("Empty stack\n");
+			ret = -EINVAL;
+			goto end;
+		}
+		ret = 0;
+		goto end;
+	}
+
+	/* binary */
+	case FILTER_OP_MUL:
+	case FILTER_OP_DIV:
+	case FILTER_OP_MOD:
+	case FILTER_OP_PLUS:
+	case FILTER_OP_MINUS:
+	case FILTER_OP_RSHIFT:
+	case FILTER_OP_LSHIFT:
+	case FILTER_OP_BIN_AND:
+	case FILTER_OP_BIN_OR:
+	case FILTER_OP_BIN_XOR:
+	{
+		ERR("unsupported bytecode op %u\n",
+			(unsigned int) *(filter_opcode_t *) pc);
+		ret = -EINVAL;
+		goto end;
+	}
+
+	case FILTER_OP_EQ:
+	case FILTER_OP_NE:
+	case FILTER_OP_GT:
+	case FILTER_OP_LT:
+	case FILTER_OP_GE:
+	case FILTER_OP_LE:
+	case FILTER_OP_EQ_STRING:
+	case FILTER_OP_NE_STRING:
+	case FILTER_OP_GT_STRING:
+	case FILTER_OP_LT_STRING:
+	case FILTER_OP_GE_STRING:
+	case FILTER_OP_LE_STRING:
+	case FILTER_OP_EQ_S64:
+	case FILTER_OP_NE_S64:
+	case FILTER_OP_GT_S64:
+	case FILTER_OP_LT_S64:
+	case FILTER_OP_GE_S64:
+	case FILTER_OP_LE_S64:
+	case FILTER_OP_EQ_DOUBLE:
+	case FILTER_OP_NE_DOUBLE:
+	case FILTER_OP_GT_DOUBLE:
+	case FILTER_OP_LT_DOUBLE:
+	case FILTER_OP_GE_DOUBLE:
+	case FILTER_OP_LE_DOUBLE:
+	case FILTER_OP_EQ_DOUBLE_S64:
+	case FILTER_OP_NE_DOUBLE_S64:
+	case FILTER_OP_GT_DOUBLE_S64:
+	case FILTER_OP_LT_DOUBLE_S64:
+	case FILTER_OP_GE_DOUBLE_S64:
+	case FILTER_OP_LE_DOUBLE_S64:
+	case FILTER_OP_EQ_S64_DOUBLE:
+	case FILTER_OP_NE_S64_DOUBLE:
+	case FILTER_OP_GT_S64_DOUBLE:
+	case FILTER_OP_LT_S64_DOUBLE:
+	case FILTER_OP_GE_S64_DOUBLE:
+	case FILTER_OP_LE_S64_DOUBLE:
+	{
+		/* Pop 2, push 1 */
+		if (vstack_pop(stack)) {
+			ret = -EINVAL;
+			goto end;
+		}
+		if (!vstack_ax(stack)) {
+			ERR("Empty stack\n");
+			ret = -EINVAL;
+			goto end;
+		}
+		vstack_ax(stack)->type = REG_S64;
+		next_pc += sizeof(struct binary_op);
+		break;
+	}
+
+	/* unary */
+	case FILTER_OP_UNARY_PLUS:
+	case FILTER_OP_UNARY_MINUS:
+	case FILTER_OP_UNARY_NOT:
+	case FILTER_OP_UNARY_PLUS_S64:
+	case FILTER_OP_UNARY_MINUS_S64:
+	case FILTER_OP_UNARY_NOT_S64:
+	{
+		/* Pop 1, push 1 */
+		if (!vstack_ax(stack)) {
+			ERR("Empty stack\n");
+			ret = -EINVAL;
+			goto end;
+		}
+		vstack_ax(stack)->type = REG_S64;
+		next_pc += sizeof(struct unary_op);
+		break;
+	}
+
+	case FILTER_OP_UNARY_PLUS_DOUBLE:
+	case FILTER_OP_UNARY_MINUS_DOUBLE:
+	case FILTER_OP_UNARY_NOT_DOUBLE:
+	{
+		/* Pop 1, push 1 */
+		if (!vstack_ax(stack)) {
+			ERR("Empty stack\n");
+			ret = -EINVAL;
+			goto end;
+		}
+		vstack_ax(stack)->type = REG_DOUBLE;
+		next_pc += sizeof(struct unary_op);
+		break;
+	}
+
+	/* logical */
+	case FILTER_OP_AND:
+	case FILTER_OP_OR:
+	{
+		struct logical_op *insn = (struct logical_op *) pc;
+		int merge_ret;
+
+		/* Add merge point to table */
+		merge_ret = merge_point_add_check(merge_points,
+					insn->skip_offset, stack);
+		if (merge_ret) {
+			ret = merge_ret;
+			goto end;
+		}
+		/* Continue to next instruction */
+		/* Pop 1 when jump not taken */
+		if (vstack_pop(stack)) {
+			ret = -EINVAL;
+			goto end;
+		}
+		next_pc += sizeof(struct logical_op);
+		break;
+	}
+
+	/* load */
+	case FILTER_OP_LOAD_FIELD_REF:
+	{
+		ERR("Unknown field ref type\n");
+		ret = -EINVAL;
+		goto end;
+	}
+	case FILTER_OP_LOAD_FIELD_REF_STRING:
+	case FILTER_OP_LOAD_FIELD_REF_SEQUENCE:
+	{
+		if (vstack_push(stack)) {
+			ret = -EINVAL;
+			goto end;
+		}
+		vstack_ax(stack)->type = REG_STRING;
+		next_pc += sizeof(struct load_op) + sizeof(struct field_ref);
+		break;
+	}
+	case FILTER_OP_LOAD_FIELD_REF_S64:
+	{
+		if (vstack_push(stack)) {
+			ret = -EINVAL;
+			goto end;
+		}
+		vstack_ax(stack)->type = REG_S64;
+		next_pc += sizeof(struct load_op) + sizeof(struct field_ref);
+		break;
+	}
+	case FILTER_OP_LOAD_FIELD_REF_DOUBLE:
+	{
+		if (vstack_push(stack)) {
+			ret = -EINVAL;
+			goto end;
+		}
+		vstack_ax(stack)->type = REG_DOUBLE;
+		next_pc += sizeof(struct load_op) + sizeof(struct field_ref);
+		break;
+	}
+
+	case FILTER_OP_LOAD_STRING:
+	{
+		struct load_op *insn = (struct load_op *) pc;
+
+		if (vstack_push(stack)) {
+			ret = -EINVAL;
+			goto end;
+		}
+		vstack_ax(stack)->type = REG_STRING;
+		next_pc += sizeof(struct load_op) + strlen(insn->data) + 1;
+		break;
+	}
+
+	case FILTER_OP_LOAD_S64:
+	{
+		if (vstack_push(stack)) {
+			ret = -EINVAL;
+			goto end;
+		}
+		vstack_ax(stack)->type = REG_S64;
+		next_pc += sizeof(struct load_op)
+				+ sizeof(struct literal_numeric);
+		break;
+	}
+
+	case FILTER_OP_LOAD_DOUBLE:
+	{
+		if (vstack_push(stack)) {
+			ret = -EINVAL;
+			goto end;
+		}
+		vstack_ax(stack)->type = REG_DOUBLE;
+		next_pc += sizeof(struct load_op)
+				+ sizeof(struct literal_double);
+		break;
+	}
+
+	case FILTER_OP_CAST_TO_S64:
+	case FILTER_OP_CAST_DOUBLE_TO_S64:
+	{
+		/* Pop 1, push 1 */
+		if (!vstack_ax(stack)) {
+			ERR("Empty stack\n");
+			ret = -EINVAL;
+			goto end;
+		}
+		vstack_ax(stack)->type = REG_S64;
+		next_pc += sizeof(struct cast_op);
+		break;
+	}
+	case FILTER_OP_CAST_NOP:
+	{
+		next_pc += sizeof(struct cast_op);
+		break;
+	}
+
+	}
+end:
+	*_next_pc = next_pc;
+	return ret;
+}
+
+/*
+ * Never called concurrently (hash seed is shared).
+ */
+int lttng_filter_validate_bytecode(struct bytecode_runtime *bytecode)
+{
+	struct cds_lfht *merge_points;
+	void *pc, *next_pc, *start_pc;
+	int ret = -EINVAL;
+	struct vstack stack;
+
+	vstack_init(&stack);
+
+	if (!lttng_hash_seed_ready) {
+		lttng_hash_seed = time(NULL);
+		lttng_hash_seed_ready = 1;
+	}
+	/*
+	 * Note: merge_points hash table used by single thread, and
+	 * never concurrently resized. Therefore, we can use it without
+	 * holding RCU read-side lock and free nodes without using
+	 * call_rcu.
+	 */
+	merge_points = cds_lfht_new(DEFAULT_NR_MERGE_POINTS,
+			MIN_NR_BUCKETS, MAX_NR_BUCKETS,
+			0, NULL);
+	if (!merge_points) {
+		ERR("Error allocating hash table for bytecode validation\n");
+		return -ENOMEM;
+	}
+	start_pc = &bytecode->data[0];
+	for (pc = next_pc = start_pc; pc - start_pc < bytecode->len;
+			pc = next_pc) {
+		if (bytecode_validate_overflow(bytecode, start_pc, pc) != 0) {
+			ERR("filter bytecode overflow\n");
+			ret = -EINVAL;
+			goto end;
+		}
+		dbg_printf("Validating op %s (%u)\n",
+			print_op((unsigned int) *(filter_opcode_t *) pc),
+			(unsigned int) *(filter_opcode_t *) pc);
+
+		/*
+		 * For each instruction, validate the current context
+		 * (traversal of entire execution flow), and validate
+		 * all 	merge points targeting this instruction.
+		 */
+		ret = validate_instruction_all_contexts(bytecode, merge_points,
+					&stack, start_pc, pc);
+		if (ret)
+			goto end;
+		ret = exec_insn(bytecode, merge_points, &stack, &next_pc, pc);
+		if (ret <= 0)
+			goto end;
+	}
+end:
+	if (delete_all_nodes(merge_points)) {
+		if (!ret) {
+			ERR("Unexpected merge points\n");
+			ret = -EINVAL;
+		}
+	}
+	if (cds_lfht_destroy(merge_points, NULL)) {
+		ERR("Error destroying hash table\n");
+	}
+	return ret;
+}

=== added file 'liblttng-ust/lttng-filter.c'
--- liblttng-ust/lttng-filter.c	1970-01-01 00:00:00 +0000
+++ liblttng-ust/lttng-filter.c	2012-09-11 15:34:43 +0000
@@ -0,0 +1,353 @@
+/*
+ * lttng-filter.c
+ *
+ * LTTng UST filter code.
+ *
+ * Copyright (C) 2010-2012 Mathieu Desnoyers <mathieu.desnoyers@efficios.com>
+ *
+ * This library is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU Lesser General Public
+ * License as published by the Free Software Foundation; only
+ * version 2.1 of the License.
+ *
+ * This library is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with this library; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#include "lttng-filter.h"
+
+static const char *opnames[] = {
+	[ FILTER_OP_UNKNOWN ] = "UNKNOWN",
+
+	[ FILTER_OP_RETURN ] = "RETURN",
+
+	/* binary */
+	[ FILTER_OP_MUL ] = "MUL",
+	[ FILTER_OP_DIV ] = "DIV",
+	[ FILTER_OP_MOD ] = "MOD",
+	[ FILTER_OP_PLUS ] = "PLUS",
+	[ FILTER_OP_MINUS ] = "MINUS",
+	[ FILTER_OP_RSHIFT ] = "RSHIFT",
+	[ FILTER_OP_LSHIFT ] = "LSHIFT",
+	[ FILTER_OP_BIN_AND ] = "BIN_AND",
+	[ FILTER_OP_BIN_OR ] = "BIN_OR",
+	[ FILTER_OP_BIN_XOR ] = "BIN_XOR",
+
+	/* binary comparators */
+	[ FILTER_OP_EQ ] = "EQ",
+	[ FILTER_OP_NE ] = "NE",
+	[ FILTER_OP_GT ] = "GT",
+	[ FILTER_OP_LT ] = "LT",
+	[ FILTER_OP_GE ] = "GE",
+	[ FILTER_OP_LE ] = "LE",
+
+	/* string binary comparators */
+	[ FILTER_OP_EQ_STRING ] = "EQ_STRING",
+	[ FILTER_OP_NE_STRING ] = "NE_STRING",
+	[ FILTER_OP_GT_STRING ] = "GT_STRING",
+	[ FILTER_OP_LT_STRING ] = "LT_STRING",
+	[ FILTER_OP_GE_STRING ] = "GE_STRING",
+	[ FILTER_OP_LE_STRING ] = "LE_STRING",
+
+	/* s64 binary comparators */
+	[ FILTER_OP_EQ_S64 ] = "EQ_S64",
+	[ FILTER_OP_NE_S64 ] = "NE_S64",
+	[ FILTER_OP_GT_S64 ] = "GT_S64",
+	[ FILTER_OP_LT_S64 ] = "LT_S64",
+	[ FILTER_OP_GE_S64 ] = "GE_S64",
+	[ FILTER_OP_LE_S64 ] = "LE_S64",
+
+	/* double binary comparators */
+	[ FILTER_OP_EQ_DOUBLE ] = "EQ_DOUBLE",
+	[ FILTER_OP_NE_DOUBLE ] = "NE_DOUBLE",
+	[ FILTER_OP_GT_DOUBLE ] = "GT_DOUBLE",
+	[ FILTER_OP_LT_DOUBLE ] = "LT_DOUBLE",
+	[ FILTER_OP_GE_DOUBLE ] = "GE_DOUBLE",
+	[ FILTER_OP_LE_DOUBLE ] = "LE_DOUBLE",
+
+	/* Mixed S64-double binary comparators */
+	[ FILTER_OP_EQ_DOUBLE_S64 ] = "EQ_DOUBLE_S64",
+	[ FILTER_OP_NE_DOUBLE_S64 ] = "NE_DOUBLE_S64",
+	[ FILTER_OP_GT_DOUBLE_S64 ] = "GT_DOUBLE_S64",
+	[ FILTER_OP_LT_DOUBLE_S64 ] = "LT_DOUBLE_S64",
+	[ FILTER_OP_GE_DOUBLE_S64 ] = "GE_DOUBLE_S64",
+	[ FILTER_OP_LE_DOUBLE_S64 ] = "LE_DOUBLE_S64",
+
+	[ FILTER_OP_EQ_S64_DOUBLE ] = "EQ_S64_DOUBLE",
+	[ FILTER_OP_NE_S64_DOUBLE ] = "NE_S64_DOUBLE",
+	[ FILTER_OP_GT_S64_DOUBLE ] = "GT_S64_DOUBLE",
+	[ FILTER_OP_LT_S64_DOUBLE ] = "LT_S64_DOUBLE",
+	[ FILTER_OP_GE_S64_DOUBLE ] = "GE_S64_DOUBLE",
+	[ FILTER_OP_LE_S64_DOUBLE ] = "LE_S64_DOUBLE",
+
+	/* unary */
+	[ FILTER_OP_UNARY_PLUS ] = "UNARY_PLUS",
+	[ FILTER_OP_UNARY_MINUS ] = "UNARY_MINUS",
+	[ FILTER_OP_UNARY_NOT ] = "UNARY_NOT",
+	[ FILTER_OP_UNARY_PLUS_S64 ] = "UNARY_PLUS_S64",
+	[ FILTER_OP_UNARY_MINUS_S64 ] = "UNARY_MINUS_S64",
+	[ FILTER_OP_UNARY_NOT_S64 ] = "UNARY_NOT_S64",
+	[ FILTER_OP_UNARY_PLUS_DOUBLE ] = "UNARY_PLUS_DOUBLE",
+	[ FILTER_OP_UNARY_MINUS_DOUBLE ] = "UNARY_MINUS_DOUBLE",
+	[ FILTER_OP_UNARY_NOT_DOUBLE ] = "UNARY_NOT_DOUBLE",
+
+	/* logical */
+	[ FILTER_OP_AND ] = "AND",
+	[ FILTER_OP_OR ] = "OR",
+
+	/* load */
+	[ FILTER_OP_LOAD_FIELD_REF ] = "LOAD_FIELD_REF",
+	[ FILTER_OP_LOAD_FIELD_REF_STRING ] = "LOAD_FIELD_REF_STRING",
+	[ FILTER_OP_LOAD_FIELD_REF_SEQUENCE ] = "LOAD_FIELD_REF_SEQUENCE",
+	[ FILTER_OP_LOAD_FIELD_REF_S64 ] = "LOAD_FIELD_REF_S64",
+	[ FILTER_OP_LOAD_FIELD_REF_DOUBLE ] = "LOAD_FIELD_REF_DOUBLE",
+
+	[ FILTER_OP_LOAD_STRING ] = "LOAD_STRING",
+	[ FILTER_OP_LOAD_S64 ] = "LOAD_S64",
+	[ FILTER_OP_LOAD_DOUBLE ] = "LOAD_DOUBLE",
+
+	/* cast */
+	[ FILTER_OP_CAST_TO_S64 ] = "CAST_TO_S64",
+	[ FILTER_OP_CAST_DOUBLE_TO_S64 ] = "CAST_DOUBLE_TO_S64",
+	[ FILTER_OP_CAST_NOP ] = "CAST_NOP",
+};
+
+const char *print_op(enum filter_op op)
+{
+	if (op >= NR_FILTER_OPS)
+		return "UNKNOWN";
+	else
+		return opnames[op];
+}
+
+static
+int apply_field_reloc(struct ltt_event *event,
+		struct bytecode_runtime *runtime,
+		uint32_t runtime_len,
+		uint32_t reloc_offset,
+		const char *field_name)
+{
+	const struct lttng_event_desc *desc;
+	const struct lttng_event_field *fields, *field = NULL;
+	unsigned int nr_fields, i;
+	struct field_ref *field_ref;
+	struct load_op *op;
+	uint32_t field_offset = 0;
+
+	dbg_printf("Apply reloc: %u %s\n", reloc_offset, field_name);
+
+	/* Ensure that the reloc is within the code */
+	if (runtime_len - reloc_offset < sizeof(uint16_t))
+		return -EINVAL;
+
+	/* Lookup event by name */
+	desc = event->desc;
+	if (!desc)
+		return -EINVAL;
+	fields = desc->fields;
+	if (!fields)
+		return -EINVAL;
+	nr_fields = desc->nr_fields;
+	for (i = 0; i < nr_fields; i++) {
+		if (!strcmp(fields[i].name, field_name)) {
+			field = &fields[i];
+			break;
+		}
+		/* compute field offset */
+		switch (fields[i].type.atype) {
+		case atype_integer:
+		case atype_enum:
+			field_offset += sizeof(int64_t);
+			break;
+		case atype_array:
+		case atype_sequence:
+			field_offset += sizeof(unsigned long);
+			field_offset += sizeof(void *);
+			break;
+		case atype_string:
+			field_offset += sizeof(void *);
+			break;
+		case atype_float:
+			field_offset += sizeof(double);
+			break;
+		default:
+			return -EINVAL;
+		}
+	}
+	if (!field)
+		return -EINVAL;
+
+	/* Check if field offset is too large for 16-bit offset */
+	if (field_offset > FILTER_BYTECODE_MAX_LEN - 1)
+		return -EINVAL;
+
+	/* set type */
+	op = (struct load_op *) &runtime->data[reloc_offset];
+	field_ref = (struct field_ref *) op->data;
+	switch (field->type.atype) {
+	case atype_integer:
+	case atype_enum:
+		op->op = FILTER_OP_LOAD_FIELD_REF_S64;
+		break;
+	case atype_array:
+	case atype_sequence:
+		op->op = FILTER_OP_LOAD_FIELD_REF_SEQUENCE;
+		break;
+	case atype_string:
+		op->op = FILTER_OP_LOAD_FIELD_REF_STRING;
+		break;
+	case atype_float:
+		op->op = FILTER_OP_LOAD_FIELD_REF_DOUBLE;
+		break;
+	default:
+		return -EINVAL;
+	}
+	/* set offset */
+	field_ref->offset = (uint16_t) field_offset;
+	return 0;
+}
+
+/*
+ * Take a bytecode with reloc table and link it to an event to create a
+ * bytecode runtime.
+ */
+static
+int _lttng_filter_event_link_bytecode(struct ltt_event *event,
+		struct lttng_ust_filter_bytecode *filter_bytecode)
+{
+	int ret, offset, next_offset;
+	struct bytecode_runtime *runtime = NULL;
+	size_t runtime_alloc_len;
+
+	if (!filter_bytecode)
+		return 0;
+	/* Even is not connected to any description */
+	if (!event->desc)
+		return 0;
+	/* Bytecode already linked */
+	if (event->filter || event->filter_data)
+		return 0;
+
+	dbg_printf("Linking\n");
+
+	/* We don't need the reloc table in the runtime */
+	runtime_alloc_len = sizeof(*runtime) + filter_bytecode->reloc_offset;
+	runtime = zmalloc(runtime_alloc_len);
+	if (!runtime) {
+		ret = -ENOMEM;
+		goto link_error;
+	}
+	runtime->len = filter_bytecode->reloc_offset;
+	/* copy original bytecode */
+	memcpy(runtime->data, filter_bytecode->data, runtime->len);
+	/*
+	 * apply relocs. Those are a uint16_t (offset in bytecode)
+	 * followed by a string (field name).
+	 */
+	for (offset = filter_bytecode->reloc_offset;
+			offset < filter_bytecode->len;
+			offset = next_offset) {
+		uint16_t reloc_offset =
+			*(uint16_t *) &filter_bytecode->data[offset];
+		const char *field_name =
+			(const char *) &filter_bytecode->data[offset + sizeof(uint16_t)];
+
+		ret = apply_field_reloc(event, runtime, runtime->len, reloc_offset, field_name);
+		if (ret) {
+			goto link_error;
+		}
+		next_offset = offset + sizeof(uint16_t) + strlen(field_name) + 1;
+	}
+	/* Validate bytecode */
+	ret = lttng_filter_validate_bytecode(runtime);
+	if (ret) {
+		goto link_error;
+	}
+	/* Specialize bytecode */
+	ret = lttng_filter_specialize_bytecode(runtime);
+	if (ret) {
+		goto link_error;
+	}
+	event->filter_data = runtime;
+	event->filter = lttng_filter_interpret_bytecode;
+	return 0;
+
+link_error:
+	event->filter = lttng_filter_false;
+	free(runtime);
+	return ret;
+}
+
+void lttng_filter_event_link_bytecode(struct ltt_event *event,
+		struct lttng_ust_filter_bytecode *filter_bytecode)
+{
+	int ret;
+
+	ret = _lttng_filter_event_link_bytecode(event, filter_bytecode);
+	if (ret) {
+		dbg_printf("[lttng filter] warning: cannot link event bytecode\n");
+	}
+}
+
+/*
+ * Link bytecode to all events for a wildcard. Skips events that already
+ * have a bytecode linked.
+ * We do not set each event's filter_bytecode field, because they do not
+ * own the filter_bytecode: the wildcard owns it.
+ */
+void lttng_filter_wildcard_link_bytecode(struct session_wildcard *wildcard)
+{
+	struct ltt_event *event;
+	int ret;
+
+	if (!wildcard->filter_bytecode)
+		return;
+
+	cds_list_for_each_entry(event, &wildcard->events, wildcard_list) {
+		if (event->filter)
+			continue;
+		ret = _lttng_filter_event_link_bytecode(event,
+				wildcard->filter_bytecode);
+		if (ret) {
+			fprintf(stderr, "[lttng filter] error linking wildcard bytecode\n");
+		}
+
+	}
+	return;
+}
+
+/*
+ * Need to attach filter to an event before starting tracing for the
+ * session. We own the filter_bytecode if we return success.
+ */
+int lttng_filter_event_attach_bytecode(struct ltt_event *event,
+		struct lttng_ust_filter_bytecode *filter_bytecode)
+{
+	if (event->chan->session->been_active)
+		return -EPERM;
+	if (event->filter_bytecode)
+		return -EEXIST;
+	event->filter_bytecode = filter_bytecode;
+	return 0;
+}
+
+/*
+ * Need to attach filter to a wildcard before starting tracing for the
+ * session. We own the filter_bytecode if we return success.
+ */
+int lttng_filter_wildcard_attach_bytecode(struct session_wildcard *wildcard,
+		struct lttng_ust_filter_bytecode *filter_bytecode)
+{
+	if (wildcard->chan->session->been_active)
+		return -EPERM;
+	if (wildcard->filter_bytecode)
+		return -EEXIST;
+	wildcard->filter_bytecode = filter_bytecode;
+	return 0;
+}

=== added file 'liblttng-ust/lttng-filter.h'
--- liblttng-ust/lttng-filter.h	1970-01-01 00:00:00 +0000
+++ liblttng-ust/lttng-filter.h	2012-09-11 15:34:43 +0000
@@ -0,0 +1,194 @@
+#ifndef _LTTNG_FILTER_H
+#define _LTTNG_FILTER_H
+
+/*
+ * lttng-filter.h
+ *
+ * LTTng UST filter header.
+ *
+ * Copyright (C) 2010-2012 Mathieu Desnoyers <mathieu.desnoyers@efficios.com>
+ *
+ * This library is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU Lesser General Public
+ * License as published by the Free Software Foundation; only
+ * version 2.1 of the License.
+ *
+ * This library is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with this library; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#include <errno.h>
+#include <stdio.h>
+#include <helper.h>
+#include <lttng/ust-events.h>
+#include <stdint.h>
+#include <assert.h>
+#include <errno.h>
+#include <string.h>
+#include <inttypes.h>
+#include <limits.h>
+#include <usterr-signal-safe.h>
+#include "filter-bytecode.h"
+
+/* Filter stack length, in number of entries */
+#define FILTER_STACK_LEN	10	/* includes 2 dummy */
+#define FILTER_STACK_EMPTY	1
+
+#ifndef min_t
+#define min_t(type, a, b)	\
+		((type) (a) < (type) (b) ? (type) (a) : (type) (b))
+#endif
+
+#ifndef likely
+#define likely(x)	__builtin_expect(!!(x), 1)
+#endif
+
+#ifndef unlikely
+#define unlikely(x)	__builtin_expect(!!(x), 0)
+#endif
+
+#ifdef DEBUG
+#define dbg_printf(fmt, args...)     printf("[debug bytecode] " fmt, ## args)
+#else
+#define dbg_printf(fmt, args...)				\
+do {								\
+	/* do nothing but check printf format */		\
+	if (0)							\
+		printf("[debug bytecode] " fmt, ## args);	\
+} while (0)
+#endif
+
+/* Linked bytecode */
+struct bytecode_runtime {
+	uint16_t len;
+	char data[0];
+};
+
+enum entry_type {
+	REG_S64,
+	REG_DOUBLE,
+	REG_STRING,
+	REG_TYPE_UNKNOWN,
+};
+
+/* Validation stack */
+struct vstack_entry {
+	enum entry_type type;
+};
+
+struct vstack {
+	int top;	/* top of stack */
+	struct vstack_entry e[FILTER_STACK_LEN];
+};
+
+static inline
+void vstack_init(struct vstack *stack)
+{
+	stack->top = -1;
+}
+
+static inline
+struct vstack_entry *vstack_ax(struct vstack *stack)
+{
+	if (unlikely(stack->top < 0))
+		return NULL;
+	return &stack->e[stack->top];
+}
+
+static inline
+struct vstack_entry *vstack_bx(struct vstack *stack)
+{
+	if (unlikely(stack->top < 1))
+		return NULL;
+	return &stack->e[stack->top - 1];
+}
+
+static inline
+int vstack_push(struct vstack *stack)
+{
+	if (stack->top >= FILTER_STACK_LEN - 1) {
+		ERR("Stack full\n");
+		return -EINVAL;
+	}
+	++stack->top;
+	return 0;
+}
+
+static inline
+int vstack_pop(struct vstack *stack)
+{
+	if (unlikely(stack->top < 0)) {
+		ERR("Stack empty\n");
+		return -EINVAL;
+	}
+	stack->top--;
+	return 0;
+}
+
+/* Execution stack */
+struct estack_entry {
+	union {
+		int64_t v;
+		double d;
+
+		struct {
+			const char *str;
+			size_t seq_len;
+			int literal;		/* is string literal ? */
+		} s;
+	} u;
+};
+
+struct estack {
+	int top;	/* top of stack */
+	struct estack_entry e[FILTER_STACK_LEN];
+};
+
+#define estack_ax_v	ax
+#define estack_bx_v	bx
+
+#define estack_ax(stack, top)					\
+	({							\
+		assert((top) > FILTER_STACK_EMPTY);		\
+		&(stack)->e[top];				\
+	})
+
+#define estack_bx(stack, top)					\
+	({							\
+		assert((top) > FILTER_STACK_EMPTY + 1);		\
+		&(stack)->e[(top) - 1];				\
+	})
+
+#define estack_push(stack, top, ax, bx)				\
+	do {							\
+		assert((top) < FILTER_STACK_LEN - 1);		\
+		(stack)->e[(top) - 1].u.v = (bx);		\
+		(bx) = (ax);					\
+		++(top);					\
+	} while (0)
+
+#define estack_pop(stack, top, ax, bx)				\
+	do {							\
+		assert((top) > FILTER_STACK_EMPTY);		\
+		(ax) = (bx);					\
+		(bx) = (stack)->e[(top) - 2].u.v;		\
+		(top)--;					\
+	} while (0)
+
+const char *print_op(enum filter_op op);
+
+int lttng_filter_validate_bytecode(struct bytecode_runtime *bytecode);
+int lttng_filter_specialize_bytecode(struct bytecode_runtime *bytecode);
+
+int lttng_filter_false(void *filter_data,
+		const char *filter_stack_data);
+int lttng_filter_interpret_bytecode(void *filter_data,
+		const char *filter_stack_data);
+
+#endif /* _LTTNG_FILTER_H */

=== added file 'liblttng-ust/lttng-hash-helper.h'
--- liblttng-ust/lttng-hash-helper.h	1970-01-01 00:00:00 +0000
+++ liblttng-ust/lttng-hash-helper.h	2012-09-11 15:34:43 +0000
@@ -0,0 +1,160 @@
+#ifndef _LTTNG_HASH_HELPER_H
+#define _LTTNG_HASH_HELPER_H
+
+/*
+ * lttng-hash-helper.h
+ *
+ * LTTng hash table helpers.
+ *
+ * Copyright (C) 2012 Mathieu Desnoyers <mathieu.desnoyers@efficios.com>
+ *
+ * This library is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU Lesser General Public
+ * License as published by the Free Software Foundation; only
+ * version 2.1 of the License.
+ *
+ * This library is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with this library; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#include <assert.h>
+#include <stdint.h>
+#include <urcu/compiler.h>
+
+/*
+ * Hash function
+ * Source: http://burtleburtle.net/bob/c/lookup3.c
+ * Originally Public Domain
+ */
+
+#define rot(x, k) (((x) << (k)) | ((x) >> (32 - (k))))
+
+#define mix(a, b, c) \
+do { \
+	a -= c; a ^= rot(c,  4); c += b; \
+	b -= a; b ^= rot(a,  6); a += c; \
+	c -= b; c ^= rot(b,  8); b += a; \
+	a -= c; a ^= rot(c, 16); c += b; \
+	b -= a; b ^= rot(a, 19); a += c; \
+	c -= b; c ^= rot(b,  4); b += a; \
+} while (0)
+
+#define final(a, b, c) \
+{ \
+	c ^= b; c -= rot(b, 14); \
+	a ^= c; a -= rot(c, 11); \
+	b ^= a; b -= rot(a, 25); \
+	c ^= b; c -= rot(b, 16); \
+	a ^= c; a -= rot(c,  4);\
+	b ^= a; b -= rot(a, 14); \
+	c ^= b; c -= rot(b, 24); \
+}
+
+static inline __attribute__((unused))
+uint32_t lttng_hash_u32(
+	const uint32_t *k,	/* the key, an array of uint32_t values */
+	size_t length,		/* the length of the key, in uint32_ts */
+	uint32_t initval)	/* the previous hash, or an arbitrary value */
+{
+	uint32_t a, b, c;
+
+	/* Set up the internal state */
+	a = b = c = 0xdeadbeef + (((uint32_t) length) << 2) + initval;
+
+	/*----------------------------------------- handle most of the key */
+	while (length > 3) {
+		a += k[0];
+		b += k[1];
+		c += k[2];
+		mix(a, b, c);
+		length -= 3;
+		k += 3;
+	}
+
+	/*----------------------------------- handle the last 3 uint32_t's */
+	switch (length) {	/* all the case statements fall through */
+	case 3: c += k[2];
+	case 2: b += k[1];
+	case 1: a += k[0];
+		final(a, b, c);
+	case 0:			/* case 0: nothing left to add */
+		break;
+	}
+	/*---------------------------------------------- report the result */
+	return c;
+}
+
+static inline
+void lttng_hashword2(
+	const uint32_t *k,	/* the key, an array of uint32_t values */
+	size_t length,		/* the length of the key, in uint32_ts */
+	uint32_t *pc,		/* IN: seed OUT: primary hash value */
+	uint32_t *pb)		/* IN: more seed OUT: secondary hash value */
+{
+	uint32_t a, b, c;
+
+	/* Set up the internal state */
+	a = b = c = 0xdeadbeef + ((uint32_t) (length << 2)) + *pc;
+	c += *pb;
+
+	/*----------------------------------------- handle most of the key */
+	while (length > 3) {
+		a += k[0];
+		b += k[1];
+		c += k[2];
+		mix(a, b, c);
+		length -= 3;
+		k += 3;
+	}
+
+	/*----------------------------------- handle the last 3 uint32_t's */
+	switch (length) {	/* all the case statements fall through */
+	case 3: c += k[2];
+	case 2: b += k[1];
+	case 1: a += k[0];
+		final(a, b, c);
+	case 0:			/* case 0: nothing left to add */
+		break;
+	}
+	/*---------------------------------------------- report the result */
+	*pc = c;
+	*pb = b;
+}
+
+#if (CAA_BITS_PER_LONG == 32)
+static inline
+unsigned long lttng_hash_mix(const void *_key, size_t length, unsigned long seed)
+{
+	unsigned int key = (unsigned int) _key;
+
+	assert(length == sizeof(unsigned int));
+	return lttng_hash_u32(&key, 1, seed);
+}
+#else
+static inline
+unsigned long lttng_hash_mix(const void *_key, size_t length, unsigned long seed)
+{
+	union {
+		uint64_t v64;
+		uint32_t v32[2];
+	} v;
+	union {
+		uint64_t v64;
+		uint32_t v32[2];
+	} key;
+
+	assert(length == sizeof(unsigned long));
+	v.v64 = (uint64_t) seed;
+	key.v64 = (uint64_t) _key;
+	lttng_hashword2(key.v32, 2, &v.v32[0], &v.v32[1]);
+	return v.v64;
+}
+#endif
+
+#endif /* _LTTNG_HASH_HELPER_H */

=== modified file 'liblttng-ust/lttng-ust-abi.c'
--- liblttng-ust/lttng-ust-abi.c	2012-06-29 16:47:49 +0000
+++ liblttng-ust/lttng-ust-abi.c	2012-09-11 15:34:43 +0000
@@ -52,6 +52,8 @@
 
 static
 int lttng_abi_tracepoint_list(void);
+static
+int lttng_abi_tracepoint_field_list(void);
 
 /*
  * Object descriptor table. Should be protected from concurrent access
@@ -220,6 +222,7 @@
 static const struct lttng_ust_objd_ops lttng_wildcard_ops;
 static const struct lttng_ust_objd_ops lib_ring_buffer_objd_ops;
 static const struct lttng_ust_objd_ops lttng_tracepoint_list_ops;
+static const struct lttng_ust_objd_ops lttng_tracepoint_field_list_ops;
 
 enum channel_type {
 	PER_CPU_CHANNEL,
@@ -260,9 +263,9 @@
 long lttng_abi_tracer_version(int objd,
 	struct lttng_ust_tracer_version *v)
 {
-	v->major = LTTNG_UST_MAJOR_VERSION;
-	v->minor = LTTNG_UST_MINOR_VERSION;
-	v->patchlevel = LTTNG_UST_PATCHLEVEL_VERSION;
+	v->major = LTTNG_UST_INTERNAL_MAJOR_VERSION;
+	v->minor = LTTNG_UST_INTERNAL_MINOR_VERSION;
+	v->patchlevel = LTTNG_UST_INTERNAL_PATCHLEVEL_VERSION;
 	return 0;
 }
 
@@ -303,6 +306,8 @@
  *		Returns the LTTng kernel tracer version
  *	LTTNG_UST_TRACEPOINT_LIST
  *		Returns a file descriptor listing available tracepoints
+ *	LTTNG_UST_TRACEPOINT_FIELD_LIST
+ *		Returns a file descriptor listing available tracepoint fields
  *	LTTNG_UST_WAIT_QUIESCENT
  *		Returns after all previously running probes have completed
  *
@@ -320,6 +325,8 @@
 				(struct lttng_ust_tracer_version *) arg);
 	case LTTNG_UST_TRACEPOINT_LIST:
 		return lttng_abi_tracepoint_list();
+	case LTTNG_UST_TRACEPOINT_FIELD_LIST:
+		return lttng_abi_tracepoint_field_list();
 	case LTTNG_UST_WAIT_QUIESCENT:
 		synchronize_trace();
 		return 0;
@@ -354,7 +361,7 @@
 	 * We tolerate no failure path after event creation. It will stay
 	 * invariant for the rest of the session.
 	 */
-	ret = ltt_event_create(channel, &metadata_params, NULL, &event);
+	ret = ltt_event_create(channel, &metadata_params, &event);
 	if (ret < 0) {
 		goto create_error;
 	}
@@ -602,6 +609,88 @@
 	.cmd = lttng_tracepoint_list_cmd,
 };
 
+static
+long lttng_tracepoint_field_list_cmd(int objd, unsigned int cmd,
+	unsigned long arg, union ust_args *uargs)
+{
+	struct lttng_ust_field_list *list = objd_private(objd);
+	struct lttng_ust_field_iter *tp = &uargs->field_list.entry;
+	struct lttng_ust_field_iter *iter;
+
+	switch (cmd) {
+	case LTTNG_UST_TRACEPOINT_FIELD_LIST_GET:
+	{
+	retry:
+		iter = lttng_ust_field_list_get_iter_next(list);
+		if (!iter)
+			return -ENOENT;
+		if (!strcmp(iter->event_name, "lttng_ust:metadata"))
+			goto retry;
+		memcpy(tp, iter, sizeof(*tp));
+		return 0;
+	}
+	default:
+		return -EINVAL;
+	}
+}
+
+static
+int lttng_abi_tracepoint_field_list(void)
+{
+	int list_objd, ret;
+	struct lttng_ust_field_list *list;
+
+	list_objd = objd_alloc(NULL, &lttng_tracepoint_field_list_ops);
+	if (list_objd < 0) {
+		ret = list_objd;
+		goto objd_error;
+	}
+	list = zmalloc(sizeof(*list));
+	if (!list) {
+		ret = -ENOMEM;
+		goto alloc_error;
+	}
+	objd_set_private(list_objd, list);
+
+	/* populate list by walking on all registered probes. */
+	ret = ltt_probes_get_field_list(list);
+	if (ret) {
+		goto list_error;
+	}
+	return list_objd;
+
+list_error:
+	free(list);
+alloc_error:
+	{
+		int err;
+
+		err = lttng_ust_objd_unref(list_objd);
+		assert(!err);
+	}
+objd_error:
+	return ret;
+}
+
+static
+int lttng_release_tracepoint_field_list(int objd)
+{
+	struct lttng_ust_field_list *list = objd_private(objd);
+
+	if (list) {
+		ltt_probes_prune_field_list(list);
+		free(list);
+		return 0;
+	} else {
+		return -EINVAL;
+	}
+}
+
+static const struct lttng_ust_objd_ops lttng_tracepoint_field_list_ops = {
+	.release = lttng_release_tracepoint_field_list,
+	.cmd = lttng_tracepoint_field_list_cmd,
+};
+
 struct stream_priv_data {
 	struct lttng_ust_lib_ring_buffer *buf;
 	struct ltt_channel *ltt_chan;
@@ -664,7 +753,7 @@
 	 * We tolerate no failure path after event creation. It will stay
 	 * invariant for the rest of the session.
 	 */
-	ret = ltt_event_create(channel, event_param, NULL, &event);
+	ret = ltt_event_create(channel, event_param, &event);
 	if (ret < 0) {
 		goto event_error;
 	}
@@ -946,6 +1035,8 @@
  *		Enable recording for this event (weak enable)
  *	LTTNG_UST_DISABLE
  *		Disable recording for this event (strong disable)
+ *	LTTNG_UST_FILTER
+ *		Attach a filter to an event.
  */
 static
 long lttng_event_cmd(int objd, unsigned int cmd, unsigned long arg,
@@ -962,6 +1053,17 @@
 		return ltt_event_enable(event);
 	case LTTNG_UST_DISABLE:
 		return ltt_event_disable(event);
+	case LTTNG_UST_FILTER:
+	{
+		int ret;
+		ret = lttng_filter_event_attach_bytecode(event,
+				(struct lttng_ust_filter_bytecode *) arg);
+		if (ret)
+			return ret;
+		lttng_filter_event_link_bytecode(event,
+				event->filter_bytecode);
+		return 0;
+	}
 	default:
 		return -EINVAL;
 	}
@@ -999,6 +1101,8 @@
  *		Enable recording for these wildcard events (weak enable)
  *	LTTNG_UST_DISABLE
  *		Disable recording for these wildcard events (strong disable)
+ *	LTTNG_UST_FILTER
+ *		Attach a filter to a wildcard.
  */
 static
 long lttng_wildcard_cmd(int objd, unsigned int cmd, unsigned long arg,
@@ -1018,6 +1122,17 @@
 		return ltt_wildcard_enable(wildcard);
 	case LTTNG_UST_DISABLE:
 		return ltt_wildcard_disable(wildcard);
+	case LTTNG_UST_FILTER:
+	{
+		int ret;
+
+		ret = lttng_filter_wildcard_attach_bytecode(wildcard,
+				(struct lttng_ust_filter_bytecode *) arg);
+		if (ret)
+			return ret;
+		lttng_filter_wildcard_link_bytecode(wildcard);
+		return 0;
+	}
 	default:
 		return -EINVAL;
 	}

=== modified file 'liblttng-ust/lttng-ust-comm.c'
--- liblttng-ust/lttng-ust-comm.c	2012-06-29 16:47:49 +0000
+++ liblttng-ust/lttng-ust-comm.c	2012-09-11 15:34:43 +0000
@@ -22,7 +22,6 @@
 #define _LGPL_SOURCE
 #include <sys/types.h>
 #include <sys/socket.h>
-#include <sys/prctl.h>
 #include <sys/mman.h>
 #include <sys/stat.h>
 #include <sys/types.h>
@@ -44,8 +43,10 @@
 #include <lttng/ust.h>
 #include <ust-comm.h>
 #include <usterr-signal-safe.h>
+#include <helper.h>
 #include "tracepoint-internal.h"
 #include "ltt-tracer-core.h"
+#include "compat.h"
 #include "../libringbuffer/tlsfixup.h"
 
 /*
@@ -175,7 +176,6 @@
 int register_app_to_sessiond(int socket)
 {
 	ssize_t ret;
-	int prctl_ret;
 	struct {
 		uint32_t major;
 		uint32_t minor;
@@ -194,11 +194,7 @@
 	reg_msg.uid = getuid();
 	reg_msg.gid = getgid();
 	reg_msg.bits_per_long = CAA_BITS_PER_LONG;
-	prctl_ret = prctl(PR_GET_NAME, (unsigned long) reg_msg.name, 0, 0, 0);
-	if (prctl_ret) {
-		ERR("Error executing prctl");
-		return -errno;
-	}
+	lttng_ust_getprocname(reg_msg.name);
 
 	ret = ustcomm_send_unix_sock(socket, &reg_msg, sizeof(reg_msg));
 	if (ret >= 0 && ret != sizeof(reg_msg))
@@ -256,6 +252,7 @@
 	struct ustcomm_ust_reply lur;
 	int shm_fd, wait_fd;
 	union ust_args args;
+	ssize_t len;
 
 	ust_lock();
 
@@ -285,6 +282,74 @@
 		else
 			ret = lttng_ust_objd_unref(lum->handle);
 		break;
+	case LTTNG_UST_FILTER:
+	{
+		/* Receive filter data */
+		struct lttng_ust_filter_bytecode *bytecode;
+
+		if (lum->u.filter.data_size > FILTER_BYTECODE_MAX_LEN) {
+			ERR("Filter data size is too large: %u bytes\n",
+				lum->u.filter.data_size);
+			ret = -EINVAL;
+			goto error;
+		}
+
+		if (lum->u.filter.reloc_offset > lum->u.filter.data_size - 1) {
+			ERR("Filter reloc offset %u is not within data\n",
+				lum->u.filter.reloc_offset);
+			ret = -EINVAL;
+			goto error;
+		}
+
+		bytecode = zmalloc(sizeof(*bytecode) + lum->u.filter.data_size);
+		if (!bytecode) {
+			ret = -ENOMEM;
+			goto error;
+		}
+		len = ustcomm_recv_unix_sock(sock, bytecode->data,
+				lum->u.filter.data_size);
+		switch (len) {
+		case 0:	/* orderly shutdown */
+			ret = 0;
+			free(bytecode);
+			goto error;
+		case -1:
+			DBG("Receive failed from lttng-sessiond with errno %d", errno);
+			if (errno == ECONNRESET) {
+				ERR("%s remote end closed connection\n", sock_info->name);
+				ret = -EINVAL;
+				free(bytecode);
+				goto error;
+			}
+			ret = -EINVAL;
+			goto end;
+		default:
+			if (len == lum->u.filter.data_size) {
+				DBG("filter data received\n");
+				break;
+			} else {
+				ERR("incorrect filter data message size: %zd\n", len);
+				ret = -EINVAL;
+				free(bytecode);
+				goto end;
+			}
+		}
+		bytecode->len = lum->u.filter.data_size;
+		bytecode->reloc_offset = lum->u.filter.reloc_offset;
+		if (ops->cmd) {
+			ret = ops->cmd(lum->handle, lum->cmd,
+					(unsigned long) bytecode,
+					&args);
+			if (ret) {
+				free(bytecode);
+			}
+			/* don't free bytecode if everything went fine. */
+		} else {
+			ret = -ENOSYS;
+			free(bytecode);
+		}
+		break;
+	}
 	default:
 		if (ops->cmd)
 			ret = ops->cmd(lum->handle, lum->cmd,
@@ -367,6 +432,22 @@
 		}
 	}
 	/*
+	 * LTTNG_UST_TRACEPOINT_FIELD_LIST_GET needs to send the field
+	 * after the reply.
+	 */
+	if (lur.ret_code == USTCOMM_OK) {
+		switch (lum->cmd) {
+		case LTTNG_UST_TRACEPOINT_FIELD_LIST_GET:
+			len = ustcomm_send_unix_sock(sock,
+				&args.field_list.entry,
+				sizeof(args.field_list.entry));
+			if (len != sizeof(args.field_list.entry)) {
+				ret = -1;
+				goto error;
+			}
+		}
+	}
+	/*
 	 * We still have the memory map reference, and the fds have been
 	 * sent to the sessiond. We can therefore close those fds. Note
 	 * that we keep the write side of the wait_fd open, but close
@@ -669,7 +750,7 @@
  * This thread does not allocate any resource, except within
  * handle_message, within mutex protection. This mutex protects against
  * fork and exit.
- * The other moment it allocates resources is at socket connexion, which
+ * The other moment it allocates resources is at socket connection, which
  * is also protected by the mutex.
  */
 static
@@ -855,6 +936,7 @@
 {
 	struct timespec constructor_timeout;
 	sigset_t sig_all_blocked, orig_parent_mask;
+	pthread_attr_t thread_attr;
 	int timeout_mode;
 	int ret;
 
@@ -904,13 +986,22 @@
 		ERR("pthread_sigmask: %s", strerror(ret));
 	}
 
-	ret = pthread_create(&global_apps.ust_listener, NULL,
+	ret = pthread_attr_init(&thread_attr);
+	if (ret) {
+		ERR("pthread_attr_init: %s", strerror(ret));
+	}
+	ret = pthread_attr_setdetachstate(&thread_attr, PTHREAD_CREATE_DETACHED);
+	if (ret) {
+		ERR("pthread_attr_setdetachstate: %s", strerror(ret));
+	}
+
+	ret = pthread_create(&global_apps.ust_listener, &thread_attr,
 			ust_listener_thread, &global_apps);
 	if (ret) {
 		ERR("pthread_create global: %s", strerror(ret));
 	}
 	if (local_apps.allowed) {
-		ret = pthread_create(&local_apps.ust_listener, NULL,
+		ret = pthread_create(&local_apps.ust_listener, &thread_attr,
 				ust_listener_thread, &local_apps);
 		if (ret) {
 			ERR("pthread_create local: %s", strerror(ret));
@@ -918,6 +1009,10 @@
 	} else {
 		handle_register_done(&local_apps);
 	}
+	ret = pthread_attr_destroy(&thread_attr);
+	if (ret) {
+		ERR("pthread_attr_destroy: %s", strerror(ret));
+	}
 
 	/* Restore original signal mask in parent */
 	ret = pthread_sigmask(SIG_SETMASK, &orig_parent_mask, NULL);

=== added file 'liblttng-ust/lttng-ust-uuid.h'
--- liblttng-ust/lttng-ust-uuid.h	1970-01-01 00:00:00 +0000
+++ liblttng-ust/lttng-ust-uuid.h	2012-09-11 15:34:43 +0000
@@ -0,0 +1,54 @@
+#ifndef _LTTNG_UST_UUID_H
+#define _LTTNG_UST_UUID_H
+
+/*
+ * Copyright (C) 2011   Mathieu Desnoyers <mathieu.desnoyers@efficios.com>
+ *
+ * THIS MATERIAL IS PROVIDED AS IS, WITH ABSOLUTELY NO WARRANTY EXPRESSED
+ * OR IMPLIED.  ANY USE IS AT YOUR OWN RISK.
+ *
+ * Permission is hereby granted to use or copy this program
+ * for any purpose,  provided the above notices are retained on all copies.
+ * Permission to modify the code and to distribute modified code is granted,
+ * provided the above notices are retained, and a notice that the code was
+ * modified is included with the above copyright notice.
+ */
+
+#include <config.h>
+#include <lttng/ust-events.h> /* For LTTNG_UST_UUID_LEN */
+/*
+ * Includes final \0.
+ */
+#define LTTNG_UST_UUID_STR_LEN		37
+
+#ifdef LTTNG_UST_HAVE_LIBUUID
+#include <uuid/uuid.h>
+
+static inline
+int lttng_ust_uuid_generate(unsigned char *uuid_out)
+{
+	uuid_generate(uuid_out);
+	return 0;
+}
+
+#elif defined(LTTNG_UST_HAVE_LIBC_UUID)
+#include <uuid.h>
+#include <stdint.h>
+
+static inline
+int lttng_ust_uuid_generate(unsigned char *uuid_out)
+{
+	uint32_t status;
+
+	uuid_create((uuid_t *) uuid_out, &status);
+	if (status == uuid_s_ok)
+		return 0;
+	else
+		return -1;
+}
+
+#else
+#error "LTTng-UST needs to have a UUID generator configured."
+#endif
+
+#endif /* _LTTNG_UST_UUID_H */

=== modified file 'liblttng-ust/tracepoint-internal.h'
--- liblttng-ust/tracepoint-internal.h	2012-06-29 16:47:49 +0000
+++ liblttng-ust/tracepoint-internal.h	2012-09-11 15:34:43 +0000
@@ -32,10 +32,10 @@
 };
 
 extern int tracepoint_probe_register_noupdate(const char *name,
-		void *callback, void *priv,
+		void (*callback)(void), void *priv,
 		const char *signature);
 extern int tracepoint_probe_unregister_noupdate(const char *name,
-		void *callback, void *priv);
+		void (*callback)(void), void *priv);
 extern void tracepoint_probe_update_all(void);
 
 /*

=== modified file 'liblttng-ust/tracepoint.c'
--- liblttng-ust/tracepoint.c	2012-06-29 16:47:49 +0000
+++ liblttng-ust/tracepoint.c	2012-09-11 15:34:43 +0000
@@ -138,7 +138,7 @@
 
 static void *
 tracepoint_entry_add_probe(struct tracepoint_entry *entry,
-			   void *probe, void *data)
+			   void (*probe)(void), void *data)
 {
 	int nr_probes = 0;
 	struct tracepoint_probe *old, *new;
@@ -170,8 +170,8 @@
 }
 
 static void *
-tracepoint_entry_remove_probe(struct tracepoint_entry *entry, void *probe,
-			      void *data)
+tracepoint_entry_remove_probe(struct tracepoint_entry *entry,
+			      void (*probe)(void), void *data)
 {
 	int nr_probes = 0, nr_del = 0, i;
 	struct tracepoint_probe *old, *new;
@@ -391,7 +391,7 @@
 }
 
 static struct tracepoint_probe *
-tracepoint_add_probe(const char *name, void *probe, void *data,
+tracepoint_add_probe(const char *name, void (*probe)(void), void *data,
 		const char *signature)
 {
 	struct tracepoint_entry *entry;
@@ -418,8 +418,8 @@
  * The probe address must at least be aligned on the architecture pointer size.
  * Called with the tracepoint mutex held.
  */
-int __tracepoint_probe_register(const char *name, void *probe, void *data,
-		const char *signature)
+int __tracepoint_probe_register(const char *name, void (*probe)(void),
+		void *data, const char *signature)
 {
 	void *old;
 	int ret = 0;
@@ -440,7 +440,8 @@
 	return ret;
 }
 
-static void *tracepoint_remove_probe(const char *name, void *probe, void *data)
+static void *tracepoint_remove_probe(const char *name, void (*probe)(void),
+		void *data)
 {
 	struct tracepoint_entry *entry;
 	void *old;
@@ -462,7 +463,8 @@
  * @probe: probe function pointer
  * @probe: probe data pointer
  */
-int __tracepoint_probe_unregister(const char *name, void *probe, void *data)
+int __tracepoint_probe_unregister(const char *name, void (*probe)(void),
+		void *data)
 {
 	void *old;
 	int ret = 0;
@@ -499,7 +501,7 @@
  *
  * caller must call tracepoint_probe_update_all()
  */
-int tracepoint_probe_register_noupdate(const char *name, void *probe,
+int tracepoint_probe_register_noupdate(const char *name, void (*probe)(void),
 				       void *data, const char *signature)
 {
 	void *old;
@@ -525,7 +527,7 @@
  * caller must call tracepoint_probe_update_all()
  * Called with the tracepoint mutex held.
  */
-int tracepoint_probe_unregister_noupdate(const char *name, void *probe,
+int tracepoint_probe_unregister_noupdate(const char *name, void (*probe)(void),
 					 void *data)
 {
 	void *old;

=== modified file 'libringbuffer/Makefile.in'
--- libringbuffer/Makefile.in	2012-06-29 16:47:49 +0000
+++ libringbuffer/Makefile.in	2012-09-11 15:34:43 +0000
@@ -1,4 +1,4 @@
-# Makefile.in generated by automake 1.11.3 from Makefile.am.
+# Makefile.in generated by automake 1.11.6 from Makefile.am.
 # @configure_input@
 
 # Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2000, 2001, 2002,
@@ -16,6 +16,23 @@
 @SET_MAKE@
 
 VPATH = @srcdir@
+am__make_dryrun = \
+  { \
+    am__dry=no; \
+    case $$MAKEFLAGS in \
+      *\\[\ \	]*) \
+        echo 'am--echo: ; @echo "AM"  OK' | $(MAKE) -f - 2>/dev/null \
+          | grep '^AM OK$$' >/dev/null || am__dry=yes;; \
+      *) \
+        for am__flg in $$MAKEFLAGS; do \
+          case $$am__flg in \
+            *=*|--*) ;; \
+            *n*) am__dry=yes; break;; \
+          esac; \
+        done;; \
+    esac; \
+    test $$am__dry = yes; \
+  }
 pkgdatadir = $(datadir)/@PACKAGE@
 pkgincludedir = $(includedir)/@PACKAGE@
 pkglibdir = $(libdir)/@PACKAGE@
@@ -92,6 +109,11 @@
 am__v_GEN_0 = @echo "  GEN   " $@;
 SOURCES = $(libringbuffer_la_SOURCES)
 DIST_SOURCES = $(libringbuffer_la_SOURCES)
+am__can_run_installinfo = \
+  case $$AM_UPDATE_INFO_DIR in \
+    n|no|NO) false;; \
+    *) (install-info --version) >/dev/null 2>&1;; \
+  esac
 ETAGS = etags
 CTAGS = ctags
 DISTFILES = $(DIST_COMMON) $(DIST_SOURCES) $(TEXINFOS) $(EXTRA_DIST)
@@ -165,7 +187,6 @@
 SET_MAKE = @SET_MAKE@
 SHELL = @SHELL@
 STRIP = @STRIP@
-TEXINFO = @TEXINFO@
 VERSION = @VERSION@
 abs_builddir = @abs_builddir@
 abs_srcdir = @abs_srcdir@

=== modified file 'libringbuffer/backend_internal.h'
--- libringbuffer/backend_internal.h	2012-06-29 16:47:49 +0000
+++ libringbuffer/backend_internal.h	2012-09-11 15:34:43 +0000
@@ -448,7 +448,7 @@
 
 /* arch-agnostic implementation */
 
-static inline int fls(unsigned int x)
+static inline int lttng_ust_fls(unsigned int x)
 {
 	int r = 32;
 
@@ -481,7 +481,7 @@
 {
 	int order;
 
-	order = fls(count) - 1;
+	order = lttng_ust_fls(count) - 1;
 	if (count & (count - 1))
 		order++;
 	return order;

=== modified file 'libringbuffer/frontend_internal.h'
--- libringbuffer/frontend_internal.h	2012-06-29 16:47:49 +0000
+++ libringbuffer/frontend_internal.h	2012-09-11 15:34:43 +0000
@@ -32,6 +32,8 @@
  */
 
 #include <urcu/compiler.h>
+#include <signal.h>
+#include <pthread.h>
 
 #include <lttng/ringbuffer-config.h>
 #include "backend_types.h"
@@ -397,7 +399,9 @@
 				int wakeup_fd = shm_get_wakeup_fd(handle, &buf->self._ref);
 
 				if (wakeup_fd >= 0) {
-					int ret;
+					sigset_t sigpipe_set, pending_set, old_set;
+					int ret, sigpipe_was_pending = 0;
+
 					/*
 					 * Wake-up the other end by
 					 * writing a null byte in the
@@ -416,13 +420,55 @@
 					 * 2) check if there is data in
 					 *    the buffer.
 					 * 3) wait on the pipe (poll).
-					 */
+					 *
+					 * Discard the SIGPIPE from write(), not
+					 * disturbing any SIGPIPE that might be
+					 * already pending. If a bogus SIGPIPE
+					 * is sent to the entire process
+					 * concurrently by a malicious user, it
+					 * may be simply discarded.
+					 */
+					ret = sigemptyset(&pending_set);
+					assert(!ret);
+					/*
+					 * sigpending returns the mask
+					 * of signals that are _both_
+					 * blocked for the thread _and_
+					 * pending for either the thread
+					 * or the entire process.
+					 */
+					ret = sigpending(&pending_set);
+					assert(!ret);
+					sigpipe_was_pending = sigismember(&pending_set, SIGPIPE);
+					/*
+					 * If sigpipe was pending, it
+					 * means it was already blocked,
+					 * so no need to block it.
+					 */
+					if (!sigpipe_was_pending) {
+						ret = sigemptyset(&sigpipe_set);
+						assert(!ret);
+						ret = sigaddset(&sigpipe_set, SIGPIPE);
+						assert(!ret);
+						ret = pthread_sigmask(SIG_BLOCK, &sigpipe_set, &old_set);
+						assert(!ret);
+					}
 					do {
 						ret = write(wakeup_fd, "", 1);
 					} while (ret == -1L && errno == EINTR);
+					if (ret == -1L && errno == EPIPE && !sigpipe_was_pending) {
+						struct timespec timeout = { 0, 0 };
+						do {
+							ret = sigtimedwait(&sigpipe_set, NULL,
+								&timeout);
+						} while (ret == -1L && errno == EINTR);
+					}
+					if (!sigpipe_was_pending) {
+						ret = pthread_sigmask(SIG_SETMASK, &old_set, NULL);
+						assert(!ret);
+					}
 				}
 			}
-
 		}
 	}
 }

=== modified file 'libringbuffer/getcpu.h'
--- libringbuffer/getcpu.h	2012-06-29 16:47:49 +0000
+++ libringbuffer/getcpu.h	2012-09-11 15:34:43 +0000
@@ -20,7 +20,6 @@
  */
 
 #include <urcu/compiler.h>
-#include <sched.h>
 
 #ifdef LTTNG_UST_DEBUG_VALGRIND
 
@@ -38,6 +37,33 @@
 #else
 
 /*
+ * sched_getcpu.
+ */
+#ifdef __linux__
+
+/* old uClibc versions didn't have sched_getcpu */
+#if defined(__UCLIBC__) && __UCLIBC_MAJOR__ == 0 && \
+	(__UCLIBC_MINOR__ < 9 || \
+	 (__UCLIBC_MINOR__ == 9 && __UCLIBC_SUBLEVEL__ <= 32))
+#include <sys/syscall.h>
+#define __getcpu(cpu, node, cache)	syscall(__NR_getcpu, cpu, node, cache)
+/*
+ * If getcpu is not implemented in the kernel, use cpu 0 as fallback.
+ */
+static inline
+int lttng_ust_get_cpu(void)
+{
+	int cpu, ret;
+
+	ret = __getcpu(&cpu, NULL, NULL);
+	if (caa_unlikely(ret < 0))
+		return 0;
+	return c;
+}
+#else /* __UCLIBC__ */
+#include <sched.h>
+
+/*
  * If getcpu is not implemented in the kernel, use cpu 0 as fallback.
  */
 static inline
@@ -50,6 +76,23 @@
 		return 0;
 	return cpu;
 }
+#endif	/* __UCLIBC__ */
+
+#elif (defined(__FreeBSD__) || defined(__CYGWIN__))
+
+/*
+ * FreeBSD and Cygwin do not allow query of CPU ID. Always use CPU
+ * number 0, with the assocated performance degradation on SMP.
+ */
+static inline
+int lttng_ust_get_cpu(void)
+{
+	return 0;
+}
+
+#else
+#error "Please add support for your OS into liblttng-ust/compat.h."
+#endif
 
 #endif
 

=== modified file 'libringbuffer/ring_buffer_frontend.c'
--- libringbuffer/ring_buffer_frontend.c	2012-06-29 16:47:49 +0000
+++ libringbuffer/ring_buffer_frontend.c	2012-09-11 15:34:43 +0000
@@ -67,6 +67,7 @@
 #include "frontend.h"
 #include "shm.h"
 #include "tlsfixup.h"
+#include "../liblttng-ust/compat.h"	/* For ENODATA */
 
 #ifndef max
 #define max(a, b)	((a) > (b) ? (a) : (b))

=== modified file 'libringbuffer/shm.c'
--- libringbuffer/shm.c	2012-06-29 16:47:49 +0000
+++ libringbuffer/shm.c	2012-09-11 15:34:43 +0000
@@ -87,7 +87,7 @@
 	int shmfd, waitfd[2], ret, i, sigblocked = 0;
 	struct shm_object *obj;
 	char *memory_map;
-	char tmp_name[NAME_MAX] = "ust-shm-tmp-XXXXXX";
+	char tmp_name[NAME_MAX] = "/ust-shm-tmp-XXXXXX";
 	sigset_t all_sigs, orig_sigs;
 
 	if (table->allocated_len >= table->size)

=== modified file 'snprintf/Makefile.in'
--- snprintf/Makefile.in	2012-06-29 16:47:49 +0000
+++ snprintf/Makefile.in	2012-09-11 15:34:43 +0000
@@ -1,4 +1,4 @@
-# Makefile.in generated by automake 1.11.3 from Makefile.am.
+# Makefile.in generated by automake 1.11.6 from Makefile.am.
 # @configure_input@
 
 # Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2000, 2001, 2002,
@@ -16,6 +16,23 @@
 @SET_MAKE@
 
 VPATH = @srcdir@
+am__make_dryrun = \
+  { \
+    am__dry=no; \
+    case $$MAKEFLAGS in \
+      *\\[\ \	]*) \
+        echo 'am--echo: ; @echo "AM"  OK' | $(MAKE) -f - 2>/dev/null \
+          | grep '^AM OK$$' >/dev/null || am__dry=yes;; \
+      *) \
+        for am__flg in $$MAKEFLAGS; do \
+          case $$am__flg in \
+            *=*|--*) ;; \
+            *n*) am__dry=yes; break;; \
+          esac; \
+        done;; \
+    esac; \
+    test $$am__dry = yes; \
+  }
 pkgdatadir = $(datadir)/@PACKAGE@
 pkgincludedir = $(includedir)/@PACKAGE@
 pkglibdir = $(libdir)/@PACKAGE@
@@ -93,6 +110,11 @@
 am__v_GEN_0 = @echo "  GEN   " $@;
 SOURCES = $(libustsnprintf_la_SOURCES)
 DIST_SOURCES = $(libustsnprintf_la_SOURCES)
+am__can_run_installinfo = \
+  case $$AM_UPDATE_INFO_DIR in \
+    n|no|NO) false;; \
+    *) (install-info --version) >/dev/null 2>&1;; \
+  esac
 ETAGS = etags
 CTAGS = ctags
 DISTFILES = $(DIST_COMMON) $(DIST_SOURCES) $(TEXINFOS) $(EXTRA_DIST)
@@ -166,7 +188,6 @@
 SET_MAKE = @SET_MAKE@
 SHELL = @SHELL@
 STRIP = @STRIP@
-TEXINFO = @TEXINFO@
 VERSION = @VERSION@
 abs_builddir = @abs_builddir@
 abs_srcdir = @abs_srcdir@

=== modified file 'snprintf/fflush.c'
--- snprintf/fflush.c	2010-03-18 16:18:28 +0000
+++ snprintf/fflush.c	2012-09-11 15:34:43 +0000
@@ -36,7 +36,7 @@
 #include "local.h"
 
 /* Flush a single file, or (if fp is NULL) all files.  */
-int ust_safe_fflush(LFILE *fp)
+int ust_safe_fflush(LTTNG_UST_LFILE *fp)
 {
 
 	if (fp == NULL)
@@ -50,7 +50,7 @@
 }
 
 int
-__sflush(LFILE *fp)
+__sflush(LTTNG_UST_LFILE *fp)
 {
 	unsigned char *p;
 	int n, t;

=== modified file 'snprintf/fileext.h'
--- snprintf/fileext.h	2010-03-18 16:18:28 +0000
+++ snprintf/fileext.h	2012-09-11 15:34:43 +0000
@@ -32,12 +32,12 @@
 /*
  * file extension
  */
-struct __sfileext {
-	struct	__sbuf _ub; /* ungetc buffer */
+struct __lttng_ust_sfileext {
+	struct	__lttng_ust_sbuf _ub; /* ungetc buffer */
 	struct wchar_io_data _wcio;	/* wide char io status */
 };
 
-#define _EXT(fp) ((struct __sfileext *)((fp)->_ext._base))
+#define _EXT(fp) ((struct __lttng_ust_sfileext *)((fp)->_ext._base))
 #define _UB(fp) _EXT(fp)->_ub
 
 #define _FILEEXT_INIT(fp) \

=== modified file 'snprintf/fvwrite.c'
--- snprintf/fvwrite.c	2010-03-18 16:18:28 +0000
+++ snprintf/fvwrite.c	2012-09-11 15:34:43 +0000
@@ -46,11 +46,11 @@
  * to the three different kinds of output buffering is handled here.
  */
 int
-__sfvwrite(LFILE *fp, struct __suio *uio)
+__sfvwrite(LTTNG_UST_LFILE *fp, struct __lttng_ust_suio *uio)
 {
 	size_t len;
 	char *p;
-	struct __siov *iov;
+	struct __lttng_ust_siov *iov;
 	int w, s;
 	char *nl;
 	int nlknown, nldist;

=== modified file 'snprintf/fvwrite.h'
--- snprintf/fvwrite.h	2010-03-18 16:18:28 +0000
+++ snprintf/fvwrite.h	2012-09-11 15:34:43 +0000
@@ -35,14 +35,14 @@
 /*
  * I/O descriptors for __sfvwrite().
  */
-struct __siov {
+struct __lttng_ust_siov {
 	void	*iov_base;
 	size_t	iov_len;
 };
-struct __suio {
-	struct	__siov *uio_iov;
+struct __lttng_ust_suio {
+	struct	__lttng_ust_siov *uio_iov;
 	int	uio_iovcnt;
 	int	uio_resid;
 };
 
-extern int __sfvwrite(LFILE *, struct __suio *);
+extern int __sfvwrite(LTTNG_UST_LFILE *, struct __lttng_ust_suio *);

=== modified file 'snprintf/local.h'
--- snprintf/local.h	2010-03-18 16:18:28 +0000
+++ snprintf/local.h	2012-09-11 15:34:43 +0000
@@ -42,27 +42,27 @@
 #include "wcio.h"
 #include "fileext.h"
 
-int	__sflush(LFILE *);
-LFILE	*__sfp(void);
-int	__srefill(LFILE *);
+int	__sflush(LTTNG_UST_LFILE *);
+LTTNG_UST_LFILE	*__sfp(void);
+int	__srefill(LTTNG_UST_LFILE *);
 int	__sread(void *, char *, int);
 int	__swrite(void *, const char *, int);
 fpos_t	__sseek(void *, fpos_t, int);
 int	__sclose(void *);
 void	__sinit(void);
 void	_cleanup(void);
-void	__smakebuf(LFILE *);
-int	__swhatbuf(LFILE *, size_t *, int *);
-int	_fwalk(int (*)(LFILE *));
-int	__swsetup(LFILE *);
+void	__smakebuf(LTTNG_UST_LFILE *);
+int	__swhatbuf(LTTNG_UST_LFILE *, size_t *, int *);
+int	_fwalk(int (*)(LTTNG_UST_LFILE *));
+int	__swsetup(LTTNG_UST_LFILE *);
 int	__sflags(const char *, int *);
-wint_t __fgetwc_unlock(LFILE *);
+wint_t __fgetwc_unlock(LTTNG_UST_LFILE *);
 
 extern void __atexit_register_cleanup(void (*)(void));
 extern int __sdidinit;
 
 /*
- * Return true if the given LFILE cannot be written now.
+ * Return true if the given LTTNG_UST_LFILE cannot be written now.
  */
 #define	cantwrite(fp) \
 	((((fp)->_flags & __SWR) == 0 || (fp)->_bf._base == NULL) && \

=== modified file 'snprintf/snprintf.c'
--- snprintf/snprintf.c	2010-03-18 16:18:28 +0000
+++ snprintf/snprintf.c	2012-09-11 15:34:43 +0000
@@ -42,8 +42,8 @@
 {
 	int ret;
 	char dummy;
-	LFILE f;
-	struct __sfileext fext;
+	LTTNG_UST_LFILE f;
+	struct __lttng_ust_sfileext fext;
 
 	/* While snprintf(3) specifies size_t stdio uses an int internally */
 	if (n > INT_MAX)

=== modified file 'snprintf/various.h'
--- snprintf/various.h	2010-03-18 16:18:28 +0000
+++ snprintf/various.h	2012-09-11 15:34:43 +0000
@@ -35,7 +35,7 @@
 
 #include <stdarg.h>
 
-struct __sbuf {
+struct __lttng_ust_sbuf {
         unsigned char *_base;
         int     _size;
 };
@@ -64,13 +64,13 @@
  * _ub._base becomes non-nil (i.e., a stream has ungetc() data iff
  * _ub._base!=NULL) and _up and _ur save the current values of _p and _r.
  */
-typedef struct __sFILE {
+typedef struct __lttng_ust_sFILE {
         unsigned char *_p;      /* current position in (some) buffer */
         int     _r;             /* read space left for getc() */
         int     _w;             /* write space left for putc() */
         short   _flags;         /* flags, below; this FILE is free if 0 */
         short   _file;          /* fileno, if Unix descriptor, else -1 */
-        struct  __sbuf _bf;     /* the buffer (at least 1 byte, if !NULL) */
+        struct  __lttng_ust_sbuf _bf;     /* the buffer (at least 1 byte, if !NULL) */
         int     _lbfsize;       /* 0 or -_bf._size, for inline putc */
 
         /* operations */
@@ -81,7 +81,7 @@
         int     (*_write)(void *, const char *, int);
 
         /* extension data, to avoid further ABI breakage */
-        struct  __sbuf _ext;
+        struct  __lttng_ust_sbuf _ext;
         /* data for long sequences of ungetc() */
         unsigned char *_up;     /* saved _p when _p is doing ungetc data */
         int     _ur;            /* saved _r when _r is counting ungetc data */
@@ -91,12 +91,12 @@
         unsigned char _nbuf[1]; /* guarantee a getc() buffer */
 
         /* separate buffer for fgetln() when line crosses buffer boundary */
-        struct  __sbuf _lb;     /* buffer for fgetln() */
+        struct  __lttng_ust_sbuf _lb;     /* buffer for fgetln() */
 
         /* Unix stdio files get aligned to block boundaries on fseek() */
         int     _blksize;       /* stat.st_blksize (may be != _bf._size) */
         fpos_t  _offset;        /* current lseek offset */
-} LFILE;
+} LTTNG_UST_LFILE;
 
 #define __SLBF  0x0001          /* line buffered */
 #define __SNBF  0x0002          /* unbuffered */
@@ -117,8 +117,8 @@
 
 #define __sferror(p)    (((p)->_flags & __SERR) != 0)
 
-extern int ust_safe_fflush(LFILE *fp);
-extern int ust_safe_vfprintf(LFILE *fp, const char *fmt0, va_list ap);
+extern int ust_safe_fflush(LTTNG_UST_LFILE *fp);
+extern int ust_safe_vfprintf(LTTNG_UST_LFILE *fp, const char *fmt0, va_list ap);
 
 extern size_t ust_safe_mbrtowc(wchar_t *pwc, const char *s, size_t n, mbstate_t *ps);
 

=== modified file 'snprintf/vfprintf.c'
--- snprintf/vfprintf.c	2011-07-19 20:46:09 +0000
+++ snprintf/vfprintf.c	2012-09-11 15:34:43 +0000
@@ -92,7 +92,7 @@
  * then reset it so that it can be reused.
  */
 static int
-__sprint(LFILE *fp, struct __suio *uio)
+__sprint(LTTNG_UST_LFILE *fp, struct __lttng_ust_suio *uio)
 {
 	int err;
 
@@ -112,10 +112,10 @@
  * worries about ungetc buffers and so forth.
  */
 //static int
-//__sbprintf(LFILE *fp, const char *fmt, va_list ap)
+//__sbprintf(LTTNG_UST_LFILE *fp, const char *fmt, va_list ap)
 //{
 //	int ret;
-//	LFILE fake;
+//	LTTNG_UST_LFILE fake;
 //	struct __sfileext fakeext;
 //	unsigned char buf[BUFSIZ];
 //
@@ -189,13 +189,13 @@
 #define CHARINT		0x0800		/* 8 bit integer */
 #define MAXINT		0x1000		/* largest integer size (intmax_t) */
 
-int ust_safe_vfprintf(LFILE *fp, const char *fmt0, va_list ap)
+int ust_safe_vfprintf(LTTNG_UST_LFILE *fp, const char *fmt0, va_list ap)
 {
 	char *fmt;		/* format string */
 	int ch;			/* character from fmt */
 	int n, n2;		/* handy integers (short term usage) */
 	char *cp;		/* handy char pointer (short term usage) */
-	struct __siov *iovp;	/* for PRINT macro */
+	struct __lttng_ust_siov *iovp;	/* for PRINT macro */
 	int flags;		/* flags as above */
 	int ret;		/* return value accumulator */
 	int width;		/* width from format (%8d), or 0 */
@@ -241,8 +241,8 @@
 	int size;		/* size of converted field or string */
 	const char *xdigs = NULL;	/* digits for %[xX] conversion */
 #define NIOV 8
-	struct __suio uio;	/* output information: summary */
-	struct __siov iov[NIOV];/* ... and individual io vectors */
+	struct __lttng_ust_suio uio;	/* output information: summary */
+	struct __lttng_ust_siov iov[NIOV];/* ... and individual io vectors */
 	char buf[BUF];		/* buffer with space for digits of uintmax_t */
 	char ox[2];		/* space for 0x; ox[1] is either x, X, or \0 */
 	union arg *argtable;	/* args, built due to positional arg */

=== modified file 'snprintf/wsetup.c'
--- snprintf/wsetup.c	2010-03-18 16:18:28 +0000
+++ snprintf/wsetup.c	2012-09-11 15:34:43 +0000
@@ -42,7 +42,7 @@
  * _wsetup returns 0 if OK to write, nonzero otherwise.
  */
 int
-__swsetup(LFILE *fp)
+__swsetup(LTTNG_UST_LFILE *fp)
 {
 	/* make sure stdio is set up */
 //	if (!__sdidinit)

=== modified file 'tests/Makefile.in'
--- tests/Makefile.in	2012-06-29 16:47:49 +0000
+++ tests/Makefile.in	2012-09-11 15:34:43 +0000
@@ -1,4 +1,4 @@
-# Makefile.in generated by automake 1.11.3 from Makefile.am.
+# Makefile.in generated by automake 1.11.6 from Makefile.am.
 # @configure_input@
 
 # Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2000, 2001, 2002,
@@ -17,6 +17,23 @@
 
 
 VPATH = @srcdir@
+am__make_dryrun = \
+  { \
+    am__dry=no; \
+    case $$MAKEFLAGS in \
+      *\\[\ \	]*) \
+        echo 'am--echo: ; @echo "AM"  OK' | $(MAKE) -f - 2>/dev/null \
+          | grep '^AM OK$$' >/dev/null || am__dry=yes;; \
+      *) \
+        for am__flg in $$MAKEFLAGS; do \
+          case $$am__flg in \
+            *=*|--*) ;; \
+            *n*) am__dry=yes; break;; \
+          esac; \
+        done;; \
+    esac; \
+    test $$am__dry = yes; \
+  }
 pkgdatadir = $(datadir)/@PACKAGE@
 pkgincludedir = $(includedir)/@PACKAGE@
 pkglibdir = $(libdir)/@PACKAGE@
@@ -100,6 +117,11 @@
 	install-pdf-recursive install-ps-recursive install-recursive \
 	installcheck-recursive installdirs-recursive pdf-recursive \
 	ps-recursive uninstall-recursive
+am__can_run_installinfo = \
+  case $$AM_UPDATE_INFO_DIR in \
+    n|no|NO) false;; \
+    *) (install-info --version) >/dev/null 2>&1;; \
+  esac
 RECURSIVE_CLEAN_TARGETS = mostlyclean-recursive clean-recursive	\
   distclean-recursive maintainer-clean-recursive
 AM_RECURSIVE_TARGETS = $(RECURSIVE_TARGETS:-recursive=) \
@@ -204,7 +226,6 @@
 SET_MAKE = @SET_MAKE@
 SHELL = @SHELL@
 STRIP = @STRIP@
-TEXINFO = @TEXINFO@
 VERSION = @VERSION@
 abs_builddir = @abs_builddir@
 abs_srcdir = @abs_srcdir@
@@ -515,13 +536,10 @@
 	done
 	@list='$(DIST_SUBDIRS)'; for subdir in $$list; do \
 	  if test "$$subdir" = .; then :; else \
-	    test -d "$(distdir)/$$subdir" \
-	    || $(MKDIR_P) "$(distdir)/$$subdir" \
-	    || exit 1; \
-	  fi; \
-	done
-	@list='$(DIST_SUBDIRS)'; for subdir in $$list; do \
-	  if test "$$subdir" = .; then :; else \
+	    $(am__make_dryrun) \
+	      || test -d "$(distdir)/$$subdir" \
+	      || $(MKDIR_P) "$(distdir)/$$subdir" \
+	      || exit 1; \
 	    dir1=$$subdir; dir2="$(distdir)/$$subdir"; \
 	    $(am__relativize); \
 	    new_distdir=$$reldir; \

=== modified file 'tests/demo/Makefile.am'
--- tests/demo/Makefile.am	2012-06-29 16:47:49 +0000
+++ tests/demo/Makefile.am	2012-09-11 15:34:43 +0000
@@ -33,5 +33,11 @@
 
 noinst_PROGRAMS = demo
 demo_SOURCES = demo.c ust_tests_demo.h
-# The demo program only depends on libdl.
-demo_LDFLAGS = -ldl
+# The demo program only depends on libdl/libc for dlopen().
+if LTTNG_UST_BUILD_WITH_LIBDL
+demo_LDADD = -ldl
+endif
+if LTTNG_UST_BUILD_WITH_LIBC_DL
+demo_LDADD = -lc
+endif
+

=== modified file 'tests/demo/Makefile.in'
--- tests/demo/Makefile.in	2012-06-29 16:47:49 +0000
+++ tests/demo/Makefile.in	2012-09-11 15:34:43 +0000
@@ -1,4 +1,4 @@
-# Makefile.in generated by automake 1.11.3 from Makefile.am.
+# Makefile.in generated by automake 1.11.6 from Makefile.am.
 # @configure_input@
 
 # Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2000, 2001, 2002,
@@ -17,6 +17,23 @@
 
 
 VPATH = @srcdir@
+am__make_dryrun = \
+  { \
+    am__dry=no; \
+    case $$MAKEFLAGS in \
+      *\\[\ \	]*) \
+        echo 'am--echo: ; @echo "AM"  OK' | $(MAKE) -f - 2>/dev/null \
+          | grep '^AM OK$$' >/dev/null || am__dry=yes;; \
+      *) \
+        for am__flg in $$MAKEFLAGS; do \
+          case $$am__flg in \
+            *=*|--*) ;; \
+            *n*) am__dry=yes; break;; \
+          esac; \
+        done;; \
+    esac; \
+    test $$am__dry = yes; \
+  }
 pkgdatadir = $(datadir)/@PACKAGE@
 pkgincludedir = $(includedir)/@PACKAGE@
 pkglibdir = $(libdir)/@PACKAGE@
@@ -79,10 +96,7 @@
 PROGRAMS = $(noinst_PROGRAMS)
 am_demo_OBJECTS = demo.$(OBJEXT)
 demo_OBJECTS = $(am_demo_OBJECTS)
-demo_LDADD = $(LDADD)
-demo_LINK = $(LIBTOOL) $(AM_V_lt) --tag=CC $(AM_LIBTOOLFLAGS) \
-	$(LIBTOOLFLAGS) --mode=link $(CCLD) $(AM_CFLAGS) $(CFLAGS) \
-	$(demo_LDFLAGS) $(LDFLAGS) -o $@
+demo_DEPENDENCIES =
 DEFAULT_INCLUDES = -I.@am__isrc@ -I$(top_builddir) -I$(top_builddir)/include/lttng
 depcomp = $(SHELL) $(top_srcdir)/config/depcomp
 am__depfiles_maybe = depfiles
@@ -115,6 +129,11 @@
 DIST_SOURCES = $(liblttng_ust_provider_ust_tests_demo_la_SOURCES) \
 	$(liblttng_ust_provider_ust_tests_demo3_la_SOURCES) \
 	$(demo_SOURCES)
+am__can_run_installinfo = \
+  case $$AM_UPDATE_INFO_DIR in \
+    n|no|NO) false;; \
+    *) (install-info --version) >/dev/null 2>&1;; \
+  esac
 ETAGS = etags
 CTAGS = ctags
 DISTFILES = $(DIST_COMMON) $(DIST_SOURCES) $(TEXINFOS) $(EXTRA_DIST)
@@ -191,7 +210,6 @@
 SET_MAKE = @SET_MAKE@
 SHELL = @SHELL@
 STRIP = @STRIP@
-TEXINFO = @TEXINFO@
 VERSION = @VERSION@
 abs_builddir = @abs_builddir@
 abs_srcdir = @abs_srcdir@
@@ -287,8 +305,9 @@
 	$(FORCE_SHARED_LIB_OPTIONS)
 
 demo_SOURCES = demo.c ust_tests_demo.h
-# The demo program only depends on libdl.
-demo_LDFLAGS = -ldl
+@LTTNG_UST_BUILD_WITH_LIBC_DL_TRUE@demo_LDADD = -lc
+# The demo program only depends on libdl/libc for dlopen().
+@LTTNG_UST_BUILD_WITH_LIBDL_TRUE@demo_LDADD = -ldl
 all: all-am
 
 .SUFFIXES:
@@ -347,7 +366,7 @@
 	rm -f $$list
 demo$(EXEEXT): $(demo_OBJECTS) $(demo_DEPENDENCIES) $(EXTRA_demo_DEPENDENCIES) 
 	@rm -f demo$(EXEEXT)
-	$(AM_V_CCLD)$(demo_LINK) $(demo_OBJECTS) $(demo_LDADD) $(LIBS)
+	$(AM_V_CCLD)$(LINK) $(demo_OBJECTS) $(demo_LDADD) $(LIBS)
 
 mostlyclean-compile:
 	-rm -f *.$(OBJEXT)

=== modified file 'tests/demo/README'
--- tests/demo/README	2012-06-29 16:47:49 +0000
+++ tests/demo/README	2012-09-11 15:34:43 +0000
@@ -4,7 +4,8 @@
 executing the demo. Executing "demo" without the shell wrapper will not
 provide any tracing support. This ensures the demo binary can be
 distributed on distros without depending on having liblttng-ust.so in
-place. Note: the "demo" program must be compiled with "-ldl".
+place. Note: the "demo" program must be compiled with "-ldl" on Linux,
+with "-lc" on BSD.
 
 The simplest command to trace the demo program are:
 lttng create

=== modified file 'tests/fork/Makefile.am'
--- tests/fork/Makefile.am	2012-06-29 16:47:49 +0000
+++ tests/fork/Makefile.am	2012-09-11 15:34:43 +0000
@@ -8,5 +8,14 @@
 fork2_LDADD = $(top_builddir)/liblttng-ust/liblttng-ust.la \
 		$(top_builddir)/liblttng-ust-fork/liblttng-ust-fork.la
 
+if LTTNG_UST_BUILD_WITH_LIBDL
+fork_LDADD += -ldl
+fork2_LDADD += -ldl
+endif
+if LTTNG_UST_BUILD_WITH_LIBC_DL
+fork_LDADD += -lc
+fork2_LDADD += -lc
+endif
+
 noinst_SCRIPTS = run
 EXTRA_DIST = run

=== modified file 'tests/fork/Makefile.in'
--- tests/fork/Makefile.in	2012-06-29 16:47:49 +0000
+++ tests/fork/Makefile.in	2012-09-11 15:34:43 +0000
@@ -1,4 +1,4 @@
-# Makefile.in generated by automake 1.11.3 from Makefile.am.
+# Makefile.in generated by automake 1.11.6 from Makefile.am.
 # @configure_input@
 
 # Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2000, 2001, 2002,
@@ -17,6 +17,23 @@
 
 
 VPATH = @srcdir@
+am__make_dryrun = \
+  { \
+    am__dry=no; \
+    case $$MAKEFLAGS in \
+      *\\[\ \	]*) \
+        echo 'am--echo: ; @echo "AM"  OK' | $(MAKE) -f - 2>/dev/null \
+          | grep '^AM OK$$' >/dev/null || am__dry=yes;; \
+      *) \
+        for am__flg in $$MAKEFLAGS; do \
+          case $$am__flg in \
+            *=*|--*) ;; \
+            *n*) am__dry=yes; break;; \
+          esac; \
+        done;; \
+    esac; \
+    test $$am__dry = yes; \
+  }
 pkgdatadir = $(datadir)/@PACKAGE@
 pkgincludedir = $(includedir)/@PACKAGE@
 pkglibdir = $(libdir)/@PACKAGE@
@@ -37,6 +54,10 @@
 host_triplet = @host@
 target_triplet = @target@
 noinst_PROGRAMS = fork$(EXEEXT) fork2$(EXEEXT)
+@LTTNG_UST_BUILD_WITH_LIBDL_TRUE@am__append_1 = -ldl
+@LTTNG_UST_BUILD_WITH_LIBDL_TRUE@am__append_2 = -ldl
+@LTTNG_UST_BUILD_WITH_LIBC_DL_TRUE@am__append_3 = -lc
+@LTTNG_UST_BUILD_WITH_LIBC_DL_TRUE@am__append_4 = -lc
 subdir = tests/fork
 DIST_COMMON = README $(srcdir)/Makefile.am $(srcdir)/Makefile.in
 ACLOCAL_M4 = $(top_srcdir)/aclocal.m4
@@ -55,15 +76,18 @@
 PROGRAMS = $(noinst_PROGRAMS)
 am_fork_OBJECTS = fork.$(OBJEXT)
 fork_OBJECTS = $(am_fork_OBJECTS)
+am__DEPENDENCIES_1 =
 fork_DEPENDENCIES = $(top_builddir)/liblttng-ust/liblttng-ust.la \
-	$(top_builddir)/liblttng-ust-fork/liblttng-ust-fork.la
+	$(top_builddir)/liblttng-ust-fork/liblttng-ust-fork.la \
+	$(am__DEPENDENCIES_1) $(am__DEPENDENCIES_1)
 AM_V_lt = $(am__v_lt_@AM_V@)
 am__v_lt_ = $(am__v_lt_@AM_DEFAULT_V@)
 am__v_lt_0 = --silent
 am_fork2_OBJECTS = fork2.$(OBJEXT)
 fork2_OBJECTS = $(am_fork2_OBJECTS)
 fork2_DEPENDENCIES = $(top_builddir)/liblttng-ust/liblttng-ust.la \
-	$(top_builddir)/liblttng-ust-fork/liblttng-ust-fork.la
+	$(top_builddir)/liblttng-ust-fork/liblttng-ust-fork.la \
+	$(am__DEPENDENCIES_1) $(am__DEPENDENCIES_1)
 SCRIPTS = $(noinst_SCRIPTS)
 DEFAULT_INCLUDES = -I.@am__isrc@ -I$(top_builddir) -I$(top_builddir)/include/lttng
 depcomp = $(SHELL) $(top_srcdir)/config/depcomp
@@ -93,6 +117,11 @@
 am__v_GEN_0 = @echo "  GEN   " $@;
 SOURCES = $(fork_SOURCES) $(fork2_SOURCES)
 DIST_SOURCES = $(fork_SOURCES) $(fork2_SOURCES)
+am__can_run_installinfo = \
+  case $$AM_UPDATE_INFO_DIR in \
+    n|no|NO) false;; \
+    *) (install-info --version) >/dev/null 2>&1;; \
+  esac
 ETAGS = etags
 CTAGS = ctags
 DISTFILES = $(DIST_COMMON) $(DIST_SOURCES) $(TEXINFOS) $(EXTRA_DIST)
@@ -166,7 +195,6 @@
 SET_MAKE = @SET_MAKE@
 SHELL = @SHELL@
 STRIP = @STRIP@
-TEXINFO = @TEXINFO@
 VERSION = @VERSION@
 abs_builddir = @abs_builddir@
 abs_srcdir = @abs_srcdir@
@@ -228,12 +256,12 @@
 AM_CPPFLAGS = -I$(top_srcdir)/include -Wsystem-headers
 fork_SOURCES = fork.c ust_tests_fork.h
 fork_LDADD = $(top_builddir)/liblttng-ust/liblttng-ust.la \
-		$(top_builddir)/liblttng-ust-fork/liblttng-ust-fork.la
-
+	$(top_builddir)/liblttng-ust-fork/liblttng-ust-fork.la \
+	$(am__append_1) $(am__append_3)
 fork2_SOURCES = fork2.c
 fork2_LDADD = $(top_builddir)/liblttng-ust/liblttng-ust.la \
-		$(top_builddir)/liblttng-ust-fork/liblttng-ust-fork.la
-
+	$(top_builddir)/liblttng-ust-fork/liblttng-ust-fork.la \
+	$(am__append_2) $(am__append_4)
 noinst_SCRIPTS = run
 EXTRA_DIST = run
 all: all-am

=== modified file 'tests/hello-static-lib/Makefile.am'
--- tests/hello-static-lib/Makefile.am	2012-06-29 16:47:49 +0000
+++ tests/hello-static-lib/Makefile.am	2012-09-11 15:34:43 +0000
@@ -8,7 +8,14 @@
 
 noinst_PROGRAMS = hello
 hello_SOURCES = hello.c
-hello_LDADD = -ldl liblttng-ust-provider-ust-test-hello.la
+hello_LDADD = liblttng-ust-provider-ust-test-hello.la
+
+if LTTNG_UST_BUILD_WITH_LIBDL
+hello_LDADD += -ldl
+endif
+if LTTNG_UST_BUILD_WITH_LIBC_DL
+hello_LDADD += -lc
+endif
 
 noinst_SCRIPTS = run
 EXTRA_DIST = run

=== modified file 'tests/hello-static-lib/Makefile.in'
--- tests/hello-static-lib/Makefile.in	2012-06-29 16:47:49 +0000
+++ tests/hello-static-lib/Makefile.in	2012-09-11 15:34:43 +0000
@@ -1,4 +1,4 @@
-# Makefile.in generated by automake 1.11.3 from Makefile.am.
+# Makefile.in generated by automake 1.11.6 from Makefile.am.
 # @configure_input@
 
 # Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2000, 2001, 2002,
@@ -18,6 +18,23 @@
 
 
 VPATH = @srcdir@
+am__make_dryrun = \
+  { \
+    am__dry=no; \
+    case $$MAKEFLAGS in \
+      *\\[\ \	]*) \
+        echo 'am--echo: ; @echo "AM"  OK' | $(MAKE) -f - 2>/dev/null \
+          | grep '^AM OK$$' >/dev/null || am__dry=yes;; \
+      *) \
+        for am__flg in $$MAKEFLAGS; do \
+          case $$am__flg in \
+            *=*|--*) ;; \
+            *n*) am__dry=yes; break;; \
+          esac; \
+        done;; \
+    esac; \
+    test $$am__dry = yes; \
+  }
 pkgdatadir = $(datadir)/@PACKAGE@
 pkgincludedir = $(includedir)/@PACKAGE@
 pkglibdir = $(libdir)/@PACKAGE@
@@ -38,6 +55,8 @@
 host_triplet = @host@
 target_triplet = @target@
 noinst_PROGRAMS = hello$(EXEEXT)
+@LTTNG_UST_BUILD_WITH_LIBDL_TRUE@am__append_1 = -ldl
+@LTTNG_UST_BUILD_WITH_LIBC_DL_TRUE@am__append_2 = -lc
 subdir = tests/hello-static-lib
 DIST_COMMON = $(srcdir)/Makefile.am $(srcdir)/Makefile.in
 ACLOCAL_M4 = $(top_srcdir)/aclocal.m4
@@ -65,7 +84,9 @@
 PROGRAMS = $(noinst_PROGRAMS)
 am_hello_OBJECTS = hello.$(OBJEXT)
 hello_OBJECTS = $(am_hello_OBJECTS)
-hello_DEPENDENCIES = liblttng-ust-provider-ust-test-hello.la
+am__DEPENDENCIES_1 =
+hello_DEPENDENCIES = liblttng-ust-provider-ust-test-hello.la \
+	$(am__DEPENDENCIES_1) $(am__DEPENDENCIES_1)
 SCRIPTS = $(noinst_SCRIPTS)
 DEFAULT_INCLUDES = -I.@am__isrc@ -I$(top_builddir) -I$(top_builddir)/include/lttng
 depcomp = $(SHELL) $(top_srcdir)/config/depcomp
@@ -97,6 +118,11 @@
 	$(hello_SOURCES)
 DIST_SOURCES = $(liblttng_ust_provider_ust_test_hello_la_SOURCES) \
 	$(hello_SOURCES)
+am__can_run_installinfo = \
+  case $$AM_UPDATE_INFO_DIR in \
+    n|no|NO) false;; \
+    *) (install-info --version) >/dev/null 2>&1;; \
+  esac
 ETAGS = etags
 CTAGS = ctags
 DISTFILES = $(DIST_COMMON) $(DIST_SOURCES) $(TEXINFOS) $(EXTRA_DIST)
@@ -170,7 +196,6 @@
 SET_MAKE = @SET_MAKE@
 SHELL = @SHELL@
 STRIP = @STRIP@
-TEXINFO = @TEXINFO@
 VERSION = @VERSION@
 abs_builddir = @abs_builddir@
 abs_srcdir = @abs_srcdir@
@@ -238,7 +263,8 @@
 	$(top_builddir)/liblttng-ust/liblttng-ust.la
 
 hello_SOURCES = hello.c
-hello_LDADD = -ldl liblttng-ust-provider-ust-test-hello.la
+hello_LDADD = liblttng-ust-provider-ust-test-hello.la $(am__append_1) \
+	$(am__append_2)
 noinst_SCRIPTS = run
 EXTRA_DIST = run
 all: all-am

=== modified file 'tests/hello.cxx/Makefile.am'
--- tests/hello.cxx/Makefile.am	2012-06-29 16:47:49 +0000
+++ tests/hello.cxx/Makefile.am	2012-09-11 15:34:43 +0000
@@ -4,5 +4,12 @@
 hello_SOURCES = hello.cpp tp.c ust_tests_hello.h
 hello_LDADD = $(top_builddir)/liblttng-ust/liblttng-ust.la
 
+if LTTNG_UST_BUILD_WITH_LIBDL
+hello_LDADD += -ldl
+endif
+if LTTNG_UST_BUILD_WITH_LIBC_DL
+hello_LDADD += -lc
+endif
+
 noinst_SCRIPTS = run
 EXTRA_DIST = run

=== modified file 'tests/hello.cxx/Makefile.in'
--- tests/hello.cxx/Makefile.in	2012-06-29 16:47:49 +0000
+++ tests/hello.cxx/Makefile.in	2012-09-11 15:34:43 +0000
@@ -1,4 +1,4 @@
-# Makefile.in generated by automake 1.11.3 from Makefile.am.
+# Makefile.in generated by automake 1.11.6 from Makefile.am.
 # @configure_input@
 
 # Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2000, 2001, 2002,
@@ -17,6 +17,23 @@
 
 
 VPATH = @srcdir@
+am__make_dryrun = \
+  { \
+    am__dry=no; \
+    case $$MAKEFLAGS in \
+      *\\[\ \	]*) \
+        echo 'am--echo: ; @echo "AM"  OK' | $(MAKE) -f - 2>/dev/null \
+          | grep '^AM OK$$' >/dev/null || am__dry=yes;; \
+      *) \
+        for am__flg in $$MAKEFLAGS; do \
+          case $$am__flg in \
+            *=*|--*) ;; \
+            *n*) am__dry=yes; break;; \
+          esac; \
+        done;; \
+    esac; \
+    test $$am__dry = yes; \
+  }
 pkgdatadir = $(datadir)/@PACKAGE@
 pkgincludedir = $(includedir)/@PACKAGE@
 pkglibdir = $(libdir)/@PACKAGE@
@@ -37,6 +54,8 @@
 host_triplet = @host@
 target_triplet = @target@
 noinst_PROGRAMS = hello$(EXEEXT)
+@LTTNG_UST_BUILD_WITH_LIBDL_TRUE@am__append_1 = -ldl
+@LTTNG_UST_BUILD_WITH_LIBC_DL_TRUE@am__append_2 = -lc
 subdir = tests/hello.cxx
 DIST_COMMON = README $(srcdir)/Makefile.am $(srcdir)/Makefile.in
 ACLOCAL_M4 = $(top_srcdir)/aclocal.m4
@@ -55,7 +74,9 @@
 PROGRAMS = $(noinst_PROGRAMS)
 am_hello_OBJECTS = hello.$(OBJEXT) tp.$(OBJEXT)
 hello_OBJECTS = $(am_hello_OBJECTS)
-hello_DEPENDENCIES = $(top_builddir)/liblttng-ust/liblttng-ust.la
+am__DEPENDENCIES_1 =
+hello_DEPENDENCIES = $(top_builddir)/liblttng-ust/liblttng-ust.la \
+	$(am__DEPENDENCIES_1) $(am__DEPENDENCIES_1)
 AM_V_lt = $(am__v_lt_@AM_V@)
 am__v_lt_ = $(am__v_lt_@AM_DEFAULT_V@)
 am__v_lt_0 = --silent
@@ -104,6 +125,11 @@
 am__v_GEN_0 = @echo "  GEN   " $@;
 SOURCES = $(hello_SOURCES)
 DIST_SOURCES = $(hello_SOURCES)
+am__can_run_installinfo = \
+  case $$AM_UPDATE_INFO_DIR in \
+    n|no|NO) false;; \
+    *) (install-info --version) >/dev/null 2>&1;; \
+  esac
 ETAGS = etags
 CTAGS = ctags
 DISTFILES = $(DIST_COMMON) $(DIST_SOURCES) $(TEXINFOS) $(EXTRA_DIST)
@@ -177,7 +203,6 @@
 SET_MAKE = @SET_MAKE@
 SHELL = @SHELL@
 STRIP = @STRIP@
-TEXINFO = @TEXINFO@
 VERSION = @VERSION@
 abs_builddir = @abs_builddir@
 abs_srcdir = @abs_srcdir@
@@ -238,7 +263,8 @@
 top_srcdir = @top_srcdir@
 AM_CPPFLAGS = -I$(top_srcdir)/include -Wsystem-headers
 hello_SOURCES = hello.cpp tp.c ust_tests_hello.h
-hello_LDADD = $(top_builddir)/liblttng-ust/liblttng-ust.la
+hello_LDADD = $(top_builddir)/liblttng-ust/liblttng-ust.la \
+	$(am__append_1) $(am__append_2)
 noinst_SCRIPTS = run
 EXTRA_DIST = run
 all: all-am

=== modified file 'tests/hello/Makefile.am'
--- tests/hello/Makefile.am	2012-06-29 16:47:49 +0000
+++ tests/hello/Makefile.am	2012-09-11 15:34:43 +0000
@@ -3,6 +3,14 @@
 noinst_PROGRAMS = hello
 hello_SOURCES = hello.c tp.c ust_tests_hello.h
 hello_LDADD = $(top_builddir)/liblttng-ust/liblttng-ust.la
+hello_CFLAGS = -Werror=old-style-definition
+
+if LTTNG_UST_BUILD_WITH_LIBDL
+hello_LDADD += -ldl
+endif
+if LTTNG_UST_BUILD_WITH_LIBC_DL
+hello_LDADD += -lc
+endif
 
 noinst_SCRIPTS = run
 EXTRA_DIST = run

=== modified file 'tests/hello/Makefile.in'
--- tests/hello/Makefile.in	2012-06-29 16:47:49 +0000
+++ tests/hello/Makefile.in	2012-09-11 15:34:43 +0000
@@ -1,4 +1,4 @@
-# Makefile.in generated by automake 1.11.3 from Makefile.am.
+# Makefile.in generated by automake 1.11.6 from Makefile.am.
 # @configure_input@
 
 # Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2000, 2001, 2002,
@@ -17,6 +17,23 @@
 
 
 VPATH = @srcdir@
+am__make_dryrun = \
+  { \
+    am__dry=no; \
+    case $$MAKEFLAGS in \
+      *\\[\ \	]*) \
+        echo 'am--echo: ; @echo "AM"  OK' | $(MAKE) -f - 2>/dev/null \
+          | grep '^AM OK$$' >/dev/null || am__dry=yes;; \
+      *) \
+        for am__flg in $$MAKEFLAGS; do \
+          case $$am__flg in \
+            *=*|--*) ;; \
+            *n*) am__dry=yes; break;; \
+          esac; \
+        done;; \
+    esac; \
+    test $$am__dry = yes; \
+  }
 pkgdatadir = $(datadir)/@PACKAGE@
 pkgincludedir = $(includedir)/@PACKAGE@
 pkglibdir = $(libdir)/@PACKAGE@
@@ -37,6 +54,8 @@
 host_triplet = @host@
 target_triplet = @target@
 noinst_PROGRAMS = hello$(EXEEXT)
+@LTTNG_UST_BUILD_WITH_LIBDL_TRUE@am__append_1 = -ldl
+@LTTNG_UST_BUILD_WITH_LIBC_DL_TRUE@am__append_2 = -lc
 subdir = tests/hello
 DIST_COMMON = README $(srcdir)/Makefile.am $(srcdir)/Makefile.in
 ACLOCAL_M4 = $(top_srcdir)/aclocal.m4
@@ -53,12 +72,17 @@
 CONFIG_CLEAN_FILES =
 CONFIG_CLEAN_VPATH_FILES =
 PROGRAMS = $(noinst_PROGRAMS)
-am_hello_OBJECTS = hello.$(OBJEXT) tp.$(OBJEXT)
+am_hello_OBJECTS = hello-hello.$(OBJEXT) hello-tp.$(OBJEXT)
 hello_OBJECTS = $(am_hello_OBJECTS)
-hello_DEPENDENCIES = $(top_builddir)/liblttng-ust/liblttng-ust.la
+am__DEPENDENCIES_1 =
+hello_DEPENDENCIES = $(top_builddir)/liblttng-ust/liblttng-ust.la \
+	$(am__DEPENDENCIES_1) $(am__DEPENDENCIES_1)
 AM_V_lt = $(am__v_lt_@AM_V@)
 am__v_lt_ = $(am__v_lt_@AM_DEFAULT_V@)
 am__v_lt_0 = --silent
+hello_LINK = $(LIBTOOL) $(AM_V_lt) --tag=CC $(AM_LIBTOOLFLAGS) \
+	$(LIBTOOLFLAGS) --mode=link $(CCLD) $(hello_CFLAGS) $(CFLAGS) \
+	$(AM_LDFLAGS) $(LDFLAGS) -o $@
 SCRIPTS = $(noinst_SCRIPTS)
 DEFAULT_INCLUDES = -I.@am__isrc@ -I$(top_builddir) -I$(top_builddir)/include/lttng
 depcomp = $(SHELL) $(top_srcdir)/config/depcomp
@@ -88,6 +112,11 @@
 am__v_GEN_0 = @echo "  GEN   " $@;
 SOURCES = $(hello_SOURCES)
 DIST_SOURCES = $(hello_SOURCES)
+am__can_run_installinfo = \
+  case $$AM_UPDATE_INFO_DIR in \
+    n|no|NO) false;; \
+    *) (install-info --version) >/dev/null 2>&1;; \
+  esac
 ETAGS = etags
 CTAGS = ctags
 DISTFILES = $(DIST_COMMON) $(DIST_SOURCES) $(TEXINFOS) $(EXTRA_DIST)
@@ -161,7 +190,6 @@
 SET_MAKE = @SET_MAKE@
 SHELL = @SHELL@
 STRIP = @STRIP@
-TEXINFO = @TEXINFO@
 VERSION = @VERSION@
 abs_builddir = @abs_builddir@
 abs_srcdir = @abs_srcdir@
@@ -222,7 +250,9 @@
 top_srcdir = @top_srcdir@
 AM_CPPFLAGS = -I$(top_srcdir)/include -Wsystem-headers
 hello_SOURCES = hello.c tp.c ust_tests_hello.h
-hello_LDADD = $(top_builddir)/liblttng-ust/liblttng-ust.la
+hello_LDADD = $(top_builddir)/liblttng-ust/liblttng-ust.la \
+	$(am__append_1) $(am__append_2)
+hello_CFLAGS = -Werror=old-style-definition
 noinst_SCRIPTS = run
 EXTRA_DIST = run
 all: all-am
@@ -270,7 +300,7 @@
 	rm -f $$list
 hello$(EXEEXT): $(hello_OBJECTS) $(hello_DEPENDENCIES) $(EXTRA_hello_DEPENDENCIES) 
 	@rm -f hello$(EXEEXT)
-	$(AM_V_CCLD)$(LINK) $(hello_OBJECTS) $(hello_LDADD) $(LIBS)
+	$(AM_V_CCLD)$(hello_LINK) $(hello_OBJECTS) $(hello_LDADD) $(LIBS)
 
 mostlyclean-compile:
 	-rm -f *.$(OBJEXT)
@@ -278,8 +308,8 @@
 distclean-compile:
 	-rm -f *.tab.c
 
-@AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/hello.Po@am__quote@
-@AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/tp.Po@am__quote@
+@AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/hello-hello.Po@am__quote@
+@AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/hello-tp.Po@am__quote@
 
 .c.o:
 @am__fastdepCC_TRUE@	$(AM_V_CC)$(COMPILE) -MT $@ -MD -MP -MF $(DEPDIR)/$*.Tpo -c -o $@ $<
@@ -302,6 +332,34 @@
 @AMDEP_TRUE@@am__fastdepCC_FALSE@	DEPDIR=$(DEPDIR) $(CCDEPMODE) $(depcomp) @AMDEPBACKSLASH@
 @am__fastdepCC_FALSE@	$(AM_V_CC@am__nodep@)$(LTCOMPILE) -c -o $@ $<
 
+hello-hello.o: hello.c
+@am__fastdepCC_TRUE@	$(AM_V_CC)$(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(hello_CFLAGS) $(CFLAGS) -MT hello-hello.o -MD -MP -MF $(DEPDIR)/hello-hello.Tpo -c -o hello-hello.o `test -f 'hello.c' || echo '$(srcdir)/'`hello.c
+@am__fastdepCC_TRUE@	$(AM_V_at)$(am__mv) $(DEPDIR)/hello-hello.Tpo $(DEPDIR)/hello-hello.Po
+@AMDEP_TRUE@@am__fastdepCC_FALSE@	$(AM_V_CC)source='hello.c' object='hello-hello.o' libtool=no @AMDEPBACKSLASH@
+@AMDEP_TRUE@@am__fastdepCC_FALSE@	DEPDIR=$(DEPDIR) $(CCDEPMODE) $(depcomp) @AMDEPBACKSLASH@
+@am__fastdepCC_FALSE@	$(AM_V_CC@am__nodep@)$(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(hello_CFLAGS) $(CFLAGS) -c -o hello-hello.o `test -f 'hello.c' || echo '$(srcdir)/'`hello.c
+
+hello-hello.obj: hello.c
+@am__fastdepCC_TRUE@	$(AM_V_CC)$(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(hello_CFLAGS) $(CFLAGS) -MT hello-hello.obj -MD -MP -MF $(DEPDIR)/hello-hello.Tpo -c -o hello-hello.obj `if test -f 'hello.c'; then $(CYGPATH_W) 'hello.c'; else $(CYGPATH_W) '$(srcdir)/hello.c'; fi`
+@am__fastdepCC_TRUE@	$(AM_V_at)$(am__mv) $(DEPDIR)/hello-hello.Tpo $(DEPDIR)/hello-hello.Po
+@AMDEP_TRUE@@am__fastdepCC_FALSE@	$(AM_V_CC)source='hello.c' object='hello-hello.obj' libtool=no @AMDEPBACKSLASH@
+@AMDEP_TRUE@@am__fastdepCC_FALSE@	DEPDIR=$(DEPDIR) $(CCDEPMODE) $(depcomp) @AMDEPBACKSLASH@
+@am__fastdepCC_FALSE@	$(AM_V_CC@am__nodep@)$(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(hello_CFLAGS) $(CFLAGS) -c -o hello-hello.obj `if test -f 'hello.c'; then $(CYGPATH_W) 'hello.c'; else $(CYGPATH_W) '$(srcdir)/hello.c'; fi`
+
+hello-tp.o: tp.c
+@am__fastdepCC_TRUE@	$(AM_V_CC)$(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(hello_CFLAGS) $(CFLAGS) -MT hello-tp.o -MD -MP -MF $(DEPDIR)/hello-tp.Tpo -c -o hello-tp.o `test -f 'tp.c' || echo '$(srcdir)/'`tp.c
+@am__fastdepCC_TRUE@	$(AM_V_at)$(am__mv) $(DEPDIR)/hello-tp.Tpo $(DEPDIR)/hello-tp.Po
+@AMDEP_TRUE@@am__fastdepCC_FALSE@	$(AM_V_CC)source='tp.c' object='hello-tp.o' libtool=no @AMDEPBACKSLASH@
+@AMDEP_TRUE@@am__fastdepCC_FALSE@	DEPDIR=$(DEPDIR) $(CCDEPMODE) $(depcomp) @AMDEPBACKSLASH@
+@am__fastdepCC_FALSE@	$(AM_V_CC@am__nodep@)$(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(hello_CFLAGS) $(CFLAGS) -c -o hello-tp.o `test -f 'tp.c' || echo '$(srcdir)/'`tp.c
+
+hello-tp.obj: tp.c
+@am__fastdepCC_TRUE@	$(AM_V_CC)$(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(hello_CFLAGS) $(CFLAGS) -MT hello-tp.obj -MD -MP -MF $(DEPDIR)/hello-tp.Tpo -c -o hello-tp.obj `if test -f 'tp.c'; then $(CYGPATH_W) 'tp.c'; else $(CYGPATH_W) '$(srcdir)/tp.c'; fi`
+@am__fastdepCC_TRUE@	$(AM_V_at)$(am__mv) $(DEPDIR)/hello-tp.Tpo $(DEPDIR)/hello-tp.Po
+@AMDEP_TRUE@@am__fastdepCC_FALSE@	$(AM_V_CC)source='tp.c' object='hello-tp.obj' libtool=no @AMDEPBACKSLASH@
+@AMDEP_TRUE@@am__fastdepCC_FALSE@	DEPDIR=$(DEPDIR) $(CCDEPMODE) $(depcomp) @AMDEPBACKSLASH@
+@am__fastdepCC_FALSE@	$(AM_V_CC@am__nodep@)$(CC) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(hello_CFLAGS) $(CFLAGS) -c -o hello-tp.obj `if test -f 'tp.c'; then $(CYGPATH_W) 'tp.c'; else $(CYGPATH_W) '$(srcdir)/tp.c'; fi`
+
 mostlyclean-libtool:
 	-rm -f *.lo
 

=== modified file 'tests/hello/ust_tests_hello.h'
--- tests/hello/ust_tests_hello.h	2012-06-29 16:47:49 +0000
+++ tests/hello/ust_tests_hello.h	2012-09-11 15:34:43 +0000
@@ -46,6 +46,7 @@
 		ctf_float(float, floatfield, floatarg)
 		ctf_float(double, doublefield, doublearg)
 		ctf_integer(bool, boolfield, boolarg)
+		ctf_integer_nowrite(int, filterfield, anint)
 	)
 )
 

=== modified file 'tests/ust-basic-tracing/Makefile.in'
--- tests/ust-basic-tracing/Makefile.in	2012-06-29 16:47:49 +0000
+++ tests/ust-basic-tracing/Makefile.in	2012-09-11 15:34:43 +0000
@@ -1,4 +1,4 @@
-# Makefile.in generated by automake 1.11.3 from Makefile.am.
+# Makefile.in generated by automake 1.11.6 from Makefile.am.
 # @configure_input@
 
 # Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2000, 2001, 2002,
@@ -16,6 +16,23 @@
 @SET_MAKE@
 
 VPATH = @srcdir@
+am__make_dryrun = \
+  { \
+    am__dry=no; \
+    case $$MAKEFLAGS in \
+      *\\[\ \	]*) \
+        echo 'am--echo: ; @echo "AM"  OK' | $(MAKE) -f - 2>/dev/null \
+          | grep '^AM OK$$' >/dev/null || am__dry=yes;; \
+      *) \
+        for am__flg in $$MAKEFLAGS; do \
+          case $$am__flg in \
+            *=*|--*) ;; \
+            *n*) am__dry=yes; break;; \
+          esac; \
+        done;; \
+    esac; \
+    test $$am__dry = yes; \
+  }
 pkgdatadir = $(datadir)/@PACKAGE@
 pkgincludedir = $(includedir)/@PACKAGE@
 pkglibdir = $(libdir)/@PACKAGE@
@@ -89,6 +106,11 @@
 am__v_GEN_0 = @echo "  GEN   " $@;
 SOURCES = $(ust_basic_tracing_SOURCES)
 DIST_SOURCES = $(ust_basic_tracing_SOURCES)
+am__can_run_installinfo = \
+  case $$AM_UPDATE_INFO_DIR in \
+    n|no|NO) false;; \
+    *) (install-info --version) >/dev/null 2>&1;; \
+  esac
 ETAGS = etags
 CTAGS = ctags
 DISTFILES = $(DIST_COMMON) $(DIST_SOURCES) $(TEXINFOS) $(EXTRA_DIST)
@@ -162,7 +184,6 @@
 SET_MAKE = @SET_MAKE@
 SHELL = @SHELL@
 STRIP = @STRIP@
-TEXINFO = @TEXINFO@
 VERSION = @VERSION@
 abs_builddir = @abs_builddir@
 abs_srcdir = @abs_srcdir@

=== modified file 'tests/ust-basic-tracing/ust-basic-tracing.c'
--- tests/ust-basic-tracing/ust-basic-tracing.c	2012-06-29 16:47:49 +0000
+++ tests/ust-basic-tracing/ust-basic-tracing.c	2012-09-11 15:34:43 +0000
@@ -42,6 +42,7 @@
 #include <ust-comm.h>
 #include "../../libringbuffer/backend.h"
 #include "../../libringbuffer/frontend.h"
+#include "../../liblttng-ust/compat.h"	/* For ENODATA */
 
 #define MAX_NR_STREAMS	64
 #define MAX_NR_EVENTS	128
@@ -222,7 +223,7 @@
 	}
 
 	/* copy */
-	outfd = open(outfile, O_WRONLY | O_CREAT | O_LARGEFILE | O_TRUNC,
+	outfd = open(outfile, O_WRONLY | O_CREAT | O_TRUNC,
 			S_IRUSR | S_IWUSR | S_IRGRP | S_IWGRP);
 	if (outfd < 0) {
 		perror("open output");

=== modified file 'tests/ust-multi-test/Makefile.in'
--- tests/ust-multi-test/Makefile.in	2012-06-29 16:47:49 +0000
+++ tests/ust-multi-test/Makefile.in	2012-09-11 15:34:43 +0000
@@ -1,4 +1,4 @@
-# Makefile.in generated by automake 1.11.3 from Makefile.am.
+# Makefile.in generated by automake 1.11.6 from Makefile.am.
 # @configure_input@
 
 # Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2000, 2001, 2002,
@@ -16,6 +16,23 @@
 @SET_MAKE@
 
 VPATH = @srcdir@
+am__make_dryrun = \
+  { \
+    am__dry=no; \
+    case $$MAKEFLAGS in \
+      *\\[\ \	]*) \
+        echo 'am--echo: ; @echo "AM"  OK' | $(MAKE) -f - 2>/dev/null \
+          | grep '^AM OK$$' >/dev/null || am__dry=yes;; \
+      *) \
+        for am__flg in $$MAKEFLAGS; do \
+          case $$am__flg in \
+            *=*|--*) ;; \
+            *n*) am__dry=yes; break;; \
+          esac; \
+        done;; \
+    esac; \
+    test $$am__dry = yes; \
+  }
 pkgdatadir = $(datadir)/@PACKAGE@
 pkgincludedir = $(includedir)/@PACKAGE@
 pkglibdir = $(libdir)/@PACKAGE@
@@ -89,6 +106,11 @@
 am__v_GEN_0 = @echo "  GEN   " $@;
 SOURCES = $(ust_multi_test_SOURCES)
 DIST_SOURCES = $(ust_multi_test_SOURCES)
+am__can_run_installinfo = \
+  case $$AM_UPDATE_INFO_DIR in \
+    n|no|NO) false;; \
+    *) (install-info --version) >/dev/null 2>&1;; \
+  esac
 ETAGS = etags
 CTAGS = ctags
 DISTFILES = $(DIST_COMMON) $(DIST_SOURCES) $(TEXINFOS) $(EXTRA_DIST)
@@ -162,7 +184,6 @@
 SET_MAKE = @SET_MAKE@
 SHELL = @SHELL@
 STRIP = @STRIP@
-TEXINFO = @TEXINFO@
 VERSION = @VERSION@
 abs_builddir = @abs_builddir@
 abs_srcdir = @abs_srcdir@

=== modified file 'tests/ust-multi-test/ust-multi-test.c'
--- tests/ust-multi-test/ust-multi-test.c	2012-06-29 16:47:49 +0000
+++ tests/ust-multi-test/ust-multi-test.c	2012-09-11 15:34:43 +0000
@@ -42,6 +42,7 @@
 #include <ust-comm.h>
 #include <../../libringbuffer/backend.h>
 #include <../../libringbuffer/frontend.h>
+#include "../../liblttng-ust/compat.h"	/* For ENODATA */
 
 #define NR_SESSIONS	4
 #define NR_CHANNELS	1
@@ -229,7 +230,7 @@
 	}
 
 	/* copy */
-	outfd = open(outfile, O_WRONLY | O_CREAT | O_LARGEFILE | O_TRUNC,
+	outfd = open(outfile, O_WRONLY | O_CREAT | O_TRUNC,
 			S_IRUSR | S_IWUSR | S_IRGRP | S_IWGRP);
 	if (outfd < 0) {
 		perror("open output");

=== modified file 'tools/Makefile.in'
--- tools/Makefile.in	2012-06-29 16:47:49 +0000
+++ tools/Makefile.in	2012-09-11 15:34:43 +0000
@@ -1,4 +1,4 @@
-# Makefile.in generated by automake 1.11.3 from Makefile.am.
+# Makefile.in generated by automake 1.11.6 from Makefile.am.
 # @configure_input@
 
 # Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2000, 2001, 2002,
@@ -16,6 +16,23 @@
 @SET_MAKE@
 
 VPATH = @srcdir@
+am__make_dryrun = \
+  { \
+    am__dry=no; \
+    case $$MAKEFLAGS in \
+      *\\[\ \	]*) \
+        echo 'am--echo: ; @echo "AM"  OK' | $(MAKE) -f - 2>/dev/null \
+          | grep '^AM OK$$' >/dev/null || am__dry=yes;; \
+      *) \
+        for am__flg in $$MAKEFLAGS; do \
+          case $$am__flg in \
+            *=*|--*) ;; \
+            *n*) am__dry=yes; break;; \
+          esac; \
+        done;; \
+    esac; \
+    test $$am__dry = yes; \
+  }
 pkgdatadir = $(datadir)/@PACKAGE@
 pkgincludedir = $(includedir)/@PACKAGE@
 pkglibdir = $(libdir)/@PACKAGE@
@@ -88,6 +105,11 @@
 am__v_at_0 = @
 SOURCES =
 DIST_SOURCES =
+am__can_run_installinfo = \
+  case $$AM_UPDATE_INFO_DIR in \
+    n|no|NO) false;; \
+    *) (install-info --version) >/dev/null 2>&1;; \
+  esac
 DISTFILES = $(DIST_COMMON) $(DIST_SOURCES) $(TEXINFOS) $(EXTRA_DIST)
 ACLOCAL = @ACLOCAL@
 AMTAR = @AMTAR@
@@ -159,7 +181,6 @@
 SET_MAKE = @SET_MAKE@
 SHELL = @SHELL@
 STRIP = @STRIP@
-TEXINFO = @TEXINFO@
 VERSION = @VERSION@
 abs_builddir = @abs_builddir@
 abs_srcdir = @abs_srcdir@
@@ -254,8 +275,11 @@
 $(am__aclocal_m4_deps):
 install-dist_binSCRIPTS: $(dist_bin_SCRIPTS)
 	@$(NORMAL_INSTALL)
-	test -z "$(bindir)" || $(MKDIR_P) "$(DESTDIR)$(bindir)"
 	@list='$(dist_bin_SCRIPTS)'; test -n "$(bindir)" || list=; \
+	if test -n "$$list"; then \
+	  echo " $(MKDIR_P) '$(DESTDIR)$(bindir)'"; \
+	  $(MKDIR_P) "$(DESTDIR)$(bindir)" || exit 1; \
+	fi; \
 	for p in $$list; do \
 	  if test -f "$$p"; then d=; else d="$(srcdir)/"; fi; \
 	  if test -f "$$d$$p"; then echo "$$d$$p"; echo "$$p"; else :; fi; \

